/*
 ****************************************************************
 *								*
 *			op_code.h				*
 *								*
 *	Estrutura da tabela de cdigos de operadores		*
 *								*
 *	Verso	1.0.00, de 17.09.92				*
 *		3.0.10, de 13.04.95				*
 *								*
 *	Mdulo: AS-80386/486/PENTIUM				*
 *		Tradutores					*
 *		Categoria D					*
 *								*
 *	TROPIX: Sistema Operacional Tempo-Real Multiprocessado	*
 *		Copyright  2000 NCE/UFRJ - tecle "man licena"	*
 * 								*
 ****************************************************************
 */


#define	NOFLAG		0	/* Nenhum indicador */

/*
 ******* Indicadores dos OPCODEs ********************************
 */
#define	IQ		0x01	/* Valor do operando imediato j no passo 1 */
#define	NOSKIP		0x02	/* No pule mesmo dentro de ".if" falso */

/*
 ******* Indicadores dos endereos ******************************
 */
#define	WP		0x01	/* Deve acrescentar 0x66 se 16 bits */
#define	LP		0x02	/* Deve acrescentar 0x66 se 32 bits */
#define	getOPND3	0x04	/* Obtm o terceiro operando */
#define	WAITP		0x08	/* Deve 0x9B (wait para flutuante) */

/*
 ****** Tipos de Instrues *************************************
 */
#define	I_REGULAR	0	/* Instruo Regular */
#define	I_ANOMALOUS	1	/* Instruo Anmala */
#define	I_PSEUDO	2	/* Pseudo-instruo */
#define	I_PREFIX	3	/* Prefixo */
#define	I_FLOAT		4	/* Ponto Flutuante */

/*
 ******* Entrada da tabela de instrucoes ************************
 */
/*** typedef	struct instr	OPCODE; ***/

struct	instr
{
	char	o_name[SIDSZ+1];	/* Nome da instruo */

	schar	o_type;			/* Tipo (regular, pseudo, ...) */
	schar	o_group;		/* Nmero do grupo da instruo */
	short	o_flags;		/* Indicadores da instruo */

	OPADDR	*o_begin;		/* Primeiro e ltimo endereamentos */
	OPADDR	*o_end;
	OPCODE	*o_link;		/* Cadeia de colises */
};

#define	NOOPCODE (OPCODE *)NULL

/*
 ******* Estrutura de um Padro: opcode + endereamento *********
 */
/*** typedef	struct opaddr	OPADDR; ***/

struct opaddr
{
	char	o_opcode;	/* Codigo da instruo */
	char	o_opexten;	/* Extenso do opcode */
	char	o_group;	/* Nmero do grupo do endereamento */
	char	o_flags;	/* Indicadores do endereamento */

	ulong	o_opnd1;	/* Os dois operandos */
	ulong	o_opnd2;
};

#define	NOOPADDR (OPADDR *)NULL
