.bp
.he 'CC (cmd)'TROPIX: Manual de Referncia'CC (cmd)'
.fo 'Atualizado em 28.08.01'Verso 4.1.0'Pag. %'

.b NOME
.in 5
.wo "cc -"
Compilador para linguagem "C"
.br

.in
.sp
.b SINTAXE
.in 5
cc [-casumvOSTPEC.] [-D <def>] ...
.in 14
[-U <id>] ... [-I <dir>] ... [-o <obj>] <arquivo> ...

.in
.sp
.b DESCRIO
.in 5
O comando "cc"  a interface para o sistema de compilao da linguagem "C" do
TROPIX. O sistema  composto pelas seguintes ferramentas:
prprocessador ("cpp" (cmd)), compilador (do GNU, programa contribudo),
montador ("as" (cmd)) e "link-editor" (ld (cmd)).
O comando "cc" processa as opes dadas, e executa as diversas ferramentas
com os argumentos apropriados. 

.sp
Nesta verso de "cc", todos os mdulos executveis gerados so reentrantes.
Se for necessrio gerar um mdulo NO reentrante,  necessrio usar "ld" diretamente.

.sp
O comando aceita diversos tipos de <arquivo>s como argumentos:

.in +3
.ip 1. 3
Arquivos cujos nomes terminam com ".c" so considerados programas fonte
em "C" e podem ser prprocessados, compilados, montados 
e "link-editados". O processo de compilao pode ser interrompido
aps qualquer uma destas fases, atravs de opes adequadas.
Se a montagem  executada, ento  produzido um mdulo objeto em
um arquivo cujo nome  o do programa fonte com ".c" substitudo por ".o".
No entanto, o arquivo "*.o"  normalmente apagado se um nico programa
fonte em "C"  compilado e "link-editado". 

.ip 2. 3
Arquivos cujos nomes terminam com ".s" so considerados programas fonte
em linguagem simblica ("assembly"), e podem ser montados e "link-editados".
 produzido um mdulo objeto em um arquivo cujo nome  o do programa fonte
com ".s" substitudo por ".o". No entanto, o arquivo "*.o"
 normalmente apagado se um nico programa fonte  montado e "link-editado". 

.ip 3. 3
Arquivos cujos nomes no terminam com ".c" nem ".s" so considerados
nomes de mdulos objeto ou bibliotecas, e so passados para o "link-editor".

.ep
.in -3

.sp
Se for gerado um mdulo executvel, o seu nome ser, por omisso, "a.out" (veja a opo "-o").

.sp
Dependendo da varivel "CC_SHLIB" do ambiente (ver "enrivon" (fmt)), a
"link-edio"  realizada com bibliotecas convencionais ou compartilhadas.
Se o ambiente contiver a varivel "CC_SHLIB" com o valor "0", a "link-edio"
ser realizada com as biliotecas convencionais "/lib/libc" e "/lib/libm".
Por outro lado, se o ambiente NO contiver a varivel "CC_SHLIB",
ou a contiver com o valor "1", a "link-edio" ser realizada com a
bilioteca compartilhada "/lib/libt.o". Se a varivel "CC_SHLIB" contiver
outro valor, este ser usado como nome para a biblioteca ser usada.
De qualquer modo, bibliotecas adicionais podem ser dadas no final da lista
de <arquivo>s.

.sp 2
As opes do comando so:

.in +3
.ip -c 9
Suprime a fase de "link-edio", e no remove os mdulos objeto produzidos.

.bc	/*************************************/
.ip -n 9
Se for produzido um mdulo executvel, ele deve ser reentrante.
.ec	/*************************************/

.ip -a 9
Gera os mdulos objeto e o mdulo executvel com as tabelas de smbolos
completas (normalmente elas contm apenas os smbolos globais).

.ip -s 9
Se for produzido um mdulo executvel, ele no deve conter a tabela de smbolos.

.ip -u 9
Durante a fase de "link-edio", lista os smbolos no referenciados.

.ip -m 9
Durante a fase de "link-edio", produz um mapa dos mdulos carregados.

.bc	/*************************************/
.ip -f 9
Durante a fase de "link-edio",
utiliza a biblioteca de ponto flutuante "falsa".
Isto  til para programas que sabidamente no utilizam nenhuma operao
de ponto flutuante (seja de entrada/sada ou aritmtica), pois o mdulo
executvel fica da ordem de 5 Kb menor.
 de responsabilidade do usurio certificar-se de que o programa
realmente no utiliza operaes de ponto flutuante
(se alguma funo da biblioteca "falsa" for chamada, ser impressa uma
mensagem de erro, e a execuo  cancelada).

.ip -l 9
Durante a fase de compilao, lista o programa fonte (sada do prprocessador).

.ip -L 9
Durante a fase de montagem, gera o arquivo de listagem do montador com o nome
"*.l". Esta opo faz tambm com que o compilador mantenha
trechos do programa fonte em "C" na sada simblica. 

.ip -w 9
Durante a fase de compilao, gera as informaes adicionais necessrias 
para utilizar o depurador simblico "wsdb" (cmd).
Se for utilizada esta opo, no pode ser utilizada a fase de otimizao
(opo "-O").
.ec	/*************************************/

.ip -v 9
Lista os nomes das fases sendo executadas, alm de algumas informaes
adicionais fornecidas por algumas das fases.

.ip -O 9
Executa a fase de otimizao do compilador "C". Esta opo no tem efeito
para programas fonte em linguagem simblica.
.bc	/*************************************/
Se for utilizada esta opo, no pode ser utilizada a depurao simblica
(opo "-w").
.ec	/*************************************/

.ip -S 9
Compila os programas fonte em "C" dados, gerando os
programas correspondentes em linguagem simblica (com o sufixo ".s").
No  realizada nenhuma montagem nem "linkedio".

.ip -T 9
Executa apenas o prprocessador e a fase de anlise sinttica
do compilador nos programas fonte em "C" dados.
So executadas heursticas especiais do compilador, com a finalidade
de apontar construes suspeitas dos programas em "C",
que normalmente no so indicadas.
Este modo  semelhante ao utilitrio "lint" de alguns sistemas UNIX.
No  gerado nenhum arquivo.

.ip -P 9
Executa apenas o prprocessador nos programas fonte em "C" dados,
gerando os programas correspondentes (com o sufixo ".i").

.ip -E 9
Executa apenas o prprocessador nos programas fonte em "C" dados,
pondo o resultado na sada padro.

.ip -C 9
No remove os comentrios durante o prprocessamento; isto 
til para as opes "-P" e "-E".

.ip -. 9
Aloca os arquivos temporrios no diretrio corrente
ao invs do diretrio "/tmp".

.bc	/*************************************/
.ip "-p <cpu>" 9
Gera cdigo objeto para a <cpu> dada.
Se esta opo no for dada, esta informao  procurada no ambiente (fmt).
Se tambm no for dada no ambiente, ser gerado o cdigo objeto
nativo do compilador.
Nesta verso, o cdigo nativo  o do MC68010, e podem ser dados
"m10" (MC68010), "m20" (MC68020) ou "m20,m81" (MC68020 e MC68881).
.ec	/*************************************/

.ip '-D <def>' 9
Prdefine macros para a fase de prprocessamento:
<def>  uma definio de macro do tipo "identificador" ou
"identificador=valor".
No primeiro caso, a macro  definida com valor "1".
Veja maiores detalhes em "cpp" (cmd).

.ip '-U <id>' 9
No permite macros com o nome <id> durante a fase de prprocessamento.
Mesmo que hajam definies da macro <id>
no decorrer do texto, elas so ignoradas.
Veja maiores detalhes em "cpp" (cmd).

.ip '-I <dir>' 9
Acrescenta <dir>  lista de diretrios de busca de arquivos "#include"
durante a fase de prprocessamento.
Veja maiores detalhes em "cpp" (cmd).

.ip "-o <obj>" 9
Se <obj> for um diretrio j existente, os mdulos objeto gerados
sero nele colocados com o sufixo ".o", e/ou o mdulo executvel gerado
ser nele colocado com o nome "a.out".
Em caso contrrio, <obj> ser usado como o nome do mdulo objeto
(executvel ou no) gerado.
Se esta opo no for dada, o nome do mdulo executvel gerado
ser "a.out".

.ep
.in -3

.in
.sp
.b DIAGNSTICOS
.in 5
Tanto o prprocessador como o compilador emitem diagnsticos,
que (por hiptese) so auto-explicativos.
O "link-editor" pode emitir diagnsticos sobre mdulos objeto no encontrados.

.in
.sp
.b OBSERVAES
.in 5
Como "cc" usualmente cria arquivos no diretrio corrente,  necessrio
executar o comando em um diretrio no qual podem ser criados arquivos.

.bc	/*************************************/
.sp
Com a utilizao da opo "-f", podem ocorrer colises entre smbolos
externos dos mdulos objeto do usurio e a biblioteca "falsa".
Neste caso  necessrio mudar os nomes dos smbolos do usurio
(ou no usar a opo "-f").
.ec	/*************************************/
 
.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd): "
cpp, as, ld
.bc	/*************************************/
cpp, as, ld, wsdb
.ec	/*************************************/
.br
.wo "(fmt): "
ambiente
.br

.in
.sp
.b
REFERNCIAS
.r
.in 5
Kernighan, B. W., e Ritchie, D. M., "The C programming Language",
Prentice-Hall, 1978. 

.sp
"American National Standard: Programming Language C" (ANSI),
Technical Commitee X3J11.

.in
.sp
.(t
.b ARQUIVOS
.in 5
.nf
     a.out		Sada da "link-edio" (nome por omisso)
     plcc*		Arquivos temporrios
     /tmp/plcc*
     /lib/cpp		Prprocessador
     /lib/gcc.486	Compilador "C"
     /bin/as		Montador
     /bin/ld		"Link-editor"
     /lib/crt0.o	"Run time startoff"
     /lib/crt1.o	"Run time startoff"
     /lib/libc		Bibliotecas padro
     /lib/libt.o
     /usr/include	Diretrio padro para arquivos de "#include"
.fi
.)t

.in
.sp
.b EXEMPLOS
.in 7
.sp
.nf
		cc -o obj alpha.c beta.c gamma.s
.fi
.in 5
.sp
compila "alpha.c" e "beta.c", monta "gamma.s" e gera um mdulo executvel.
Se "obj" for um diretrio existente, o mdulo gerado ser
"obj/a.out" e em caso contrrio "obj".

.sp
.nf
		cc -c -o redoma alpha.c beta.c gamma.c delta.c
.fi
.sp
compila "alpha.c", "beta.c", "gamma.c" e "delta.c", colocando
os mdulos objetos ("alpha.o", ...) no diretrio "redoma", que j deve existir.

.in
.sp
.b ESTADO
.in 5
Efetivo.

.in
