.bp 1
.he 'CPP (cmd)'TROPIX: Manual de Referncia'CPP (cmd)'
.fo 'Atualizado em 24.08.01'Verso 4.1.0'Pag. %'

.b NOME
.in 5
cpp - prprocessador para fontes em "C"

.in
.sp
.b SINTAXE
.in 5
/lib/cpp [-PCTv] [-D <def> ...] [-U <id> ...] [-I <dir> ...]
.nf
					 <entrada> [<sada>]
.fi

.in
.sp
.b DESCRIO
.in 5
O comando "cpp"  o prprocessador para programas fontes na linguagem
"C" do TROPIX.
Usualmente, ele  invocado automaticamente
atravs do comando "cc" (cmd), 
como o primeiro passo de uma compilao.
O comando tambm pode ser utilizado separadamente, mas neste caso,
deve-se levar em conta o formato do arquivo de sada.

.sp
O argumento <entrada>  o nome do arquivo de onde o comando ir obter
a entrada.
Se o segundo argumento <sada> for fornecido, ele ser utilizado como
nome do arquivo de sada; em caso contrrio, a sada ser posta na sada padro.

.sp
Os diretrios implcitos de busca dos arquivos "#include" so:
"/usr/include", "/usr/xwin/include" e "/usr/xwin/include/X11" (veja a opo "-I").

.sp
Nesta verso do sistema, foi removido o limite do tamanho dos identificadores,
isto , os nomes das macros, variveis, ... podem ter tamanhos arbitrrios.

.sp
As opes do comando so:

.in +3
.ip -P 10
Normalmente, o prprocessador gera uma srie de informaes de controle,
que so esperadas pelo compilador "C"
para acompanhar a origem de cada linha do programa fonte.
Com esta opo, esta informao no  gerada.

.ip -C 10
Normalmente, o prprocessador suprime todos os comentrios
(no estilo da linguagem "C") na sada.
Com esta opo, os comentrios so includos na sada.

.ip -T 10
Emite mais diagnsticos.

.ip -v 10
Verboso. Ao final do prprocessamento, imprime uma tabela com
as macros definidas.

.ip '-D <def>' 10
Prdefine macros;
<def>  uma definio de macro do tipo "identificador" ou
"identificador=valor"
(no primeiro caso, a macro  definida com valor "1").

.sp
A opo "-D" tem precedncia mais alta do que as definies de
macros atravs de "pragma getenv" (ver abaixo), isto , se a mesma macro for
definida dos dois modos, a que prevalece  a dada pela opo "-D".

.ip '-U <id>' 10
No permite macros com o nome <id>.
Mesmo que hajam definies da macro <id>
no decorrer do texto, elas so ignoradas.

.ip '-I <dir>' 10
Acrescenta <dir>  lista de diretrios de busca de arquivos "#include"
cujos nomes no comeam por "/".

.sp
Arquivos "#include" cujos nomes esto cercados por "" so 
procurados em primeiro lugar no diretrio do arquivo que contm
a diretiva "#include", em seguida nos diretrios dados pelas
opes "-I" e finalmente nos diretrios implcitos (veja acima).

.sp
Para arquivos "#include" cujos nomes esto cercados por <>, a
busca  anloga, exceto que o diretrio do arquivo que contm
a diretiva "#include" no  consultada.

.ep
.in -3

.sp 2
A diretiva "#pragma" reconhecida nesta verso de "cpp"  apenas o "getenv".
Atravs desta diretiva podemos definir variveis do ambiente como macros
(ver ("environ" (fmt)).
Ela pode ser usado em duas formas:
.sp
.nf
		#pragma getenv (<id1>, <id2>, ...)
.fi
.sp
em que so definidas as variveis <id1>, <id2>, ... e
.sp
.nf
		#pragma getenv
.fi
.sp
em que todas as variveis do ambiente so definidas como macros.

.sp
.in
.b
DIAGNSTICOS
.r
.in 5
As incorrees so classificadas em "erros" e "advertncias".
Para cada incorreo  impressa a linha, com um ponteiro
indicando o local provvel da incorreo, seguida de uma
mensagem explicativa.
Para alguns tipos de incorrees so impressos apenas o nmero da linha
e nome do arquivo ao invs da linha propriamente dita. 

.sp
.in
.b
VEJA TAMBM
.r
.nf
     (cmd): cc
     (fmt): environ
.fi

.in
.sp
.b ESTADO
.in 5
Efetivo.
.in
