/*
 ****************************************************************
 *								*
 *			convtab.c				*
 *								*
 *	Tabela de converso de caracteres			*
 *								*
 *	Verso	1.0.0, de 01.10.86				*
 *		3.0.1, de 24.04.97				*
 *								*
 *	Mdulo: dd						*
 *		Utilitrios Bsicos				*
 *		Categoria B					*
 * 								*
 *	TROPIX: Sistema Operacional Tempo-Real Multiprocessado	*
 *		Copyright  2000 NCE/UFRJ - tecle "man licena"	*
 * 								*
 ****************************************************************
 */

/*
 ****************************************************************
 *	Conversao de EBCDIC para ASCII				*
 ****************************************************************
 */
entry const char	etoa[]	=
{
/*	NUL	SOH	STX	ETX	9C	HT	86	(del)	*/

	0,	0x01,	0x02,	0x03,	0x9C,	0x09,	0x86,	0x7F,


/*	97	8D	8E	VT	FF	CR	SO	SI	*/

	0x97,	0x8D,	0x8E,	0x0B,	0x0C,	0x0D,	0x0E,	0x0F,


/*	DLE	DC1	DC2	DC3	9D	85	BS	87	*/

	0x10,	0x11,	0x12,	0x13,	0x9D,	0x85,	0x08,	0x87,


/*	CAN	EM	92	8F	FS	GS	RS	US	*/

	0x18,	0x19,	0x92,	0x8F,	0x1C,	0x1D,	0x1E,	0x1F,


/*	80	81	82	83	84	LF	ETB	ESC	*/

	0x80,	0x81,	0x82,	0x83,	0x84,	0x0A,	0x17,	0x1B,


/*	88	89	8A	8B	8C	ENQ	ACK	BE	*/

	0x88,	0x89,	0x8A,	0x8B,	0x8C,	0x05,	0x06,	0x07,


/*	90	91	SYN	93	94	95	96	EOT	*/

	0x90,	0x91,	0x16,	0x93,	0x94,	0x95,	0x96,	0x04,


/*	98	99	9A	9B	DC4	NAK	9E	SUB	*/

	0x98,	0x99,	0x9A,	0x9B,	0x14,	0x15,	0x9E,	0x1A,


/*	blank	A0	A1	A2	A3	A4	A5	A6	*/

	0x20,	0xA0,	0xA1,	0xA2,	0xA3,	0xA4,	0xA5,	0xA6,


/*	A7	A8	[	.	<	(	+	!	*/

	0xA7,	0xA8,	0x5B,	0x2E,	0x3C,	0x28,	0x2B,	0x21,


/*	&	A9	AA	AB	AC	AD	AE	AF	*/

	0x26,	0xA9,	0xAA,	0xAB,	0xAC,	0xAD,	0xAE,	0xAF,


/*	B0	B1	]	$	*	)	;	^	*/

	0xB0,	0xB1,	0x5D,	0x24,	0x2A,	0x29,	0x3B,	0x5E,


/*	-	/	B2	B3	B4	B5	B6	B7	*/

	0x2D,	0x2F,	0xB2,	0xB3,	0xB4,	0xB5,	0xB6,	0xB7,


/*	B8	B9	|	,	%	_	>	?	*/

	0xB8,	0xB9,	0x7C,	0x2C,	0x25,	0x5F,	0x3E,	0x3F,


/*	BA	BB	BC	BD	BE	BF	C0	C1	*/

	0xBA,	0xBB,	0xBC,	0xBD,	0xBE,	0xBF,	0xC0,	0xC1,


/*	C2	`	:	#	@	'	=	"	*/

	0xC2,	0x60,	0x3A,	0x23,	0x40,	0x27,	0x3D,	0x22,


/*	C3	a	b	c	d	e	f	g	*/

	0xC3,	0x61,	0x62,	0x63,	0x64,	0x65,	0x66,	0x67,


/*	h	i	C4	C5	C6	C7	C8	C9	*/

	0x68,	0x69,	0xC4,	0xC5,	0xC6,	0xC7,	0xC8,	0xC9,


/*	CA	;	k	l	m	n	o	p	*/

	0xCA,	0x6A,	0x6B,	0x6C,	0x6D,	0x6E,	0x6F,	0x70,


/*	q	r	CB	CC	CD	CE	CF	D0	*/

	0x71,	0x72,	0xCB,	0xCC,	0xCD,	0xCE,	0xCF,	0xD0,


/*	D1	~	s	t	u	v	w	x	*/

	0xD1,	0x7E,	0x73,	0x74,	0x75,	0x76,	0x77,	0x78,


/*	y	z	D2	D3	D4	D5	D6	D7	*/

	0x79,	0x7A,	0xD2,	0xD3,	0xD4,	0xD5,	0xD6,	0xD7,


/*	D8	D9	DA	DB	DC	DD	DE	DF	*/

	0xD8,	0xD9,	0xDA,	0xDB,	0xDC,	0xDD,	0xDE,	0xDF,


/*	E0	E1	E2	E3	E4	E5	E6	E7	*/

	0xE0,	0xE1,	0xE2,	0xE3,	0xE4,	0xE5,	0xE6,	0xE7,


/*	{	A	B	C	D	E	F	G	*/

	0x7B,	0x41,	0x42,	0x43,	0x44,	0x45,	0x46,	0x47,


/*	H	I	E8	E9	EA	EB	EC	ED	*/

	0x48,	0x49,	0xE8,	0xE9,	0xEA,	0xEB,	0xEC,	0xED,


/*	}	J	K	L	M	N	O	P	*/

	0x7D,	0x4A,	0x4B,	0x4C,	0x4D,	0x4E,	0x4F,	0x50,


/*	Q	R	EE	EF	F0	F1	F2	F3	*/

	0x51,	0x52,	0xEE,	0xEF,	0xF0,	0xF1,	0xF2,	0xF3,


/*	\	9F	S	T	U	V	W	X	*/

	0x5C,	0x9F,	0x53,	0x54,	0x55,	0x56,	0x57,	0x58,


/*	Y	Z	F4	F5	F6	F7	F8	F9	*/

	0x59,	0x5A,	0xF4,	0xF5,	0xF6,	0xF7,	0xF8,	0xF9,


/*	0	1	2	3	4	5	6	7	*/

	0x30,	0x31,	0x32,	0x33,	0x34,	0x35,	0x36,	0x37,


/*	8	9	FA	FB	FC	FD	FE	FF	*/

	0x38,	0x39,	0xFA,	0xFB,	0xFC,	0xFD,	0xFE,	0xFF

}	/* end etoa */;

/*
 ****************************************************************
 *	Conversao de ASCII para EBCDIC				*
 ****************************************************************
 */
entry const char	atoe[]	=
{
/*	NUL	SOH	STX	ETX	EOT	ENQ	ACK	BE	*/

	0,	0x01,	0x02,	0x03,	0x37,	0x2D,	0x2E,	0x2F,


/*	BS	HT	LF	VT	FF	CR	SO	SI	*/

	0x16,	0x05,	0x25,	0x0B,	0x0C,	0x0D,	0x0E,	0x0F,


/*	DLE	DC1	DC2	DC3	DC4	NAK	SYN	ETB	*/

	0x10,	0x11,	0x12,	0x13,	0x3C,	0x3D,	0x32,	0x26,


/*	CAN	EM	SUB	ESC	FS	GS	RS	US	*/

	0x18,	0x19,	0x3F,	0x27,	0x1C,	0x1D,	0x1E,	0x1F,


/*	blank	!	"	#	$	%	&	'	*/

	0x40,	0x4F,	0x7F,	0x7B,	0x5B,	0x6C,	0x50,	0x7D,


/*	(	)	*	+	,	-	.	/	*/

	0x4D,	0x5D,	0x5C,	0x4E,	0x6B,	0x60,	0x4B,	0x61,


/*	0	1	2	3	4	5	6	7	*/

	0xF0,	0xF1,	0xF2,	0xF3,	0xF4,	0xF5,	0xF6,	0xF7,


/*	8	9	:	;	<	=	>	?	*/

	0xF8,	0xF9,	0x7A,	0x5E,	0x4C,	0x7E,	0x6E,	0x6F,


/*	@	A	B	C	D	E	F	G	*/

	0x7C,	0xC1,	0xC2,	0xC3,	0xC4,	0xC5,	0xC6,	0xC7,


/*	H	I	J	K	L	M	N	O	*/

	0xC8,	0xC9,	0xD1,	0xD2,	0xD3,	0xD4,	0xD5,	0xD6,


/*	P	Q	R	S	T	U	V	W	*/

	0xD7,	0xD8,	0xD9,	0xE2,	0xE3,	0xE4,	0xE5,	0xE6,


/*	X	Y	Z	[	\	]	^	_	*/

	0xE7,	0xE8,	0xE9,	0x4A,	0xE0,	0x5A,	0x5F,	0x6D,


/*	`	a	b	c	d	e	f	g	*/

	0x79,	0x81,	0x82,	0x83,	0x84,	0x85,	0x86,	0x87,


/*	h	i	j	k	l	m	n	o	*/

	0x88,	0x89,	0x91,	0x92,	0x93,	0x94,	0x95,	0x96,


/*	p	q	r	s	t	u	v	w	*/

	0x97,	0x98,	0x99,	0xA2,	0xA3,	0xA4,	0xA5,	0xA6,


/*	x	y	z	{	|	}	~	(del)	*/

	0xA7,	0xA8,	0xA9,	0xC0,	0x6A,	0xD0,	0xA1,	0x07,


/*	80	81	82	83	84	85	86	87	*/

	0x20,	0x21,	0x22,	0x23,	0x24,	0x15,	0x06,	0x17,


/*	88	89	8A	8B	8C	8D	8E	8F	*/

	0x28,	0x29,	0x2A,	0x2B,	0x2C,	0x09,	0x0A,	0x1B,


/*	90	91	92	93	94	95	96	97	*/

	0x30,	0x31,	0x1A,	0x33,	0x34,	0x35,	0x36,	0x08,


/*	98	99	9A	9B	9C	9D	9E	9F	*/

	0x38,	0x39,	0x3A,	0x3B,	0x04,	0x14,	0x3E,	0xE1,


/*	A0	A1	A2	A3	A4	A5	A6	A7	*/

	0x41,	0x42,	0x43,	0x44,	0x45,	0x46,	0x47,	0x48,


/*	A8	A9	AA	AB	AC	AD	AE	AF	*/

	0x49,	0x51,	0x52,	0x53,	0x54,	0x55,	0x56,	0x57,


/*	B0	B1	B2	B3	B4	B5	B6	B7	*/

	0x58,	0x59,	0x62,	0x63,	0x64,	0x65,	0x66,	0x67,


/*	B8	B9	BA	BB	BC	BD	BE	BF	*/

	0x68,	0x69,	0x70,	0x71,	0x72,	0x73,	0x74,	0x75,


/*	C0	C1	C2	C3	C4	C5	C6	C7	*/

	0x76,	0x77,	0x78,	0x80,	0x8A,	0x8B,	0x8C,	0x8D,


/*	C8	C9	CA	CB	CC	CD	CE	CF	*/

	0x8E,	0x8F,	0x90,	0x9A,	0x9B,	0x9C,	0x9D,	0x9E,


/*	D0	D1	D2	D3	D4	D5	D6	D7	*/

	0x9F,	0xA0,	0xAA,	0xAB,	0xAC,	0xAD,	0xAE,	0xAF,


/*	D8	D9	DA	DB	DC	DD	DE	DF	*/

	0xB0,	0xB1,	0xB2,	0xB3,	0xB4,	0xB5,	0xB6,	0xB7,


/*	E0	E1	E2	E3	E4	E5	E6	E7	*/

	0xB8,	0xB9,	0xBA,	0xBB,	0xBC,	0xBD,	0xBE,	0xBF,


/*	E8	E9	EA	EB	EC	ED	EE	EF	*/

	0xCA,	0xCB,	0xCC,	0xCD,	0xCE,	0xCF,	0xDA,	0xDB,


/*	F0	F1	F2	F3	F4	F5	F6	F7	*/

	0xDC,	0xDD,	0xDE,	0xDF,	0xEA,	0xEB,	0xEC,	0xED,


/*	F8	F9	FA	FB	FC	FD	FE	FF	*/

	0xEE,	0xEF,	0xFA,	0xFB,	0xFC,	0xFD,	0xFE,	0xFF

}	/* end atoe */;

/*
 ****************************************************************
 *	Conversao de ASCII para IBM				*
 ****************************************************************
 */
entry const char	atoibm[]	=
{
/*	NUL	SOH	STX	ETX	EOT	ENQ	ACK	BE	*/

	0,	0x01,	0x02,	0x03,	0x37,	0x2D,	0x2E,	0x2F,


/*	BS	HT	LF	VT	FF	CR	SO	SI	*/

	0x16,	0x05,	0x25,	0x0B,	0x0C,	0x0D,	0x0E,	0x0F,


/*	DLE	DC1	DC2	DC3	DC4	NAK	SYN	ETB	*/

	0x10,	0x11,	0x12,	0x13,	0x3C,	0x3D,	0x32,	0x26,


/*	CAN	EM	SUB	ESC	FS	GS	RS	US	*/

	0x18,	0x19,	0x3F,	0x27,	0x1C,	0x1D,	0x1E,	0x1F,


/*	blank	!	"	#	$	%	&	'	*/

	0x40,	0x5A,	0x7F,	0x7B,	0x5B,	0x6C,	0x50,	0x7D,


/*	(	)	*	+	,	-	.	/	*/

	0x4D,	0x5D,	0x5C,	0x4E,	0x6B,	0x60,	0x4B,	0x61,


/*	0	1	2	3	4	5	6	7	*/

	0xF0,	0xF1,	0xF2,	0xF3,	0xF4,	0xF5,	0xF6,	0xF7,


/*	8	9	:	;	<	=	>	?	*/

	0xF8,	0xF9,	0x7A,	0x5E,	0x4C,	0x7E,	0x6E,	0x6F,


/*	@	A	B	C	D	E	F	G	*/

	0x7C,	0xC1,	0xC2,	0xC3,	0xC4,	0xC5,	0xC6,	0xC7,


/*	H	I	J	K	L	M	N	O	*/

	0xC8,	0xC9,	0xD1,	0xD2,	0xD3,	0xD4,	0xD5,	0xD6,


/*	P	Q	R	S	T	U	V	W	*/

	0xD7,	0xD8,	0xD9,	0xE2,	0xE3,	0xE4,	0xE5,	0xE6,


/*	X	Y	Z	[	\	]	^	_	*/

	0xE7,	0xE8,	0xE9,	0xAD,	0xE0,	0xBD,	0x5F,	0x6D,


/*	`	a	b	c	d	e	f	g	*/

	0x79,	0x81,	0x82,	0x83,	0x84,	0x85,	0x86,	0x87,


/*	h	i	j	k	l	m	n	o	*/

	0x88,	0x89,	0x91,	0x92,	0x93,	0x94,	0x95,	0x96,


/*	p	q	r	s	t	u	v	w	*/

	0x97,	0x98,	0x99,	0xA2,	0xA3,	0xA4,	0xA5,	0xA6,


/*	x	y	z	{	|	}	~	(del)	*/

	0xA7,	0xA8,	0xA9,	0xC0,	0x4F,	0xD0,	0xA1,	0x07,


/*	80	81	82	83	84	85	86	87	*/

	0x20,	0x21,	0x22,	0x23,	0x24,	0x15,	0x06,	0x17,


/*	88	89	8A	8B	8C	8D	8E	8F	*/

	0x28,	0x29,	0x2A,	0x2B,	0x2C,	0x09,	0x0A,	0x1B,


/*	90	91	92	93	94	95	96	97	*/

	0x30,	0x31,	0x1A,	0x33,	0x34,	0x35,	0x36,	0x08,


/*	98	99	9A	9B	9C	9D	9E	9F	*/

	0x38,	0x39,	0x3A,	0x3B,	0x04,	0x14,	0x3E,	0xE1,


/*	A0	A1	A2	A3	A4	A5	A6	A7	*/

	0x41,	0x42,	0x43,	0x44,	0x45,	0x46,	0x47,	0x48,


/*	A8	A9	AA	AB	AC	AD	AE	AF	*/

	0x49,	0x51,	0x52,	0x53,	0x54,	0x55,	0x56,	0x57,


/*	B0	B1	B2	B3	B4	B5	B6	B7	*/

	0x58,	0x59,	0x62,	0x63,	0x64,	0x65,	0x66,	0x67,


/*	B8	B9	BA	BB	BC	BD	BE	BF	*/

	0x68,	0x69,	0x70,	0x71,	0x72,	0x73,	0x74,	0x75,


/*	C0	C1	C2	C3	C4	C5	C6	C7	*/

	0x76,	0x77,	0x78,	0x80,	0x8A,	0x8B,	0x8C,	0x8D,


/*	C8	C9	CA	CB	CC	CD	CE	CF	*/

	0x8E,	0x8F,	0x90,	0x9A,	0x9B,	0x9C,	0x9D,	0x9E,


/*	D0	D1	D2	D3	D4	D5	D6	D7	*/

	0x9F,	0xA0,	0xAA,	0xAB,	0xAC,	0xAD,	0xAE,	0xAF,


/*	D8	D9	DA	DB	DC	DD	DE	DF	*/

	0xB0,	0xB1,	0xB2,	0xB3,	0xB4,	0xB5,	0xB6,	0xB7,


/*	E0	E1	E2	E3	E4	E5	E6	E7	*/

	0xB8,	0xB9,	0xBA,	0xBB,	0xBC,	0xBD,	0xBE,	0xBF,


/*	E8	E9	EA	EB	EC	ED	EE	EF	*/

	0xCA,	0xCB,	0xCC,	0xCD,	0xCE,	0xCF,	0xDA,	0xDB,


/*	F0	F1	F2	F3	F4	F5	F6	F7	*/

	0xDC,	0xDD,	0xDE,	0xDF,	0xEA,	0xEB,	0xEC,	0xED,


/*	F8	F9	FA	FB	FC	FD	FE	FF	*/

	0xEE,	0xEF,	0xFA,	0xFB,	0xFC,	0xFD,	0xFE,	0xFF

}	/* end atoibm */;
