.bp 1
.he 'DD (cmd)'TROPIX: Manual de Referncia'DD (cmd)'
.fo 'escrito em 14.10.04'Verso 4.6.0'Pag. %'

.b NOME
.in 5
dd - copia e converte arquivos

.in
.sp
.b SINTAXE
.in 5
dd [-v] [<argumento>=<valor>] ...

.in
.sp
.b DESCRIO
.in 5
O comando "dd" copia o arquivo de entrada
para a sada especificada, efetuando
possveis converses.
Por omisso, so utilizadas a entrada/sada padro.

.sp
Se o arquivo de sada for regular, e NO for dado o argumento
"seek", ele ser truncado antes da cpia.

.sp
Podemos especificar os tamanhos dos blocos de entrada e de sada
para blocar/desblocar arquivos e/ou
aproveitar as vantagens das operaes de
entrada e sada em modo fsico no-estruturado ("raw").

.sp
Este comando, ao contrrio do usual, utiliza uma sintaxe com
palavras chaves, onde so dados grupos, contendo cada um
o nome de um argumento, seguido do caracter "=" e do seu respectivo valor.
Estes grupos podem vir em qualquer ordem.

.sp
As opes do comando so:

.in +3
.ip -v
Verboso: escreve uma estatstica ao final da execuo,
contendo o nmero de blocos completamente/parcialmente lidos/escritos.

.ep
.in -3

.sp
Os argumentos so as seguintes:

.in +3
.ip 'if=<arq>' 15
Nome do arquivo de entrada (por omisso, a entrada padro).

.ip 'of=<arq>' 15
Nome do arquivo de sada (por omisso, a sada padro).

.ip 'ibs=<n>' 15
Tamanho do bloco de entrada (por omisso 4096).

.ip 'obs=<n>' 15
Tamanho do bloco de sada (por omisso 4096).

.ip 'bs=<n>' 15
Tamanho do bloco de entrada e de sada;
este argumento tem prioridade sobre "ibs" e "obs",
e  til especialmente quando no for especificada nenhuma
converso, pois no sero feitas cpias entra reas da memria.

.ip 'cbs=<n>' 15
Tamanho da rea de converso.

.ip 'skip=<n>' 15
Pule os <n> blocos iniciais do arquivo de entrada,
antes de iniciar a cpia.

.ip 'seek=<n>' 15
Inicie a cpia, no arquivo de sada, a partir do bloco <n>
(numerao comeando a partir de 0).

.ip 'count=<n>' 15
Copie apenas <n> blocos da entrada.

.ip 'conv=ascii' 15
Converta o cdigo EBCDIC para ASCII.

.in +5
.ip 'ebcdic' 10
Converta o cdigo ASCII para EBCDIC.

.ip 'ibm' 10
Converso, um pouco diferente, de ASCII para EBCDIC.

.ip 'lcase' 10
Converta letras maisculas em minsculas.

.ip 'ucase' 10
Converta letras minsculas em maisculas.

.ip 'swab0' 10
Inverta bytes consecutivos
(converte "abcd" em "badc").

.ip 'swab1' 10
Inverta pares de bytes consecutivos
(converte "abcd" em "cdab").

.ip 'swab2' 10
Realize, para pares de bytes consecutivos, swab0 e swab1 simultaneamente
(converte "abcd" em "dcba").

.ip 'noerror' 10
No interrompa o programa se ocorrer algum erro.

.ip 'sync' 10
Complete todo bloco de entrada para o tamanho "ibs".

.ip '..., ...' 10
Vrias opes de converso podem ser separadas por vrgula.

.in -5
.in -3
.ep

.sp 2
Quando for especificado um nmero (valor <n>), normalmente espera-se
um valor decimal; no entanto podemos usar
hexadecimal (se o nmero comear com "0x" ou "0X"),
ou octal (se o nmero comear com "0").
Alm disto, o nmero pode terminar com
"c" ou "C" para especificar multiplicao por 2048,
"k" ou "K" para especificar multiplicao por 1024,
"b" ou "B" para especificar multiplicao por 512,
"l" ou "L" para especificar multiplicao por 4 e
"w" ou "W" para especificar multiplicao por 2.
Lembre-se no entanto, que "b" e "B" so tambm algarismos hexadecimais!

.sp
O argumento "cbs=<n>" (rea de converso)  usado apenas se for especificada
uma converso "ascii", "ebcdic", ou "ibm".
No primeiro caso, so colocados "n" bytes na rea de converso
(convertidos para ASCII),
os brancos mais  direita so suprimidos, e um caractere <nl>  adicionado
antes de escrever o bloco na sada.
Nos outros dois casos, o procedimento  o inverso:
 lida uma linha do arquivo de entrada ASCII
(delimitada por um <nl>) na rea de converso
(convertida para EBCDIC), e a rea  completada com brancos.

.sp
Ao final, escreve uma estatstica (veja a opo "-v", acima).

.in
.sp
.b
OBSERVAO
.r
.in 5
A converso "ibm"  uma variante da converso ASCII para EBCDIC,
que apesar de no corresponder exatamente ao padro, adapta-se
melhor aos casos usuais.

.in
.sp
.b
VEJA TAMBM
.r
.in 5
(cmd): cp, tr

.in
.sp
.b EXEMPLOS
.in 7
.sp
dd if=arq1 of=arq2 conv=ucase
.sp
.in +3
Copia "arq1" para "arq2" convertendo as letras minsculas para maisculas.
.sp 2

.in -3
dd if=/dev/rmt0 of=arq ibs=800 cbs=80 conv=ascii,swab0
.sp
.in +3
A unidade de fita contm um arquivo,
cujos registros lgicos de 80 bytes em EBCDIC esto blocados em 800 bytes.
Este arquivo ser lido, os bytes consecutivos sero invertidos
e convertidos para ASCII, os brancos no final de cada registro de 80 bytes
sero eliminados, e finalmente sero acrescentados <nl>.
O arquivo convertido  escrito em "arq".
.in -3

.in
.sp
.b ESTADO
.in 5
Efetivo.
.in
