.bp
.he 'DIFF (cmd)'TROPIX: Manual de Referncia'DIFF (cmd)'
.fo 'Atualizado em 24.04.97'Verso 3.0.0'Pag. %'

.b NOME
.in 5
.wo "diff -"
comparador diferencial de arquivos
.br

.in
.sp
.b SINTAXE
.in 5
.(l
diff [-efc] [-i <nm>] [-C <n>] [-b] <arquivo1> <arquivo2>
.)l

.in
.sp
.b DESCRIO
.in 5
O comando "diff" compara os arquivos de texto <arquivo1> e <arquivo2>,
indicando todas as linhas diferentes entre eles.

.sp
Se um dos <arquivo>s (mas no ambos) for "-", ele  lido da entrada padro.

.sp
Se um dos <arquivo>s (mas no ambos) for um diretrio, ser utilizado
o arquivo homnimo ao outro neste diretrio.
Neste caso no pode ser dado "-".

.sp 2
As diferenas entre os <arquivo>s podem ser indicadas de vrios modos,
dependendo da chave dada:

.in +3
.ip -- 9
Se no for dada nenhuma das chaves abaixo,  emitida a sada "normal"
do comando, que consiste em linhas nas formas:
.sp
.(l
			n1     a  n3,n4
			n1,n2  d  n3
			n1,n2  c  n3,n4
.)l
.sp
Estas linhas so semelhantes a comandos do editor "ed" (cmd) para converter
o <arquivo1> no <arquivo2>. 
Os nmeros aps as letras so referentes ao <arquivo2>.
Como no "ed", se n1 = n2 ou n3 = n4, o par de nmeros 
abreviado em um nmero nico.

.sp
Alm disto, se as letras "a" e "d" dos comandos forem intercambiadas,
e as linhas forem lidas de trs para frente, obtemos comandos para
converter o <arquivo2> no <arquivo1>. 

.sp
Seguindo cada uma destas linhas, vem todas as linhas afetadas do
<arquivo1> indicadas por "<", e todas as linhas afetadas do
<arquivo2> indicadas por ">".

.ip -e 9
Gera uma seqncia de comandos "a", "c" e "d" para o "ed", que converte
o <arquivo1> no <arquivo2>.

.ip -f 9
Gera uma seqncia de comandos semelhante  chave "-e",
na ordem inversa, mas que no pode ser utilizada pelo "ed".

.ip -c 9
Para cada diferena entre os <arquivo>s, mostra a regio afetada de cada
<arquivo> incluindo <n> linhas antes e <n> linhas aps a regio (o contexto).
O valor de <n>  normalmente 2, mas pode ser alterado atravs da opo "-C"
(veja abaixo).

.sp
Se houve substituio de linhas, isto  indicado atravs 
do prefixo "!"; a remoo de linhas do <arquivo1>  indicada pelo
prefixo "-"; a adio de linhas no <arquivo2>  indicada
atravs do prefixo "+".

.ip '-i <nm>' 9
Gera um arquivo "universal" contendo tanto o <arquivo1> como o 
<arquivo2> onde as distines entre os <arquivo>s  
esto codificadas na forma das diretivas "#ifdef <nm>", "#ifndef <nm>",
"#else" e "#endif" do prprocessador da linguagem "C"
(veja "cpp" (cmd)).

.sp
A partir deste arquivo "universal" podemos recuperar tanto o <arquivo1>
como o <arquivo2> atravs do comando "ifdef" (cmd)
utilizando a opo "-U <nm>" ou "-D <nm>" respectivamente.

.sp
Se os <arquivo>s no possurem macros/diretivas do "cpp", ou ainda,
se se tratarem de programas fontes em "C" que desejamos
compilar, podemos aplicar o "cpp" (ou "cc" (cmd)) diretamente
ao arquivo "universal".
 
.ep
.in -3

.sp 2
Alm das chaves, temos ainda as opes:

.in +3
.ip -b 8
Ignora brancos nos finais das linhas e considera outras seqncias
de brancos iguais entre si.

.ip '-C <n>' 8
O nmero de linhas de contexto deve ser <n> ao invs de 2 (valor por omisso).

.ep
.in -3

.in
.sp
.b
VALOR DE RETORNO
.r
.in 5
Retorna 0 para arquivos iguais, 1 para arquivos diferentes e 2 para
arquivos inacessveis ou erros. 

.in
.sp
.b OBSERVAES
.in 5
O comando "diff" obtm o conjunto mnimo de diferenas, exceto em
(raros) casos patolgicos.  

.sp
Uma seqncia de comandos gerada pelas chaves "-e" e "-f"
pode no funcionar corretamente se alguma das linhas modificadas
consistir de apenas um ponto.

.sp
Um arquivo "universal" gerado pela chave "-i"
pode no funcionar corretamente se alguma das linhas modificadas
consistir justamente de uma diretiva para o "cpp".

.(t
.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd): "
cmp, comm, ed, cpp, cc, ifdef, show
.br
.)t

.in
.sp
.b ARQUIVO
.in 5
/tmp/diff??????

.in
.sp
.b EXEMPLO
.in 5
Uma das maneiras mais cmodas para a utilizao do comando
utiliza a sada das diferenas com contexto associado ao comando "show":

.sp
.ce
	diff -c fonte.c ../old | show 


.in
.sp
.b ESTADO
.in 5
Efetivo.

.in
