.bp
.he 'DOSMP (cmd)'TROPIX: Manual de Referncia'DOSMP (cmd)'
.fo 'Atualizado em 19.10.05'Verso 4.8.0'Pag. %'

.b NOME
.in 5
.wo "dosmp -"
processa um sistema de arquivos no formato MS-DOS
.br

.in
.sp
.b SINTAXE
.in 5
.(l
dosmp [-crv] [-0123] [<dispositivo>]
.)l

.in
.sp
.b DESCRIO
.in 5
O programa "dosmp"  uma interface para o processamento de sistemas
de arquivos no formato MS-DOS. Ele permite uma srie de operaes
tais como listagens, cpias e comparaes de arquivos de/para o
sistema TROPIX.

.sp
O nome do <dispositivo> contendo o sistema de arquivos DOS pode ser dado
juntamente com o nome do programa, ou pode ser dado posteriormente
atravs do comando "mount" (ver abaixo). Caso o <dispositivo> ainda
no contenha um sistema de arquivos DOS, pode ser utilizada a opo
"-c" (ver abaixo) para criar um sistema DOS, ou pode ser utilizado
posteriormente o comando "mkfs".

.sp
Nesta verso, "dosmp" s est
aceitando <dispositivo>s especiais estruturados (isto , de blocos),
e arquivos regulares (isto , uma imagem de um sistema de arquivos
DOS contida em um arquivo regular).
So aceitas FATs de 12, 16 e 32 bits.

.sp
Se for dado um diretrio, "dosmp" supe que seja um ponto de montagem
e procura o  <dispositivo> correspondente na tabela "fstab" (veja "fstab" (fmt)).

.sp
Aps a anlise do <dispositivo> (possivelmente) dado, "dosmp" passa
o controle para o interpretador de comandos, aguardando instrues
do usurio. Para indicar que est aguardando comandos, "dosmp" imprime
uma linha contendo os caracteres
.sp
.nf
		"dosmp [n]> "
.fi
.sp
onde "n"  o nmero
do comando no histrico (ver os comandos "h", "eh" e "xh" abaixo). 
Caso o sistema de arquivos contenha o nome de um volume no diretrio
raiz (por exemplo, "cartas"), a linha impressa ser
.sp
.nf
		"dosmp (cartas) [n]>".
.fi
.sp

.sp
As opes do comando so:

.in +3
.ip --
(Caso normal, sem as opes "-c" e "-r"): Se for dado um <dispositivo>,
"dosmp" assume que contm um sistema de arquivos DOS, e monta-o somente
para leituras (o que pode ser alterado posteriormente atravs do comando "rw").
Se NO for dado um <dispositivo>, "dosmp" aguarda comandos do usurio.

.ip -c
Se for dado um <dispositivo>, "dosmp" nele cria um sistema de arquivos
DOS. Em caso contrrio, aguarda comandos do usurio.

.ip -r
Modo garantido contra modificaes dos sistemas de arquivos:
como o caso normal acima, s que no  aceito o comando "rw", nem
qualquer outro que modifique o sistema de arquivos DOS.

.ip -v
Verboso.

.ip -0
O <dispositivo> usado  "/dev/fd0".

.ip -1
O <dispositivo> usado  "/dev/fd1".

.ip -2
O <dispositivo> usado  "/dev/zip0".

.ip -3
O <dispositivo> usado  "/dev/zip1".

.ep
.in -3

.(t
.in
.sp
.b 'MODO DE REPRESENTAO DE DADOS'
.in 5
O formato de armazenamento de arquivos de texto em sistemas DOS 
ligeiramente diferente do que no TROPIX. As separaes de linhas,
por exemplo, so feitas atravs de dois caracteres, <cr><nl> (ao
invs apenas de <nl>), e o final do arquivo pode conter o caratere <^Z>.
.)t

.sp
Para controlar a converso (ou no) entre os formatos, temos
o modo de representao de dados corrente, que pode ser ISO (ASCII) ou
BINRIO. O modo ISO supe que estejamos processando textos, e portanto
todos os contedos dos arquivos regulares lidos/escritos de/para
o sistema DOS so convertidos conforme a descrio acima.
O modo BINRIO supe que estejamos processando dados binrios, e portanto
os contedos no so convertidos.
Os contedos de diretrios nunca so convertidos.

.sp
O comando "status" informa o modo corrente,
o comando "iso" altera o modo para ISO e
o comando "bin" altera o modo para BINRIO.
Durante a descrio de cada comando (abaixo),  mencionado se o modo de
representao de dados corrente  relevante para o seu funcionamento.

.sp
O programa "dosmp" inicia no modo ISO.

.in
.sp
.b 'NOMES DE ARQUIVOS'
.in 5
O comando "lfn" do programa "dosmp" permite escolher o modo de converso
dos nomes do sistema TROPIX para o DOS. Com o modo "off", os nomes
so convertidos para o formato antigo (tradicional) do DOS, que permite
apenas 11 caracteres mausculos, 8 na base e 3 na extenso.

.sp
Com o modo "on", os nomes so convertidos para o formato novo ("Long
File Names" (LFN), do Windows 95/98), que permite at 255 caracteres.

.sp
Independente do modo, "dosmp" sempre le integralmente os LFNs encontrados.
O comando "ls" (veja abaixo) imprime os nomes completos, enquanto que
o comando "lc" (veja abaixo) os trunca a 35 caracteres.

.sp
O programa "dosmp" inicia no modo "on".
O comando "status" informa o modo corrente (veja o comando "lfn", abaixo).

.bc	/*************************************/
.in
.sp
.b 'NOMES DE ARQUIVOS'
.in 5
A sintaxe dos nomes de arquivos tambm so diferentes entre os sistemas
DOS e TROPIX. Enquanto que no TROPIX, os nomes podem ter at 14 caracteres
maisculos ou minsculos, no DOS os nomes podem ter apenas 11 caracteres
mausculos, 8 na base e 3 na extenso.

.sp
Na criao ou cpia de arquivos, o usurio  alertado quando o nome
dado (ou obtido do TROPIX) no  adequado para o DOS. Neste caso,
o prprio "dosmp" sugere um truncamento adequado, e consulta o usurio
se ele aceita a sugesto.
No caso da sugesto ser aceita, "dosmp" tenta conservar os caracteres
truncados em uma rea no utilizada dos diretrios DOS
(apenas para facilitar o usurio do prprio "dosmp"). 
Em caso contrrio, "dosmp" pede um nome substituto para o usurio,
mas neste caso, os (possveis) caracteres truncados no so conservados.

.sp
As sugestes de truncamento so feitas sempre no final da base/extenso,
como mostram os seguintes exemplos:
.nf

		abcdefghijkl		=>  ABCDEFGH
		abc.uvwxyz		=>  ABC		UVW
		abcdefghijkl.uvwxyz	=>  ABCDEFGH	UVW
		.abc.uvw		=>  ABC		UVW
		abc.def.uvw		=>  ABC		DEF
.fi

.sp
Utilizando o comando "lc" (ver abaixo) podemos ver os nomes dos
arquivos com os caracteres truncados (possivelmente) restaurados,
e usando "lc -d", podemos ver os nomes dos arquivos como sero
"vistos" pelos sistemas DOS. 

.sp
O que infelizmente no  conservado,  a informao de quais os caracteres
so originalmente maisculos no TROPIX. Todos caracteres so armazenados
em mausculo no sistema DOS, e convertidos para minsculos quando
"dosmp" se referencia a eles.
Portanto (por exemplo), o nome "Makefile" ser armazenado como
"MAKEFILE" no sistema de arquivos DOS, e convertido de volta para "makefile"
quando "dosmp" se referir a ele.
Por este motivo, nestes casos,  prefervel usar os comandos de comparao
que obtenham os nomes do sistema TROPIX, tais como "cmpput" e "cmpputtree"
(ao invs de "cmp" e "cmpgettree").
.ec	/*************************************/

.in
.sp
.b 'EXPANSO DOS META-CARACTERES DOS ARGUMENTOS'
.in 5
De acordo com o comando, os meta-caracteres "?*[]!" dos seus argumentos
no so expandidos,
so expandidos no sistema de arquivos DOS ou
so expandidos no sistema de arquivos TROPIX.

.sp
Normalmente, quando os argumentos no se referirem a arquivos ou
se referirem a arquivos que ainda vo ser criados, eles
no so expandidos (tal como nos comandos "mount" e "mkdir");
quando os argumentos se referirem a arquivos DOS, eles so expandidos
no sistema DOS (tal como nos comandos "mv" e "get"); e
quando os argumentos se referirem a arquivos TROPIX, eles so expandidos
no sistema TROPIX (tal como nos comandos "put" e "puttree").

.sp
Repare que na expanso no sistema DOS, os arquivos com o atributo "h"
(ver "chmod", abaixo) no so considerados.
Durante a descrio de cada comando, o usurio  alertado se por acaso
a expanso no segue o bom senso descrito acima.

.in
.sp
.b 'DIRETRIO CORRENTE'
.in 5
Ao utilizar o comando "dosmp", temos em cada momento, dois diretrios
correntes: o do DOS e o do TROPIX. Eles podem ser alterados respectivamente
pelos comandos "cd" e "!cd".

.sp
O modo mais cmodo de usar o "dosmp"  o de trabalhar entre diretrios
correntes. Isto  uma decorrncia do fato de que alguns dos comandos mais
importantes ("get" e "put", entre outros) sempre se referirem a arquivos no
diretrio corrente do sistema de arquivos destino.

Por exemplo, no comando "get alpha/beta/gamma.c"  copiado o arquivo
"alpha/beta/gamma.c" do sistema DOS no arquivo "gamma.c" do diretrio
corrente do sistema TROPIX.

.sp
Se durante a descrio de um comando, nada for mencionado,
so utilizados os nomes completos dos arquivos
(isto , todos os componentes do caminho).
Em caso contrrio,  indicado em qual sistema  usado o diretrio
corrente.

.in
.sp
.(t
.b COMANDOS
.in 5
O programa "dosmp" reconhece os seguintes comandos:

.bc	/*************************************/
.in +3
.ec	/*************************************/
.ip " 1." 4
?
.sp
Como "help", abaixo.

.ip " 2." 4
!<comando> [<argumento> ...]
.sp
Executa o <comando> com os respectivos <argumento>s no sistema TROPIX.
Isto vale inclusive para o comando "cd".
.)t

.ip " 3." 4
arena [-v]
.sp
Imprime e verifica a consistncia da arena de "malloc" (libc).
Este comando  indicado para a depurao e/ou manuteno do programa,
e no para o uso normal.

.(t
.ip " 4." 4
ascii
.sp
Altera o modo de representao de dados para ISO (ASCII).
.)t

.ip " 5." 4
bin
.sp
Altera o modo de representao de dados para BINRIO.

.ip " 6." 4
bye
.sp
Encerra o programa. Um EOF (normalmente <^D>) tem o mesmo efeito.

.ip " 7." 4
cat <arquivo>
.sp
Imprime um arquivo DOS na sada padro.
O contedo do arquivo  convertido,
conforme o modo de representao de dados.

.ip " 8." 4
cd <novo_diretrio>
.sp
Altera o diretrio corrente DOS para <novo_diretrio>.

.ip " 9." 4
chd <novo_diretrio>
.sp
Como "cd", acima.

.ip "10." 4
chm [-v] <modo> <arquivo> ...
.sp
Como "chmod", abaixo.

.ip "11." 4
chmod [-v] <modo> <arquivo> ...
.sp
Altera atributos de arquivos DOS.
Podem ser alterados os atributos "m" (arquivo modificado),
"s" (arquivo do sistema DOS), "h" (arquivos ocultos),
"r" (arquivo com proteo de escrita), alm dos atributos
"1" e "2" (reservados).
O <modo> pode ser dado como uma constante inteira decimal,
octal ou hexadecimal (conforme a sintaxe da linguagem "C")
ou ainda simbolicamente com a sintaxe
.sp
.nf
			[u] <op> <atributo>
.fi
.sp
onde <op> pode ser "=", "+" ou "-" e <atributo> deve ser uma das
letras descritas acima. Vrios modos podem ser dados, separados
por virgulas, como no exemplo
.sp
.nf
			chmod u-h,+r alpha beta
.fi
.sp
Se for dada a opo "-v", so listados os modos antigo e novo de
cada <arquivo>. A sintaxe do <modo> deste comando  baseada em
"chmod" (cmd), onde podem ser vistos mais detalhes.

.ip "12." 4
chsize [-s <n>]
.sp
O objetivo do comando "chsize"  o de liberar <n> MB ainda no
alocados do final do sistema de arquivos DOS, para a
criao de uma nova partio
(por exemplo, para um sistema de arquivos de um outro sistema operacional).
Antes de usar este comando,  recomendvel desfragmentar
o sistema de arquivos atravs do comando DEFRAG ou SPEED DISK
(dos NORTON UTILITIES).
Talvez seja til tambm usar o comando "compac" (veja abaixo).

.sp
Sem opes, o comando informa o tamanho atual da partio,
o tamanho atual do sistema de arquivos DOS
e o espao livre disponvel no final do sistema de
arquivos (em MB).

.sp
Com a opo "-s <n>", alm dos dados acima, so propostos novos tamanhos
para a partio DOS, o sistema de arquivos DOS e a nova partio
a ser criada. Este ltimo valor pode no ser exatamente igual ao
valor dado <n>, por arredondamentos decorrentes do tamanho do cilindro
do disco.

.sp
Se a proposta for aceita, o superbloco original do sistema de arquivos
 gravado no arquivo "dos_sb" (no diretrio corrente do TROPIX),
e o sistema de arquivos tem o seu tamanho
reduzido para o valor da proposta.
Anote o novo tamanho da partio DOS e o tamanho da nova partio
a ser criada (em MB e blocos).

.sp
Se tudo correr de acordo com as expectativas (isto , o DOS reconhecer
corretamente o novo tamanho do sistema de arquivos DOS), utilize o
"fdisk" (disponvel no "boot2") para alterar o tamanho 
da partio DOS e criar a nova partio (de acordo com os tamanhos anotados).

.sp
Se houver problemas com o novo sistema de arquivos DOS
(de tamanho reduzido), o tamanho original pode ser restaurado atravs do
comando

.sp
.nf
		dd if=dos_sb of=/dev/dos_c
.fi
.sp
onde "/dev/dos_c" deve ser substitudo pelo dispositivo correspondente
 partio DOS.

.ip "13." 4
clri <arquivo> ...
.sp
Remove entradas de diretrio DOS (modo de pnico).
Em casos de emergncia, remove <arquivos>, que por alguma razo,
o comando "rm" (ver abaixo) no consegue remover. Aps o uso, deve
ser usado o comando "fsck" (ver abaixo) para restaurar a consistncia
do sistema de arquivos DOS.
Este comando no  indicado para o uso normal.

.(t
.ip "14." 4
cmp <arquivo> ...
.sp
Compara pares de arquivos correspondentes entre os sistemas DOS e TROPIX.
O comando "cmp" nada comenta sobre arquivos iguais.
Para arquivos diferentes, indica o nmero do primeiro caractere
diferente, ou se um dos arquivos  prefixo do outro.
Se NO forem iguais, informa qual das verses  a mais recente.
.)t
.sp
Se algum nome de <arquivo> for um caminho com vrios componentes,
o nome completo ser usado apenas para referenciar o arquivo DOS;
no TROPIX ser utilizado o diretrio corrente.
Os contedos dos arquivos DOS so convertidos,
conforme o modo de representao de dados.
Os meta-caracteres "?*[]!" so expandidos no sistema DOS.

.ip "15." 4
cmpget <arquivo> ...
.sp
Como "cmp", acima.

.ip "16." 4
cmpgettree [-ui.s] [-p "<p>"] [-P "<P>"] <rvore>
.sp
O comando "cmpgettree" caminha a <rvore> DOS comparando cada
arquivo com o arquivo correspondente da <rvore> TROPIX.
Se for encontrada alguma diferena entre as rvores, ela  indicada,
e de acordo com a opo "-u" a rvore TROPIX pode
ser atualizada.
.sp
Para maiores detalhes sobre as opes "-ui.spP" consulte "cmptree" (cmd).
Normalmente no so selecionados arquivos com o atributo "h"
(ver "chmod" acima). A opo "-." seleciona tambm estes arquivos.
.sp
O comando "cmpgettree" nada comenta sobre pares de arquivos iguais.
Para arquivos diferentes, indica o nmero do primeiro caractere
diferente, ou se um dos arquivos  prefixo do outro.
Se NO forem iguais, informa qual das verses  a mais recente.
.sp
O nome completo da <rvore>  usado tanto para referenciar o
sistema TROPIX como o DOS.
Os contedos dos arquivos DOS so convertidos,
conforme o modo de representao de dados.
Os meta-caracteres "?*[]!" so expandidos no sistema DOS.

.ip "17." 4
cmpput <arquivo> ...
.sp
Como "cmp", acima, s que
se algum nome de <arquivo> for um caminho com vrios componentes,
o nome completo ser usado apenas para referenciar o arquivo TROPIX;
no DOS ser utilizado o diretrio corrente. Alm disto,
os meta-caracteres "?*[]!" so expandidos no sistema TROPIX.

.(t
.ip "18." 4
cmpputtree [-ui.s] [-p "<p>"] [-P "<P>"] <rvore>
.sp
O comando "cmpputtree" caminha a <rvore> TROPIX comparando cada
arquivo com o arquivo correspondente da <rvore> DOS.
Se for encontrada alguma diferena entre as rvores, ela  indicada,
e de acordo com a opo "-u" a rvore DOS pode
ser atualizada.
.)t
.sp
Para maiores detalhes sobre as opes "-ui.spP" consulte "cmptree" (cmd).
.sp
O comando "cmpputtree" nada comenta sobre pares de arquivos iguais.
Para arquivos diferentes, indica o nmero do primeiro caractere
diferente, ou se um dos arquivos  prefixo do outro.
Se NO forem iguais, informa qual das verses  a mais recente.
.sp
O nome completo da <rvore>  usado tanto para referenciar o
sistema TROPIX como o DOS.
Os contedos dos arquivos DOS so convertidos,
conforme o modo de representao de dados.
Os meta-caracteres "?*[]!" so expandidos no sistema TROPIX.

.ip "19." 4
compac [-v]
.sp
Compacta o sistema de arquivos. Este comando  um desfragmentador
especial para retirar do final do sistema de arquivos aqueles
arquivos que contm "cluster"s os quais os desfragmentadores
tais como o DEFRAG ou SPEED DISK (dos NORTON UTILITIES)
consideram que "no devem ser movidos".
Isto  til para um posterior uso do comando "chsize" (veja acima).

.sp
Lembre-se no entanto, ao usar o comando "compac", de que ele no tem
conscincia das possveis conseqncias ocasionadas por
estas mudanas no funcionamento do DOS/Windows.

.bc	/*************************************/
.ps
O comando "compac"
deve (naturalmente) ser usado somente aps o sistema de
arquivos tiver sido desfragmentado por um desfragmentador
do Windows, e ele ter decidido no mover alguns "cluster"s
no final do sistema de arquivos.
Mesmo assim, deve ser usado apenas quando 
.ec	/*************************************/

.sp
Este comando  interativo; a cada ciclo ele imprime o grau de
compacticidade e o espao livre ao final do sistema de arquivos
(100 \% de compacticidade significa que todos os "cluster"s ocupados
esto contguos no incio do sistema de arquivos).

.sp
Em seguida  impresso o nome do arquivo que contm o ltimo
"cluster" ocupado do sistema de arquivos, e o usurio  consultado
se deseja mover o arquivo para o incio do sistema.

.sp
Se a resposta for afirmativa, o arquivo  movido,
e o ciclo se repete. Deste modo podemos mover arquivos at que haja
um certo espao livre desejado ao final do sistema para um
"chsize" posterior.

.ip "20." 4
del [-ifv] <arquivo> ...
.sp
Como "rm", abaixo.

.(t
.ip "21." 4
df
.sp
Imprime o espao total e livre do sistema de arquivos em KB.
Informa tambm o nome do dispositivo, se est protegido contra
escritas ("RO") e a identificao contida no super-bloco do sistemas
de arquivos.
.)t

.(t
.ip "22." 4
diff <arquivo>
.sp
Compara diferencialmente arquivos entre os sistemas TROPIX e DOS.
Este comando copia o arquivo DOS para uma arquivo temporrio,
compara as verses atravs de "diff" (cmd) e mostra as diferenas
com "show" (cmd).
A ordem das diferenas indicadas  TROPIX, DOS.
.)t
.sp
Se o nome do <arquivo> for um caminho com vrios componentes,
o nome completo ser usado apenas para referenciar o arquivo TROPIX;
no DOS ser utilizado o diretrio corrente.
O contedo do arquivo DOS  convertido,
conforme o modo de representao de dados.
Os meta-caracteres "?*[]!" so expandidos no sistema DOS.

.ip "23." 4
du [-sa] [<rvore> ...]
.sp
Informa sobre o espao usado (em KB) por todos os arquivos e diretrios 
contidos em cada <rvore> dada do sistema de arquivos.
.sp
Se for dada a opo "-s", imprime somente o total de cada <rvore>.
Se for dada a opo "-a", imprime uma linha para cada arquivo.
Os meta-caracteres "?*[]!" so expandidos no sistema DOS.

.(t
.ip "24." 4
dir [-d] [<diretrio> ...]
.sp
Como "lc", abaixo.
.)t

.ip "25." 4
dump <arquivo>
.sp
Como "xd", abaixo.

.ip "26." 4
echo [-d] <argumento> ...
.sp
Ecoa os <argumento>s (expandidos no sistema DOS).
Isto  til para saber como os argumentos iro ser expandidos,
antes de utilizar um comando cujos argumentos so expandidos no DOS.
.sp
Se for dada a opo "-d", os argumentos sero impressos em um formato
vetorial (ao invs de linear).

.ip "27." 4
echoget [-d] <argumento> ...
.sp
Como "echo", acima.

.ip "28." 4
echoput [-d] <argumento> ...
.sp
Como "echo", acima, s que
os meta-caracteres "?*[]!" so expandidos no sistema TROPIX.

.ip "29." 4
eh [<n>]
.sp
Edita (e opcionalmente executa) o comando de nmero <n> do histrico.
Se <n> for omitido, edita o ltimo comando presente no histrico.
A edio  realizada pela funo "edit" (libc).
Aps a edio, o usurio  consultado se deseja realmente executar
o comando editado.

.(t
.ip "30." 4
era [-ifv] <arquivo> ...
.sp
Como "rm", abaixo.
.)t

.ip "31." 4
exit
.sp
Encerra o programa. Um EOF (normalmente <^D>) tem o mesmo efeito.

.ip "32." 4
fsck [-f]
.sp
Verifica a consistncia do sistema de arquivos. Se o sistema de arquivos
estiver montado com permisso de escrita, o usurio  consultado
se deseja consertar alguns erros mais simples.
Se for dada a opo "-f", "fsck" conserta sem consultar o usurio.

.sp
De modo normal, no entanto, recomendamos efetuar o conserto
do sistema de arquivos MS-DOS atravs do prprio MS-DOS.

.(t
.ip "33." 4
get [-ifv] <arquivo> ...
.sp
Copia arquivos DOS para o diretrio corrente do sistema TROPIX.
Para detalhes sobre as opes "-ifv", use "get -H".
.)t
.sp
Se algum nome de <arquivo> for um caminho com vrios componentes,
o nome completo ser usado apenas para referenciar o arquivo DOS.
Os contedos dos arquivos DOS so convertidos,
conforme o modo de representao de dados.

.ip "34." 4
gettree [-ifv.s] [-p "<p>"] [-P "<P>"] <rvore>
.sp
Copia rvores DOS para o sistema TROPIX.
Para maiores detalhes sobre as opes "-ifv.spP" consulte "cptree" (cmd).
Normalmente no so selecionados arquivos com o atributo "h"
(ver "chmod" acima). A opo "-." seleciona tambm estes arquivos.
.sp
O nome completo da <rvore>  usado tanto para referenciar o
sistema TROPIX como o DOS.
Os contedos dos arquivos DOS so convertidos,
conforme o modo de representao de dados.

.ip "35." 4
h
.sp
Imprime os comandos do histrico. Nesta verso, o histrico armazena
os ltimos 20 comandos executados.

.ip "36." 4
help
.sp
Imprime uma lista de todos os comandos disponveis. Em certos
casos, recomenda o uso de alguns comandos.
Para obter um resumo de um <comando>, use "<comando> -H".

.ip "37." 4
image
.sp
Altera o modo de representao de dados para BINRIO.

.ip "38." 4
iso
.sp
Altera o modo de representao de dados para ISO (ASCII).

.(t
.ip "39." 4
lc [<diretrio> ...]
.sp
Imprime o contedo dos <diretrio>s dados.
Se no for dado nenhum <diretrio> ser considerado o diretrio corrente.
.)t

.sp
Se o ambiente contiver a varivel MODECOLOR, os diversos tipos
de arquivos sero impressos com cores distintas (veja "modecolor" (libc)).

.(t
.ip "40." 4
lfn [off|8.3] [on|255|w95|W95]
.sp
Indica o modo de criao dos nomes DOS. Com o argumento "off" ou "8.3",
os nomes sero criados no estilo "antigo" ou "ortodoxo", isto , da poca
pr-windows-95, com nome de at 8 caracteres e uma extenso de at 3
caracteres.
.)t
.sp
Com o argumento "on", "255", "w95" ou "W95",
os nomes sero criados no estilo "novo", isto , da poca
windows-95/98, com nomes de at 255 caracteres.

.(t
.ip "41." 4
ls [-al] <arquivo> ...
.sp
Imprime caractersticas dos <arquivo>s dados.
Se um <aquivo> for um diretrio, imprime caractersticas de todos
arquivos do diretrio.
Se no for dado nenhum <arquivo> ser considerado o diretrio corrente.
.)t
.sp
Com a opo "-a" so listados tambm as entradas "." e ".." dos diretrios.
Sem a opo "-l" so listados apenas os nomes dos arquivos;
com esta opo so listados tambm o tipo do arquivo, os seus atributos,
o seu tamanho e sua data. Se o arquivo tiver o atributo "h"
(ver "chmod" acima), o seu nome vir entre parenteses.

.sp
Se o ambiente contiver a varivel MODECOLOR, os diversos tipos
de arquivos sero impressos com cores distintas (veja "modecolor" (libc)).

.ip "42." 4
md <diretrio> ...
.sp
Como "mkdir", abaixo.

.ip "43." 4
mkd <diretrio> ...
.sp
Como "mkdir", abaixo.

.ip "44." 4
mkdir <diretrio> ...
.sp
Cria diretrios DOS.
O diretrio pai de cada <diretrio> a ser criado j deve existir.

.ip "45." 4
mkfile <arquivo> <MB sz>
.sp
Cria o <arquivo> DOS de tamanho <MB sz>.
O espao em disco necessrio  alocado em uma rea contgua.
Se o sistema de arquivos no possuir <MB sz> contguos,
 emitida uma mensagem de erro, e o arquivo no  criado.
O contedo do arquivo NO  inicializado (ou em outras palavras,
permanecem os valores j existentes nos blocos do disco).

.sp
O objetivo usual deste comando  criao dos arquivos necessrios
para a instalao do TROPIX em arquivos de uma partio DOS.

.ip "46." 4
mkfs [-v] [-sfc ...] [-01] [-c <b>] [<dispositivo>]
.sp
Cria um sistema de arquivos DOS.
Para detalhes sobre as opes do comando, use "mkfs -H".
.sp
Se no for dado o nome do <dispositivo>, ser usado o corrente.

.bc	/*************************************/
.sp
Repare que com a criao de sistemas de arquivos com parmetros no
convencionais h o risco de desentendimentos (fatais)
com o sistema operacional MS-DOS j que ele (aparentemente)
no examina o superbloco dos sistemas de arquivos.
.sp
Embora que o programa "dosmp" possa ser usado para criar sistemas de
arquivos nos discos rgidos, isto deve ser feito com muito cuidado,
pela mesma razo do pargrafo anterior.
.ec	/*************************************/

.ip "47." 4
mkv <nome_do_volume>
.sp
Cria um nome de volume de sistema de arquivos DOS. Repare que o
<nome_do_volume> deve vir normalmente na raiz do sistema de arquivos.

.ip "48." 4
mount [-01] [<dispositivo>]
.sp
Monta o <dispositivo> com um sistema de arquivos DOS.
Para detalhes sobre as opes do comando, use "mount -H".
.sp
Se o nome do <dispositivo> no for dado, ser usado o dispositivo corrente.
Neste caso, o meio (por exemplo, um disquete) pode ser trocado,
para ser montado um novo sistema de arquivos.

.ip "49." 4
mv [-ifv] <arquivo1> <arquivo2>
.br
mv [-ifv] <arquivo1> [<arquivo2> ...] <diretrio>
.sp
Move (troca o nome) de arquivos (regulares ou volumes) DOS.
Para detalhes sobre as opes do comando, use "mv -H".
.sp
Em sua primeira forma, o comando "mv" move
(troca o nome de) <arquivo1> para <arquivo2>.
Na segunda forma, um ou mais <arquivo>s so movidos para o
<diretrio> especificado, com seus nomes originais.

.ip "50." 4
mvtree <diretrio1> <diretrio2>
.sp
Move (troca o nome) de diretrios DOS.
Se o <diretrio2> ainda no existe, o novo nome de <diretrio1>
ser <diretrio2>. Em caso contrrio, ser <diretrio2>/<nome1>, onde
<nome1>  o ltimo componente do caminho de <diretrio1>.

.ip "51." 4
param
.sp
Imprime os parmetros do sistema de arquivos DOS montado.

.ip "52." 4
path
.sp
Como "pwd", abaixo.

.(t
.ip "53." 4
put [-ifv] <arquivo> ...
.sp
Copia arquivos TROPIX para o diretrio corrente do sistema DOS.
Para detalhes sobre as opes "-ifv", use "get -H".
.)t
.sp
Se algum nome de <arquivo> for um caminho com vrios componentes,
o nome completo ser usado apenas para referenciar o arquivo TROPIX.
Os contedos dos arquivos DOS so convertidos,
conforme o modo de representao de dados.

.ip "54." 4
puttree [-ifv.s] [-p "<p>"] [-P "<P>"] <rvore>
.sp
Copia rvores TROPIX para o sistema DOS.
Para maiores detalhes sobre as opes "-ifv.spP" consulte "cptree" (cmd).
.sp
O nome completo da <rvore>  usado tanto para referenciar o
sistema TROPIX como o DOS.
Os contedos dos arquivos DOS so convertidos,
conforme o modo de representao de dados.

.ip "55." 4
pwd
.sp
Imprime o diretrio corrente DOS.

.ip "56." 4
quit (ou simplesmente "q")
.sp
Encerra o programa. Um EOF (normalmente <^D>) tem o mesmo efeito.

.ip "57." 4
rd <diretrio> ...
.sp
Como "rmdir", abaixo.

.ip "58." 4
ren [-ifv] <arquivo1> <arquivo2>
.br
ren [-ifv] <arquivo1> [<arquivo2> ...] <diretrio>
.sp
Como "mv", acima.

.ip "59." 4
rm [-ifv] <arquivo> ...
.sp
Remove arquivos DOS (regulares ou volumes).
Para detalhes sobre as opes "-ifv", use "rm -H".

.(t
.ip "60." 4
rmd <diretrio> ...
.sp
Como "rmdir", abaixo.
.)t

.ip "61." 4
rmdir <diretrio> ...
.sp
Remove diretrios DOS.

.(t
.ip "62." 4
rmtree [-fv] <rvore>
.sp
Remove uma rvore DOS.
Para detalhes sobre as opes "-fv", use "rmtree -H".
.)t

.ip "63." 4
rmv [-ifv] <arquivo> ...
.sp
Como "rm", acima.

.ip "64." 4
ro
.sp
Permite apenas leituras no sistema de arquivos DOS.

.ip "65." 4
rv [-ifv] <arquivo> ...
.sp
Como "rm", acima.

.(t
.ip "66." 4
rw
.sp
Permite leituras e escritas no sistema de arquivos DOS.
Este comando no  aceito se foi dada a opo "-r" para "dosmp".
.)t

.(t
.ip "67." 4
set
.sp
Como "status", abaixo.
.)t

.ip "68." 4
seta
.sp
Altera o modo de representao de dados para ISO (ASCII).

.ip "69." 4
setb
.sp
Altera o modo de representao de dados para BINRIO.

.(t
.ip "70." 4
show <arquivo>
.sp
Mostra um arquivo na tela do terminal.
Este comando copia o arquivo DOS para uma arquivo temporrio,
e mostra-o atravs de "show" (cmd).
.)t
.sp
O contedo do arquivo DOS  convertido,
conforme o modo de representao de dados.

.(t
.ip "71." 4
stat
.sp
Como "status", abaixo.
.)t

.ip "72." 4
status
.sp
Informa o estado do sistema de arquivos e o modo de representao
de dados corrente.

.ip "73." 4
sys [-v] [-d <dir>]
.sp
Grava os arquivos "IO.SYS", "DRVSPACE.BIN", "MSDOS.SYS" e "COMMAND.COM"
na raiz do sistema de arquivos DOS para torn-lo carregvel.

.sp
Estes arquivos so procurados no diretrio <dir> (normalmente ".").

.(t
.ip "74." 4
tdat <arquivo> ...
.sp
Como "touch", abaixo.
.)t

.ip "75." 4
touch <arquivo> ...
.sp
Atribui a data atual a cada <arquivo> DOS dado.

.ip "76." 4
tree [-l] [<rvore> ...]
.sp
Como "walk", abaixo.

.ip "77." 4
type <arquivo>
.sp
Como "cat", acima.

.(t
.ip "78." 4
umount
.sp
O sistema de arquivos  desmontado, e "dosmp" aguarda que outro
seja montado (atravs de "mount", acima) ou que seja criado um (atravs
de "mkfs", acima).
.)t

.(t
.ip "79." 4
walk [-l] [<rvore> ...]
.sp
Percorre rvores DOS listando os nomes dos arquivos.
Se no for dada nenhuma <rvore>,  percorrido o diretrio corrente.
.)t
.sp
Normalmente,  dado o tipo do arquivo, seu tamanho e nome.
Se for dada a opo "-l" so dados tambm o nmero do primeiro
"cluster" do arquivo e outras informaes.

.sp
Se o ambiente contiver a varivel MODECOLOR, os diversos tipos
de arquivos sero impressos com cores distintas (veja "modecolor" (libc)).

.ip "80." 4
waste
.sp
Analisa o sistema de arquivos e imprime o espao total (em KB)
desperdiados nos finais dos "cluster"s alocados aos arquivos.

.ip "81." 4
xd <arquivo>
.sp
"Dump" em hexadecimal e ISO do <arquivo>,
que pode ser regular ou um diretrio.
.sp
Se o <arquivo> for regular, o seu contedo  convertido,
conforme o modo de representao de dados.

.ip "82." 4
xh [<n>]
.sp
Excuta o comando de nmero <n> do histrico.
Se <n> for omitido, executa o ltimo comando presente no histrico.

.ep
.bc	/*************************************/
.in -3
.ec	/*************************************/

.in
.sp
.b OBSERVAO
.in 5
Como o sistema de arquivos DOS no tem o conceito de elo fsico nem simblico,
os comandos de cpia no testam a existncia de elos no sistema TROPIX.
Isto significa (por exemplo) que se durante uma operao de cpia
para o DOS, dois nomes de arquivos se referirem a um mesmo arquivo TROPIX,
ele ser copiado duas vezes, uma vez com cada nome.

.in
.sp
.b AGRACECIMENTO
.in 5
O autor agradece a Norival Ribeiro Figueira cujo programa "pldos" (cmd)
foi meticulosamente estudado, e serviu de inspirao para o "dosmp".

.in
.sp
.(t
.b
VEJA TAMBM
.r
.in 5
.wo "(libc): "
edit, modecolor
.br
.wo "(cmd):  "
pldos, chmod, cptree, cmptree, diff, show
.br
.wo "(fmt):  "
ambiente, fstab
.br
.)t

.in
.sp
.b ESTADO
.in 5
Efetivo.

.in
