/*
 ****************************************************************
 *								*
 *			do_cd.c					*
 *								*
 *	Muda de diretrio corrente				*
 *								*
 *	Verso	3.0.0, de 28.10.93				*
 *		3.0.0, de 10.06.95				*
 *								*
 *	Mdulo: DOSMP						*
 *		Utilitrios Sofisticados			*
 *		Categoria B					*
 *								*
 *	TROPIX: Sistema Operacional Tempo-Real Multiprocessado	*
 *		Copyright  2000 NCE/UFRJ - tecle "man licena"	*
 * 		Inspirado no PLDOS de Norival Ribeiro Figueira	*
 * 								*
 ****************************************************************
 */

#include <sys/types.h>

#include <stdio.h>
#include <string.h>
#include <errno.h>

#include "../h/common.h"
#include "../h/dos.h"
#include "../h/proto.h"

/*
 ******	Prottipos de funes ***********************************
 */
void	do_cd_help (void);

/*
 ******	Definies globais **************************************
 */
entry int	cwd_cluster;		/* Diretrio corrente */

/*
 ****************************************************************
 *	Muda de diretrio corrente				*
 ****************************************************************
 */
void
do_cd (int argc, const char *argv[])
{
	int		opt;
	const char	*dir_nm;
	DOSSTAT		z;

	/*
	 *	Analisa as opes
	 */
	while ((opt = cmd_getopt (argv, "H")) >= 0)
	{
		switch (opt)
		{
		    case 'H':			/* Help */
			do_cd_help ();
			return;

		    default:			/* Erro */
			fprintf (stderr, "\n");
			do_cd_help ();
			return;
		}
	}

	/*
	 *	Pequena consistncia
	 */
	argc -= cmd_optind;
	argv += cmd_optind;

	if (argc != 1)
		{ do_cd_help (); return; }

	dir_nm = argv[0];

	/*
	 *	Procura o diretrio
	 */
	if (dos_stat (dir_nm, &z) < 0)
	{
		printf
		(	"%s: No achei o diretrio \"%s\" (%s)\n",
			cmd_nm, dir_nm, strerror (errno)
		);
		return;
	}

	if (!Z_ISDIR (z.z_mode))
	{
		printf
		(	"O arquivo \"%s\" no  um diretrio \n",
			dir_nm
		);
		return;
	}

	cwd_cluster = z.z_cluster;

}	/* end do_cd */

/*
 ****************************************************************
 *	Resumo de utilizao do programa			*
 ****************************************************************
 */
void
do_cd_help (void)
{
	fprintf
	(	stderr,
		"%s - troca de diretrio corrente DOS\n"
		"\nSintaxe:\n"
		"\t%s <novo_diretrio>\n",
		cmd_nm, cmd_nm
	);

}	/* end help */
