.bp
.he 'DU (cmd)'TROPIX: Manual de Referncia'DU (cmd)'
.fo 'Atualizado em 27.10.04'Verso 4.6.0'Pag. %'

.b NOME
.in 5
.wo "du -"
informa sobre o uso de disco
.br

.in
.sp
.b SINTAXE
.in 5
.(l
du [-dam.sN] [-b <sz>] [-p "<p>"] [-P "<P>"] [<rvore> ...]
.)l

.bc	/*************************************/
Opes:	-d: Informa tambm para cada subrvore
	-a: Informa tambm para cada arquivo
	-m: Escreve os valores em MB (ao invs de KB)
	-.: Lista tambm arquivos ocultos (".old" ...)
	-s: Adiciona os padres dos fontes em "C"
	-N: L os nomes das <rvore>s de "stdin"
	-b: Use <sz> como o tamanho do bloco
	-p: Seleciona arquivos atravs dos padres <p> de incluso
	-P: Seleciona arquivos atravs dos padres <P> de excluso
.ec	/*************************************/

.in
.sp
.b DESCRIO
.in 5
O comando "du" informa sobre o espao ocupado pelos arquivos e diretrios
contidos em cada <rvore> dada, no sistema de arquivos (em disco).

.sp
O espao  dado normalmente em KB (veja a opo "-m" abaixo),
e NO considera os arquivos "ocultos" (arquivos cujos "caminhos" contm
algum componente que comea com um ponto - veja a opo "-.").

.sp
Normalmente, <rvore>  o nome de um diretrio (a raiz) cujos arquivos
e subdiretrios (recursivamente) definem a rvore.
Se <rvore> for o nome de um arquivo (e no de um diretrio),
a rvore consiste em apenas este arquivo.
Se no for dada nenhuma <rvore>, ser considerada a rvore cuja raiz 
o diretrio corrente.

.sp
Os tamanhos dos arquivos so arredondados para o tamanho do bloco
do sistema de arquivos nos quais esto contidos, para dar um valor
representativo do espao efetivamente ocupado no meio (veja a opo "-b" abaixo).

.sp
Sem opes, o comando imprime uma linha para cada <rvore> dada.
.bc	/*************************************/
e para cada um de seus subdiretrios.
.ec	/*************************************/

.sp
As opes do comando so:

.in +3
.ip -d
Imprime uma linha tambm para cada subrvore.

.ip -a
Imprime uma linha tambm para cada arquivo.

.ip -m
Imprime os resultados em MB (ao invs de KB).

.ip "-."
Seleciona tambm nomes de arquivos ocultos.
Normalmente, arquivos cujos nomes contm algum componente que
comea com um ponto (exceto "..") no so selecionados
(como por exemplo "/usr/src/sys/.old/rot.c").
Esta opo faz com que estes arquivos sejam tambm considerados.


.ip "-s"
Esta opo  a abreviatura de
.sp
.nf
			-p "*[Mm]akefile *.[cshryv]"
.fi
.sp
e  til para selecionar arquivos relacionados com a linguagem "C".
Padres adicionais podem ser dados com a opo "-p" (veja abaixo).

.ip -N
L os nomes das rvores de "stdin".

.ip "-b"
Use <sz> como o tamanho do bloco para o arredondamento dos arquivos.
Podem ser usados os sufixos "c" ou "C" para especificar multiplicao
por 2048, "k" ou "K" para especificar multiplicao por 1024,
"b" ou "B" para especificar multiplicao por 512.

.ip "-p"
Padres de incluso:
Seleciona apenas arquivos cujos nomes so aceitos por um dos <padres> dados.
Cada padro  uma expresso regular, como as do "sh" (cmd),
formada com "*", "?", "!", "[...]" (ver "patmatch" (libc)).
Os padres so aplicados ao nome completo do arquivo,
sem considerar o caractere "/" como especial.
Um caractere branco ou <ht> indica o final de um padro, de tal modo que
uma nica opo pode conter vrios padres
(desde que venham entre aspas ou apstrofes).
Ao total podemos ter at 20 <padres>.

.ip -P
Padres de excluso:
Esta opo  anloga  opo "-p", exceto que os padres so usados
para a excluso de arquivos (ao invs de incluso).
Todos os arquivos cujos nomes so
aceitos por estes padres no so selecionados, mesmo que tenham sido
aceitos pelos padres das opes "-p" ou "-s".

.ep
.in -3


.in
.sp
.b OBSERVAES
.in 5
Um arquivo com mais de um elo fsico s  considerado uma nica vez.

.sp
No caso de elos simblicos, so computados os espaos ocupados
pelos prprios elos, e no pelos arquivos referenciados.

.sp
No so computados os blocos indiretos dos arquivos.

.sp
Arquivos com "buracos" (ver "lseek" (sys)) so computados incorretamente.

.in
.sp
.(t
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd): "
df
.br
.wo "(sys): "
lseek
.br
.wo "(libc):"
patmatch
.br
.)t

.in
.sp
.b ESTADO
.in 5
Efetivo.
.in
