.bp 1
.he 'ED (cmd)'TROPIX: Manual de Referncia'ED (cmd)'
.fo 'Atualizado em 27.04.97'Verso 3.0.0'Pag. %'

.b NOME
.in 5
ed - editor de textos orientado por linhas

.in
.sp
.b SINTAXE
.in 5
ed [nome]

.in
.sp
.b DESCRIO
.in 5
O programa "ed"  um editor de textos orientado por linhas.

.br
.sp
Se o parmetro "nome" estiver presente, "ed" l o arquivo correspondente
simulando um comando "e" (edit), descrito abaixo.

.br
.sp
O editor "ed" opera em uma cpia do arquivo em edio.
Quaisquer alteraes realizadas na cpia
no afetaro o arquivo at
que um comando "w" (write) seja executado.
Chamaremos a cpia do arquivo em edio de
.b
"buffer".
.r

.br
.sp
Os comandos de "ed" tm uma estrutura simples e regular:
zero, um ou dois endereos seguidos de um comando com apenas um caractere,
possivelmente acompanhado de argumentos e sufixos.
Os endereos especificam as linhas no "buffer" atingidas pelo comando.
Na falta de endereos so assumidos endereos pr-estabelecidos.

.br
.sp
.b Endereamento:
.in 5
.sp
O endereamento de linhas no "buffer"
baseia-se no conceito de linha corrente.
De modo geral a linha corrente  a ltima linha afetada
por um comando; entretanto o efeito exato na linha corrente
 explicado na discusso dos comandos.
Endereos podem ser construidos do seguinte modo:
.br

.in 10
.ip 1. 4
O caractere "." enderea a linha corrente.

.ip 2. 4
O caractere "$" enderea a ltima linha no "buffer".

.ip 3. 4
Um nmero decimal "n" enderea a linha de ordem "n'sima" no "buffer".

.ip 4. 4
A sequncia "'m" enderea a linha marcada com o nome "m",
que deve ser uma letra minscula.
Linhas so marcadas com o comando "k" (mark), que ser descrito adiante.

.ip 5. 4
Uma expresso regular entre barras ("/expresso/")
enderea a linha encontrada buscando-se avante aps a linha corrente
ou aps o endereo especificado at ento
e parando na primeira linha que contem uma cadeia
que corresponda  expresso regular.
Se necessrio a busca d a volta, passando pelo fim do "buffer".

.ip 6. 4
Uma expresso regular entre interrogaes ("?expresso?")
enderea a linha encontrada buscando-se retroativamente
antes da linha corrente
ou do endereo especificado at ento
e parando na primeira linha que contem uma cadeia
que corresponda  expressao regular.
Se necessrio a busca d a volta, passando pelo incio do "buffer".

.ip 7. 4
Um endereo seguido de um "+" (sinal de soma)
ou de um "-" (sinal de subtrao)
seguido de um nmero decimal especifica um endereo mais ou menos
o nmero indicado de linhas.

.ip 8. 4
Se um endereo comea com "+" ou com  "-" a adio ou subtrao
 tomada como em relao a linha corrente, isto ,
"-5" equivale  ".-5".

.ip 9. 4
Se um endereo termina com "+" (ou "-"), ento um  somado (ou subtraido).
Como consequncia desta regra e da regra 8,
o endereo "-" se refere  linha anterior a linha corrente.
Mais ainda, "-" e "+" no final de um endereo tm efeito cumulativo,
assim "--" se refere a linha corrente menos dois.
.lp

.br
.in 5
.sp
.b 'Expresses Regulares:'

.br
.in 5
.sp
O editor "ed" suporta uma forma limitada de expresses regulares.
Uma expresso regular especifica um conjunto de cadeias de caracteres.
Dizemos que um membro deste conjunto de cadeias
corresponde  expresso regular.
Na definio de expresso regular a seguir a palavra "caractere"
significa qualquer caractere  exceo de <nl>:

.in 10
.br
.ip 1. 4
Qualquer caractere exceto um caractere especial corresponde a si prprio.
Caracteres especiais so o delimitador da expresso regular
e mais os caracteres "\", "[", "." e em alguns casos "^", "*" e "$".

.ip 2. 4
Um "\" (barra invertida) seguido de qualquer caractere corresponde
ao prprio caractere.

.ip 3. 4
Um "." (ponto) corresponde a qualquer caractere.

.ip 4. 4
Uma cadeia no vazia "s" entre colchetes "[s]" (ou "[^s]")
corresponde a qualquer caractere presente (ou ausente) "s".
Uma sub-cadeia "a-b" dentro de "s",
com "a" e "b" em ordem crescente ISO,
significa o conjunto de caracteres ISO entre "a" e "b", inclusive.
Os caracteres "]", "-" e "\" podem ser especificados precedendo-os com "\".

.ip 5. 4
Uma expresso regular da forma 1 at 4 seguido de "*"
corresponde a zero ou mais ocorrncias da expresso regular.

.ip 6. 4
Uma expresso regular "x" da forma 1 at 6, seguida
de uma expresso regular "y" da forma 1 at 5
corresponde a uma ocorrncia de "x" seguida de uma ocorrncia de "y"
com a correspondncia para "x" sendo a mais longa
que permita a correspondncia para "y".

.ip 7. 4
Uma expresso regular da forma 1 at 6 precedida por "^"
(ou seguida de "$"),
 restrita a correspondncias no incio (ou no fim)
de uma linha.

.ip 8. 4
Uma expresso regular da forma 1 at 7 corresponde
 mais longa das correspondncias mais  esquerda da linha.

.ip 9. 4
Uma expresso regular vazia
equivale a cpia da ltima expresso regular procurada.
.lp
.in 5

Expresses regulares so usadas em endereos para especificar linhas
e no comando "s" (substitute), descrito abaixo,
para especificar a poro da linha que ser substituida.
.br


.in 5
.br
.sp
.b 'Modo Entrada de Texto:'
.br

.in 5
.sp
Alguns comandos permitem a adio de texto novo no "buffer".
Enquanto "ed" est recebendo texto,
dizemos que ele est em modo de entrada de texto.
Neste modo, nenhum comando  reconhecido;
toda entrada  simplesmente acrescentada ao "buffer".
O modo de entrada de texto termina  quando entramos
uma linha contendo apenas "." (ponto).
Apos a execuo destes comandos
a linha corrente ser a ltima linha no texto entrado
ou, se este for nulo, a linha endereada para o comando.
.br

.in 5
.br
.sp
.b Comandos:
.br

.in 5
.sp
Os comandos de "ed" podem requerer zero, um ou dois endereos.
Quando so fornecidos endereos a menos,
"ed" assume endereos pr-estabelecidos.
 um erro dar mais endereos do que o comando espera.
.br

.sp
Se no for especificado nenhum comando
aps o endereamento
o comando ser "p" (print).
Uma linha em branco faz da linha seguinte  linha corrente
a nova linha corrente e a mostra.
.br

.sp
Endereos so tipicamente separados por uma vrgula (",").
Quando os endereos so separados por um ponto e vrgula (";"),
o segundo endereo  calculado fazendo-se antes
o primeiro endereo como linha corrente.
Esta caracterstica pode ser usada para determinar 
a linha incial para buscas para frente e para trs ("/" e "?").
O segundo endereo de toda sequncia de dois endereos
tem que corresponder a uma linha de ordem superior
a linha correspondente ao primeiro endereo.
.br

.sp
Na lista a seguir de comandos do "ed",
os valores pr-estabelecidos para os endereos
so mostrados entre parnteses.
.br
.sp
.(b
.in 5
(.) a
.br
<texto>
.br
 .
.br

.in 10
O comando 
"a" (append)
l o texto dado
e o acrescenta ao "buffer" a partir da linha endereada.
.)b

.sp
.(b
.in 5
(.,.) c
.br
<texto>
.br
 .
.br

.in 10
O comando 
"c" (change)
remove as linhas endereadas,
e ento recebe o texto entrado
que substitui estas linhas.
Se no houver texto entrado,
a nova linha corrente ser a linha anterior s linhas removidas.
.)b

.sp
.(b
.in 5
(., .) d[p]
.br
.in 10
O comando 
"d" (delete)
remove as linhas endereadas do "buffer".
A linha originalmente aps a ltima linha removida
se tornar  a linha corrente;
se as linhas removidas estavam originalmente no final do "buffer",
a ltima linha no "buffer" ser a nova linha corrente.
Se o sufixo "p" estiver presente a nova linha corrente  mostrada.
.br
.)b

.sp
.(b
.in 5
e [arquivo]
.br

.in 10
O comando 
"e" (edit)
causa a remoo de todas linhas no "buffer"
e a leitura de "arquivo" para o "buffer".
O nmero de linhas e caracteres lidos  escrito.
O nome "arquivo"  lembrado para poder ser usado em sub-sequentes
comandos "r", "w" e "e" como nome de arquivo pr-estabelecido.
.)b

.sp
.(b
.in 5

E [arquivo]
.br
.in 5
e! [arquivo]
.br
.in 10
Estes comandos so equivalentes ao comando "e",
exceto que nenhuma mensagem de erro  enviada
se o "buffer" j foi alterado
desde sua ltima atualizao no sistema de arquivos.
.br
.)b

.sp
.(b
.in 5

f [arquivo]
.br
.in 10
O comando 
"f" (filename)
informa o nome lembrado para o arquivo em edio.
Se "arquivo"  dado, o nome correntemente lembrado  trocado para "arquivo".
.br
.)b

.sp
.(b
.in 5

(1,$) g/expresso regular/ [comando]
.br
.in 10
O comando 
"g" (global)
marca todas as linhas endereadas
onde h uma ocorrncia de "expresso regular"
e para cada uma dessas linhas
a torna a linha corrente
e executa "comando"
Os comandos "a", "i", "c",
"g" e "v" no so permitidos.
.)b

.sp
.(b
.in 5
g [comando]
.br
.in 10
O comando 
"g" (global)
sem especificao de expresso regular
utiliza as linhas marcadas no ltimo comando "g" ou "v".
.)b

.sp
.(b
.in 5
(.) i
.br
<texto>
.br
 .
.br

.in 10
O comando 
"i" (insert)
acrescenta  o texto antes da linha endereada.
Este comando difere do comando "a" apenas no local para colocao do texto.
.)b

.sp
.(b
.in 5
(., .+1) j
.br
.in 10
O comando
"j" (join)
transforma as linhas endereadas
em uma nica linha.
A linha resultante ser a nova linha corrente.
.)b

.sp
.(b
.in 5
(.) k m
.br
.in 10
O comando 
"k" (mark)
marca a linha endereada com a letra minscula "m".
O endereamento "'m" se refere a esta linha.
.)b

.sp
.(b
.in 5
(., .) l
.br
.in 10
O comando 
"l" (list)
mostra as linhas endereadas
de uma forma no ambgua.
Os caracteres <bs> so indicados por "<"
e caracteres de tabulao (<ht>) so indicados por ">".
Linhas muito longas so quebradas
em linhas de at 72 colunas.
O final de cada linha  indicado com um "$".
.)b

.sp
.(b
.in 5
(., .) m endereo
.br
.in 10
O comando 
"m" (move)
reposiciona as linhas endereadas para aps a linha endereada
por "endereo". A ltima das linhas movidas se tornar a linha
corrente.
.)b

.sp
.(b
.in 5
(., .) n
.br
.in 10
O comando 
"n" (number)
exibe as linhas endereadas
com os nmeros das linhas e um <ht>  esquerda.
.)b

.sp
.(b
.in 5
(., .) p
.br
.in 10
O comando
"p" (print)
mostra as linhas endereadas.
A ltima linha mostrada ser a nova linha corrente.
O comando "p" pode ser colocado na mesma linha que um comando
que no realize entrada ou saida.
.)b

.sp
.(b
.in 5
(., .) P
.br
.in 10
Este comando mostra uma pgina com a linha endereada no centro.
A linha corrente permanece inalterada.
.)b

.sp
.(b
.in 5
q
.in 10
O comando 
"q" (quit)
faz com que "ed" termine.
O arquivo em edio no  automaticamente atualizado no disco.
.)b

.sp
.(b
.in 5
Q
.br
.in 5
q!
.in 10
Estes comandos so o mesmo que "q", exceto que
nenhuma mensagem de erro
ocorre se o "buffer" j foi alterado  desde
a ltima atualizao do arquivo.
.)b

.sp
.(b
.in 5
($) r [arquivo]
.br
.in 10
O comando 
"r" (read)
l  "arquivo" para o "buffer"
aps a linha endereada.
Se "arquivo" estiver ausente,
o nome corrente  utilizado.
O nome "arquivo"   lembrado se ainda no houver um nome de arquivo corrente.
Se a leitura for bem sucedida,
o nmero de  linhas e caracteres lidos  mostrado.
A nova linha corrente ser a ltima linha lida do arquivo.
A ltima linha lida do arquivo ser a nova linha corrente.
.)b

.sp
.(b
.in 5
(., .) s[n]/expresso regular/substituio/ [p]
.br
.in 10
O comando 
"s" (substitute)
busca em cada linha endereada
ocorrncias de "expresso regular"
e substitue as de ordem "n" por "substituio".
Se a ordem "n" no for especificada,
todas as ocorrncias de "expresso regular" so substituidas.
 um erro a no ocorrncia de 'expresso regular'
em todas as linhas endereadas.
.br
.sp
Qualquer caractere de pontuaco pode ser usado em lugar de "/"
para delimitar a expresso regular e a substituio.
.br
.sp
O caracter "&" em 'substituio'  substituido
pela cadeia correspondente  expresso regular.
O significado especial de "&" pode ser anulado
precedendo-o por "\".
.br
.sp
O caractere <nl> precedido por "\"
divide a linha substituida em duas.
.br
.sp
A ltima linha onde houve substituio ser a nova linha corrente.
.)b

.sp
.(b
.in 5
(., .) t endereo
.br
.in 10
Este comando age como o comando "m" (move),
exceto que uma cpia das linhas endereadas
 colocada aps "endereo".
A ltima linha copiada ser a nova linha corrente.
.)b

.sp
.(b
.in 5
(1, $) v/expresso regular/ [comando]
.br
.in 10
Este comando  o mesmo que o comando "g", exceto que
"comando"  executado para cada linha no contendo
"expresso regular".
.)b

.sp
.(b
.in 5
(1, $) w[!] [arquivo]
.br
.in 10
O comando 
"w" (write)
escreve as linhas endereadas
em "arquivo".
Se o arquivo no existe,  criado.
Este comando no ser obedecido se "arquivo" for o nome correntemente lembrado
e no tenha havido alterao no texto
desde sua ltima atualizao no disco
ou se "arquivo" no for o nome correntemente lembrado
e j existir um arquivo com seu nome.
O comando seguido de exclamao s no  executado
em caso de erro de escrita no disco.
A linha corrente permanece inalterada.
Se o comando  bem sucedido
o nmero de linhas e caracteres escritos  mostrado.
.)b

.sp
.(b
.in 5
(1, $) W [arquivo]
.br
.in 10
Este comando  o mesmo que "w", exceto que as linhas endereadas
so acrescentadas no final de "arquivo".
.)b

.sp
.(b
.in 5
($) =
.br
.in 10
O nmero da linha endereada  mostrado.
A linha corrente permanece inalterada.
.)b

.sp
.(b
.in 5
! [Comando Shell]
.br
.in 10
O restante da linha aps o "!"  enviado a "sh"(cmd)
para ser interpretado como um comando.
.)b

.sp
.(b
.in 5
(.+1, .+1)
.br
.in 10
Um endereamento apenas mostra as linhas endereadas.
A ltima linha mostrada ser a nova linha corrente.
.)b

.in
.sp
.b OBSERVAO
.in 5
A verso inicial no dispe do comando "undo".

.sp
Quando "ed" l um arquivo, todos os caracteres nulos so descartados
e  acrescentado um <nl> ao final do arquivo,
se ele estiver ausente.

.sp
As linhas muito longas quando lidas de um arquivo
ou tecladas no modo de entrada de texto
so divididas em linhas de at 255 caracteres.

.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd): "
vi, 
sh
.br

.in
.sp
.b ESTADO
.in 5
Efetivo.
.in
