/*
 ****************************************************************
 *								*
 *			main.c					*
 *								*
 *	Editor de textos orientado por linhas			*
 *								*
 *	Verso	1.0.0, de 24.10.86				*
 *		3.0.0, de 27.04.97				*
 *								*
 *	Mdulo: ED						*
 *		Editores de Texto				*
 *		Categoria B					*
 *								*
 *	TROPIX: Sistema Operacional Tempo-Real Multiprocessado	*
 *		Copyright  2000 NCE/UFRJ - tecle "man licena"	*
 * 								*
 ****************************************************************
 */

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <errno.h>

#include "../h/ed.h"
#include "../h/txtio.h"
#include "../h/proto.h"
#include "../h/extern.h"

/*
 ****************************************************************
 *	Variveis e Definies globais				*
 ****************************************************************
 */
const char	pgversion[] =  "Verso: 3.0.0, de 26.04.97";

entry int	vflag;		/* Verbose */

/*
 ******	Variveis globais ***************************************
 */
entry TEXT	Text;		/* Informaes sobre o Texto em edio */
entry BASE	*Root;		/* Incio da Lista com o Texto em edio */
entry BASE	*Current;	/* Posio Corrente */
entry AUTO	Search;		/* Expresso Regular p/ Busca */

entry bool	Interactive;		/* Edio no terminal */
entry bool	Interruption = false;	/* Houve uma interrupo */
entry char	temp_buffer[LSIZE];	/* Buffer temporario para uso geral */

/*
 ****** Prottipos de funes ***********************************
 */
void		on_signal (int, ...);
void		help (void);

/*
 ****************************************************************
 *	Editor de textos orientado por linhas			*
 ****************************************************************
 */
int
main (int argc, const char *argv[])
{
	int		opt;

	/*
	 *	Pequena inicializao
	 */
	signal (SIGINT, on_signal);
	Interactive = isatty (fileno (stdin));

	/*
	 *	Analisa as opes
	 */
	while ((opt = getopt (argc, argv, "vH")) != EOF)
	{
		switch (opt)
		{
		    case 'v':			/* Verbose */
			vflag++;
			break;

		    case 'H':			/* Help */
			help ();

		    default:			/* Erro */
			putc ('\n', stderr);
			help ();

		}	/* end switch */

	}	/* end while */

	argv += optind;
	argc -= optind;

	/*
	 *	Inicializao do Texto
	 */
	if (argv[0] != NULL)
		c_edit (argv[0]);
	else
		c_edit ("");

	Current = Root;

	for (EVER)
	{
		if (Interruption)
		{
			puts ("\nInterrupo");
			Interruption = false;
		}

		if (Interactive)
		{
			putchar (':');
			putchar (' ');
			fflush (stdout);
		}

		if (read_command ())
			command ();
		elif (!Interactive)
			c_quit ();
	}

}	/* end ed */

/*
 ****************************************************************
 *	Tratamento de Interrupes				*
 ****************************************************************
 */
void
on_signal (int signo, ...)
{
	signal (SIGINT, on_signal);

	Interruption = true;

}	/* end on_signal */

/*
 ****************************************************************
 *	Resumo de utilizao do programa			*
 ****************************************************************
 */
void
help (void)
{
	fprintf
	(	stderr,
		"%s - editor de textos orientado por linhas\n"
		"\n%s\n"
		"\nSintaxe:\n"
		"\t%s [<arquivo>]\n",
		pgname, pgversion, pgname
	);

	exit (2);

}	/* end help */
