.bp
.he 'EDBOOT (cmd)'TROPIX: Manual de Referncia'EDBOOT (cmd)'
.fo 'Atualizado em 29.08.06'Verso 4.9.0'Pag. %'

.b NOME
.in 5
.wo "edboot -"
gerencia "boot0", "boot1" e "boot2"
.br

.in
.sp
.b SINTAXE
.in 5
.(l
edboot  -0 [-wfv] [-i <ndice>] [<dispositivo>]
edboot  -1 [-wfv] [<dispositivo>]
edboot [-2] [-v] [-d <dev>] [-p <pgm>] [-V <vdeo>] [<arquivo>]
.)l

.in
.sp
.b DESCRIO
.in 5
O processo de carga do sistema operacional TROPIX  composto de
4 etapas: BIOS (em ROM), "boot0", "boot1" e "boot2".

.sp
A BIOS (aps diversos testes e inicializaes), le o primeiro
bloco de um disco (em geral "/dev/hda" ou "/dev/sda") para a memria, e passa o
controle para o programa contido neste bloco.

.sp
Este primeiro bloco contm o incio de "boot0", que por sua vez
le os seus blocos restantes do disco.
O "boot0" imprime uma tabela com as parties ativas dos diversos
discos encontrados no sistema, e pede o ndice da partio desejado
para prosseguir o procedimento de carga.

.sp
 impresso tambm o
ndice "default" (valor por omisso), que ser utilizado se
for teclado apenas <nl> ou se for decorrido um certo tempo
(da ordem de dezenas de segundos) sem que seja teclado algo.

.sp
O "boot0" permite carregar diversos sistemas operacionais,
e j foi testado com MS-DOS, Win3.1, Win95, Win98, WinNT, Win2000, WinXP, Linux
e FreeBSD (alm, naturalmente, do TROPIX).

.sp
Dependendo do ndice escohido, iremos carregar o TROPIX ou um
outro sistema operacional.
O programa "edboot" permite imprimir o valor
do ndice "default" atual ou alter-lo (veja a opo "-i" abaixo).

.sp
Se for escolhido a continuao da carga do TROPIX, o "boot0" carrega
o "boot1", que aguarda o nome do "boot2" (normalmente "boot").

.sp
A ltima etapa, o "boot2", permite escolher o nome do programa que
contm o ncleo do TROPIX (normalmente "tropix")
e tambm o dispositivo no qual ele deve ser procurado
(normalmente o mesmo dispositivo de onde foi lido "boot1").
.bc	/*************************************/
(normalmente a primeira
partio de tipo TROPIX encontrado durante a anlise das vrias parties
dos diversos discos).
.ec	/*************************************/
Tanto o nome do programa como o dispositivo podem ser consultados e/ou
modificaes atravs de "edboot" (veja as opes "-d" e "-p" abaixo).

.sp
Normalmente "edboot" procura o "boot0" em "/dev/hda" e "/dev/sda",
o "boot1" em "/dev/root" e o "boot2" em "/boot".
Os argumentos <dispositivo>/<arquivo> permitem alterar isto.

.sp
Sem opes, o programa "edboot" imprime o nome do
programa (ncleo do TROPIX) e dispositivo contidos em "/boot".

.sp
Nesta verso, os diversos programas de "boot" tentam fornecer para a
etapa seguinte qual foi o dispositivo do qual foram lidos.
O objetivo consiste em escolher um dispositivo durante a segunda etapa
("boot0"), e este mesmo dispositivo ser usado para a leitura de "boot1",
"boot2", o ncleo do TROPIX e finalmente ser usado como sistema de arquivos
RAIZ do sistema operacional.

.sp
As opes do comando so:

.bc	/*************************************/
edboot - gerencia "boot0", "boot1" e "boot2"

Verso:	4.9.0, de 29.08.06

Sintaxe:
	edboot  -0 [-wfv] [-i <ndice>] [<dispositivo>]
	edboot  -1 [-wfv] [<dispositivo>]
	edboot [-2] [-v] [-d <dev>] [-p <pgm>] [-V <vdeo>] [<arquivo>]

Opes:	-0: Instala/consulta/modifica o "boot0"
	-1: Instala/consulta o "boot1"
	-2: Consulta/modifica o "boot2"
	-w: Instala o "boot0"/"boot1" no <dispositivo>
	-f: Instala/modifica sem consultar o usurio
	-v: Verboso
	-i: A partio "default" do "boot0" ser <ndice>
	-d: O dispositivo "default" do "boot2" ser <dev>
	-p: O programa "default" a executar do "boot2" ser <pgm>
	-V: Usa o modo de <vdeo> dado no "boot2" (25x80, 113x48)

Obs.:	Sem opes nem argumentos, so impressos os parametros de "/boot"
.ec	/*************************************/


.in +3
.ip -0
Instala/consulta/modifica "boot0".
Sem as opes "-w" nem "-i",  dado o ndice da partio "default" contido em "boot0".

.sp
Alm disto, verifica se a verso instalada  a atual (contida no diretrio "/etc/boot").

.ip -1
Instala/consulta o "boot1".
Sem a opo "-w", verifica se a verso instalada  a atual (contida no diretrio "/etc/boot").

.ip -2
Consulta/modifica "boot2" (opo implcita).
Sem as opes "-d", "-V" nem "-p", so dados o dispositivo e programa "default"s contidos em "boot2".

.ip -w
Instala o "boot0"/"boot1" no <dispositivo> dado.

.sp
O programa "boot0"  construdo a partir do arquivo "/etc/boot/h.boot0"
e a tabela de parties existente no bloco 0 do <dispositivo>.
O bloco 0 original do <dispositivo>  guardado no arquivo "/etc/boot/mbr".

.sp
Se o "boot0" no funcionar adequadamente, o bloco 0 original deve ser novamente
recolocado atravs do comando

.sp
.nf
		cat /etc/boot/mbr ><dispositivo>
.fi

.sp
e a carga do TROPIX dever ser feita atravs de disquete.

.sp
O programa "boot1"  obtido a partir do arquivo
"/etc/boot/t1.l.boot1", "/etc/boot/t1.g.boot1",
"/etc/boot/v7.l.boot1" ou "/etc/boot/v7.g.boot1",
de acordo com o tipo do sistema de arquivo (T1 ou V7)
e se o dispositivo suporta as extenses da INT 13 da BIOS ou no.

.ip -f
No pede a confirmao do usurio antes de instalar
o "boot0"/"boot1".

.ip -v
Verboso. Imprime outras informaes, tais como as verses dos
programas.

.ip -i
Atribui o valor <ndice> para a partio "default" do "boot0".
Se este valor for NULO, a partio "default" do "boot0"
ser a primeira partio do tipo TROPIX (T1 ou V7) encontrado na tabela.

.ip -d
Atribui <dev> como o dispositivo "default" de "boot2".
O valor "NODEV" (ou "nodev")  interpretado como o dispositivo
usado para a leitura do "boot1", ou (na ausncia desta informao)
como a primeira partio de tipo TROPIX encontrada durante
a anlise das vrias parties dos diversos discos.

.ip -p
Atribui <pgm> como o programa "default" de "boot2".

.ip -V
Atribui <vdeo> como o modo de vdeo do "boot2". Podem ser dados os valores
"25x80" (ou "vga") para o modo 720x400 (normal) ou
"113x48" (ou "svga") para o modo 1024x768.
Durante a carga, se o controlador de vdeo no possibilitar o modo
"svga", automaticamente ser usado o "vga".

.ep
.in -3

.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd): "
boot, fdisk
.br
.wo "(ref): "
install
.br

.in
.sp
.b ARQUIVOS
.in 5
.(l
/dev/hd?
/dev/sd?
/dev/root
/etc/boot/d.boot0		Para testar, em disquete
/etc/boot/h.boot0		Para disco rgido
/etc/boot/t1.d.boot1	Disquete 1.44 MB, T1
/etc/boot/t1.g.boot1	Disco rgido, sem as extenses, T1
/etc/boot/t1.l.boot1	Disco rgido, com as extenses, T1
/etc/boot/v7.d.boot1	Disquete 1.44 MB, V7
/etc/boot/v7.g.boot1	Disco rgido, sem as extenses, V7
/etc/boot/v7.l.boot1	Disco rgido, com as extenses, V7
/etc/boot/mbr		Cpia do primeiro setor do disco
				principal ("/dev/hda" ou "/dev/sda")
/boot			Verso nica de "boot2"
.)l

.in
.sp
.b EXEMPLOS
.in 5
A execuo de 
.nf

		edboot -0 -w

.fi
ir instalar o "boot0" nos setores iniciais de "/dev/hda" (ou "/dev/sda").

.sp
A execuo de 
.nf

		edboot -0 -i 3 /dev/sda

.fi
ir alterar para 3 o ndice do  "boot0"
contido no disco SCSI "/dev/sda".

.sp
A execuo de 
.nf

		edboot -1 -v /dev/aroot

.fi
informa se a verso de "boot1" contida no primeiro bloco de "/dev/aroot"  a atual.

.sp
.(t
A execuo de 
.nf

		edboot -2 -p new.tropix /new.boot

.fi
.)t
ir alterar para "new.tropix" o ncleo "default" do "boot2"
alternativo "/new.boot".

.in
.sp
.b ESTADO
.in 5
Efetivo.

.in
