.bp
.he 'EDUSR (cmd)'TROPIX: Manual de Referncia'EDUSR (cmd)'
.fo 'Atualizado em 15.01.99'Verso 3.1.1'Pag. %'

.b NOME
.in 5
.wo "edusr -"
gerencia as contas/grupos de usurios 
.br

.in
.sp
.b SINTAXE
.in 5
.(l
edusr
.)l

.in
.sp
.b DESCRIO
.in 5
O programa "edusr"  uma interface para o gerenciamento das contas
e grupos de usurios do sistema TROPIX.
Ele gerencia o arquivos de contas/senhas "/etc/passwd",
o arquivo de grupos "/etc/group",
cria/remove os diretrios contendo os arquivos
dos usurios (diretrio "home"),
e a suas caixas postais.

.sp
No TROPIX (assim como em outros sistemas operacionais de filosofia
UNIX), cada usurio do sistema  identificado por um inteiro
no negativo chamado
UID. Alm disto, ele pertence a um certo grupo de usurios,
que (tambm)  identificado por um inteiro no negativo chamado GID.

.sp
Estes dois nmeros definem as permisses que o usurio possui para
acessar certos recursos do sistema (tais como ler/escrever um
certo arquivo ou executar um certo programa).
Se o UID de um usurio for 0, ele  considerado um "superusurio",
e tem permisso para acessar todos os recursos do sistema;
em "intro" (sys) so dados mais detalhes.

.sp
O programa "edusr" supe que os arquivos de contas/senhas e
o arquivo de grupos estejam (respectivamente) ordenados crescentemente
pelo UID e GID.

.sp
O programa "edusr" possui um interpretador de comandos, que le e
processa instrues do usurio.
Para indicar que est aguardando comandos, "edusr" imprime
uma linha contendo os caracteres
.sp
.nf
		"edusr [n]> "
.fi
.sp
onde "n"  o nmero
do comando no histrico (ver os comandos "h", "eh" e "xh" abaixo). 

.sp
Atravs do interpretador de comandos podemos efetuar diversas operaes,
tais como obter uma lista dos usurios, criar novos usurios, remover usurios,
etc ... A lista completa  dada abaixo.

.in
.sp
.b "INFORMAES DO ARQUIVO DE CONTAS"
.in 5
O arquivo de contas/senhas "/etc/passwd" contm uma linha para cada usurio
do sistema. Cada uma destas linhas contm 10 campos separados
pelo caractere ":", contendo diversas informaes.
Todos estas informaes podem ser listadas atravs do comando "pu"
(veja abaixo).

.sp
Elas so (acompanhe no arquivo "/usr/include/pwd.h"):

.in +3
.ip " 1." 4
Nome do Usurio: Pode ter no mximo 14 caracteres.

.ip " 2." 4
Senha encriptada: Esta senha  consultada pelo programa "login" sempre
que um usurio entra em sesso. O comando "edusr" no processa estas senhas;
para um usurio regular a linha  criada sem senha e
para um superusurio a linha  criada com a senha do "root".
Em ambos os casos, as senhas devem ser modificadas posteriormente
atravs do programa "passwd" (cmd).

.ip " 3." 4
Comentrio: Contm normalmente o nome completo do usurio.

.ip " 4." 4
Identificao do usurio (UID).

.ip " 5." 4
Identificao do grupo do usurio (GID).

.ip " 6." 4
Cota: O nmero mximo de blocos (de 512 bytes) que o usurio
pode alocar no disco.
Se este valor for NULO, o usurio no tem limite de blocos.
Na presente verso do sistema, este controle no est implementado.

.ip " 7." 4
Data de expirao: Indica a data aps a qual no  mais permitido
ao usurio entrar em sesso no sistema.
Se este valor for NULO, o usurio no tem data de expirao.

.ip " 8." 4
Tranca: Informao utilizada pelo controle de cotas.

.ip " 9." 4
Diretrio "home": Diretrio corrente do usurio aps entrar em sesso.
 neste diretrio que o usurio deve criar o seus arquivos.
Como ele pode tambm criar subdiretrios, o diretrio "home"
 na verdade a raiz da rvore contendo todos os arquivos do usurio.

.ip "10." 4
Interpretador de comandos: Programa que  executado ao entrar em
sesso. Normalmente  um interpretador de comandos (tal como "/bin/sh" (cmd)).

.ep
.in -3

.in
.sp
.b "VALORES CORRENTES"
.in 5
Para facilitar a criao de contas, o programa "edusr" armazena os
uma srie de "valores correntes":

.in +3
.ip " 1." 4
O grupo corrente: O grupo a que pertencer o novo usurio.
Pode ser consultado/alterado atravs do comando "g".

.ip " 2." 4
A cota corrente: O limite de cotas que ser atribudo ao novo usurio.
Pode ser consultado/alterado atravs do comando "c".

.ip " 3." 4
A data de expirao corrente: A data de expirao que ser atribuda ao novo usurio.
Pode ser consultado/alterado atravs do comando "e".

.ip " 4." 4
O diretrio "home" corrente: O diretrio que ser atribudo ao novo usurio.
Pode ser consultado/alterado atravs do comando "home".

.ip " 5." 4
O interpretador de comandos corrente: O interpretador que ser atribudo
ao novo usurio. Pode ser consultado/alterado atravs do comando "shell".

.ep
.in -3

.sp
Atravs do comando "set" podemos consultar todos os valores correntes
simultaneamente.

.sp
Alm dos valores descritos acima, "edusr" tambm consulta o arquivo
"/usr/pub/lib/profile.sample", que  usado para criar o arquivo
".profile" dos usurios.
Este arquivo naturalmente pode ser modificado conforme as necessidades.

.in
.sp
.(t
.b COMANDOS
.in 5
O programa "edusr" reconhece e processa os seguintes comandos:

.bc	/*************************************/
.in +3
.ec	/*************************************/
.ip " 1." 4
?
.sp
Como "help", abaixo.
.)t

.ip " 2." 4
!<comando> [<argumento> ...]
.sp
Executa o <comando> com os respectivos <argumento>s atravs do "sh".
Isto vale inclusive para o comando "cd".
Todo o contexto de "edusr"  conservado.

.ip " 3." 4
c [<cota>]
.sp
Como "cota", abaixo.

.ip " 4." 4
cota [<cota>]
.sp
Altera a cota corrente de blocos por usurio.
Se a <cota> no for dada, imprime a "cota" corrente.
Uma cota de 0 blocos significa a ausncia do limite de cotas.

.ip " 5." 4
data [<expir>]
.sp
Como "expir", abaixo.
 
.ip " 6." 4
e [<expir>]
.sp
Como "expir", abaixo.

.ip " 7." 4
eh [<n>]
.sp
Edita (e opcionalmente executa) o comando de nmero <n> do histrico.
Se <n> for omitido, edita o ltimo comando presente no histrico.
A edio  realizada pela funo "edit" (libc).
Aps a edio, o usurio  consultado se deseja realmente executar
o comando editado.

.(t
.ip " 8." 4
exit
.sp
Como "quit", abaixo.
.)t

.ip " 9." 4
expir [<expir>]
.sp
Altera a data de expirao da conta de usurio.
Se <expir> no for dada,  impressa a data de expirao corrente.
O formato de <expir> deve ser "dd.mm.aa", ou "0" significando
a ausncia de data de expirao.

.ip "10." 4
g [<grupo>]
.sp
Como "mkgrp", abaixo.

.ip "11." 4
h
.sp
Imprime os comandos do histrico. Nesta verso, o histrico armazena
os ltimos 20 comandos executados.

.ip "12." 4
help
.sp
Imprime uma lista de todos os comandos disponveis.
Para obter um resumo de um <comando>, use "<comando> -H" ou "<comando> ?".

.ip "13." 4
home [<diretrio>]
.sp
Altera o diretrio "home".
Se o <diretrio> no for dado, imprime o "home" corrente.

.ip "14." 4
mg [<grupo>]
.sp
Como "mkgrp", abaixo.

.ip "15." 4
mkgrp [<grupo>]
.sp
Altera o grupo corrente ou cria um novo grupo.
Se o <grupo> no for dado, imprime o grupo corrente.
Se o <grupo> dado ainda no existir, ele  criado, e passa a ser
o grupo corrente.

.ip "16." 4
mkusr [-s] <usurio> [<comentrio>]
.sp
Cria o novo <usurio> com os valores correntes.
O <comentrio>, se dado, engloba todos os argumentos aps <usurio>.
.sp
Sem a opo "-s",  criado um usurio regular sem senha, cujo UID
 escolhido automaticamente pelo programa "edusr".
Com a opo "-s",  criado um superusurio com a senha do "root".
.sp
NO esquea de atribuir uma senha posteriormente atravs do utilitrio
"passwd" (cmd).

.ip "17." 4
mu [-s] <usurio> [<comentrio>]
.sp
Como "mkusr", acima.

.(t
.ip "18." 4
pg [<grupo>]
.sp
Como "prgrp", abaixo.
.)t

.ip "19." 4
prgrp [<grupo>]
.sp
Imprime o <grupo>. Se <grupo> no for dado, imprime todos os grupos.

.ip "20." 4
prusr [-l] [-g <grupo>] [<usurio>]
.sp
Imprime informaes sobre o <usurio>. Se o <usurio> no for dado,
imprime informaes sobre todos os usurios. Se for dada a opo
"-g", somente imprime informaes sobre os usurios do <grupo> dado.

.sp
Sem a opo "-l", imprime o nome do usurio, seu UID, o nome (e GID) do grupo
a que pertence, um asterisco se NO contiver senha e o comentrio
(normalmente o nome completo do usurio).

.sp
Com a opo "-l", imprime o nome do usurio, seu UID, o nome do interpretador
de comandos e o diretrio "home".

.sp
Com a opo "-l" dada duas vezes, imprime o nome do usurio, seu UID,
a cota, um "L" se a conta estiver "trancada", a data de expirao e um
"E" caso a conta esteja expirada.
O caractere "." indica a ausncia de cota/data de expirao.
 
.ip "21." 4
pu [-l] [-g <grupo>] [<usurio>]
.sp
Como "prusr", acima.

.ip "22." 4
q
.sp
Como "quit", abaixo.

.ip "23." 4
quit
.sp
Termina a execuo de "edusr".
Um EOF (normalmente <^D>) tem o mesmo efeito.

.ip "24." 4
quota [<cota>]
.sp
Como "cota", acima.

.(t
.ip "25." 4
rg <grupo>
.sp
Como "rmgrp", abaixo.
.)t

.ip "26." 4
rmgrp <grupo>
.sp
Remove o <grupo>, juntamente com os seus usurios e arquivos.
Este comando deve ser utilizado com cuidado, para evitar a remoo
acidental de arquivos de usurios.

.ip "27." 4
rmusr <usurio>
.sp
Remove o <usurio>, juntamente com os seus arquivos e caixa postal.
Este comando deve ser utilizado com cuidado, para evitar a remoo
acidental de arquivos e/ou cartas das caixas postais dos usurios.

.ip "28." 4
ru <usurio>
.sp
Como "rmusr", acima.

.ip "29." 4
set
.sp
Imprime os valores correntes.

.ip "30." 4
shell [<shell>]
.sp
Altera o interpretador de comandos ("shell") corrente.
Se <shell> no for dado, imprime o interpretador corrente.

.ip "31." 4
u [-s] <usurio> [<comentrio>]
.sp
Como "mkusr", acima.

.ip "32." 4
xh [<n>]
.sp
Excuta o comando de nmero <n> do histrico.
Se <n> for omitido, executa o ltimo comando presente no histrico.

.ep
.bc	/*************************************/
.in -3
.ec	/*************************************/

.in
.sp
.(t
.b
VEJA TAMBM
.r
.in 5
.wo "(sys):  "
intro
.br
.wo "(libc): "
edit
.br
.wo "(cmd):  "
passwd, sh
.br
.)t

.in
.sp
.b ARQUIVOS
.in 5
/etc/passwd
 /etc/group
 /home/...
 /var/spool/mail/...
 /usr/include/pwd.h
 /usr/pub/lib/profile.sample

.in
.sp
.b ESTADO
.in 5
Efetivo.

.in
