/*
 ****************************************************************
 *								*
 *			home.c					*
 *								*
 *	Gerenciador de contas					*
 *								*
 *	Verso	1.5.0, de 04.06.84				*
 *		3.0.0, de 30.07.97				*
 *								*
 *	Mdulo: edusr						*
 *		Utilitrios Bsicos				*
 *		Categoria B					*
 *								*
 *	TROPIX: Sistema Operacional Tempo-Real Multiprocessado	*
 *		Copyright  2000 NCE/UFRJ - tecle "man licena"	*
 * 								*
 ****************************************************************
 */

#include <sys/syscall.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>

#include "../h/edusr.h"

/*
 ******	Prottipos de funes ***********************************
 */
void	do_home_help (void);

/*
 ****************************************************************
 *	Modifica o diretrio contendo os arquivos dos usurios	*
 ****************************************************************
 */
void
do_home (int argc, const char *argv[])
{
	int		opt;
	const char	*nm;

	/*
	 *	Analisa as opes
	 */
	while ((opt = cmd_getopt (argv, "H")) >= 0)
	{
		switch (opt)
		{
		    case 'H':			/* Help */
			do_home_help ();
			return;

		    default:			/* Erro */
			fprintf (stderr, "\n");
			do_home_help ();
			return;
		}
	}

	/*
	 *	Pequena consistncia
	 */
	argc -= cmd_optind;
	argv += cmd_optind;

	if (argc > 1)
		{ do_home_help (); return; }

	/*
	 *	Imprime o "home" corrente
	 */
	if (argc == 0)
		{ do_home_current (); return ; }

	/*
	 *	Processo o novo "home"
	 */
	nm = argv[0];

	if (*nm != '/')
	{
		error ("O nome do diretrio \"%s\" NO comea por \"/\"", nm);
		return;
	}

	if (chdir (nm) < 0 )
	{
		error ("*No consegui mudar o diretrio corrente para \"%s\"", nm);
		return;
	}

	strcpy (current_home, nm);

	do_home_current ();

}	/* end eddir */

/*
 ****************************************************************
 *	Imprime o valor corrente				*
 ****************************************************************
 */
void
do_home_current (void)
{
	printf
	(	"O diretrio corrente  \"%s\"\n",
		current_home
	);

}	/* end do_home_current */

/*
 ****************************************************************
 *	Resumo de utilizao do programa			*
 ****************************************************************
 */
void
do_home_help (void)
{
	fprintf
	(	stderr,
		"%s - altera o diretrio \"home\"\n"
		"\nSintaxe:\n"
		"\t%s [<diretrio>]\n"
		"\nObs.:\tSe o <diretrio> no for dado,  impresso o \"home\" corrente\n",
		cmd_nm, cmd_nm
	);

}	/* end do_home_help */
