.bp 1
.he 'EX (cmd)'TROPIX: Manual de Referncia'EX (cmd)'
.fo 'Atualizado em 18.05.97'Verso 3.0.2'Pag. %'

.b NOME
.in 5
ex - editor visual de textos

.in
.sp
.b SINTAXE
.in 5
ex [-v] [<nome>]
.br

.in
.sp
.b DESCRIO
.in 5
O comando "ex"  um editor de texto que pode utilizar toda
a tela do terminal para mostrar o arquivo em edio.
.sp
Opes:
.in 8
.ip -v 8
Funcionamento verboso. Quando esta opo est ativa,
todos os comandos no modo Visual so ecoados.
.ep
.in 5

.sp
Argumentos:
.in 8
.ip <nome> 8
Nome do arquivo a ser editado.
Se este nome no corresponde a um arquivo j existente,
o "ex" inicia a edio de um arquivo novo com o nome dado.
Se nenhum nome  fornecido, o "ex" inicia a edio 
de um arquivo novo, cujo nome poder ser indicado
mais tarde atravs dos comandos "f" (file), "r" (read) ou "w" (write),
disponveis no modo Comandos.
.ep
.in 5

.sp
O editor "ex" tem dois modos principais de operao:
o modo 
.b Visual
(pelo qual ele inicia)
e o modo
.b Comandos.
Em cada modo existem comandos para a mudana de modo
ou para a execuo de um comando no outro modo.

.in 5
.sp
.b 'Modo Visual:'
.sp
.in 5
No modo Visual o editor "ex" utiliza o vdeo do terminal
como uma janela para a visualizao do texto em edio
e o cursor como um apontador, indicando onde sero realizadas
as operaes de edio.

.sp
Os comandos no modo Visual so compostos de alguns poucos
(geralmente um) caracteres normalmente no ecoados.
O efeito dos comandos  percebido instantaneamente pelo usurio
atravs do movimento do cursor e/ou da alterao do texto na janela.
Os comandos, em sua maioria, podem ser precedidos de uma contagem,
indicando a repetio de seu efeito.
Os comandos que requerem mais de um caractere
podem ser cancelados (se ainda no foram totalmente digitados)
teclando-se o caractere <esc>.

.sp
As tabelas a seguir contm os comandos do modo Visual,
divididos em grupos com funcionalidade semelhante.

.(t
.sp
Os comandos a seguir reposicionam a janela sobre o texto em edio,
permitindo uma completa visualizao do mesmo.
.sp
.ts
center
allbox;
c s
c l.
Movendo a Janela
Comando	Funo
<^F>	avana uma janela de texto
<^B>	retrocede uma janela de texto
<^D>	avana suavemente meia janela
<^U>	retrocede suavemente meia janela
<^E>	avana uma linha
<^Y>	retrocede uma linha
G	mostra a linha dada a sua ordem
<^G>	informa a ordem da linha corrente
.te
.)t

.(t
.sp
Os comandos a seguir reposicionam o cursor,
passeando com o cursor pelo texto nas quatro direes bsicas.
.sp
.ts
center
allbox;
c s
c l.
Movendo o Cursor nas Direes Bsicas
Comando	Funo
h	retrocede um caractere
j	avana uma linha na coluna corrente
k	retrocede uma linha na coluna corrente
l	avana um caractere
.te
.)t

.(t
.sp
Os comandos a seguir reposicionam o cursor,
passeando com o cursor por linhas prximas a linha corrente.
.sp
.ts
center
allbox;
c s
c l.
Movendo o Cursor para Linhas Prximas
Comando	Funo
 - 	retrocede uma linha
+	avana uma linha
H	primeira linha na janela
M	linha central na janela
L	ltima linha na janela
.te
.)t

.(t
.sp
Os comandos a seguir reposicionam o cursor,
passeando com o cursor pela linha corrente.
.sp
.ts
center
allbox;
c s
c l.
Movendo o Cursor na Linha Corrente
Comando	Funo
0	primeiro caractere
^	incio (primeiro caractere no branco)
<bs>	retrocede um caractere
<sp>	avana um caractere
<ht>	prxima coluna de tabulao
$	ltimo caractere
.te
.)t

.(t
.sp
O editor "ex" distingue dois tipos de palavras:
para os comandos com letras maisculas
as palavras so sequncias de caracteres no incluindo
os separadores <sp> e <ht>;
para os comandos com letras minsculas, sequncias alfanumricas
ou sequncias de sinais de pontuao.
O alcance destes comandos no se limita  linha corrente.
.sp
.ts
center
allbox;
c s
c l.
Movendo o Cursor por Palavras
Comandos	Funo
w  W	avana uma palavra
e  E	avana at o final de uma palavra
b  B	retrocede ao inicio de uma palavra
.te
.)t

.(t
.sp
Os comandos a seguir movem o cursor para a primeira ocorrncia
do caractere especificado.
.sp
.ts
center
allbox;
c s
c l.
Busca de Caracteres
Comando	Funo
f<ch>	avana at o caractere <ch> (inclusive)
F<ch>	retrocede at o caractere <ch> (inclusive)
t<ch>	avana at o caractere <ch> (exclusive)
T<ch>	retrocede at o caractere <ch> (exclusive)
;	repete a ltima busca de caractere
,	repete no sentido inverso
.te
.)t

.(t
.sp
Os comandos a seguir permitem que algumas linhas do texto
sejam referenciadas por letras minsculas.
.sp
.ts
center
allbox;
c s
c l.
Marcao de Linhas
Comando	Funo
m<letra>	marca a posio corrente como <letra>
'<letra>	move para a linha marcada como <letra>
`<letra>	move para a posio marcada como <letra>
''	retorna  posio corrente conseqente
-	ao ltimo movimento relativo
.te
.)t

.(t
.sp
O editor "ex"  capaz de buscar expresses regulares no texto.
As expresses regulares aceitas esto descritas resumidamente
adiante (seo Expresses Regulares);
uma descrio completa
pode ser encontrada no guia ("ex" (ref)).
.sp
.ts
center
allbox;
c s
c l.
Busca de Expresses Regulares
Comando	Funo
/<expresso><nl>	busca avanando
?<expresso><nl>	busca retrocedendo
n	repete a ltima busca com "/" ou "?"
N	repete no sentido inverso
&	avana at o primeiro caractere aps
-	a ltima expresso regular encontrada
.te
.)t

.sp
Os comandos para a movimentao do cursor
podem ser utilizados para especificar a abrangncia
das operaes de edio
(geralmente da regio apontada pelo cursor
at a regio para onde o cursor iria).
Quando utilizados neste contexto, estes comandos so chamados de
.b
objetos.
.r

.(t
.sp
O "ex" dispe de vrios buffers, onde podem ser armazenadas partes do texto.
Os comandos para remoo de texto e manipulao de buffers
normalmente se referem a um buffer sem nome;
os outros buffers so nomeados por uma letra minscula.
.sp
.ts
center
allbox;
c s
c l.
Manipulao de Buffers
Comando	Funo
["<buf>]y<objeto>	operador para armazenamento
["<buf>]p	copia buffer aps o cursor
["<buf>]P	copia buffer antes do cursor
.te
.)t

.(t
.sp
Atravs dos operadores de edio podemos remover, substituir
e deslocar partes do texto.
.sp
.ts
center
allbox;
c s
c l.
Operadores de Edio
Comando	Funo
["<buf>]d<objeto>	remoo
c<objeto>	substituio (remoo e insero)
><objeto>	deslocamento para a direita
<<objeto>	deslocamento para a esquerda
.te
.)t

.(t
.sp
Atravs dos comandos para insero de texto
introduzimos o texto teclado no terminal
no texto em edio.
.sp
.ts
center
allbox;
c s
c l.
Insero de Texto
Comando	Funo
i	insere antes do cursor
a	insere aps o cursor
o	insere em uma nova linha abaixo
O	insere em uma nova linha acima
<eol>	termina insero de texto
.te
.)t

.(t
.sp
Todos os comandos de edio podem ser repetidos no mesmo ou em outro contexto
ou ter seu efeito anulado.
.sp
.ts
center
allbox;
c s
c l.
Repetio e Retroao dos Comandos de Edio
Comando	Funo
 . (ponto) 	repete o ltimo comando de edio
u	desfaz a ltima alterao no texto
.te
.)t

.(t
.sp
Algumas operaes mais utilizadas e que normalmente demandam
mais de um caractere para a sua especificao podem
ser especificados por comandos sinnimos,
que consistem de apenas um caractere.
.sp
.ts
center
allbox;
c s s
c c l.
Alguns Sinnimos teis
Sinnimo	Comandos	Funo
x	d<sp>	apaga o caractere sob o cursor
X	d<bs>	apaga o caractere anterior
s	c<sp>	substitui o caractere corrente
I	^i	insere no incio da linha
A	$a	insere ao final da linha corrente
C	c$	substitui at o final da linha
D	d$	remove at o final da linha
Y	yy	armazena a linha corrente
S	cc	substitui a linha corrente
<^N>	j	move para baixo
<nl>	j	move para baixo
<^P>	k	move para cima
<cr>	+	avana para a prxima linha
.te
.)t

.(t
.sp
A tabela a seguir contm alguns comandos de funes diversas,
que ainda no foram mencionados.
.sp
.ts
center
allbox;
c s
c l.
Outros Comandos
Comando	Funo
J	agrupamento de linhas
<^R> <^L>	reescreve a janela
!	envia um comando para a shell
rx	substitui o caractere corrente por "x"
%	busca o caractere par: () [] {}
.te
.)t

.in 5
.sp
.(t
.b 'Modo Insero'
.r
.sp
Durante a insero de texto (que pode ser ativada a partir do modo Visual)
os comandos do modo Visual no so vlidos
e alguns caracteres especiais podem ser usados para editar
linha a linha o texto teclado,
permitindo a correo de erros de digitao.
Os caracteres que comandam a edio da entrada so listados
a seguir com os nomes pelos quais eles podem ser alterados
atravs do comando "stty" e as suas respectivas funes.
.sp
.ts
center
allbox;
l l.
Caractere	Funo
<erase>	remove o ltimo caractere inserido
<aerase>	alternativa a <erase>
<word>	remove a ltima palavra inserida
<kill>	remove todo o texto inserido nesta linha
<retype>	reescreve a janela
<eol>	termina a insero
<eof>	alternativa a <eol>
<^V>	anula a funo especial do prx. caractere
.te
.)t

.in 5
.sp
.(t
.b 'Expresses Regulares'
.r
.sp
O editor "ex" reconhece um subconjunto de expresses regulares.
Uma expresso regular  especificada como uma cadeia de caracteres,
em que, com a execeo de alguns caracteres especiais,
um caractere normalmente corresponde a ele mesmo.
Os caracteres especiais so ".", "[", "]", "\" e,
em alguns casos, "^", "$" , "*" e "+".
A tabela a seguir resume a funcionalidade dos caracteres especiais.
.)t

.sp
.(t
.ts
center
allbox;
c l.
Carac. Especial	Significado
^	incio de uma linha
$	final de uma linha
 . (ponto) 	qualquer caractere
[s]	um caractere presente na cadeia "s"
[^s]	um caractere ausente da cadeia "s"
x*	repetio de "x" (zero ou mais vezes)
x+	repetio de "x" (uma ou mais vezes)
\x	caractere "x"
.te
.)t

.in 5
.sp
.(t
.b 'Modo Comandos'
.r
.sp
.in 5
Os comandos do editor "ed" esto disponveis no modo Comandos.
Entrada para o modo Comandos a partir do modo Visual: "Q".
Sada do modo Comandos e retorno para o modo Visual: "v".
.)t

.in
.sp
.b OBSERVAES
.in 5
O editor "ex" identifica o tipo de terminal onde ele est
sendo executado atravs da varivel TERM, presente no ambiente.
Portanto antes de usar o "ex"  importante garantir
que o nome de seu terminal j foi corretamente atribudo a varivel TERM
e que esta varivel seja exportvel.

.sp
A recepo dos sinais "SIGINT" e "SIGQUIT"
normalmente interrompe as operaes do "ex".
A recepo do sinal "SIGTERM" faz com que o texto em edio seja salvo
em um arquivo denominado "VI.SAVE" sob o diretrio corrente
e que o "ex" termine a sua execuo.

.sp
O comando "ex" identifica se o arquivo em edio  do estilo UNIX
(linhas terminadas por <nl>) ou estilo DOS (linhas terminadas por <cr><nl>),
e processa corretamento os dois estilos.

.in
.sp
.(t
.b "VEJA TAMBM"
.r
.in 5
(cmd): ed, sh
.)t
.br
(ref): ex

.in
.sp
.b ESTADO
.in 5
Efetivo.
.in
