.bp
.sp 5
.nf
     *********************************************************
     *                                                       *
     *                      CAPTULO 2                       *
     *                                                       *
     *                      MODO VISUAL                      *
     *                                                       *
     *********************************************************
.fi
.sp 4
.pp
O "vi" no modo Visual utiliza o vdeo do terminal
como uma janela sobre o texto em edio
e o cursor como um apontador no texto, localizando as operaes de edio.

.pp
Os comandos no modo Visual so compostos de alguns poucos
(geralmente um) caracteres normalmente no ecoados.
O efeito dos comandos  percebido instantaneamente pelo usurio
atravs do movimento do cursor e/ou da alterao do texto na janela.
Os comandos, em sua maioria, podem ser precedidos de uma contagem.
Os comandos que requerem mais de um caractere
podem ser cancelados (se ainda no foram totalmente digitados)
teclando-se o caractere <esc>.

.sp 2
.b
2.1. Observao e Localizao no Texto
.r
.pp
A maioria dos comandos do editor "vi" em seu modo Visual
move a janela sobre o texto ou movimenta o cursor pelo texto.
De modo geral, estes comandos podem ser precedidos por uma contagem,
para indicar uma repetio no efeito destes comandos.

.sp
.b
2.1.1. Movendo a Janela sobre o Texto
.r

.pp
A poro de texto mostrada a cada instante pela janela
 chamada de uma
.b pgina.
 possvel mover a janela 
avanando ou retrocedendo pginas
ou, mais suavemente, deslocando a janela gradualmente.

.pp
Os comandos <^F> (move forward) e <^B> (move backward) movem a janela
em unidades de uma pgina, respectivamente avanando ou retrocedendo.
Avanando ou retrocedendo a janela de uma pgina,
o editor "vi" conserva duas linhas da pgina mostrada anteriormente,
de modo a possibilitar a leitura contnua do texto.
Aps estes comandos o cursor se localiza
no incio da primeira palavra
na primeira linha da nova pgina corrente.

.pp
Os comandos <^D> (sroll down) e <^U> (scroll up)
propiciam um modo mais confortvel para percorrermos o texto.
Estes comandos respectivamente descem e sobem a janela sobre o texto,
"rolando" o vdeo e gradualmente expondo as linhas de texto adjacentes
 pgina mostrada antes do comando.
Quando especificamos uma contagem, esta se refere ao nmero de linhas 
em que a janela deve ser deslocada.
Quando no especificamos uma contagem,
a janela  deslocada de acordo com a ltima contagem
fornecida a estes comandos ou,
se at o momento no foram especificadas contagens para estes comandos,
de meia pgina.
Os comandos <^E> e <^Y>, respectivamente sobem e descem a janela de uma linha.

.pp
Se o caractere apontado pelo cursor permanecer na janela
aps a execuo dos comandos <^D>, <^U> <^E> ou <^Y>,
ele continuar sendo apontado;
em caso contrrio, o cursor apontar
o incio da primeira palavra
na primeira linha na janela.

.pp
Exemplos:
a seqncia de comandos "5<^D><^U>"
move a janela abaixo cinco linhas e retorna  posio original,
o comando <^B> retrocede uma pgina
e o comando "5<^F>" avana cinco pginas.

.sp
.b
2.1.2. Apontando uma Linha no Texto
.r

.pp
Os comandos "+" ou <cr> e "-" respectivamente avanam e retrocedem uma linha.
O comando "H" (home) move o cursor para a primeira linha na janela.
O comando "M" (medium) move o cursor para uma linha
aproximadamente no meio da janela.
O comando "L" (last) move o cursor para a ltima linha na janela.
O comando "G" (go) move o cursor para a linha especificada pela contagem;
na falta de uma contagem, "G" move o cursor para a ltima linha do texto.
O comando <^G> informa a ordem da linha apontada
e o nmero total de linhas no texto.

.sp
.b
2.1.3. Movendo o Cursor na Pgina Corrente
.r

.pp
As teclas "h", "j", "k" e "l" movem o cursor respectivamente 
para a esquerda, para baixo, para cima e para a direita.
Se h setas no teclado do seu terminal,
elas provavelmente so reconhecidas pelo editor "vi"
e tambm podem ser usadas para mover o cursor.

.sp
.b
2.1.4. Movendo o Cursor na Linha Corrente
.r

.pp
Os seguintes comandos movem o cursor sobre a linha corrente:
<bs> para o caractere  esquerda do cursor,
<sp> para o caractere  direita do cursor,
<ht> para o caractere ocupando a prxima coluna de tabulao,
"0" para o primeiro caractere,
"$" para o ltimo caractere,
"w" e "W" (word) para o incio da prxima palavra,
"e" e "E" (end) para o prximo fim de palavra,
"b" e "B" (begin) para o incio de palavra imediatamente anterior e
"^" para o incio da primeira palavra.

.pp
O editor "ex" distingue dois tipos de palavras:
para os comandos com letras maisculas
as palavras so seqncias de caracteres no incluindo
os separadores <sp> e <ht>;
para os comandos com letras minsculas, seqncias alfanumricas
ou seqncias de sinais de pontuao.
O alcance destes comandos no se limita  linha corrente.
Uma palavra  definida como uma seqncia de caracteres
diferentes de <sp> e <ht>.

.sp
.b
2.1.5. Busca de Expresses Regulares
.r

.pp
A busca de expresses regulares 
uma das formas mais prticas de localizar um trecho especfico
dentro do texto em edio.
Durante a busca de uma expresso regular, o editor "vi" percorre o texto circularmente,
ou seja, o editor "vi" considera
que ao fim do texto segue-se o seu incio e vice-versa.

.pp
O comando "/" busca uma expresso regular fornecida na ltima linha do vdeo
(como no modo Comandos descrito adiante)
avanando a partir do caractere apontado pelo cursor.
O comando "?" tambm requer uma expresso regular na ltima linha do vdeo
e procura-a nas linhas anteriores do texto.
O comando "n" (next) repete o ltimo comando "/" ou "?" executado.
O comando "N" repete a ltimo comando "/" ou "?" revertendo o sentido da busca.

.pp
O comando "&" move o cursor para o caractere
seguinte  cadeia correspondente  expresso regular.

.sp
.b
2.1.6. Busca de Caracteres
.r
.pp
Os comandos "f" e "F" (find) buscam o caractere fornecido a seguir,
repectivamente para frente e para trs.
Os comandos "t" e "T" (up to) so anlogos aos comandos "f" e "F",
porm no movem o cursor para o caractere procurado,
mas sim para o caractere que o antecedeu na busca.

.sp
.b
2.1.7. Marcao de Linhas
.r
.pp
A marcao de linhas permite que linhas sejam referenciadas por letras.
Um comando na forma "mx", onde "x"  uma letra minscula,
associa  linha corrente a marca "x".
Uma linha marcada pode ser localizada por um comando na forma
"'x", onde "x"  a marca associada.
Um comando na forma "`x" localiza a posio exata da marcao
(linha e ordem do caractere marcado).

.sp
.b
2.1.8. Verificao de Balanceamento
.r
.pp
O comando "%" busca o caractere correspondente ao balanceamento
do caractere corrente.
Os caracteres "[", "{" e "(" so balanceados respectivamente
pelos caracteres "]", "}" e ")" e vice-versa.

.sp 2
.b
2.2. Edio Bsica do Texto
.r
.pp
Esta seo aborda todos os comandos do modo Visual
para alterao do texto.

.sp
.(t
.b
2.2.1. Insero de Texto
.r

.pp
O editor "vi" dispe de vrios comandos
que permitem acrescentar caracteres teclados ao texto.
Estes comandos colocam o editor "vi" em seu modo Insero.
.)t

.pp
No modo Insero, o editor "vi" abre um espao apontado pelo cursor,
indicando onde o prximo caractere ser inserido.
O caractere <esc> encerra o modo Insero.
O estado do texto sob a janela  constantemente mantido atualizado no vdeo
durante o funcionamento do modo Insero
(para maiores detalhes, veja o Captulo 4).

.pp
Existem quatro comandos bsicos que iniciam o modo Insero.
Os comandos "i" (insert) e "a" (append) inserem texto
respectivamente  esquerda e  direita do caractere apontado pelo cursor.
Os comandos "o" e "O" (open) permitem a insero de texto
respectivamente abaixo e acima da linha apontada pelo cursor.

.sp
.b
2.2.2. Operadores
.r

.pp
Operadores manipulam extenses contguas de texto.
Os operadores devem ser seguidos de um comando para movimento do cursor
que especifica o escopo da operao.
Este comando para movimento do cursor  chamado
.b
objeto
.r
quando utilizado neste contexto.

.pp
As operaes podem abranger linhas inteiras
ou uma parte do texto entre dois caracteres,
de acordo com o tipo do movimento correspondente ao objeto.
No caso de repetio do operador, a operao abrange
um nmero de linhas inteiras dado pela contagem.

.pp
Os seguintes operadores esto disponveis:
"d" (delete) para remoo,
"c" (change) para substituio
(remoo seguida de entrada no modo Insero)
e ">" e "<" para o deslocamento de linhas
respectivamente para a direita e para a esquerda
(atravs da insero e remoo de caracteres <ht>).
O operador "y" (yank) para armazenamento independente
de partes do texto est descrito adiante
(seo 2.3. Cpia e Transferncia de Blocos).

.pp
Exemplos:
o comando "d$" remove do caractere apontado pelo cursor
at o final da linha corrente;
o comando "3cc" substitui a linha corrente
e mais duas abaixo por um texto inserido;
a seqncia "/ontem<esc>c&hoje<esc>"
busca a palavra "ontem" e a substitui pela palavra "hoje".

.sp
.b
2.2.3. Reverso e Repetio dos Comandos de Edio
.r

.pp
O comando "u" (undo) reverte o ltimo comando de edio.
Isto significa que sempre  possvel retornar o texto ao seu estado anterior.
O comando "u" tambm pode ser revertido.
A aplicao repetida do comando "u"
faz com que o texto alterne entre dois estados (o atual e o anterior).

.pp
O comando "." (ponto) repete o ltimo comando de edio.

.sp
.(t
.b
2.2.4. Substituio de um Caractere
.r

.pp
O comando "r" (replace) substitui o caractere apontado pelo cursor
pelo caractere teclado a seguir.
.)t

.sp 2
.b
2.3. Cpia e Transferncia de Blocos de Texto
.r
.pp
Blocos de texto so grupos de linhas de texto contguas.
O editor "vi" dispe de um conjunto de reas de memria
capazes de armazen-los.
Estas reas de memria so chamadas 
.b buffers.
Existem 27 buffers no editor "vi";
26 so referenciados por uma letra minscula
(buffers com nomes de "a" at "z")
e um  acessado diretamente (buffer sem nome).

.pp
As operaes bsicas relativas aos buffers
so a cpia de uma parte do texto para um buffer
e sua recproca - a cpia do contedo de um buffer para o texto.
O operador "y" (yank) copia o objeto especificado para um buffer.
Os comandos "p" e "P" (put) copiam o contedo de um buffer
para respectivamente aps e antes o cursor.

.pp
O operador "y" e os comandos "p" e "P"
na forma mais simples trabalham com o buffer sem nome.
A especificao de um buffer antecede o comando
e  feita teclando aspas (") e a letra correspondente ao buffer desejado.

.pp
Os buffers no so preenchidos apenas pelo operador "y".
As partes do texto removidas pelo operador "d"
tambm so copiadas para os buffers.

.pp
Uma aplicao interessante do buffer sem nome
 um modo bastante prtico
para a transferncia de parte do texto,
realizando a seguinte srie de comandos:
remoo da parte do texto desejada,
movimento do cursor
e cpia do buffer sem nome para o texto em edio.

.pp
Exemplos:
o comando
.b
yw
.r
guarda uma palavra no buffer sem nome;
o comando
.b
"ay'x
.r
copia para o buffer "a" as linhas
desde a linha corrente at a linha marcada como "x".

.sp 2
.b
2.4. Sinnimos
.r

.pp
Existem alguns sinnimos usando apenas um caractere
para os comandos ou seqncias de comandos utilizados
com maior frequncia e que requerem dois ou mais caracteres
para serem executados.
A lista completa dos sinnimos e seus respectivos significados
est na tabela a seguir.

.sp
.(t
.ts
center
allbox;
c s s
c c l.
Alguns Sinnimos teis
Sinnimo	Comandos	Funo
x	d<sp>	apaga o caractere sob o cursor
X	d<bs>	apaga o caractere anterior
s	c<sp>	substitui o caractere corrente
I	^i	insere no incio da linha
A	$a	insere ao final da linha corrente
C	c$	substitui at o final da linha
D	d$	remove at o final da linha
Y	yy	armazena a linha corrente
S	cc	substitui a linha corrente
.te
.)t

