
.bp
.sp 4
.nf
     *********************************************************
     *                                                       *
     *                      CAPTULO  3                      *
     *                                                       *
     *                     MODO COMANDOS                     *
     *                                                       *
     *********************************************************
.fi
.sp 4
.pp
Tanto o modo Visual como o modo Comandos so suficientes
para a realizao da maioria das operaes de edio normalmente necessrias,
entretanto em determinados contextos pode ser mais vantajoso
trabalhar em um ou no outro modo.
O modo Visual  mais adequado quando  necessria uma melhor visualizao
do texto e para a realizao de correes localizadas.
O modo Comandos  mais prtico
quando as operaes de edio podem ser mais facilmente localizadas
linha a linha ou abrangem um nmero inteiro de linhas.
Este captulo detalha a funcionalidade do modo Comandos.

.pp
Os comandos do modo Comandos podem requerer zero, um ou dois endereos.
Quando so fornecidos endereos a menos,
o "vi" assume endereos pr-estabelecidos.
 um erro dar mais endereos do que o comando espera.
.br

.pp
Se no for especificado nenhum comando
aps o endereamento
o comando ser "p" (print) (explicado mais adiante).
Uma linha em branco faz da linha seguinte  linha corrente
a nova linha corrente e a mostra.

.pp
Endereos so tipicamente separados por uma vrgula (",").
Quando os endereos so separados por um ponto e vrgula (";"),
o segundo endereo  calculado fazendo-se antes
o primeiro endereo como linha corrente.
Esta caracterstica pode ser usada para determinar 
a linha incial para buscas para frente e para trs ("/" e "?").
O segundo endereo de toda seqncia de dois endereos
tem que corresponder a uma linha de ordem superior
a linha correspondente ao primeiro endereo.

.pp
As sees a seguir descrevem a especificao de endereos
e todos os comandos disponveis.

.sp 2
.b
3.1. Endereamento
.r

.pp
O endereamento de linhas no texto em edio
baseia-se no conceito de linha corrente.
De modo geral a linha corrente  a ltima linha afetada por um comando;
entretanto a escolha exata da nova linha corrente
aps a execuo de cada comando
 explicada na discusso dos comandos.
Endereos podem ser construdos do seguinte modo:

.in +3
.ip 1. 4
O caractere "." enderea a linha corrente.

.ip 2. 4
O caractere "$" enderea a ltima linha no texto em edio.

.ip 3. 4
Um nmero decimal "n" enderea a linha de ordem "n'sima" no texto em edio.

.(t
.ip 4. 4
A seqncia "'m" enderea a linha marcada com o nome "m",
que deve ser uma letra minscula.
No modo Visual linhas so marcadas atravs do comando "m",
no modo Comandos atravs do comando "k" (mark).
.)t

.(t
.ip 5. 4
Uma expresso regular entre barras ("/expresso/")
enderea a linha encontrada buscando-se avante aps a linha corrente
ou aps o endereo especificado at ento
e parando na primeira linha que contm uma cadeia
que corresponda  expresso regular.
Se necessrio, a busca d a volta, passando pelo fim do texto em edio.
.)t

.(t
.ip 6. 4
Uma expresso regular entre interrogaes ("?expresso?")
enderea a linha encontrada buscando-se retroativamente
antes da linha corrente
ou do endereo especificado at ento
e parando na primeira linha que contm uma cadeia
que corresponda  expresso regular.
Se necessrio, a busca d a volta, passando pelo incio do texto em edio.
.)t

.(t
.ip 7. 4
Um endereo seguido de um "+" (sinal de soma)
ou de um "-" (sinal de subtrao)
seguido de um nmero decimal especifica um endereo
somado ou subtrado
do nmero indicado de linhas.
.)t

.(t
.ip 8. 4
Se um endereo comea com "+" ou com  "-" a adio ou subtrao
 tomada como em relao a linha corrente, isto ,
"-5" equivale  ".-5".
.)t

.(t
.ip 9. 4
Se um endereo termina com "+" (ou "-"), ento um  somado (ou subtrado).
Como conseqncia desta regra e da regra 8,
o endereo "-" se refere  linha anterior a linha corrente.
Mais ainda, "-" e "+" no final de um endereo tm efeito cumulativo,
assim "--" se refere a linha corrente menos dois.
.)t
.ep
.in -3

.sp 2
.b
3.2. Comandos
.r
.pp
Esto listados a seguir todos os comandos do modo Comandos.
Os valores pr-estabelecidos para os endereos
indicando a abrangncia dos comandos
so mostrados entre parnteses  esquerda dos comandos.
.br
.sp
.(b
.in 5
(.) a
.br
<texto>
.br
 .
.br

.in 10
O comando 
"a" (append)
l o texto dado
e o acrescenta ao texto em edio a partir da linha endereada.
.)b

.sp
.(b
.in 5
(.,.) c
.br
<texto>
.br
 .
.br

.in 10
O comando 
"c" (change)
remove as linhas endereadas,
e ento recebe o texto entrado
que substitui estas linhas.
Se no houver texto entrado,
a nova linha corrente ser a linha anterior s linhas removidas.
.)b

.sp
.(b
.in 5
(., .) d[p]
.br
.in 10
O comando 
"d" (delete)
remove as linhas endereadas do texto em edio.
A linha originalmente aps a ltima linha removida
se tornar  a linha corrente;
se as linhas removidas estavam originalmente no final do texto em edio,
a ltima linha no texto em edio ser a nova linha corrente.
Se o sufixo "p" estiver presente a nova linha corrente  mostrada.
.br
.)b

.sp
.(b
.in 5
e [arquivo]
.br

.in 10
O comando 
"e" (edit)
causa a remoo de todas linhas no texto em edio
e a leitura de "arquivo" para o texto em edio.
O nmero de linhas e caracteres lidos  escrito.
O nome "arquivo"  lembrado para poder ser usado em sub-sequentes
comandos "r", "w" e "e" como nome de arquivo pr-estabelecido.
.)b

.sp
.(b
.in 5

E [arquivo]
.br
.in 5
e! [arquivo]
.br
.in 10
Estes comandos so equivalentes ao comando "e",
exceto que nenhuma mensagem de erro  enviada
se o texto em edio j foi alterado
desde sua ltima atualizao no sistema de arquivos.
.br
.)b

.sp
.(b
.in 5

f [arquivo]
.br
.in 10
O comando 
"f" (filename)
informa o nome lembrado para o arquivo em edio.
Se "arquivo"  dado, o nome correntemente lembrado  trocado para "arquivo".
.br
.)b

.sp
.(b
.in 5

(1,$) g/expresso regular/ [comando]
.br
.in 10
O comando 
"g" (global)
marca todas as linhas endereadas
onde h uma ocorrncia de "expresso regular"
e para cada uma dessas linhas
a torna a linha corrente
e executa "comando"
Os comandos "a", "i", "c",
"g" e "v" no so permitidos.
.)b

.sp
.(b
.in 5
(1, $) g!/expresso regular/ [comando]
.br
.in 10
Este comando  o mesmo que o comando "g", exceto que
"comando"  executado para cada linha no contendo
"expresso regular".
.)b

.sp
.(b
.in 5
g [comando]
.br
.in 10
O comando 
"g" (global)
sem especificao de expresso regular
utiliza as linhas marcadas no ltimo comando "g".
.)b

.sp
.(b
.in 5
(.) i
 <texto>
 .

.in 10
O comando 
"i" (insert)
acrescenta  o texto antes da linha endereada.
Este comando difere do comando "a" apenas no local para colocao do texto.
.)b

.sp
.(b
.in 5
(., .+1) j
.br
.in 10
O comando
"j" (join)
transforma as linhas endereadas
em uma nica linha.
A linha resultante ser a nova linha corrente.
.)b

.sp
.(b
.in 5
(.) k m
.br
.in 10
O comando 
"k" (mark)
marca a linha endereada com a letra minscula "m".
O endereamento "'m" se refere a esta linha.
.)b

.sp
.(b
.in 5
(., .) l
.br
.in 10
O comando 
"l" (list)
mostra as linhas endereadas
de uma forma no ambgua.
Os caracteres <bs> so indicados por "<"
e caracteres de tabulao (<ht>) so indicados por ">".
Linhas muito longas so quebradas
em linhas de at 72 colunas.
O final de cada linha  indicado com um "$".
.)b

.sp
.(b
.in 5
(., .) m endereo
.br
.in 10
O comando 
"m" (move)
reposiciona as linhas endereadas para aps a linha endereada
por "endereo". A ltima das linhas movidas se tornar a linha
corrente.
.)b

.sp
.(b
.in 5
(., .) n
.br
.in 10
O comando 
"n" (number)
exibe as linhas endereadas
com os nmeros das linhas e um <ht>  esquerda.
.)b

.sp
.(b
.in 5
(., .) p
.br
.in 10
O comando
"p" (print)
mostra as linhas endereadas.
A ltima linha mostrada ser a nova linha corrente.
O comando "p" pode ser colocado na mesma linha que um comando
que no realize entrada ou saida.
.)b

.sp
.(b
.in 5
(., .) P
.br
.in 10
Este comando mostra uma pgina com a linha endereada no centro.
A linha corrente permanece inalterada.
.)b

.sp
.(b
.in 5
q
.in 10
O comando 
"q" (quit)
faz com que "vi" termine.
O arquivo em edio no  automaticamente atualizado no disco.
.)b

.sp
.(b
.in 5
Q
.br
.in 5
q!
.in 10
Estes comandos so o mesmo que "q", exceto que
nenhuma mensagem de erro
ocorre se o texto em edio j foi alterado  desde
a ltima atualizao do arquivo.
.)b

.sp
.(b
.in 5
($) r [arquivo]
.br
.in 10
O comando 
"r" (read)
l  "arquivo" para o texto em edio
aps a linha endereada.
Se "arquivo" estiver ausente,
o nome corrente  utilizado.
O nome "arquivo"   lembrado se ainda no houver um nome de arquivo corrente.
Se a leitura for bem sucedida,
o nmero de  linhas e caracteres lidos  mostrado.
A nova linha corrente ser a ltima linha lida do arquivo.
A ltima linha lida do arquivo ser a nova linha corrente.
.)b

.sp
.(b
.in 5
(., .) s[n]/expresso regular/substituio/ [p]
.br
.in 10
O comando 
"s" (substitute)
busca em cada linha endereada
ocorrncias de "expresso regular"
e substitue as de ordem "n" por "substituio".
Se a ordem "n" no for especificada,
todas as ocorrncias de "expresso regular" so substitudas.
 um erro a no ocorrncia de 'expresso regular'
em todas as linhas endereadas.
.br
.sp
Qualquer caractere de pontuaco pode ser usado em lugar de "/"
para delimitar a expresso regular e a substituio.
.br
.sp
O caracter "&" em 'substituio'  substituido
pela cadeia correspondente  expresso regular.
O significado especial de "&" pode ser anulado
precedendo-o por "\".
.br
.sp
O caractere <nl> precedido por "\"
divide a linha substituda em duas.
.br
.sp
A ltima linha onde houve substituio ser a nova linha corrente.
.)b

.sp
.(b
.in 5
(., .) t endereo
.br
.in 10
Este comando age como o comando "m" (move),
exceto que uma cpia das linhas endereadas
 colocada aps "endereo".
A ltima linha copiada ser a nova linha corrente.
.)b

.sp
.(b
.in 5
v
.in 10
O comando "v" (visual) retorna o editor ao modo Visual.
.)b

.sp
.(b
.in 5
(1, $) w[!] [arquivo]
.br
.in 10
O comando 
"w" (write)
escreve as linhas endereadas
em "arquivo".
Se o arquivo no existe,  criado.
Este comando no ser obedecido se "arquivo" for o nome correntemente lembrado
e no tenha havido alterao no texto
desde sua ltima atualizao no disco
ou se "arquivo" no for o nome correntemente lembrado
e j existir um arquivo com seu nome.
O comando seguido de exclamao s no  executado
em caso de erro de escrita no disco.
A linha corrente permanece inalterada.
Se o comando  bem sucedido
o nmero de linhas e caracteres escritos  mostrado.
.)b

.sp
.(b
.in 5
(1, $) W [arquivo]
.br
.in 10
Este comando  o mesmo que "w", exceto que as linhas endereadas
so acrescenatadas no final de "arquivo".
.)b

.sp
.(b
.in 5
($) =
.br
.in 10
O nmero da linha endereada  mostrado.
A linha corrente permanece inalterada.
.)b

.sp
.(b
.in 5
! [Comando Shell]
.br
.in 10
O restante da linha aps o "!"  enviado a "sh"(cmd)
para ser interpretado como um comando.
.)b

.sp
.(b
.in 5
(.+1, .+1)
.br
.in 10
Um endereamento apenas mostra as linhas endereadas.
A ltima linha mostrada ser a nova linha corrente.
.)b

.in 0
