.bp
.he 'FDFORMAT (cmd)'TROPIX: Manual de Referncia'FDFORMAT (cmd)'
.fo 'Atualizado em 13.05.02'Verso 4.2.0'Pag. %'

.b NOME
.in 5
.wo "fdformat -"
formata disquetes
.br

.in
.sp
.b SINTAXE
.in 5
.(l
fdformat [-fvt] [-s <tamanho>] [-e <entre>] [-01] [<dispositivo>]
.)l

.in
.sp
.b DESCRIO
.in 5
O utilitrio "fdformat" formata o disquete <dispositivo>.
Este <dispositivo> deve ser dado na forma "no estruturada"
(de caracteres), "/dev/rfd0" ou "/dev/rfd1".

.sp
Na presente verso, "fdformat" processa os sequintes formatos:

.bc	/*************************************/
   |    3"   |  1722   |     82    |     21     |  3444  |
.ec	/*************************************/

.sp
.(l
   +----------+---------+-----------+------------+--------+
   | Diametro | Tamanho | Cilindros |   Setores  | Blocos |
   |          |  (KB)   |           | por trilha |        |
   +----------+---------+-----------+------------+--------+
   |    3"   |  1440   |     80    |     18     |  2880  |
   |    3"   |   720   |     80    |      9     |  1440  |
   |          |         |           |            |        |
   |    5"   |  1200   |     80    |     15     |  2400  |
   |    5"   |   360   |     40    |      9     |   720  |
   +----------+---------+-----------+------------+--------+
.)l

.sp
Um parmetro importante a ser considerado na formatao de disquetes
 o fator de entrelaamento, que define a posio de cada setor
dentro da trilha.
Com o fator de entrelaamento 1, isto , com a numerao seqencial
dos setores na forma

.sp
.nf
		1 2 3 4 5 6 7 8 9
.fi
.sp
possivelmente a leitura/escrita do disquete ser lenta.
Isto ocorre porque entre a leitura/escrita de dois setores seguidos (5 e 6,
por exemplo) no h uma "pausa" necessria para a preparao da
leitura/escrita seguinte.
Isto significa que quando for iniciada a operao para acessar o setor 6,
a cabea de leitura/escrita ter acabado de passar por ele, forando
uma rotao extra do disquete.

.sp
Por outro lado, com o fator de entrelaamento 2 teremos a disposio
da forma

.sp
.nf
		1 6 2 7 3 8 4 9 5
.fi
.sp
com a qual (por exemplo, aps a leitura do setor 7),
temos o tempo durante a cabea est em cima do setor 3
para preparar a leitura/escrita do setor 8.
Desta maneira evitamos a rotao suprflua e aumentamos a velocidade
do dispositivo. 

.sp
Os valores por omisso do fator de entrelaamento
 2 para o tamanho de 1200 KB, e 1 para os demais.
.bc	/*************************************/
so 2 para os tamanhos de 1722 e 1200 KB, e 1 para os demais.
.ec	/*************************************/

.sp
.(t
As opes do comando so:

.in +3
.ip -f
Normalmente, o comando pede uma confirmao do usurio antes de
efetivamente iniciar a formatao (que ir destruir o contedo
antigo do disquete).
Com a opo "-f", esta confirmao no  pedida.
.)t

.ip -v
Verboso: com esta opo, so dados as seguintes informaes sobre
a formatao: nmero de setores por trilha, nmero de cilindros,
nmero total de setores e o entrelaamento usado.

.ip -t
Apenas identificao: com esta opo, o comando ao invs de formatar o
disquete, apenas tenta descobrir se o disquete j est formatado,
e (se sim) com qual formatao.

.ip -s
Tamanho do contedo do disquete: o <tamanho> dado deve ser um dos
tamanhos em KB da tabela acima. Se esta opo no for dada, 
assumido o tamanho "1440".
.bc	/*************************************/
assumido o tamanho "1722".
.ec	/*************************************/

.sp
Podem tambm ser usados os seguintes
.bc	/*************************************/
sinnimos: "1.72" para "1722", "1.44" para "1440", "1.2" para "1200",
.ec	/*************************************/
sinnimos: "1.44" para "1440", "1.2" para "1200",
".72", "0.72" para 720 e ".36", "0.36" para 360.

.ip -e
Usa o fator de entrelaamento <entre> ao invs do valor por omisso
(comentado acima).

.ip -0
Uma abreviao para o <dispositivo> "/dev/rfd0".

.ip -1
Uma abreviao para o <dispositivo> "/dev/rfd1".

.ep
.in -3

.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd): "
gar, dosmp
.br

.in
.sp
.b ESTADO
.in 5
Efetivo.

.in
