/*
 ****************************************************************
 *								*
 *			common.h				*
 *								*
 *	Definies universais					*
 *								*
 *	Verso	1.1.0, de 11.01.88				*
 *		4.2.0, de 27.04.02				*
 *								*
 *	Mdulo: GAR						*
 *		Utilitrios Bsicos				*
 *		Categoria B					*
 *								*
 *	TROPIX: Sistema Operacional Tempo-Real Multiprocessado	*
 *		Copyright  2002 NCE/UFRJ - tecle "man licena"	*
 * 								*
 ****************************************************************
 */

/*
 ****************************************************************
 *	Definies universais					*
 ****************************************************************
 */
#define	EVER	;;
#define	elif	else if
#define NOVOID	(void *)NULL
#define	NOPTR	(void *)NULL

#define STR(x)	# x
#define XSTR(x)	STR (x)

#define	STDIN	0
#define STDOUT	1

#define	MIN(a,b)	((a) < (b) ? (a) : (b))

typedef unsigned short	ushort;	/* 16 bites sem sinal */

/*
 ******	Indicadores *********************************************
 */
extern int		Tflag;		/* Gera o formato TAR */
extern int		Dflag;		/* NO Comprime */
extern int		nflag;		/* Interativo */
extern int		uflag;		/* Comparao com atualizao */
extern int		rflag;		/* Sempre cheque os CRCs */
extern int		vflag;		/* Verbose */
extern int		dflag;		/* Diretorio Corrente */
extern int		fflag;		/* Copia mesmo que j exista */
extern int		mflag;		/* Restaura dono, grupo e datas */
extern int		gflag;		/* Processa o "garfield" */
extern int		dotflag;	/* No ignora ".old" etc ... */
extern int		crcflag;	/* No gera CRC na compresso */
extern int		Gflag;		/* Debug */

/*
 ******	Declaraes da deflao *********************************
 */
#define DEF_LEVEL	5	/* Nvel de compactao normal (ZIP) */
#define MIN_LEVEL	1	/* Nvel de compactao mnimo (ZIP) */
#define MAX_LEVEL	9	/* Nvel de compactao mximo (ZIP) */

extern int		ZIP_LEVEL;	/* Os nveis podem ser de 1..9 */

/*
 ****** Variveis externas **************************************
 */
extern const char	headerversion[]; /* Verso do programa */

extern int		exit_code;	/* Cdigo de retorno */

extern int		file_block;	/* No. do bloco do arquivo na coleo */ 

/*
 ******	Buffer de Entrada/Saida *********************************
 */
extern int		col_area_sz;		/* Tamanho do buffer em vigor (blocagem) */

extern int		col_area_avail_sz;	/* No. de bytes disponiveis no buffer */

extern int		col_is_a_tape;		/* A coleo  uma fita */

/*
 ****** Variveis diversas **************************************
 */
extern const char	*g_filenm;	/* Nome do Arquivo em Processamento */
extern int		g_filenmput;	/* O Nome do Arquivo ja foi impresso */
extern int		g_nlput;	/* O <nl> j foi escrito */

extern time_t		date;		/* Data de criao da Coleo GAR */

extern int		vol;		/* No. do Volume GAR */

extern FILE		*ttyfp;		/* Para ler do terminal */

extern const char	**color_vector;	/* Para as cores dos modos */

/*
 ****** Garfield ************************************************
 */
extern const char	garfield[];
extern FILE		*gfp;

/*
 ****** Garstamp ************************************************
 */
extern const char	garstamp[];
extern time_t		garstamp_time;

/*
 ****** Coleo *************************************************
 */
extern int		device_code;	/* Cdigo do dispositivo */
extern const char	*device_nm; 	/* Nome do Dispositivo */

extern int		colfd;		/* File Descriptor da Coleo */
extern dev_t		coldev;		/* Dispositivo da Coleo */
extern ino_t		colino;		/* Inode da Coleo */

extern char		*reduce_nm0,	/* Nomes do arquivo temporrio */
			*reduce_nm1,
			*reduce_nm2;

extern long		totalbytes;	/* No. Total de Bytes lidos/escritos */

extern off_t		col_offset;	/* Tamanho da coleo */

extern off_t		col_max_offset;	/* Tamanho mximo da coleo */

/*
 ******	Prottipos de funes ***********************************
 */
extern void		(*function) (void *, int);

extern off_t		deflate (int, FILE *);
extern off_t		inflate (void (*) (), int);
extern void		msg (char *, ...);
extern off_t		reduce (int, FILE *);
extern off_t		unreduce (void (*) ());
extern char		*editpercent (int);
extern int		getpercent (long, long);
extern void		bread (void *, int);
extern void		bwrite (const void *, int);
extern void		on_signal (int, ...);
extern const char	*edit_BY_to_KB (ulong bytes);

#ifdef	STAT_H
extern void		get_dev_size (int, STAT *sp);
extern void		print_file_nm (const char *, const STAT *, const char *, FILE *);
#endif	STAT_H

