.bp 1
.he 'GREP (cmd)'TROPIX: Manual de Referncia'GREP (cmd)'
.fo 'Atualizado em 08.05.02'Verso 4.2.0'Pag. %'

.b NOME
.in 5
grep - procura padres em arquivos
.sp

.in
.sp
.b SINTAXE
.in 5
grep [-clnsmrN] <padro>[|<padro> ...] [<arquivo> ...]

.in
.sp
.b DESCRIO
.in 5
O comando "grep" l um ou mais <arquivo>s, procurando por linhas que contenham
pelo menos um dos <padres> dados.
Normalmente, cada linha selecionada  copiada para a sada padro ("stdout").

.sp
Os nomes dos arquivos podem ser dados como argumentos,
podem ser lidos de um arquivo de nomes (ver a opo "-N"),
ou por omisso, o arquivo pode ser a entrada padro ("stdin").


.sp
Os padres utilizados pelo comando "grep" so expresses regulares com
a mesma sintaxe das funes "regcmp" e "regex" (libc).

Podem ser dados vrios padres, separados pelo caractere "|".
Para que um padro possa conter este caractere sem que seja confundido
com o separador de padres, basta preced-lo por "\".

.sp
As opes de funcionamento do "grep" so:

.in 8
.ip "-c" 5
Lista apenas o nmero total de linhas selecionadas
(no copia as linhas selecionadas para a sada padro).

.ip "-l" 5
Lista apenas os nomes dos arquivos (uma nica vez)
que contm linhas selecionadas
(no copia as linhas selecionadas para a sada padro).

.ip "-n" 5
Na listagem das linhas selecionadas, inclui alm do nome do arquivo,
tambm o nmero da linha no respectivo arquivo.

.ip "-s" 5
No lista nada; retorne apenas o estado (ver o valor de retrno).

.ip "-m" 5
Procura os padres sem fazer distino entre letras mausculas e minsculas.

.ip "-r" 5
Inverte o sentido da busca, isto , selecione linhas que NO
contenham nenhum dos padres.

.ip "-N" 5
L os nomes dos arquivos da entrada padro, ao invs de obt-los
como argumentos.
Esta opo  til para utilizao com o comando "walk" (cmd).
Se no for dada esta opo,
nem arquivos como argumentos,
o contedo do arquivo ser lido da entrada padro.

.ep
.in 5
.sp 2
Deve-se tomar cuidado com a utilizao dos caracteres
"$", "*", "[", "]", "|", e "\" nos padres,
j que eles tambm tm significado especial
para o interpretador de comandos "sh" (cmd).
O mais seguro  colocar o argumento com os padres entre aspas.

.in
.sp
.b
VALOR DE RETORNO
.r
.in 5
Retorna 0 se foi selecionada pelo menos uma linha, retorna 1 se
no foi selecionada nenhuma linha, e retorna 2 se houveram erros
de sintaxe ou arquivos inacessveis.

.in
.sp
.b OBSERVAO
.in 5
O tamanho das linhas  limitado a 1024 caracteres. Linhas maiores
so divididas em duas (ou mais).

.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd): "
sh, walk
.br
.wo "(libc):"
regcmp, regex
.br


.in
.sp
.b EXEMPLOS
.in 11
.sp
grep comando /etc/passwd
.sp
.br
.in 5
lista as linhas do arquivo "/etc/passwd" que contm
a cadeia "comando" da seguinte forma:
.sp
.(b
.nf
	/etc/passwd:  data::comando data:10:0:0:0::/:/bin/data
	/etc/passwd:  who::comando who:10:0:0:0::/:/bin/who
.fi
.)b

.sp 3
.in 11
grep -v "^a" *
.sp
.in 5
percorre todos os arquivos do diretrio,
listando as linhas que no comeam com o caractere "a".

.sp 3
.in 11
walk -p "*.h" /usr/include | grep -N short
.sp
.br
.in 5
lista as linhas que contm "short" de todos os arquivos
de incluso da rvore cuja raiz  "/usr/include".
.sp

.in
.sp
.b ESTADO
.in 5
Efetivo.

.in
