.bp
.he 'IFDEF (cmd)'TROPIX: Manual de Referncia'IFDEF (cmd)'
.fo 'Atualizado em 08.05.02'Verso 4.2.0'Pag. %'

.b NOME
.in 5
.wo "ifdef -"
realiza prprocessamentos parciais
.br

.in
.sp
.b SINTAXE
.in 5
.(l
ifdef [-vr] [-D <var>] [-U <var>] <arquivo1> [<arquivo2]
ifdef [-vr] [-D <var>] [-U <var>] <arquivo> ... <diretrio>
ifdef [-vr] [-D <var>] [-U <var>] -N <diretrio>
.)l

.in
.sp
.b DESCRIO
.in 5
O programa "ifdef"  um prprocessador simplificado,
realizando um subconjunto das operaes do "cpp" (cmd).
A funo de "ifdef"  a de realizar prprocessamentos parciais, em que
apenas algumas das variveis de tempo de prprocessamento
so resolvidas.

.sp
O objetivo primordial de "ifdef"  o de, dados programas
com muitas opes complexas de prprocessamento,
retirar os trechos de programas no desejados, para simplificar e
tornar os programas mais compreensveis.

.sp
Em sua primeira forma, "ifdef" processa o <arquivo1>, colocando
o resultado em <arquivo2>. Se <arquivo2> no for dado, escreve
o resultado na sada padro.

.sp
Na segunda forma, um ou mais <arquivo>s so processados, e os
resultados colocados no <diretrio> especificado, com os mesmos
nomes dos respectivos <arquivo>s.

.sp
A terceira forma  anloga  segunda, com exceo dos nomes dos
<arquivo>s, que so lidos da entrada padro, um por linha.

.bc	/*************************************/
.sp
Normalmente, a sada de "ifdef"  utilizado adiante como entrada
para o prprocessador "cpp" numa etapa de compilao,
quando ento so resolvidas as variveis restantes.
.ec	/*************************************/

.sp 2
Para a utilizao de "ifdef", d-se uma lista de variveis
que devem ser consideradas "definidas" e outra lista de variveis
que devem ser consideradas "indefinidas".

.sp
So processadas:

.in +3
.ip 1. 3
As pseudo-intrues "#ifdef", "#ifndef", "#else" e "#endif", que referenciam
alguma das variveis dadas.

.ip 2. 3
A pseudo-intruo "#if", apenas no caso particular
.wo '"#if (0)".'

.ip 3. 3
As pseudo-intrues "#define" e "#undef"
referentes s variveis dadas, que
so eliminadas.

.ep
.in -3
.sp
Todos as demais pseudo-intrues do prprocessador,
assim como os pseudo-intrues  
referentes a variveis no dadas
so includas sem alterao nos <arquivo>s de sada.

.sp
As opes do comando so:

.in +3 
.ip "-D <var>" 10
Considera a varivel <var> definida. 
Esta definio  mais forte do que os "#undef"s encontrados
nos <arquivo>s de entrada.
Todas as referencias a esta varivel so resolvidas,
incluindo ou no os trechos adequados dos <arquivo>s de entrada.
Os <arquivo>s de sada no contm mais referncias a esta varivel.

.ip "-U <var>" 10
Considera a varivel <var> indefinida. 
Esta indefinio  mais forte do que os "#define"s encontrados
nos <arquivo>s de entrada.
Todas as referncias a esta varivel so resolvidas,
incluindo ou no os trechos adequados dos <arquivo>s de entrada.
Os <arquivo>s de sada no contm mais referncias a esta varivel.

.ip "-N" 10
Le os nomes dos <arquivo>s de entrada da entrada padro, um por linha.

.ip "-v" 10
Lista os nomes dos <arquivo>s de entrada durante o processamento.

.ip "-r" 10
Lista as variveis residuais, isto , as que so referenciadas
em um "#define", "#undef", "#ifdef" ou "#ifndef" e que no
foram dadas em nenhumas das listas de variveis do comando.
Estas so as variveis que ainda so referenciadas nos <arquivo>s
de sada.

.in -3 
.ep

.in
.sp
.b OBSERVAO
.in 5
Deve-se lembrar que o programa processa a pseudo-instruo "#if"
apenas no caso particular "#if (0)".

.sp
Isto significa que ele no reconhece que
.sp
.(l
		#if defined (ZETA)

 equivalente a

		#ifdef	ZETA
.)l
.sp
o que pode gerar programas de sada errados.

.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd): "
cpp
.br

.in
.sp
.b EXEMPLO
.r
.in 5
.wo "				ifdef -D ALPHA -U BETA a.c b.c"
.br
.sp
prprocessa o arquivo "a.c", eliminando todas as referncias s
variveis de prprocessamento "ALPHA" e "BETA" (incluindo ou no
os trechos de "a.c" apropriados), pondo o resultado em "b.c".
As pseudo-instrues referentes s demais variveis so copiadas
sem mudanas no arquivo "b.c". 

.in
.sp
.b ESTADO
.in 5
Efetivo.

.in
