.bp
.he 'EDITSCB (cmd)'TROPIX: Manual de Referncia'EDITSCB (cmd)'
.fo 'Atualizado em 14.08.98'Verso 3.1.0'Pag. %'

.b NOME
.in 5
.wo "editscb -"
edita/imprime o bloco de controle da INTERNET
.br

.in
.sp
.b SINTAXE
.in 5
.(l
editscb
editscb -e [-v] [<porta>]
editscb -t [-v]
editscb -f [-v] <dev> [<sz>]
editscb -d [-v] [+-][<arg>]
editscb -p [-v] <arg>=<valor>
.)l

.bc	/*************************************/
editscb [-etv] [-f <dev> [<sz>]] [-d [+-][<arg>]]
						[-p <arg>=<valor>]
.ec	/*************************************/

.in
.sp
.b DESCRIO
.in 5
O comando "editscb" gerencia diversos parmetros da INTERNET. 

.sp
Sem opes, "editscb" imprime inicialmente uma linha com os
seguinte parmetros gerais (veja "t_intro"):

.in +3
.ip 1.
ITBLOCKs: O nmero de reas de entrada/sada
em uso/alocadas para datagramas.

.ip 2.
RAW EPs: O nmero de estruturas ("endpoints") em uso/alocadas
para o modo-de-acesso-interno.

.ip 3.
UDP EPs: O nmero de estruturas em uso/alocadas para o modo-sem-conexo.

.ip 4.
TCP EPs: O nmero de estruturas em uso/alocadas para o modo-com-conexo.

.ep
.in -3

.sp
Em seguida "editscb" imprime os seguintes parmetros do modo-com-conexo (TCP):

.in +3
.ip 1.
WND_SZ: O tamanho total da janela:
Nmero de bytes permitidos para a recepo de dados em uma conexo.

.ip 2.
GOOD_WND: O "bom" tamanho da janela:
Limite de bytes para permitir o incio de transmisso em uma conexo.

.ip 3.
ALPHA: O fator de amortecimento do algoritmo de retransmisso TCP em \%
(Veja o RFC 793, pg. 41, para detalhes sobre este algoritmo).

.ip 4.
BETA: O fator de varincia de atraso do algoritmo de retransmisso TCP
(Veja o RFC 793, pg. 41, para detalhes sobre este algoritmo).

.ip 5.
SRTT: O tempo amortecido de viagem de ida e volta inicial (em segundos)
do algoritmo de retransmisso TCP
(Veja o RFC 793, pg. 41, para detalhes sobre este algoritmo).

.ip 6.
N_TRANS: O nmero mximo de transmisses dos datagramas TCP.

.ip 7.
WAIT: O tempo mximo (em segundos) de espera para conexes TCP
ainda no completadas.
 
.ip 8.
SILENCE: O tempo mximo (em segundos) de manuteno de conexes TCP sem
transmisso/recepo de datagramas.

.ip 9.
MAX_SGSZ: O tamanho mximo (em bytes) do segmento TCP permitido nas negociaes.

.ep
.in -3

.in
.sp
.b DEPURAO/CONTROLE
.in 5
O sistema operacional TROPIX permite que a atividade dos mdulos da
INTERNET sejam monitorados/controlados (veja a opo "-d").

.sp
Os argumentos <arg> que alteram a depurao/controle so:

.in +3
.ip 'wi:' 4
Grava a entrada de datagramas no arquivo "itnet.debug".

.ip 'wo:' 4
Grava a sada de datagramas no arquivo "itnet.debug".

.ip 'li:' 4
Relata a entrada de datagramas.

.ip 'lo:' 4
Relata a sada   de datagramas.

.ip 'rt:' 4
Relata retransmisses.

.ip 'oq:' 4
Relata remoes da fila de retransmisso.

.ip 'ce:' 4
Causa erros propositais de "checksum" na recepo de datagramas.

.ip 'er:' 4
Relata erros.

.ip 'in:' 4
Lista algumas infomaes adicionais.

.ip 'bs:' 4
Relata segmentos recusados.

.ip 'lw:' 4
Relata tamanhos das janelas.

.ip 'tt:' 4
Relata clculos do SRTT.

.ip 'gw:' 4
Executa a funo de GATEWAY.

.ip 'pi:' 4
Usa a otimizao para conexes TCP internas.

.ep
.in -3

.in
.sp
.b 'OPES DE "EDITSCB"'
.in 5
As opes do comando so:

.in +3
.ip -e
Imprime as estruturas ("endpoints") TCP em uso. Para cada conexo,
so dados os endereos IP ("Internet Protocol"), portas,
o estado da conexo, os nmeros de seqncia,
os tamanhos das janelas, os tamanhos das filas de entrada/sada,
e outras variveis da estrutura TCP_EP (Veja o arquivo 
"/usr/include/sys/itnet.h" e o RFC 793).

.sp
Se for dada a <porta> opcional, sero impressos somente os
dados referentes  esta porta local.

.ip -t
Imprime 3 tabelas: a tabela de endereos IP conhecidos,
a tabela de roteamento e a tabela de endereos dos dispositivos "ethernet".

.sp
A tabela de endereos contm uma linha para cada n conhecido da rde,
contendo o seu endereo IP, alguns indicadores e o nome do n.
Os indicadores so:
A coluna "C" contm "C" para o nome de um
computador, "A" para um nome "alias" de um computador e "M" para
um domnio de correio eletrnico.
A coluna "E" (erros) contm "N" para um nome inexistente, "S" para um rro
do servidor de nomes e <sp> se no houver erros.
A coluna "I" contm o ndice do servidor de nomes utilizado para obter
este endereo; corresponde  lista dada no final do arquivo "/etc/itnetdev".
A coluna "PRE" contm o valor de "preferncia" de um servidor de correio.

.sp
A tabela de roteamento indica para qual dispositivo de sada
o datagrama deve ser enviado (baseado no seu endereo IP destino).
O datagrama  enviado para o dispositivo associado  primeira linha que
satisfizer: ((endereo & MSCARA) == REDE).
O campo LOCAL d o endereo IP fonte a ser utilizado no datagrama. 
O campo GATEWAY d o endereo IP de um roteador, caso a rede destino no
esteja conectada diretamente a este computador.
O campo DISPOSITIVO d o nome simblico do dispositivo que deve enviar o
datagrama.

.sp
A tabela de endereos dos dispositivos "ethernet" fornece o endereo fsico
do dispositivo "ethernet" (48 bits) associado ao endereo IP. 

.ip -v
Verboso.

.ip -f
Consulta/altera o tamanho do FIFO de sada da linha serial <dev>.
Esta opo s  pertinente se a linha serial for o modlo NS16550
(ou equivalentes), e <dev> for um dispositivo SLIP ou PPP.
Se <sz> for dado (de 1 a 16), altera o valor para <sz>.
Se <sz> no for dado, imprime o valor corrente.

.ip -d
Depurao/controle: Esta opo permite consultar/alterar a
depurao/controle da INTERNET (veja os argumentos acima).

.sp
Com a opo "-d -" so impressos os estados atuais dos argumentos
(asteriscos no incio da linha indicam que o argumento est ligado);
com a opo "-d <arg>" ou "-d +<arg>"  ligado o argumento <arg>;
com a opo "-d -<arg>"  desligado o argumento <arg>.

.ip -p
Altera o parmetros.
Podem apenas ser alterados os parmetros do modo-com-conexo (TCP):
WND_SZ, GOOD_WND, ALPHA, BETA, SRTT,
N_TRANS, WAIT, SILENCE e MAX_SGSZ.
O parmetro ALPHA deve ser dado como uma percentagem; os demais
deve ser dados com o prprio valor; vrios parmetros pode ser dados
separados por vrgulas.

.sp
Repare que os valores de ITBLOCKs, RAW EPs, UDP EPs e TCP EPs so modificados
por "edscb" e NO por este comando "editscb".

.sp
Consulte "scb" (fmt), parmetros "nitblock", "nrawep", "nudpep", "ntcpep", 
"ndns", "nroute" e "nether".

.ep
.in -3

.in
.sp
.b OBSERVAO
.in 5
Repare que NO h arquivo de configurao para os parmetros TCP.
Se for desejado usar (sempre) um valor no padro,  necessrio
incluir um linha executando "editscb" no arquivo "/etc/rc".

.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd): "
edscb, prscb
.br
.wo "(xti): "
t_intro
.br
.wo "(fmt): "
scb
.br

.in
.sp
.b
REFERNCIAS
.r
.in 5
Postel, J., "Transmission Control Protocol", RFC 793,
USC/Information Sciences Institute, September 1981.

.in
.sp
.b ARQUIVOS
.in 5
/etc/itnetdev
 /etc/rc

.in
.sp
.b ESTADO
.in 5
Efetivo.

.in
