.bp
.he 'FTP (cmd)'TROPIX: Manual de Referncia'FTP (cmd)'
.fo 'Atualizado em 03.03.01'Verso 4.0.0'Pag. %'

.b NOME
.in 5
.wo "ftp -"
programa de cpia remota de arquivos da INTERNET
.br

.in
.sp
.b SINTAXE
.in 5
.(l
ftp [-vn] <n_remoto>
.)l

.in
.sp
.b DESCRIO
.in 5
O programa "ftp"  a interface do usurio para o protocolo padro de
cpias de arquivos da INTERNET. O programa permite a cpia de arquivos
de/para um computador remoto de uma rde.

.sp
Inicialmente, "ftp" obtm uma conexo com o servidor "ftp" do
<n_remoto> e em seguida executa a seqncia de "login",
pedindo a conta/senha do usurio no <n_remoto> (veja a opo "-n").
Finalmente, "ftp" passa o controle para o interpretador de comandos,
aguardando instrues do usurio.
Para indicar que est aguardando comandos, "ftp" imprime uma linha
contendo os caracteres "ftp> ".

.sp
As opes do programa so:

.in +3
.ip -v
Verboso: imprime as estatsticas sobre as transferncias de dados,
alm de outras informaes.

.ip -n
No executa automaticamente a seqncia de "login", passando diretamente o
contrle para o interpretador de comandos. Repare no entanto, que a maioria
dos comandos s podem ser executados com um usurio em sesso. Para entrar
em sesso mais tarde, deve ser usado o comando "user".

.ep
.in -3

.sp
O nome do <n_remoto> e/ou o nome do usurio podem ser pr-definidos no
ambiente (veja "environ" (fmt)) atravs da varivel "FTP",
cujo valor deve ter a forma:

.sp
.(l
	node=<n_remoto>,user=<nome_do_usurio>
.)l

.in
.sp
.b 'PARMETROS DE TRANSFERNCIA DE DADOS'
.in 5
O protocolo FTP define uma srie de parmetros que definem como a
transferncia dos dados de um arquivo ser realizada.

.sp
O tipo de representao dados pode ser ASCII, EBCDIC, IMAGEM ou LOCAL.
Esta implementao suporta apenas os tipos ASCII e IMAGEM.
O tipo ASCII  tambm chamado de ISO porque so conservados os 8 bits.

.sp
O contrle de formato pode ser NON-PRINT, TELNET ou ASA.
Esta implementao suporta apenas o formato NON-PRINT.

.sp
A estrutura de dados pode ser FILE, RECORD ou PAGE.
Esta implementao suporta apenas a estrutura FILE.

.sp
O modo de transmisso de dados pode ser STREAM, BLOCK ou COMPRESSED.
Esta implementao suporta apenas o modo STREAM.

.sp
A conexo de dados  normalmente aberta no modo "ativo", isto , com
o servidor executando o "connect". Isto pode ser alterado atravs do comando
interno "passive" (veja abaixo).

.in
.sp
.b COMANDOS
.in 5
O programa "ftp" reconhece os seguintes comandos:

.in +3
.ip " 1." 4
? [-s] [<comando>]
.sp
Como "help", abaixo.

.ip " 2." 4
!<comando> [<argumento> ...]
.sp
Executa o <comando> com os respectivos <argumento>s no n local.
Isto vale inclusive para o comando "cd".

.ip " 3." 4
ascii
.sp
Altera o tipo da representao de dados para ISO (ASCII).

.ip " 4." 4
bin
.sp
Altera o tipo da representao de dados para IMAGEM.

.ip " 5." 4
binary
.sp
Altera o tipo da representao de dados para IMAGEM.

.ip " 6." 4
bye
.sp
Encerra o programa. Um EOF (normalmente <^D>) tem o mesmo efeito.

.ip " 7." 4
cd [<diretrio_remoto>]
.sp
Altera o diretrio corrente do n remoto para <diretrio_remoto>.
Se o <diretrio_remoto> no for dado, ser usado o diretrio "HOME"
do usurio remoto.

.ip " 8." 4
cdup
.sp
Altera o diretrio corrente do n remoto para o pai do diretrio
corrente atual.

.ip " 9." 4
cmp <arquivo_local> [<arquivo_remoto>]
.sp
Compara um arquivo do n local com um arquivo do n remoto. Se o nome
do <arquivo_remoto> no for dado, ser igual ao nome do <arquivo_local>.

.ip 10. 4
delete <arquivo_remoto>
.sp
Remove o <arquivo_remoto>.

.ip 11. 4
dir [<arquivo_remoto> [<arquivo_local]]
.sp
 equivalente ao comando "ls", abaixo.

.ip 12. 4
exit
.sp
 equivalente ao comando "quit", abaixo.

.(t
.ip 13. 4
get <arquivo_remoto> [<arquivo_local>]
.sp
Copia um arquivo do n remoto para o n local. Se o nome do
<arquivo_local> no for dado, ser igual ao nome do <arquivo_remoto>.
Se o nome do <arquivo_local> for "-", o contedo do <arquivo_remoto>
ser impresso na sada padro.
.)t

.ip 14. 4
help [-s] [<comando>]
.sp
Imprime uma descrio do significado do <comando>. Se o nome do <comando>
no for dado, imprime uma lista dos comandos disponveis. Se for dada a
opo "-s" sero fornecidas as mesmas informaes, mas obtidas do
servidor.

.ip 15. 4
image
.sp
Altera o tipo da representao de dados para IMAGEM.

.ip 16. 4
iso
.sp
Altera o tipo da representao de dados para ISO (ASCII).

.ip 17. 4
lc [<diretrio_remoto>]
.sp
Imprime o contedo (no estilo de "lc") do <diretrio_remoto>.
Se este no for dado, ser considerado o diretrio corrente remoto.
Este comando no  padro do protocolo FTP, e no pode ser usado com
outros servidores.

.ip 18. 4
ls [<arquivo_remoto> [<arquivo_local]]
.sp
Imprime informaes (no estilo de "ls -l") do <arquivo_remoto>.
O <arquivo_remoto> pode tambm ser um diretrio, caso em que sero
impressas informaes sobre o contedo do diretrio remoto.
Se o <arquivo_remoto> no for dado (ou for igual a "."), ser considerado
o diretrio corrente remoto.
Se o <arquivo_local> for dado, as informaes so postas neste arquivo;
em caso contrrio so impressas na sada padro.


.ip 19. 4
mget [-f] [<diretrio>]
.sp
Copia os arquivos regulares contidos no <diretrio> do n remoto
para o n local.
Os arquivos locais sero colocados no <diretrio> (de mesmo nome) local,
que j dever existir.
Se o nome do <diretrio> no for dado, ser considerado o diretrio corrente
(remoto e local).
Se a opo "-f" no for dada, ser pedida a confirmao da cpia de cada
arquivo.

.(t
.ip 20. 4
mkdir <diretrio_remoto>
.sp
Cria o <diretrio_remoto>.
.)t

.ip 21. 4
mput [-f] [<diretrio>]
.sp
Copia os arquivos regulares contidos no <diretrio> do n local
para o n remoto.
Os arquivos locais sero colocados no <diretrio> (de mesmo nome) remoto,
que j dever existir.
Se o nome do <diretrio> no for dado, ser considerado o diretrio corrente
(local e remoto ).
Se a opo "-f" no for dada, ser pedida a confirmao da cpia de cada
arquivo.

.ip 22. 4
mv <nome_antigo> <nome_novo>
.sp
Muda o nome do arquivo remoto <nome_antigo> para <nome_novo>.

.ip 23. 4
nlst [<diretrio_remoto>]
.sp
Imprime os nomes dos arquivos regulares contidos no <diretrio_remoto>.
Se o <diretrio_remoto> no for dado, ser considerado
o diretrio corrente remoto.
Este comando  til para verificar quais os arquivos que um comando "mget"
ir copiar.

.ip 24. 4
noop
.sp
No realiza nenhuma operao.
Este comando  til para verificar se a conexo ainda est
ativa e estimar o tempo de resposta do servidor.

.ip 25. 4
passive
.sp
Alterna entre os modos "ativo" e "passivo" da abertura da conexo
de dados. No modo "ativo",  o servidor que realiza o "connect",
enquanto que no modo "passivo"  o cliente.

.ip 26. 4
port [-sn] [<nmero_do_port>]
.sp
Pelo protocolo FTP, a conexo de dados deve usar normalmente o "port"
de nmero 20, podendo ser mudado atravs de um comando "PORT".
Alm disto, uma vez mudado este nmero,
este novo "port" dever ser utilizado pelo servidor em todas as operaes
seguintes (at a recepo de um novo comando "PORT").

.sp
No entanto, h servidores FTP que no seguem estas convenes.
A funo do comando "port"  o de permitir o uso destes servidores.

.sp
Se for dada a opo "-s", ser executado um comando "PORT" para cada
operao que utiliza a conexo de dados.
Por outro lado, se for dada a opo "-n", ser executado um comando
"PORT" apenas se o nmero do "port" for diferente do utilizado
na operao anterior.

.sp
Se for dado um <nmero_do_port> diferente de zero, este ser utilizado
a partir das operaes seguintes. Se ele for igual a zero, ser obtido
um nmero de "port" temporrio do sistema operacional, e que ser
utilizado a partir das operaes seguintes.
Se o  nmero de "port" dado no puder ser usado, tambm ser obtido
um nmero de "port" temporrio do sistema operacional.
Se o <nmero_do_port> no for dado, continuar a ser usado o "port"
anteriormente utilizado.

.sp
Inicialmente, "ftp" utiliza o "port" 20 (padro) para a conexo de dados e
executa um comando "PORT" para cada operao que usa a conexo de dados.

.ip 27. 4
put <arquivo_local> [<arquivo_remoto>]
.sp
Copia um arquivo do n local para o n remoto. Se o nome do
<arquivo_remoto> no for dado, ser igual ao nome do <arquivo_local>.

.ip 28. 4
pwd
.sp
Imprime o nome do diretrio corrente remoto.

.ip 29. 4
quit
.sp
Encerra o programa. Um EOF (normalmente "^D") tem o mesmo efeito.

.ip 30. 4
quote <nome> [<argumento_1> [<argumento_2>] ]
.sp
Envia para o servidor um comando consistindo do <nome> e
possivelmente um ou dois <argumento>s (exatamente como dado(s)).
 esperada uma (e apenas uma) resposta do servidor.
A chegada de outras respostas pode ser verificada atravs do comando
"reset".

.sp
O comando "quote"  til para a utilizao de comandos disponveis
em um outro servidor, que no entanto esta implementao "ftp" no suporta.
Uma outra possibilidade  o uso de comandos que ainda
iro ser definidos futuramente no protocolo FTP
(e que estaro disponveis em um futuro servidor).

.sp
Repare que com "quote" s podemos utilizar comandos que no utilizam a
conexo de dados.

.ip 31. 4
rename <nome_antigo> <nome_novo>
.sp
Muda o nome do arquivo remoto <nome_antigo> para <nome_novo>.

.ip 32. 4
reset
.sp
L uma resposta do servidor (se disponvel).
Isto  til para que o cliente e o servidor fiquem novamente em
fase, caso o servidor (violando o protocolo) emita resposta(s)
a mais.

.ip 33. 4
rm <arquivo_remoto>
.sp
Remove o <arquivo_remoto>.

.ip 34. 4
rmdir <diretrio_remoto>
.sp
Remove o <diretrio_remoto>.

.ip 35. 4
status
.sp
Fornece informaes sobre o cliente e o servidor.

.ip 36. 4
system
.sp
Obtm o tipo de sistema operacional do servidor.

.ip 37. 4
type [ascii|a|image|i|binary|bin|b]
.sp
Altera o tipo da representao de dados.
Os nomes vlidos so "ascii" e "a" para o tipo ISO (ASCII) e
"image", "i", "binary" e "bin" para o tipo IMAGEM.
Se no for dado nenhum nome, ser impresso o tipo corrente.

.ip 38. 4
user [<nome_do_usurio>]
.sp
Inicia a seqncia de "login". Se o <nome_do_usurio> no for
dado, ele  pedido, assim como a senha e conta (caso necessrios).
A no ser que seja dada a opo "-n" (do programa), esta seqncia
 iniciada automaticamente quando "ftp"  executado.

.in -3
.ep

.in
.sp
.b "INTERRUPO DE COMANDOS E DE CPIA DE ARQUIVOS"
.in 5
Esta implementao do protocolo FTP ainda no possibilita a interrupo
de uma cpia de arquivos em andamento. Se for usada a tecla de interrupo
(normalmente <^C>), ser impressa uma mensagem indicando isto, mas a
cpia prosseguir at o final.

.sp
O nico uso significativo da tecla de interrupo  nos
comandos "mget" e "mput", que sero interrompidos ao final da
cpia do arquivo em andamento.

.in
.sp
.b "COMANDOS ACEITOS/NO ACEITOS PELO SERVIDOR"
.in 5
O servidor reconhece e processa os seguintes comandos:

.sp
.(l
	USER	PASS,	PASV,	ACCT,	CWD,	CDUP,	QUIT,
	PORT,	TYPE,	STRU,	MODE,	RETR,	STOR,	RNFR,
	RNTO,	DELE,	RMD,	MKD,	PWD,	LIST,	LC,
	NLST,	SYST,	STAT,	HELP,	NOOP
.)l

.sp
.(t
O servidor reconhece, mas no processa os seguintes comandos:

.sp
.(l
	SMNT,	REIN,	STOU,	APPE,	ALLO,	REST,
	ABOR,	SITE
.)l
.)t

.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd): "
tcmpto
.br
.wo "(fmt): "
environ
.br

.in
.sp
.b
REFERNCIAS
.r
.(l
Postel, J. & Reynolds J.:
"FILE TRANSFER PROTOCOL (FTP), RFC 959",
Outubro de 1985.
.)l

.in
.sp
.b ESTADO
.in 5
Efetivo.

.in
