/*
 ****************************************************************
 *								*
 *			mem_alloc.c				*
 *								*
 *	Alocao dinamica de memria				*
 *								*
 *	Verso	4.0.0, de 23.08.00				*
 *		4.0.0, de 23.08.00				*
 *								*
 *	Mdulo: MAIL						*
 *		Utilitrios de comunicao			*
 *		Categoria B					*
 *								*
 *	TROPIX: Sistema Operacional Multiprocessado		*
 *		Copyright  2000 NCE/UFRJ - tecle "man licena"	*
 *								*
 ****************************************************************
 */

#include <sys/syscall.h>

#include <stdio.h>
#include <stdlib.h>

/*
 ****************************************************************
 *	Definies e variveis globais				*
 ****************************************************************
 */
#define	INCR		4192	/* Tamanho Basico para alocao */

#define	elif	else if

#define	ROUND(x) ((x + 3) & ~3)	/* Arredondamento do tamanho */

entry void	*mem0,		/* Ponteiros para a rea disponvel */
		*mem1,
		*mem2;

/*
 ****************************************************************
 *	Alocao de Memria					*
 ****************************************************************
 */
void *
mem_alloc (int size)
{
	void		*addr, *status;

	size = ROUND (size);

	/*
	 *	Verifica se h espao
	 */
	while (mem1 + size > mem2)
	{
		if   ((int)(status = sbrk (INCR)) == -1)
		{
			error (NOSTR);
		}
		elif (mem0 == NOVOID)
		{
			mem0 = mem1 = status;	/* Primeira vez */
		}
		elif (status != mem2)
		{
			error ("$mem_alloc: Recebi rea NO adjacente");
		}

		mem2 = status + INCR;
	}

	/*
	 *	Acerta os indicadores
	 */
	addr = mem1; mem1 += size;

	return (addr);

}	/* end mem_alloc */

/*
 ****************************************************************
 *	Devolve um trecho no usado de memria			*
 ****************************************************************
 */
void
mem_free (void	*a)
{
	a = (void *)ROUND ((int)a);

	if (a >= mem0 && a <= mem1)
		{ mem1 = a; return; }

	error ("mem_free: Devoluo invlida de memria: %P\n", a);

}	/* end mem_free */
