.bp
.he 'POP3 (cmd)'TROPIX: Manual de Referncia'POP3 (cmd)'
.fo 'Atualizado em 01.01.03'Verso 4.4.0'Pag. %'

.b NOME
.in 5
.sp
.wo "pop3 -"
acessa uma caixa postal remota
.br

.in
.sp
.b SINTAXE
.in 5
.(l
pop3 [-av] [<usurio_remoto>@][<n_remoto>]
.)l

.in
.sp
.b DESCRIO
.in 5
O programa "pop3" permite o acesso a uma caixa postal remota, atravs
do protocolo POP3 (Post Office Protocol, Version 3).

.sp
Aps a conexo com o <n_remoto>, o programa "pop3" verifica se h
cartas para o <usurio_remoto> na caixa postal remota, que ainda no estejam
presentes na caixa postal local (isto , cartas "novas").
Se houverem cartas "novas" o usurio  consultado para decidir se deseja copi-las
para a caixa postal local.

.sp
Para cada carta "nova", o usurio  consultado para saber se deseja copi-la para
a caixa postal local, e em seguida, remove-la da caixa postal remota.
As respostas seguem as convenes da funo "askyesno" (libc) no modo "de fora",
isto , letras minsculas decidem aes sobre uma carta em particular e
letras maisculas decidem aes sobre todas as cartas seguintes. As aes
das cpias e remoes so independentes.

.sp
As cartas, uma vez copiadas para a caixa postal local, podem ser lidas atravs
do programa "mail" (cmd).

.sp
As opes do comando so:

.in +3
.ip -a
Normalmente, "pop3" apenas oferece para a remoo as cartas novas da caixa
postal remota. Com a opo "-a", todas as cartas da caixa postal remota
so oferecidas para remoo. Tambm neste caso so seguidas as
convenes da funo "askyesno" (libc) no modo "de fora".

.ip -v
Verboso.

.ep
.in -3

.in
.sp
.b 'ARGUMENTOS NO AMBIENTE'
.in 5
Para simplificar o uso do programa, o nome do <usurio_remoto> e/ou do <n_remoto>
podem ser dados no ambiente (fmt).
A cadeia do ambiente deve ter uma das formas

.sp
.nf
		POP3=<usurio_remoto>@<n_remoto>
		POP3=<n_remoto>
.fi

.sp
O nome do <n_remoto>  procurado seguindo a ordem: 
argumento da linha de execuo do programa,
ambiente (cadeia "POP3").

.sp
O nome do <usurio_remoto>  procurado seguindo a ordem: 
argumento da linha de execuo do programa,
ambiente (cadeia "POP3").

.sp
O nome do <usurio_local>  procurado seguindo a ordem: 
ambiente (cadeia "USER"), 
nome dado ao entrar na conta (conforme o programa "who" (cmd)),
nome obtido atravs da identificao numrica do usurio (UID).

.in
.sp
.(t
.b OBSERVAES
.in 5
O programa "pop3" espera que o servidor do <n_remoto> processe
o comando "UIDL", para permitir a identificao das cartas.
Se isto no ocorrer, ele supe que tdas as cartas remotas
so novas. Neste caso, uma estrategia aconselhvel  a de sempre copiar
tdas as cartas para a caixa postal local, removendo as cartas
da caixa postal remota.
.)t

.sp
O servidor "pop3" processa os seguintes comandos:
"HELP", "USER", "PASS", "QUIT", "NOOP", "LIST", "UIDL",
"STAT", "TOP", "LAST", "RETR", "DELE" e "RSET".

.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd): "
mail, who
.br
.wo "(libc):"
askyesno
.br
.wo "(fmt): "
ambiente
.br

.in
.sp
.b
REFERNCIAS
.r
.in 5
 J. Myers & M. Rose: "Post Office Protocol - version 3", RFC 1725, Novembro de 1994.

.in
.sp
.b ARQUIVOS
.in 5
 /var/spool/mail/$USER/l.*.t
 /var/spool/mail/$USER/status

.in
.sp
.b ESTADO
.in 5
Efetivo.

.in




.bc	/*************************************/
.bp
.he 'POP3 (cmd)'TROPIX: Manual de Referncia'POP3 (cmd)'
.fo 'Atualizado em 21.08.98'Verso 1.0.0'Pag. %'

.b NOME
.in 5
.wo "pop3_s -"
envia as cartas do correio eletrnico segundo o protocolo POP3
.br

.in
.sp
.b DESCRIO
.in 5
O servidor pop3_s permite o processamento remoto de correspondncia,
que  manipulada segundo o protocolo POP3, tornando simples o
acesso remoto atravs de programas de correio eletrnico que executem
em estaes de trabalho no UNIX.

.sp
As opes do comando so:

.ip 'HELP [<cadeia>]' 24
Fornece informaes sobre os comandos.

.ip 'USER <nome do usurio>' 24
Especifica o nome do usurio.

.ip 'PASS <senha>' 24
Fornece a senha.

.ip QUIT 24
Encerra o servio do servidor.

.ip NOOP 24
Apenas responde +OK

.ip 'LIST [<num.mensagem>]' 24
Fornece tamanho de uma mensagem (ou de todas).

.ip STAT 24
Fornece nmero de mensagens e tamanho total.

.ip 'TOP  <num.mensagem> [<num.linhas>]' 24
Fornece o cabecalho e as primeiras linhas de uma mensagem.

.ip LAST 24
Informa o nmero da ltima mensagem processada.

.ip 'RETR <nome arquivo>' 24
Obtm o contedo de uma mensagem.

.ip 'DELE <Num.mensagem>' 24
Remove uma mensagem.

.ip RSET 24
Desapaga todas as mensagens.

.ep
.in -3

.in
.sp
VEJA TAMBM
.r
.in 5
.wo "(cmd): "
mail
.br

.in
.sp
.(t
.b
REFERNCIAS
.r
.in 5
Rose, M: "Post Office Protocol - version 3", RFC 1225, Maio de 1991.
.)t

.in
.sp
.(t
.b ARQUIVOS
.in 5
/usr/spool/mail/$USER/l.*.a
.br
/usr/spool/mail/$USER/status
.)t

.in
.sp
.b ESTADO
.in 5
Efetivo.

.in
.ec	/*************************************/
