.bp
.he 'PPP (cmd)'TROPIX: Manual de Referncia'PPP (cmd)'
.fo 'Escrito em 14.04.00'Verso 3.2.3'Pag. %'

.b NOME
.in 5
.sp
.wo "ppp -"
cria uma comunicao PPP com um n remoto
.br

.in
.sp
.b SINTAXE
.in 5
.(l
ppp [-l <linha>] [-t <texto>] [-p <conta>:<senha>]
.)l

.bc	/*************************************/
ppp [-l <linha>] [-s <velocidade>] [-t <texto>] [-f <n>] [-j]

Opes:	-l: Define a <linha> de comunicaes a utilizar
	    (se no dada,  utilizada a linha "/dev/pppline")
	-t: Escreve o <texto> de inicializao do modem
	    (contendo o nmero do telefone)
	-p: Usa a <conta:senha> dada

Obs.:	Para desconectar use "ps -k" ou "kill ..."
.ec	/*************************************/

.in
.sp
.b DESCRIO
.in 5
O comando "ppp" cria uma conexo PPP ("Point to Point Protocol")
atravs de uma linha de comunicaes.

.sp
Para criar uma conexo PPP atravs do comando "ppp" so necessrios
os seguintes recursos/conhecimentos:

.in +3
.ip 1.
Uma conta em um provedor que permita o acesso atravs de linha discada
(por exemplo, o NCE/UFRJ).

.ip 2.
O endereo IP do servidor de nomes (DNS) do provedor
(por exemplo, 146.164.10.2 no caso do NCE).

.sp
Este endereo deve ser includo na linha "name_server"
do arquivo "/etc/itnetdev" (veja itnetdev (fmt)). Este endereo deve
ser dado antes de inicializar a rede (por exemplo, atravs de
um "boot").

.ip 3.
O nmero de telefone a discar (por exemplo, 598-3240 no caso do NCE).

.ip 4.
Configurar o modem. Para isto  necessrio saber o endereo ("port")
do modem e o seu IRQ (nmero da interrupo). Estes dois dados podem
ser alterados apenas nesta execuo do TROPIX (durante o "boot") ou
(um pouco mais) definitivamente atravs do comando "edscb" (cmd).

.sp
Para facilitar,  til dar um "link" (isto , criar um sinnimo) do 
dispositivo do modem ("/dev/ppp00?") para o nome "default"
("/dev/pppline"); veja a opo "-l".

.ip 5.
Saber os caracteres de inicializao/controle do modem. Normalmente
basta uma cadeia do tipo "atpd5983240" (para discar o NCE), mas dependendo
da marca/modelo do modem, outros caracteres de controle podem ser necessrios.
Consulte o manual do seu modem.

.sp
Por exemplo, se for desejado teclar no modo de tom (ao invs de pulso
como acima), basta trocar o "p" por "t".
Se voc tiver um "modem" "US Robotics", talvez seja til
acrescentar os caracteres "s6=5", que aumentam o tempo de espera pelo
sinal de discar para 5 segundos
(considerando que os telefones cariocas (muitas vzes)
demoram para dar o sinal de discar).
Com estas duas modificaes, teramos a cadeia "ats6=5td5983240".

.sp
Esta cadeia pode ser dada atravs da opo "-t" (ver abaixo), ou ser teclada
manualmente.

.bc	/*************************************/
Com os telefones brasileiros, que (muitas vzes) demoram para dar o sinal de discar,
 til acrescentar os caracteres "s6=5"

.ip 6.
Saber a velocidade do modem. Se no for usada a opo "-s" (ver abaixo),
o modem ir tentar negociar a velocidade de 9600 baud (a no ser que ele
seja mais lento do que isto). Normalmente, o mais simples  utilizar
a opo "-s 38.4", pois neste caso o modem ir negociar a maior velocidade
comum (isto no atual estado da tecnologia, que so modems de at 33600
baud).
.ec	/*************************************/

.ep
.in -3

.sp
.(t
Aps a discagem, quando o modem do provedor atender, inicia-se a fase de
autenticao, onde negocia-se o nome da conta e da senha. Em seguida, assim que
o provedor enviar o primeiro pacote PPP, o programa "ppp" inicia
automaticamente a negociao PPP, aps a qual volta o "prompt" do
"sh" (cmd). Neste ponto, fica um processo "ppp" em "background",
e a conexo recem criada j pode ser usada.
.)t

.sp
Repare na linha "Entrando em modo PPP ...". Nela so dadas a velocidade
da conexo, e o nmero do processo ("pid") que ser usado
mais tarde para terminar a conexo.

.sp
Nesta verso de "ppp" j  processado o protocolo PAP ("Password
Authentication Protocol").

.sp
Se no for conseguida a conexo na primeira tentativa, o comando "ppp"
executa mais 4 tentativas, aps as quais a execuo  encerrada.
Durante esta fase, o comando pode ser cancelado teclando-se os
caracteres "~.".

.sp
Utilize o comando "editscb" (cmd) com a opo "-t" para verificar 
se o dispositivo "ppp" foi includo na tabela de roteamento.
Para testar a disponibilidade de ns da rede, use o comando "ping" (cmd).

.sp
Para encerrar a conexo, basta cancelar o processo "ppp" (que ficou em
"background"). Para isto usamos o comando "kill" (cmd) para terminar
o processo cujo nmero foi dado no momento do estabelecimento da conexo
("pid"), veja acima. Se voc no guardou este nmero, 
podemos usar o comando "ps" (cmd) com o argumento "-k".
Uma outra alternativa  de usar "ps" apenas para saber o "pid" do processo
"ppp" e em seguida usar o comando "kill".

.sp
As opes do comando so:

.in +3
.ip -l
Define a <linha> de comunicaes a utilizar.
Se esta opo no for dada,  utilizada a linha "/dev/pppline".
Repare que "/dev/ppp000" corresponde a COM1 (do MS-DOS),
"/dev/ppp001" corresponde a COM2,
"/dev/ppp002" corresponde a COM3, e assim por adiante.

.bc	/*************************************/
ppp [-l <linha>] [-s <velocidade>] [-t <texto>] [-f <n>] [-j]

.ip -s
Define a <velocidade> da linha.
Uma lista completa de velocidades  dada em "stty" (cmd).
Se esta opo no for dada, a velocidade da linha ser estabelecida
em 115200 baud, e posteriormente o modem ir negociar a maior velocidade
possvel com o modem do provedor.
Esta opo s precisa ser usada se for desejado utilizar velocidades
mais baixas do que o mximo acima mencionado.
.ec	/*************************************/

.ip -t
Escreve o <texto> dado na linha. Este <texto>  normalmente usado
para inicializar um modem e discar o nmero de telefone desejado. 

.bc	/*************************************/
.ip -f
Define o nmero mximo <n> de caracteres a escrever no FIFO
de sada da linha serial em cada interrupo.
Os valores vlidos vo de 1 a 16 (mas dependem do tipo da linha serial).
O objetivo desta opo  a de reduzir a velocidade de sada da
linha serial, e normalmente NO deve ser usada.

.ip -j
Normalmente,  utilizada a compresso de "Van Jacobson" nos cabealhos
TCP/IP, que reduz o tamanho tpico de 40 bytes para (at) 3 bytes. 
Com esta opo, esta compresso no  utilizada,
e normalmente (a opo) NO deve ser usada.
.ec	/*************************************/

.ip -p
Fornece a conta/senha para a conexo PPP. Normalmente, para a "conta" 
usado o prprio nome do usurio dado no "login" (cmd), e que est em geral disponvel
atravs da varivel "USER" do ambiente (veja "environ" (fmt)). Atravs desta
opo podemos dar um outro nome de conta.

.sp
A senha correspondente  pedida no incio da execuo de "ppp". Podemos tambm
adicion-la  opo "-p" da linha de comando (veja a observao, abaixo),
o que por um lado  cmodo, por outro lado torna a senha menos secreta.

.sp
Na forma "-p <conta>:<senha>" so dados a conta e senha,
em "-p <conta>"  dada apenas a conta, e em "-p :<senha>  dada apenas a senha.

.ep
.in -3

.in
.sp
.b OBSERVAO
.in 5
Uma forma cmoda de utilizar o programa "ppp"  o de construir
arquivos contendo j uma linha de comando para um provedor.
Veja como exemplo o arquivo "/usr/pub/bin/pppnce".

.sp
Durante a conexo PPP,  adicionada uma entrada para o dispositivo
"ppp" na tabela de roteamento. Esta entrada ter sempre prioridade
sobre entradas "default" (veja "itnetdev").

.bc	/*************************************/
Lembre-se de que o roteamento para o dispositivo "ppp" NO ser
possvel se for usado o roteamento "default" (veja "itnetdev").
.ec	/*************************************/

.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd): "
sh, ps, kill, stty, edscb, editscb, ping
.br
.wo "(fmt): "
itnetdev, environ
.br

.in
.sp
.b
REFERNCIAS
.r
.in 5
W. Simpson, "The Point-to-Point Protocol (PPP)", RFC 1661,
Julho 1994.

.sp
V. Jacobson, "Compressing TCP/IP Headers for Low-Speed Serial
Links", RFC 1144, Fevereiro 1990.

.in
.sp
.b ARQUIVOS
.in 5
/dev/ppp00?
 /etc/itnetdev
 /usr/pub/bin/pppnce

.in
.sp
.b ESTADO
.in 5
Efetivo.

.in
