/*
 ****************************************************************
 *								*
 *			reduce0.c				*
 *								*
 *	Comprime um arquivo segundo o algoritmo LZW		*
 *								*
 *	Verso	2.3.0, de 14.09.90				*
 *		3.0.0, de 14.05.95				*
 *								*
 *	Mdulo: TCMPTO_C/TNET					*
 *		Utilitrios de comunicaes			*
 *		Categoria D					*
 *								*
 *	TROPIX: Sistema Operacional Tempo-Real Multiprocessado	*
 *		Copyright  2000 NCE/UFRJ - tecle "man licena"	*
 * 								*
 ****************************************************************
 */

#include <sys/types.h>

#include <stdio.h>
#include <stdlib.h>
#include <stat.h>
#include <signal.h>
#include <string.h>

#include "../reduce.h"

/*
 ****************************************************************
 *	Variveis e Definies globais				*
 ****************************************************************
 */
entry long	in_cnt, out_cnt; /* Total de caracteres de entrada/sada */

entry int	in_fd;		/* Descritor do arquivo */

entry int	code_area[NC];	/* Cabem sempre NC cdigos at de 16 bits */

/*
 ****** Parmetros de compresso ********************************
 */
entry int	MAX_BIT_SZ;	/* O algoritmo funciona no mximo com 16 bits */ 

entry int	MAX_BIT_USED;	/* Nmero de bits realmente usados */ 

entry int	MAX_CODE;	/* Nunca pode usar este cdigo */

entry int	CODE_SOURCE;	/* Fonte de novos cdigos */

entry int	TEST_POINT;	/* Prximo teste de performance */

entry int	bit_sz;		/* Tamanho atual */

entry int	max_code;	/* ltimo cdigo do tamanho atual */

/*
 ****************************************************************
 *	Edita uma percentagem					*
 ****************************************************************
 */
char *
editpercent (register int quoc)
{
	static char	buf[8];
	char		*sinal;

	if (quoc < 0)
		{ sinal = "-"; quoc = -quoc; }
	else
		sinal = "";


	sprintf (buf, "%s%d.%02d", sinal, quoc / 100, quoc % 100);
	
	return (buf);

}	/* end editpercent */

/*
 ****************************************************************
 *	Calcula uma percentagem					*
 ****************************************************************
 */
int
getpercent (register long numer, register long denom)
{
	int		quoc;

	/*
	 *	Tenta evitar overflow
	 */
	if (numer > (0x7FFFFFFF / 10000))
		quoc = numer / (denom / 10000);
	else
		quoc = 10000 * numer / denom;

	return (quoc);

}	/* end percent */
