/*
 ****************************************************************
 *								*
 *			<tnet.h>				*
 *								*
 *	Formato do segmento de comunicao da TNET		*
 *								*
 *	Verso	2.3.0, de 23.10.91				*
 *		3.0.5, de 05.08.97				*
 *								*
 *	Mdulo: TCMPTO_C/TNET					*
 *		Utilitrios de comunicaes			*
 *		Categoria D					*
 *								*
 *	TROPIX: Sistema Operacional Tempo-Real Multiprocessado	*
 *		Copyright  2000 NCE/UFRJ - tecle "man licena"	*
 * 								*
 ****************************************************************
 */

/*
 ****************************************************************
 *	Algumas constantes universais				*
 ****************************************************************
 */
#define	IN_CALLs		/* Usa as chamadas especiais */

#define	MIN_COMPRESS_SZ	100

#define	SEGCRCSZ	(BLSZ/2)

/*
 ******	Verifica se as macro variveis esto definidas **********
 */
#if	!defined (BIG_ENDIAN) && !defined (LITTLE_ENDIAN)
#error	"Uma das macrovariveis \"BIG/LITTLE_ENDIAN\" deve estar definida"
#endif	BIG_ENDIAN/LITTLE_ENDIAN

/*
 ******	Definies relativas  ordem de bytes da CPU ************
 */
#ifdef	LITTLE_ENDIAN
#define	ENDIAN_LONG(x)	long_endian_cv (x)
#define	ENDIAN_SHORT(x)	short_endian_cv (x)
#else
#define	ENDIAN_LONG(x)	(x)
#define	ENDIAN_SHORT(x)	(x)
#endif	LITTLE_ENDIAN

/*
 ****************************************************************
 *	Cdigos dos diversos tipos de SEGMENTOS			*
 ****************************************************************
 */
typedef enum
{
	FQUIT = -1,	/* Reservado pelo protocolo de segmentos */

	FFLAGS = 1,	/* Flags iniciais do programa para o parceiro */
	FEOF,		/* Final do programa */
	FMSG,		/* Mensagem para o parceiro */
	FNAME,		/* Nome de um arquivo */
	FSTAT,		/* Estado de um arquivo */
	FCMP,		/* Envie os CRCs */
	FCRC,		/* Segmento de CRCs */
	FBLOCK,		/* Bloco de um arquivo */
	FLINK		/* Informaes de LINK */

}	SEG_TYPE;

/*
 ****** Segmento contendo uma mensagem **************************
 */
typedef struct
{
	int	m_type;			/* Tipo */
	int	m_code;			/* Cdigo */
	int	m_len;			/* Tamanho */

}	MSG;

/*
 ****** Segmento do tipo "FFLAGS" *********************************
 */
typedef struct
{
	int	seg_type;		/* Tipo */
	int	seg_flags[16];		/* Flags */

}	SEGFLAGS;

/*
 ****** Estrutura das operaes *********************************
 */
typedef enum
{
	CP = 0,			/* Cpia de sentido ainda indefinido */
	CPTO,			/* Cpia para o n remoto */
	CPFROM,			/* Cpia para o n local */

	L_LINK,			/* Operao de LINK local */
	R_LINK,			/* Operao de LINK remoto */

	L_RM,			/* Operao de remoo local */
	R_RM,			/* Operao de remoo remota */

	L_RM_LINK,		/* Operao de remoo e LINK locais */
	L_RM_CPFROM,		/* Operao de remoo e cpia locais */
	R_RM_LINK,		/* Operao de remoo e LINK remotos */
	R_RM_CPTO,		/* Operao de remoo e cpia remotos */

	F_PROCESS,		/* Arquivo aceito (-i) */
	F_PASS			/* Arquivo no aceito (-i) */

}	OP_NM;

#define OP_STR { "CP", "CPTO", "CPFROM", "L_LINK", "R_LINK", "L_RM", "R_RM" }
