.bp 1
.he 'LD (cmd)'TROPIX: Manual de Referncia'LD (cmd)'
.fo 'Atualizado em 12.07.02'Verso 4.3.0'Pag. %'

.b NOME
.in 5
ld - "link-editor" de mdulos objeto

.in
.sp
.b SINTAXE
.in 5
ld [-rbsmnvu.] [-o <obj>] [-e <ent>] [-T <tb>] [-D <db>]
.in 45
<mod> ... [-l<x> ...]

.in
.sp
.b DESCRIO
.in 5
O comando "ld" rene diversos mdulos objeto em apenas um,
efetuando relocaes e resolvendo smbolos externos.

.sp
Dependendo das opes, "ld" efetua uma das 4 seguintes funes:

.in +3
.ip "1. " 3
Gera um mdulo executvel regular:
Neste caso, so dados vrios mdulos objeto <mod> ..., que
so reunidos, gerando um mdulo objeto executvel.
Isto  obtido se NO for dada nenhuma das opes "-n", "-r" nem "-b".

.ip "2. " 3
Gera um mdulo executvel reentrante:
Como acima, mas gerando mdulo objeto executvel reentrante,
isto , durante a execuo, a seco TEXT e a sees DATA+BSS ficaro em
regies diferentes e o texto ser protegido contra escritas. 
Isto  obtido com a opo "-n".

.ip "3. " 3
Gera um mdulo objeto NO executvel, que pode ser usado como futuras
entradas para "ld".
Isto  obtido com a opo "-r".

.ip "4. " 3
Gera uma biblioteca compartilhada.
Isto  obtido com a opo "-b".

.ep
.in -3

.bc	/*************************************/
  ld [-rbsmnvu.] [-o <obj>] [-e <ent>] [-T <tb>] [-D <db>] <m> ... [-l<x> ...]

Opes:	-r: Mantem a relocao, no define COMMON
	-b: Gera uma biblioteca compartilhada
	-s: Gera o mdulo objeto sem tabela de smbolos
	-m: Gera um mapa de link-edio
	-n: Gera o mdulo objeto reentrante
	-v: Verboso
	-u: Lista os smbolos no referenciados
	    Se for dado duas vezes, lista tambm os das bibliotecas
	-.: Usa os arquivos temporrios no diretrio corrente
	-o: O nome do mdulo gerado ser <obj> ao invs de "a.out"
	-e: O nome do smbolo de entrada ser <ent> ao invs de "start"
	-T: O endereo do incio da seo "text" ser <tb>
	-D: O endereo do incio da seo "data" ser <db>

Obs.:	<m> ... so mdulos objeto
	<x> ... so abreviaturas para nomes de bibliotecas
.ec	/*************************************/

.bc	/*************************************/
.sp
No caso mais simples, so dados vrios mdulos objeto <mod> ..., que
so reunidos, produzindo um mdulo objeto que pode ser executado, ou
se foi dada a opo "-r", ser usado como a entrada de uma execuo
subseqente de "ld".
.ec	/*************************************/

.sp
Normalmente, a sada de "ld"  posta no arquivo "a.out", que  um
mdulo objeto executvel, se NO ocorreu nenhum erro durante a execuo
de "ld" e NO foram dadas as opes "-r" nem "-b".
(veja as opes "-o", "-r", "-b").

.sp
Cada <mod> dado pode ser o nome de um mdulo objeto
(veja o formato em  "a.out" (fmt)), o nome de uma biblioteca convencional
de mdulos objeto (veja "mklib" (cmd) e "lib" (fmt)) ou ainda o nome de
uma biblioteca compartilhada.
Das bibliotecas so somente carregados os mdulos necessrios para
definir referncias externas ainda no resolvidas.

.sp
Os nomes das bibliotecas podem ser dados na sua forma completa
(por ex. "/lib/lib<x>"), ou na sua forma abreviada -l<x>.
O nome -l<x> representa uma das bibliotecas "/lib/lib<x>", "/usr/lib/lib<x>"
ou "/usr/xwin/lib/lib<x>", pesquisadas nesta ordem.
Como exemplo, a biblioteca padro de funes da linguagem "C" ("libc")
encontra-se no diretrio "/lib/libc" e pode ser representada abreviadamente
por "-lc", na chamada de "ld".

.sp
As bibliotecas compartilhadas seguem as mesmas convenes de nomes, por
exemplo "-lt.o" representa "/lib/libt.o".

.sp
Normalmente, o ponto de entrada do mdulo objeto final
(ou seja, o endereo inicial de execuo do programa)
 o smbolo "start" (que deve ser global e pertencer  seo TEXT)
ou se este no existir, o endereo de incio da seo TEXT
(veja a opo "-e").

.sp
As opes do comando so:

.in +3
.bc	/*************************************/
.ip -a
Normalmente, a tabela de smbolos do mdulo objeto final contm apenas
os smbolos globais. Com esta opo, so conservados todos os smbolos.
.ec	/*************************************/

.ip -r
Mantm a relocao no mdulo objeto final e no define a rea de COMMON.
O comando no emite diagnsticos sobre smbolos ainda no definidos,
e o mdulo objeto de sada no  executvel. 

.sp
O objetivo da opo  o de realizar uma "link-edio" parcial de alguns mdulos,
gerando um mdulo objeto intermedirio que pode ser usado como
a entrada de uma execuo subseqente de "ld".

.ip -b
Gera uma biblioteca compartilhada.
Esta funo  semelhante  opo "-r", mas define a rea de COMMON.

.ip -s
Gera o mdulo objeto final sem a tabela de smbolos.
Somente permitido para mdulos objeto executveis.
.bc	/*************************************/
Gera o mdulo objeto final sem a tabela de smbolos nem as
informaes de depurao.
.ec	/*************************************/

.ip -m
Gera um mapa de "link-edio", contendo os endereos e tamanhos das
trs sees (TEXT, DATA e BSS) de cada um dos mdulos carregados.

.ip -n
Gera um mdulo objeto executvel reentrante.

.ip -v
Com esta opo, so dadas informaes sobre os mdulos carregados.

.ip -u
Lista os smbolos no referenciados.
Se for dado apenas uma vez, sero listados os smbolos no
referenciados apenas dos mdulos dados explicitamente.
Se for dado duas vezes (na forma "-uu") sero listados
todos os smbolos no referenciados, incluindo os das bibliotecas.

.ip -.
Aloca os arquivos temporrios no diretrio corrente.
Isto pode ser til se o tamanho do dispositivo de "/tmp" for pequeno.

.ip -o
Normalmente, o nome do mdulo objeto final  "a.out".
Com esta opo, o nome do mdulo passa a ser <obj>.

.ip -e
O ponto de entrada do mdulo objeto final ser o smbolo <ent>,
ao invs do smbolo "start", ou o endereo de incio da seo TEXT.
O smbolo <ent> deve ser global e pertencer  seo TEXT.

.ip -T
O endereo inicial de carga da seo TEXT do mdulo-objeto final ser <tb>.
Se esta opo for omitida, este endereo ser 4 MB.
Se o endereo dado comear por "0x" ou "0X" ele ser considerado dado em
hexadecimal; se comear por "0", em octal;
em caso contrrio em decimal.

.ip -D
O endereo inicial de carga da seo DATA do mdulo-objeto final ser <db>.
Se esta opo for omitida, este endereo ser contguo ao fim da seo TEXT,
no caso de programas normais (0407) ou 512 MB
no caso de programas reentrantes (0410).
Se o endereo dado comear por "0x" ou "0X" ele ser considerado dado em
hexadecimal; se comear por "0", em octal;
em caso contrrio em decimal.

.in +3
.ep

.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd): "
mklib, mkshlib
.bc	/*************************************/
mklib, wsdb
.ec	/*************************************/
.br
.wo "(fmt): "
a.out, lib
.br

.in
.sp
.(t
.b ARQUIVOS
.in 5
 /usr/include/a.out.h
.bc	/*************************************/
 /usr/include/lib.h
.ec	/*************************************/
.)t

.in
.sp
.b ESTADO
.in 5
Efetivo.

.in
