.bp
.he 'LS (cmd)'TROPIX: Manual de Referncia'LS (cmd)'
.fo 'Atualizado em 18.09.05'Verso 4.8.0'Pag. %'


.b NOME
.in 5
.wo "ls -"
lista caractersticas de arquivos e diretrios
.br

.in
.sp
.b SINTAXE
.in 5
.(l
ls [-lL3ditaRN] [<nome> ...]
.)l

.in
.sp
.b DESCRIO
.in 5
O comando "ls" lista caractersticas de arquivos e contedos de diretrios.
Para cada <nome> dado, se for um arquivo normal (no diretrio),
"ls" fornece uma srie de caractersticas, e se for um diretrio,
fornece as mesmas caractersticas para cada membro deste diretrio.

.sp
Se no for dado nenhum <nome> (nem a opo "-N"),  considerado o
diretrio corrente.

.sp 2
O formato da listagem  controlado pelas opes:

.in +3
.ip --
Simples: se no for dada nenhuma das 3 opes abaixo, a listagem contm
apenas os nomes dos arquivos/diretrios.

.ip -l
Longo: a listagem contm o tipo do arquivo, proteo,
nmero de elos fsicos, o dono (UID), o grupo (GID), tamanho (bytes),
data da ltima modificao e o seu nome.
Para arquivos especiais,  dado (ao invs do tamanho),
a identificao numrica ("major" e "minor") do dispositivo.
Normalmente so impressos os nomes simblicos do dono/grupo,
a no ser que eles no sejam encontrados nos arquivos correspondentes.

.ip -L
Muito longo: como o longo, mas com o modo completo (os 24 bites).

.ip -3
Tempos: a listagem contm o tipo do arquivo, data da criao,
data da ltima modificao, data do ltimo acesso e o seu nome.

.ep
.in -3

.sp 2
Temos ainda, as seguintes outras opes:

.in +3
.ip -d
Se <nome> for um diretrio, informa sobre o prprio diretrio
(e no sobre o seu contedo);  normalmente usado
em conjunto com "-l" para obter o estado de um diretrio.

.ip -i
D tambm o nmero do n-ndice do arquivo.

.ip -t
Ordena os arquivos pela data da ltima modificao, ao invs de
alfabeticamente pelo nome do arquivo, como  usual.

.ip -a
D informaes sobre todas as entradas; normalmente as informaes
sobre as entradas "." e ".." so suprimidas.

.ip -R
Lista os contedos dos subdiretrios encontrados recursivamente.
Deste modo, podemos obter caractersticas de todos os arquivos de uma rvore.

.ip -N
L os <nome>s dos arquivos da entrada padro.

.ep
.in -3

.sp 2
O tipo/modo/proteo do arquivo dado pela opo "-L" tem a forma:
.nf

		"R 7654321mtsg rwxrwxrwx"
.fi

.sp
onde o primeiro caractere indica o tipo de arquivo:

.sp
.in +3
.wo 'R  '
Arquivo regular
.br
.wo 'B  '
Dispositivo especial de blocos (estruturado)
.br
.wo 'C  '
Dispositivo especial de caracteres (no estruturado)
.br
.wo 'L  '
Elo simblico
.br
.wo 'D  '
Diretrio
.br
.wo 'F  '
"Fifo"
.br
.wo '?  '
Arquivo de tipo invlido
.br
.in -3

.sp
Aps o tipo do arquivo, temos ento 11  caracteres relativos aos atributos
do arquivo. Se algum indicador estiver desligado, o caracter
assume o valor '-' ao invs do caracter indicado acima.
Os indicadores de nomes provisrios "7" a "1" ainda no so usados
e esto reservados para uso futuro. os 4 restantes so:

.in +3
.ip 'm  '
(S_IMETX)
Uma imagem do programa  guardada na memria interna
aps a execuo, mesmo que no haja mais usurios do programa.

.ip 't  '
(S_ISVTX)
Uma imagem do programa  guardada na rea de SWAP (em disco)
aps a execuo, mesmo que no haja mais usurios do programa.

.ip 's  '
(S_ISUID)
O UID efetivo do processo passa a ser igual ao
dono do arquivo quando o arquivo  executado como um programa
("set user ID"). 

.ip 'g  '
(S_ISGID)
O GID efetivo do processo passa a ser igual ao
grupo do arquivo quando o arquivo  executado como um programa
("set group ID"). 

.ep
.in -3

.sp
Para mais informaes sobre os diversos atributos, veja "chmod" (sys).

.sp
Os ltimos 9 caracteres referem-se ao modo de proteo do arquivo,
dividido em 3 grupos de 3 caracteres.
O primeiro grupo de 3 caracteres d a proteo para o dono. Esta proteo
contm a permisso para leitura (1. caractere), escrita (2. caractere)
e execuo (arquivo regular)/pesquisa (diretrio) (3. caractere) do arquivo,
de acordo com o seguinte cdigo:

.sp
.in +9
.wo 'r  '
permisso para leitura
.br
.wo 'w  '
permisso para escrita
.br
.wo 'x  '
permisso para execuo/pesquisa
.br
.wo '-  '
sem a permisso correspondente
.in -9

.sp
Analogamente, os trs caracteres seguintes indicam a proteo
relativa a usurios do mesmo grupo do arquivo, e os ltimos trs
a proteo relativa os demais usurios.

.sp
O tipo/proteo do arquivo dado pela opo "-l" tem a forma:
.nf

		"R rwxrwxrwx"

.fi
que  uma simplificao da forma acima, onde o grupo central  suprimido.

.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd): "
chmod
.br
.wo "(sys): "
intro, chmod
.br
.wo "(libc):"
modetostr
.br

.in
.sp
.b ARQUIVOS
.in 5
 /etc/passwd
 /etc/group

.in
.sp
.b EXEMPLO
.r
.in 5
Uma execuo do comando "ls -l ls" poder imprimir:
.br
.nf

	R rwxr-x--x 1 <root> <sys>  5288  21:26:05 2005 18 set  ls

.fi
o que significa que "ls"  um arquivo regular,
com permisso para leitura, escrita e execuo para o dono,
leitura e execuo para os usurios do mesmo grupo
e de execuo para os outros usurios.
O dono do arquivo  "root" e o seu grupo  "sys".
Vemos ainda, que o arquivo possui 5288 bytes, e a ltima modificao
no arquivo foi feita s 21 horas, 26 minutos e 5 segundos de 18 de setembro de 2005.

.in
.sp
.b ESTADO
.in 5
Efetivo.

.in
