.bp
.tp
.sp 10
.nf
      *******   *******  *******   *******    *    *     *
         *      *     *  *     *   *     *    *     *   *
         *      *     *  *     *   *     *    *      * *
         *      *******  *     *   *******    *       *
         *      *  *     *     *   *          *      * *
         *      *   *    *     *   *          *     *   *
         *      *    *   *******   *          *    *     *
.fi
.sp 10
.ce
MAKE - Gerenciador de Manuteno de Programas
.sp 2
.ce
Verso 3.2.3
.sp 4
.ce
Guia
.sp 11
.ce
Dezembro de 1999
.bp
.sp 10
.ce
CONTEDO
.sp 5
.nf
	Cap. 1 - Introduo ...........................	 2

	Cap. 2 - Definies Bsicas ...................  3

	Cap. 3 - Formato do Arquivo de Descrio ......  5

	Cap. 4 - Macros ...............................	 7

	Cap. 5 - Uso do Comando ....................... 10
.fi
.bp
.he 'Sistema TROPIX'Guia'MAKE'
.fo 'Escrito em 13.12.99'Verso 3.2.3'Pag. %'
.sp 5
.nf
     *********************************************************
     *							     *
     *			CAPTULO 1			     *
     *							     *
     *	     		INTRODUO			     *
     *							     *
     *********************************************************
.fi
.sp 4
.pp
Normalmente, um programa grande e complexo  dividido em mdulos
de tamanhos menores, mais fceis de manipular.
Estes mdulos em geral recebem tratamentos diversos:
alguns so programas fonte em "C"
e necessitam ser processados pelo compilador "C",
outros so programas fonte em "assembly"
e necessitam ser processados pelo montador, etc...
Os mdulos objetos gerados por este tradutores
so em seguida geralmente "link-editados" com
certas bibliotecas, e o mdulo final instalado em algum diretrio.

.pp
Infelizmente,  muito fcil para um programador esquecer
que arquivos dependem de outros, que arquivos
foram modificados recentemente e a seqncia exata de operaes
necessrias para construir uma nova verso do programa.
Aps a edio de vrios arquivos,  natural que se perca a viso
geral dos arquivos modificados e dos mdulos
objetos ainda vlidos, j que a alterao de um arquivo
de declaraes ("*.h") pode tornar obsoletos dezenas de mdulos
objetos.

.pp
Esquecer de recompilar um mdulo que foi modificado ou que
inclui um arquivo de declaraes modificado resultar em um programa
que no executa corretamente.
Por outro lado, recompilar sistematicamente todos os mdulos a cada
alterao desperdia tempo.

.pp
O programa "make", objeto deste manual, automatiza muitas das atividades
de desenvolvimento e manuteno de programas. Se as informaes
de interdependncia dos arquivos e a seqncia de operaes
so armazenadas em um arquivo (chamado de "arquivo de 
descrio"), o simples comando
.sp
.nf
		make
.fi
.sp
 suficiente para atualizar os arquivos necessrios,
independentemente do nmero de arquivos editados desde o ltimo
"make". Na maioria dos casos, o arquivo de descrio  simples,
e no necessita de mudanas freqentes.

.bp
.sp 5
.nf
     *********************************************************
     *							     *
     *			CAPTULO 2			     *
     *							     *
     *	     	    DEFINIES BSICAS			     *
     *							     *
     *********************************************************
.fi
.sp 4
.pp
A operao bsica do "make"  a atualizao de um mdulo, que
consiste em:
.in 2
.ip 1. 3
providenciar para que todos os arquivos dos quais
o mdulo dependa existam e estejam atualizados;
.ip 2. 3
criar o mdulo (se ele no existe), ou atualiz-lo (caso no esteja atualizado)
em relao s suas dependncias, executando uma seqncia de operaes
especificada.
.in 0
.lp
Vamos dar um exemplo: 
um programa "pgm"  criado a partir da 
compilao e "link-edio" de trs mdulos escritos em "C": 
"md1.c", "md2.c" e "md3.c". Os mdulos "md1.c" e "md2.c" usam declaraes 
definidas em "md0.h" (isto , contm a linha "#include md0.h").
.pp
As interdependncias e operaes necessrias
para a criao do programa podem ser resumidas no seguinte texto:
.sp
.nf
	pgm:	md1.o md2.o md3.o
		cc -n -o pgm md1.o md2.o md3.o

	md1.o:	md0.h md1.c
		cc -O -c md1.c

	md2.o:	md0.h md2.c
		cc -O -c md2.c

	md3.o:	md3.c
		cc -O -c md3.c
.fi
.pp
Se este texto estiver em um arquivo com o nome de "Makefile",
o comando
.sp
.nf
	make
.fi
.sp
ir executar as operaes estritamente necessrias para criar/recriar
o programa "pgm" aps qualquer mudana realizada em alguns dos
arquivos "md1.c", "md2.c", "md3.c" ou "md0.h". 
.pp
Suponhamos que este programa ("pgm") seja novo, isto , os seus componentes
nunca foram compilados. Neste caso, o "make" far executar 
os seguintes comandos:
.sp
.nf
		=> cc -c md1.c
		=> cc -c md2.c
		=> cc -c md3.c
		=> cc -n -o pgm md1.o md2.o md3.o
.fi
.sp
O "make" lista cada comando antes de execut-lo, precedendo-o do sinal "=>".
.pp
Suponhamos agora que, ao executarmos o programa "pgm", constatamos a
necessidade de uma alterao no mdulo "md2.c".
Se, aps a edio de "md2.c", invocarmos novamente o "make", sero
executados apenas os seguinte comandos:
.sp
.nf
		=> cc -c md2.c
		=> cc -n -o pgm md1.o md2.o md3.o
.fi
.sp
que, como podemos ver, so exatamente os necessrios.

.bp
.sp 5
.nf
     *********************************************************
     *							     *
     *			CAPTULO 3			     *
     *							     *
     *	       FORMATO DO ARQUIVO DE DESCRIO		     *
     *							     *
     *********************************************************
.fi
.sp 4

.pp
Normalmente, o comando "make" procura o arquivo de descrio no diretrio
em que  invocado com os nomes "Makefile" ou "makefile", nesta ordem.
Caso seja chamado com a opo "-f" (ver "make" (cmd)),
outros nomes podem ser utilizados.

.pp
O arquivo de descrio  constitudo de quatro tipos de entradas:
.in 2
.ip 1. 3
entradas para especificao de dependncias;
.ip 2. 3
entradas para declarao de alvos virtuais;
.ip 3. 3
entradas para declarao de macros;
.ip 4. 3
entradas para incluso de macros como variveis do ambiente.
.in 0

.pp
As entradas para especificao de dependncias podem estender-se por diversas
linhas consecutivas do arquivo de descrio, possuindo o seguinte
formato geral:

.sp
.nf
	<alvos>:	<pr-requisitos>
			<operao 1>
			<operao 2>
			   .   .
			   .   .
			<operao n>
.fi

.sp
onde <alvos> so os nomes do mdulos a serem criados/atualizados e
<pr-requisitos> so nomes de mdulos dos quais os alvos dependem.
Os nomes podem ser separados por brancos (<sp>) ou tabuladores (<ht>).

.pp
As linhas <operao 1> a <operao n> contm os comandos necessrios 
criao/atualizao dos alvos e devem iniciar com um tabulador (<ht>).

.pp
O conjunto de operaes  executado, visando a criao/atualizao dos
alvos, quando:

.in 2
.ip 1. 3
so especificados pr-requisitos e o tempo de ltima modificao de um
deles for mais recente que o tempo de ltima modificao de um dos alvos;
.ip 2. 3
no so especificados pr-requisitos;
.ip 3. 3
 especificada a palavra reservada ".exist" no lugar de pr-requisitos
e um dos alvos  inexistente.
.in 0

.pp
As operaes so listadas na tela imediatamente antes de
serem executadas; havendo erros, o processamento do "make"  interrompido.
Podemos utilizar as variantes <@operao>, para que ela no seja listada,
ou <-operao>, para que o "make" continue o processamento
mesmo em caso de erro nesta operao.

.pp
Normalmente, o conjunto de operaes especificadas para atualizar um
alvo deve produzir alterao do tempo de ltima modificao do alvo,
tornando-o mais recente que todos os seus pr-requisitos, como 
 o caso de compilaes e link-edies.
Do contrrio, a cada chamada do "make", este conjunto ser
re-executado.

.pp
Quando uma linha termina pelo caractere "\", a linha seguinte  considerada
uma continuao. Isto permite estender as listas de alvos e pr-requisitos
ou mesmo uma linha de operao.

.pp
O arquivo de descrio pode conter comentrios,
que so iniciados pelo caractere "#" e se estendem at o fim da linha
em que iniciam.
Linhas vazias so ignoradas.

.pp
Normalmente, alvos correspondem a arquivos, que devem existir fisicamente.
Alvos virtuais so declarados com entradas do tipo
.sp
.ce
".virtual <alvo> ..."
.pp
Tais alvos no correspondem a arquivos, funcionando apenas como ndices
para seqncias de comandos. Um exemplo comum de aplicao  declarar
um alvo cujo efeito  copiar o programa-objeto final para o diretrio
apropriado. 
.pp
Utilizando o exemplo anterior, vamos introduzir o alvo virtual "cp",
que possui como pre-requisito "pgm".
A operao utilizada para atualizar o alvo "cp" consiste em copiar "pgm"
para o diretrio "/usr/bin".
.sp
.nf
	.virtual cp

	pgm:	md1.o md2.o md3.o
		cc -n -o pgm md1.o md2.o md3.o

	md1.o:	md0.h md1.c
		cc -O -c md1.c

	md2.o:	md0.h md2.c
		cc -O -c md2.c

	md3.o:	md3.c
		cc -O -c md3.c

	cp:	pgm
		cp -f pgm /usr/bin
.fi
.pp
O comando
.sp
.nf
	make cp
.fi
.sp
compila e linkedita, se necessrio, o programa "pgm", copiando-o para
o diretrio "/usr/bin".

.pp
As entradas para declarao de macros e incluso no ambiente sero analisadas
no prximo captulo.

.bp
.sp 5
.nf
     *********************************************************
     *							     *
     *			CAPTULO 4			     *
     *							     *
     *	       		  MACROS			     *
     *							     *
     *********************************************************
.fi
.sp 4
.pp
O "make" prov um mecanismo simples de substituio de macros no
arquivo de descrio.

.pp
Uma entrada no arquivo de descrio para declarao de macro tem a forma:
.sp
.nf
	<macro> = <texto>
.fi
.sp
onde <macro>  um identificador (seqncia de letras, dgitos e "_" iniciada
por letra) e <texto>  uma seqncia qualquer de caracteres.
O sinal de "=" pode ser precedido e sucedido de separadores (<sp> ou <ht>),
que so ignorados. O <texto> se encerra com o fim da linha de declarao,
ou prossegue em linhas de continuao com o uso do caractere "\".

.pp
So exemplos de declaraes de macros:
.sp
.nf
	PGM	= pgm
	OBJ	= md1.o	\
		  md2.o \
		  md3.o
	FLAGS	= -n
.fi

.pp
A referncia a uma macro consiste em preceder seu nome do caractere "$",
como "$PGM", "$OBJ" e "$FLAGS". Este mecanismo provoca a insero do
texto da macro no lugar onde foi referenciada.

.pp
s vezes,  conveniente, na referncia a uma macro, delimitar seu nome por
parnteses: $(PGM), $(OBJ) e $(FLAGS).

.pp
Com as definies acima, o arquivo de descrio do captulo 2
pode ser reescrito da seguinte maneira:
.sp
.nf
	PGM	= pgm
	OBJ	= md1.o md2.o md3.o
	INC	= md0.h
	CC	= cc
	CFLAGS	= -O
	LDFLAGS	= -n

	$PGM:	$OBJ
		$CC $LDFLAGS -o $PGM $OBJ

	md1.o:	md1.c $INC
		$CC $CFLAGS -c md1.c

	md2.o:	md2.c $INC
	 	$CC $CFLAGS -c md2.c

	md3.o:	md3.c
		$CC $CFLAGS -c md3.c
.fi

.pp
Com a utilizao de macros, evitamos a repetio dos nomes dos
mdulos, o que pode abreviar substancialmente o tamanho do arquivo
de descrio, bem como facilitar-lhe a manuteno.

.pp
Existem algumas macros especiais, para as quais o prprio "make"
atribui valores intrinsecamente.
Seus nomes so: "$", "@", "*", "<" e "?", e correspondem aos seguintes
textos:

.in 1
.ip $$ 4
o caractere "$";
.ip $@ 4
nome do alvo a criar/atualizar;
.ip $* 4
nome do alvo a criar/atualizar sem a extenso;
.ip $< 4
nomes dos pr-requisitos dos quais dependem o alvo;
.ip $? 4
nomes dos pr-requisitos mais recentes que o alvo e, portanto, causadores
de sua atualizao/criao.
.in 0
.lp
Os valores das macros @, *, < e ? so atualizados de acordo com a lista de
dependncias que estiver sendo processada durante a execuo. Estas
macros s tm utilidade em linhas de comandos.

.sp
 Exemplo:

.sp
.nf
	pgm:	md1.o md2.o md3.o
		cc -n -o pgm $<

	md1.o:	md0.h md1.c
		cc -c $*.c

	md2.o:	md0.h md2.c
		cc -c md2.c

	md3.o:	md3.c
		cc -c md3.c

	print:	md0.h md1.c md2.c md3.c
		pr $?
		touch print
.fi

.pp
Repare o mdulo "print": a idia  imprimir os programas fontes que tenham
sido alterados desde a ltima impresso. 

.pp
Alm das macros definidas no arquivo de descrio, todas as cadeias do
ambiente (ver "environ" (fmt)) so automaticamente disponveis como macros.

.pp
O terceiro tipo de entrada possvel em um arquivo de descrio destina-se
a inserir como variveis do ambiente macros declaradas no arquivo de
descrio ou transmitidas ao "make" atravs da opo "-D" (ver "make" (cmd)).
Com linhas do tipo

.sp
.ce
".putenv <macro> ..."
.sp

colocamos macros selecionadas como variveis no ambiente,
para que os programas executados
possam obter os seus valores (por exemplo, o "cpp" (cmd)).

.bp
.sp 5
.nf
     *********************************************************
     *							     *
     *			CAPTULO 5			     *
     *							     *
     * 		      USO DO COMANDO			     *
     *							     *
     *********************************************************
.fi
.sp 4
.pp
A sintaxe do comando "make" 
.sp
.nf
	make [-intvab] [-f <desc>] [-D <macro>=<valor>] ...
	<mdulo> ...
.fi

.pp
A opo "-i" funciona como se todas as linhas de comandos no arquivo
de descrio estivesses precedidas de "-" (ignorar erros).

.pp
A opo "-n" permite
listar as operaes necessrias  atualizao sem execut-las.

.pp
Cuidado com a opo "-t", pois ela atualiza as datas de modificao
dos arquivos sem na realidade atualiz-los.
Com isto, a memria dos mdulos no atualizados  perdida.

.pp
A opo "-v" explica o motivo das atualizaes.

.pp
A opo "-a" apenas lista os alvos especificados no arquivo de
descrio, exceto os da forma "*.o". Se for duplicada ("-aa"),
todos os alvos, sem exceo, so listados.

.pp
A opo "-b" provoca a atualizao de todos os mdulos,
independentemente das datas.

.pp
A opo "-f" permite especificar o nome do arquivo de descrio.

.pp
A opo "-D" define a macro <macro> com o texto <valor>.
Esta definio prevalece sobre definies homnimas
no arquivo de descrio e/ou no ambiente.
