/*
 ****************************************************************
 *								*
 *			mkfifo.c				*
 *								*
 *	Cria FIFOs 						*
 *								*
 *	Verso	1.0.0, de 05.02.86				*
 *		3.0.0, de 31.10.90				*
 *								*
 *	Mdulo: mkfifo						*
 *		Utilitrios Bsicos				*
 *		Categoria B					*
 *								*
 *	TROPIX: Sistema Operacional Multiprocessado		*
 *		Copyright  2000 NCE/UFRJ - tecle "man licena"	*
 * 								*
 ****************************************************************
 */

#include <sys/types.h>
#include <sys/syscall.h>

#include <stdio.h>
#include <stdlib.h>
#include <stat.h>
#include <errno.h>

/*
 ****************************************************************
 *	Variveis e Definies globais				*
 ****************************************************************
 */
const char	pgversion[] =  "Verso:	3.0.0, de 23.05.97";

#define	elif	else if

entry int	exit_code = 0;	/* Cdigo de retorno */

entry int	vflag;		/* Verbose */

/*
 ****** Prottipos de funes ***********************************
 */
void		help (void);

/*
 ****************************************************************
 *	Cria FIFOs 						*
 ****************************************************************
 */
int
main (int argc, register const char *argv[])
{
	register int	opt;

	/*
	 *	Analisa as opes
	 */
	while ((opt = getopt (argc, argv, "vH")) != EOF)
	{
		switch (opt)
		{
		    case 'v':			/* Verbose */
			vflag++;
			break;

		    case 'H':			/* Help */
			help ();

		    default:			/* Erro */
			putc ('\n', stderr);
			help ();

		}	/* end switch */

	}	/* end while */

	argv += optind;
	argc -= optind;

	/*
	 *	Cria os FIFOs
	 */
	for (/* vazio */; *argv; argv++)
	{
		if (mknod (*argv, S_IFIFO|S_IWRITE|S_IREAD, 0) < 0)
		{
			fprintf
			(	stderr,
				"%s: No consegui criar \"%s\" (%s)\n",
				pgname, *argv, strerror (errno)
			);
			exit_code++;
		}

	}	/* end for */

	return (exit_code);

}	/* end mkfifo */

/*
 ****************************************************************
 *	Resumo de utilizao do programa			*
 ****************************************************************
 */
void
help (void)
{
	fprintf
	(	stderr,
		"%s - cria FIFOs\n"
		"\n%s\n"
		"\nSintaxe:\n"
		"\t%s <fifo> ...\n",
		pgname, pgversion, pgname
	);

	exit (2);

}	/* end help */
