.bp
.he 'MKFST1 (cmd)'TROPIX: Manual de Referncia'MKFST1 (cmd)'
.fo 'Atualizado em 22.09.04'Verso 4.6.0'Pag. %'

.b NOME
.in 5
.wo "mkfst1 -"
gera um sistema de arquivos T1
.br

.in
.sp
.b SINTAXE
.in 5
.(l
mkfst1 [-rfv] <dev> [<fs> [<vn> [<pn>]]]
.)l

.in
.sp
.b DESCRIO
.in 5
O  comando "mkfst1" cria um sistema de arquivos T1 no dispositivo
<dev>, no formato adequado para conter arquivos e
ser "montado" (veja "mount" (cmd)).

.sp
Tambm pode ser criado um sistema de arquivos T1 em um arquivo regular
(veja a opo "r").

.sp
Um sistema de arquivos T1  composto de uma ou mais zonas,
descritas por mapas de bits.
Cada zona compreende 8192 blocos de 4 KB, totalizando 32 MB.
Cada zona contm o seu mapa de bits no 3. bloco, e pode conter
blocos livres, de dados ou de ns-ndice.
A primeira zona  especial, pois contm 
o bloco de "boot" (o "boot1", na seqncia de carga do sistema)
e o Superbloco em seus blocos iniciais.

.sp
Para a criao do sistema de arquivos,
 necessria a definio de 3 parmetros.
Cada um dos parmetros pode ser dado:

.in +3
.ip 1. 3
Com um valor <val>: O valor <val> ser utilizado.

.ip 2. 3
Na forma "-": Ser utilizado um valor "padro", descrito abaixo,
em cada um dos parmetros.

.ip 3. 3
Na forma ".": Supe-se que <dev> j contenha um sistema de arquivos,
e o valor ser herdado do sistema existente.
Se <dev> NO contiver um sistema de arquivos T1,
ser utilizado o valor "padro".

.ip 4. 3
No ser dado: Como ".", acima.

.ep
.in -3

.sp
Os parmetros so:

.in +3
.ip <fs>
Tamanho do sistema. Especifica o tamanho total do
sistema de arquivos (normalmente em blocos de 512 bytes;
com o sufixo "k" ou "K" em KB e com o sufixo "m" ou "M" em MB).
O valor padro  o obtido da tabela de parties do disco
(veja "prdisktb" (cmd)).
Obviamente, se for dado um valor ele no pode ser maior
do que o espao total da partio.

.sp
Repare que o sistema de arquivos T1 possui blocos de 4 KB,
e podem ocorrer truncamentos na converso de 512 bytes para 4 KB.

.ip <vn>
Nome do Volume (at 14 caracteres).
Este parmetro tem aspecto puramente documentacional,
e em geral  utilizado para descrever o contedo do sistema
de arquivos.
Este nome  dado nas sadas dos comandos "mount" e "fsname" (cmd).
O valor padro  igual a "???"
(ele pode ser alterado posteriormente atravs do comando "fsname").

.ip <pn>
Nome do Dispositivo Fsico (at 14 caracteres).
Este parmetro tem aspecto puramente documentacional,
e em geral  utilizado para indicar o nome do dispositivo em
que reside o sistema de arquivos.
Este nome  dado nas sadas dos comandos "mount" e "fsname" (cmd).
O valor padro  igual ao nome do dispositivo da tabela de parties
(ele pode ser alterado posteriormente atravs do comando "fsname").

.ep
.in -3

.sp
Normalmente, antes de iniciar a gerao do sistema de arquivos T1,
"mkfst1" escreve todos os parmetros que ir usar, pedindo ento
uma confirmao do usurio para iniciar a gerao (veja a opo "-f").

.sp
As opes do comando so:

.in +3
.ip -r
Arquivo regular. Caso o dispositivo <dev> no exista, cria um
arquivo regular com o sistema de arquivos T1.

.ip -f
Fora:
Como a gerao de um sistema de arquivos destri todos os arquivos
que porventura j existam em <dev>, "mkfst1" normalmente
pede a confirmao do usurio, antes de iniciar a escrita em <dev>.
Com esta opo, a confirmao do usurio no  pedida.
Alm disto, no  impressa a lista de parmetros utilizados
na gerao.

.ip -v
Verboso. Esta opo informa se o dispositivo j tem um sistema de
arquivos T1 (dando os seus parmetros se for o caso).

.ep
.in -3

.sp
O comando "mkfst1" preenche o bloco de "boot" (primeiro bloco do
sistema de arquivos T1) com o arquivo "/etc/boot/t1.g.boot1" ou
"/etc/boot/t1.l.boot1", a no ser
para os disquetes de 1440 KB ("/dev/fd?"), em que utiliza o arquivo
"/etc/boot/t1.d.boot1". Este bloco pode posteriormente ser alterado
atravs do comando "edboot" ou "dd" (cmd).

.in
.sp
.b OBSERVAES
.in 5
Repare que, mesmo quando o sistema de arquivos T1 j existe,
e os parmetros no so dados, NO  herdado o bloco de
"boot".

.sp
Por razes de segurana e consistncia, o superbloco de um
sistema de arquivos T1 possui um campo que contm um "nmero mgico".
Deste modo o sistema operacional pode identificar
se naquele dispositivo existe realmente um sistema de arquivos
(por exemplo, em operaes de "mount").

.sp
Antes de iniciar a criao do sistema de arquivos T1,
o comando "mkfst1" verifica se o dispositivo <dev> est
est montado sob algum diretrio.
Se isto ocorrer, o novo sistema no ser
criado, sendo enviada uma mensagem correspondente.
.bc	/*************************************/
Assim, sobre o dispositivo que for raiz ("root") do sistema no
momento, no poder ser criado um sistema de arquivos.
.ec	/*************************************/

.sp
O comando gera automaticamente o diretrio "lost+found",
utilizado pelo "fsckt1" ao reconectar arquivos T1.

.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd): "
mount, fsname, fsckt1, dd, prdisktb, edboot
.br

.in
.sp
.b ARQUIVOS
.in 5
/etc/boot/*

.in
.sp
.(t
.b EXEMPLOS
.in 5
.(l
	mkfst1 /dev/hd2a
.)l
.)t

.sp
Se em "/dev/hd2a" j existir um sistema de arquivos T1, sero
herdados todos os seus 3 parmetros. Em caso contrrio, os
parmetros sero obtidos dos seguinte modo:
<fs> e <pn> da tabela de parties; <vn>: "???";

.sp
.(l
	mkfst1 /dev/sd3 10000
.)l

.sp
O sistema de arquivos T1 ter 10000 blocos de 512 bytes.
Os demais parmetros sero herdados do sistema anterior, ou
caso o dispositivo ainda no possuir um sistema de arquivos,
o parmetro <vn> ter o valor "???" e
<pn> ser obtido da tabela de parties.

.sp
.(l
	mkfst1 /dev/hdb3c 30000 manuais -
.)l

.sp
O sistema de arquivos T1 ter 30000 blocos de 512 bytes.
o parmetro <vn> ter o valor "manuais" e
<pn> ser obtido da tabela de parties.

.in
.sp
.b ESTADO
.in 5
Efetivo.

.in
