.bp
.he 'MKLIB (cmd)'TROPIX: Manual de Referncia'MKLIB (cmd)'
.fo 'Atualizado em 21.08.01'Verso 4.0.0'Pag. %'

.b NOME
.in 5
mklib - cria/atualiza bibliotecas de mdulos objeto

.in
.sp
.b SINTAXE
.in 5
.(l
mklib [-rudtkfv] [-cm] [<biblioteca>] [<mdulo> ...]
.)l

.in
.sp
.b DESCRIO
.in 5
O comando "mklib"  um utilitrio de criao/manuteno de bibliotecas de
mdulos objeto, como por exemplo a "libc" - biblioteca de funes bsicas
usadas por programas escritos na linguagem "C".

.sp
No sistema operacional TROPIX, uma biblioteca consiste de uma rvore
de mdulos objeto, em que a raiz contm o "arquivo de sinopse" da
biblioteca. Este arquivo, que  de texto, contm os nomes dos mdulos
da biblioteca, com os respectivos smbolos externos definidos.
Isto  necessrio para o bom funcionamento do  "link-editor" "ld" (cmd)
- mais detalhes so dados nas OBSERVAES abaixo e em "lib" (fmt").

.sp
Sem opes, o comando "mklib" espera como argumento somente o nome
da <biblioteca> (que  identificada pelo diretrio raiz da rvore),
e constri o arquivo de sinopse a partir dos mdulos presentes na
rvore. Uma possvel sinopse antiga  removida.

.sp
As opes do comando so:

.in +3
.ip -r
Substitui ou inclui os <mdulo>s da/na <biblioteca>, atualizando o arquivo
de sinopse. Os nomes dos <mdulo>s devem ser dados relativos  raiz
da <biblioteca>, mas os <mdulo>s propriamente ditos
devem estar no diretrio corrente.

.sp
Por exemplo, para substituir/incluir o mdulo "/lib/libc/etc/ftw.o"
da biblioteca "/lib/libc" deve ser dado o comando

.sp
.nf
			mklib -r /lib/libc etc/ftw.o
.fi

.sp
mas o mdulo "ftw.o" deve estar no diretrio corrente.

.ip -u
Esta opo  semelhante  "-r", mas ao invs de dar uma lista de
mdulos, as substituies so feitas a partir de todos os mdulos do
diretrio corrente cujos nomes terminam por ".o".

.sp
A substituio  realizada apenas se um mdulo com o mesmo nome
j se encontra na <biblioteca> (isto , no so feitas incluses)
e a data de modificao do
mdulo do diretrio corrente for mais recente. 

.sp
Repare que se a <biblioteca> tiver dois (ou mais) mdulos homnimos
(em subdiretrios distintos) ser considerado o primeiro encontrado
no arquivo de sinopse.

.ip -d
Remove da <biblioteca> os <mdulo>s dados.

.ip -t
Imprime na sada padro uma tabela dos mdulos da <biblioteca>,
juntamente com seus smbolos.
Se forem dados nomes de <mdulo>s, s so impressas informaes sobre eles.
Em conjunto com a opo "-v",
produz uma listagem mais detalhada de cada mdulo.

.ip -k
Realiza uma verificao de consistncia do arquivo de sinopse da <biblioteca>.
Se hover alguma inconsistncia,  necessrio recriar a sinopse
(usando "mklib" sem opes).

.ip -f
Normalmente o usurio  consultado para confirmar cada
atualizao ou remoo a ser feita. Com a opo "-f" estas operaes
so feitas sem consulta.

.ip -v
Descreve detalhes das operaes realizadas.
No caso da opo "-t", so impressas mais informaes sobre os mdulos.

.ip -c
Esta opo  uma abreviao para a <biblioteca> "/lib/libc".

.ip -m
Esta opo  uma abreviao para a <biblioteca> "/lib/libm".

.ep
.in -3

.in
.sp
.b OBSERVAES
.in 5
O arquivo de sinopse tem o nome de ".LIBSYM". Assim, por exemplo,
a sinopse da biblioteca "/lib/libc"  "/lib/libc/.LIBSYM".

.sp
Embora o comando "mklib" no exija que os nomes dos mdulos
terminem em ".o" (exceto com a opo "-u"),  recomendvel que
isto seja o caso, por questes de interao com outros comandos.

.sp
Os mdulos objeto podem ficar distribudos livremente pela rvore
da biblioteca. Nesta verso do sistema, no h mais limites no nmero
de subdiretrios (altura da rvore) nem nos tamanhos dos mdulos/smbolos.

.bc	/*************************************/
H no entanto, uma limitao da altura da rvore,
imposta pelo tamanho do caminho do mdulo (relativo  biblioteca),
que  (nesta verso) de 29 caracteres. Assim, por exemplo, o mdulo
da "libc" "/lib/libc/etc/ftw.o"  permitido, pois "etc/ftw.o" tem 9
caracteres, mas "/lib/libc/alpha/beta/gamma/delta/etc/ftw.o" no ,
pois "alpha/beta/gamma/delta/etc/ftw.o" tem 32 caracteres.
.ec	/*************************************/

.sp
Mdulos cujo caminho contm um componente que comea por "." no
so considerados por "mklib" (tal como "/lib/libc/.old/ftw.o" ou
"/lib/libc/old/.ftw.o"). Esta caracterstica pode ser usada
para "tornar invisveis" mdulos provisrios ou antigos.

.sp
O comando "mklib" mantm ordenado o arquivo de sinopse. Isto 
importante para que o comando "ld" crie os mdulos executveis
com os mdulos sempre na mesma ordem, independentemente se
mdulos foram inseridos, removidos ou substitudos na biblioteca.

.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd): "
ld
.br
.wo "(fmt): "
lib
.br

.in
.sp
.b ARQUIVOS
.in 5
<biblioteca>/.LIBSYM

.in
.sp
.b ESTADO
.in 5
Efetivo.

.in
