.bp
.he 'MOUNT (cmd)'TROPIX: Manual de Referncia'MOUNT (cmd)'
.fo 'Atualizado em 13.03.06'Verso 4.8.0'Pag. %'

.b NOME
.in 5
Monta e desmonta sistemas de arquivos:
.sp
.wo "mount  -"
monta sistemas de arquivos
.br
.wo "umount -"
desmonta sistemas de arquivos
.br

.in
.sp
.b SINTAXE
.in 5
.(l
mount [-rw] [-o <opes>] <dispositivo> <diretrio>
mount [-rw] [-o <opes>] <dispositivo ou diretrio>
mount [-rw] [-o <opes>] -a
mount [-v]

umount [-o <opes>] <dispositivo ou diretrio> ...
umount [-o <opes>] -a
.)l

.in
.sp
.b DESCRIO
.in 5
Os comandos "mount" e "umount" alteram a rvore que modela a estrutura
de arquivos do sistema operacional.

.sp
O comando "mount" incorpora uma ou mais subrvores de arquivos
 arvore principal do sistema.
Cada subrvore (indicada como <dispositivo> acima),
pode ser dada como um sistema de arquivos local
contido em um dispositivo (arquivo especial de blocos),
a imagem de um sistema de arquivos contida em um arquivo regular local
ou ainda (no caso de sistemas de arquivos NFS) de
um par da forma "servidor:/diretrio", ver "nfs" (fmt).




.bc	/*************************************/
Cada subrvore consiste de um sistema de arquivos
contido em um dispositivo (arquivo especial de blocos)
ou um arquivo regular.

O comando "mount" incorpora uma ou mais subrvores de arquivos
(ou seja, sistemas de arquivos contidos em dispositivos ou imagens
de sistemas de arquivos contidos em arquivos regulares)
 arvore principal do sistema.
.ec	/*************************************/

.sp
O comando "umount" desfaz a ao de "mount", desmontando um ou mais sistemas 
de arquivos da rvore principal.

.sp
O arquivo "/etc/fstab" suplementa a execuo de "mount" e "umount",
fornecendo informaes que podem estar omitidas de algumas formas de "mount" e "umount",
em particular, as opes de montagem.
Para ver o formato deste arquivo e quais so as opes de montagem,
veja "fstab" (fmt) e "getmntent" (libc).

.sp
Normalmente, somente o superusurio pode montar/desmontar sistemas de arquivos.
No entanto, se uma linha do arquivo "/etc/fstab" contiver a opo "user",
qualquer usurio poder montar o sistema de arquivos correspondente.
Neste caso, somente o usurio que montou o sistema (ou o superusurio)
poder desmont-lo.

.sp
Em sua primeira forma,

.sp
.(l
	mount [-rw] [-o <opes>] <dispositivo> <diretrio>
.)l

.sp
o comando "mount" incorpora
a subrvore contida no <dispositivo>  arvore principal do sistema.
O <diretrio> passa a ser a raiz desta subrvore.
Se, por acaso, o <diretrio> era a raiz de uma subrvore antes da montagem,
esta subrvore fica oculta enquanto o sistema de arquivos estiver montado.
Esta  a nica forma em que as opes de montagem definidas em "/etc/fstab"
NO so consultadas (as opes usadas so as "default", possivelmente modificadas
pelas opes "-r", "-w" ou "-o").

.sp
Na sua segunda forma,

.sp
.(l
	mount [-rw] [-o <opes>] <dispositivo ou diretrio>
.)l

.sp

basta dar o <dispositivo> ou o <diretrio>, e a informao
completa  procurada no arquivo  "/etc/fstab".
As opes de montagem usadas so as de "/etc/fstab", possivelmente modificadas
pelas opes "-r", "-w" ou "-o".

.sp
Na sua terceira forma

.sp
.(l
	mount [-rw] [-o <opes>] -a
.)l

.sp

so montados todos os
<dispositivo>s no respectivos <diretrio>s dados no arquivo "/etc/fstab",
que possuem a opo de montagem "auto".
As opes de montagem usadas so as de "/etc/fstab", possivelmente modificadas
pelas opes "-r", "-w" ou "-o".

.sp
Na sua quarta forma

.sp
.(l
	mount [-v]
.)l

.sp

o comando "mount" imprime uma tabela contendo os dispositivos mountados, respectivos
diretrios, dados sobre o dispositivo e as opes de montagem em uso (veja a opo "-v", abaixo).

.sp
Se houver clientes remotos com sistemas arquivos NFS montados neste servidor,
isto ser indicado ao final da listagem aps uma linha em branco.

.sp
Na atual verso do sistema TROPIX, podem ser montados <dispositivo>s
contendo sistemas de arquivos dos tipos TROPIX T1, TROPIX V7,
FAT12, FAT16, FAT32, CDROM (ISO 9660, Rock Ridge, Joliet), LINUX/EXT2,
NTFS (somente para leitura) e NFS (verso 2).
No  necessrio dar o tipo: ele  descoberto automaticamente pelo
cdigo da entrada da tabela de parties (ver "prdisktb" (cmd)) ou pelo
superbloco do sistema de arquivos.

.sp
As opes do comando "mount" so:

.in +3
.ip -o
Fornece uma lista das seguintes opes separadas por vrgula:
"default", "ro", "rw", "user", "nouser", "atime", "noatime", "dev", "nodev", "exec",
"noexec", "suid", "nosuid", "eject", "noeject", "case", "nocase",
"rock", "norock", "joliet", "nojoliet", "lfn", "nolfn",
"hard", "soft", "rsize", "wsize", "timeout" e "retrans".
Para o significado de cada uma destas opes, veja "getmntopt" (libc).

.ip -r
Apenas leitura: equivalente a "-o ro".

.ip -w
Leitura e escrita: equivalente a "-o rw".

.ip -a
Monta todos os dispositivos que possuem a opo de montagem "auto" no
arquivo "/etc/fstab".

.ip -v
Normalmente, "mount" somente imprime as opes de montagem diferentes das "default".
Com a opo "-v" imprime tdas as opes que se aplicam a vrios sistemas de arquivos;
Repetindo a opo ("-vv") imprime tdas as opes, mesmo as particulares de um nico
sistema de arquivos.

.ep
.in -3

.sp 2
O comando "umount" desfaz a ao de "mount", desmontando um ou mais sistemas 
de arquivos da rvore principal, dados atravs dos <dispositivo ou diretrio>s montados.

.sp
As opes do comando "umount" so:

.in +3
.ip -o
Fornece uma lista de seguintes opes separadas por vrgula:
a lista  a mesma da opo "-u", de "mount" (acima), no entanto,
atualmente apenas so consideradas as opes "eject" e "noeject",
para modificar a ao descrita no arquivo "/etc/fstab".

.ip -a
Tenta desmontar todos os dispositivos montados (exceto o dispositivo RAIZ e PIPE).
Isto s ser possvel para aqueles que no estejam em uso.

.ep
.in -3

.sp
.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd):  "
prdisktb
.br
.wo "(sys):  "
intro, mount, umount
.br
.wo "(libc): "
getmntent, getmntopt
.br
.wo "(fmt):  "
fstab, nfs
.br

.in
.sp
.b ARQUIVOS
.(l
/etc/fstab
.)l

.in
.sp
.b ESTADO
.in 5
Efetivo.

.in
