.bp
.he 'NM (cmd)'TROPIX: Manual de Referncia'NM (cmd)'
.fo 'Atualizado em 08.05.02'Verso 4.2.0'Pag. %'

.b NOME
.in 5
.wo "nm -"
imprime a tabela de smbolos de mdulos objeto
.br

.in
.sp
.b SINTAXE
.in 5
.(l
nm [-gutdbcarfonepN] [<mdulo> ...]
.)l

.in
.sp
.b DESCRIO
.in 5
O comando "nm" imprime a tabela de smbolos de cada <mdulo> objeto dado.
Se no for dado nenhum <mdulo>, nem a opo "-N" (ver abaixo),  impressa
a tabela de smbolos do mdulo "a.out".

.sp
Cada <mdulo> objeto pode ser relocvel ou absoluto, e  normalmente obtido
atravs do comando "as" ou "ld" (cmd).

.bc	/*************************************/
.sp
Cada smbolo vem precedido do seu valor (ou de brancos se for
indefinido), e de uma letra indicando
seu tipo, que pode ser: "U" (indefinido),
"A" (absoluto), "R" (registro do processador),
"C" ("common"), "T" ("text"),
"D" ("data", dados inicializados),
"B" ("bss", dados no inicializados) ou "F" (nome do mdulo).
.ec	/*************************************/

.sp
Cada smbolo vem precedido do seu valor em hexadecimal (ou de brancos se for
indefinido), e de uma letra indicando um de seus 8 tipos possveis:

.in +8
.ip 'U'
indefinido;

.ip 'T'
seo TEXT;

.ip 'D'
seo DATA: dados inicializados;

.ip 'B'
seo BSS: dados no inicializados;

.ip 'C'
seo COMMON;

.ip 'A'
absoluto;

.ip 'R'
registro do processador;

.ip 'F'
nome de mdulo.

.ep
.in -8

.sp
Se a smbolo for local, o tipo ser dado pela respectiva letra minscula.
Para cada um destes tipos de smbolos, existe uma opo
correspondente (ver abaixo). Assim, temos a opo "-t" para a seo
TEXT (tipos 't' ou 'T'), opo "-d" para a seo DATA, e assim por diante.

.sp
Normalmente, "nm" imprime todos os smbolos, e a
sada  ordenada em ordem alfabtica crescente pelo nome do smbolo.

.sp
Se no for dada nenhuma das 8 opes referentes aos tipos ("-utdbcarf"),
so impressos todos os smbolos. Se for dada uma (ou mais) destas opes
so impressos apenas os smbolos dos tipos correspondentes.

.sp
O formato da tabela de smbolo pode ser controlado pelas seguintes opes:

.in +3
.ip -g 6
Imprime somente os smbolos globais.

.ip -u 6
Imprime os smbolos indefinidos.

.ip -t 6
Imprime os smbolos da seo TEXT.

.ip -d 6
Imprime os smbolos da seo DATA.

.ip -b 6
Imprime os smbolos da seo BSS.

.ip -c 6 
Imprime os smbolos da seo COMMON.

.ip -a 6 
Imprime os smbolos absolutos.

.ip -r 6 
Imprime os smbolos de registros.

.ip -f 6 
Imprime os nomes de mdulos.

.ip -o 6
Inclue o nome do <mdulo> em cada linha da sada.

.ip -n 6
Ordena numericamente pelo valor do smbolo
(e alfabeticamente pelo nome em caso de valores iguais).

.ip -e 6
Ordena na ordem inversa (decrescente).

.ip -p 6
No ordena; imprime a tabela na ordem original.

.ip -N 6
Os nomes dos <mdulo>s so lidos da entrada padro.

.ep
.in -3

.sp
Se for pedida a ordenao numrica ascendente de apenas uma seo
("text", "data" ou "bss"), ser includa uma coluna adicional, contendo
o tamanho (em decimal) de cada elemento da tabela de smbolos.

.sp
O tamanho do ltimo smbolo  obtido atravs de clculos
utilizando os tamanhos das sees (o que nem sempre fornece o
valor correto). 

.sp
Alm disto, como a tabela de smbolos pode estar incompleta (por exemplo,
sem os smbolos locais), estes tamanhos podem no ser os reais.

.in
.sp
.b OBSERVAO
.in 5
As tabelas de smbolos de mdulos objeto de bibliotecas
podem ser obtidas dos seguintes modos:
.sp
.nf
		nm /lib/libc/stdio/*.o
	ou
		walk -p "*.o" /lib/libc/stdio | nm -N
.fi

.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd): "
mklib, ld, as
.br
.wo "(fmt): "
a.out
.br

.in
.sp
.b ESTADO
.in 5
Efetivo.

.in
