.bp 1
.he 'PS (cmd)'TROPIX: Manual de Referncia'PS (cmd)'
.fo 'Atualizado em 10.08.04'Verso 4.6.0'Pag. %'

.b NOME
.in 5
.wo "ps -"
imprime informaes sobre processos
.br

.in
.sp
.b SINTAXE
.in 5
ps [-axlk] [-t <tty>] [<pid> ...]

.in
.sp
.b DESCRIO
.in 5
O comando "ps" fornece algumas informaes sobre os processos ativos.

.sp
Sem opes nem argumentos, so dadas informaes apenas sobre os processos
do usurio que est utilizando o comando "ps",
e que esto associados a algum terminal.

.sp
Neste modo,  dada uma lista curta de informaes, contendo apenas
a identificao do terminal ("TTY"),
a identificao do processo ("PID")
e o nome do comando com os respectivos argumentos ("CMD").

.sp
O contedo da lista de informaes pode ser modificado atravs das seguintes
opes/argumentos:

.in +3
.ip -a 7
Fornece informaes sobre todos os processos associados a algum terminal
(e no apenas sobre os processos do usurio que est utilizando o comando "ps").
Esta opo s  permitida ao superusurio.

.ip -x 7
Fornece informaes sobre todos os processos,
quer tenham um terminal associado ou no.
Esta opo s  permitida ao superusurio.

.ip -l 7
Fornece informaes mais detalhadas  sobre cada processo: alm das
informaes da forma curta descrita acima ("TTY", "PID" e "CMD"),
d tambm:

.in +9
.ip F 6
indicadores do processo (ver abaixo);

.ip S 6
estado do processo (ver abaixo);

.ip UID 6
dono do processo obtido a partir da varivel "USER" do ambiente do processo
(ou, se no encontrado, o nome do usurio obtido no arquivo "/etc/passwd");

.ip US 6
indicao se o dono  superusurio ("SU") ou do grupo
do superusurio ("sys");

.ip PPID 6
identificao do  pai do processo;

.ip T 6
tipo do processo (reentrante ("n") ou no);

.ip PRI 6
prioridade do processo;

.ip NI 6
valor do "nice";

.ip UTIME 6
tempo total de CPU (em modo usurio) j utilizado pelo processo;

.ip STIME 6
tempo total de CPU (em modo de sistema) j utilizado pelo processo.

.ep
.in -9

.ip -ll 7
Com a opo "-l" dada duas vezes, algumas das informaes descritas acima
(em "-l") so substitudas por:

.in +9
.ip RUID 6
nome do usurio obtido no arquivo "/etc/passwd";

.ip ADDR 6
endereo da UPROC do processo na memria/disco em KB;

.bc	/*************************************/
.ip SIZE 6
tamanho do processo em KB;
.ec	/*************************************/

.ip MSK 6
mscara de execuo (isto , uma indicao em quais CPUs
o processo pode ser executado);

.ip PGRP 6
identificao do processo lder do grupo ao qual este
processo pertence;

.ip TGRP 6
identificao do grupo de terminais do processo;

.ip RCs 6
nmero atual/mximo de recursos lentos que o processo
ocupa/ocupou.

.ep
.in -9

.ip -lll 7
Com a opo "-l" dada trs vezes, algumas das informaes descritas acima
(em "-l") so substitudas por:

.in +9
.ip ADDR 7
endereo da UPROC do processo na memria/disco em KB;

.ip TSIZE 7
tamanho da regio TEXT do processo em KB;

.ip DSIZE 7
tamanho da regio DATA (que inclui o BSS) do processo em KB;

.ip SSIZE 7
tamanho da regio STACK do processo em KB;

.ip KFILE 7
nmero atual de arquivos abertos do processo.

.ep
.in -9

.ip -llll 7
Com a opo "-l" dada quatro vezes, algumas das informaes descritas acima
(em "-l") so substitudas por:

.in +9
.ip ALARM 8
nmero de segundos faltando antes de enviar o sinal SIGALRM para o processo;

.ip SIGALRM 8
estado do sinal SIGALRM: (D) para SIG_DFL, (I) para SIG_IGN e um endereo
em hexadecimal para indicar a funo de usurio que ser chamada.

.ep
.in -9

.ip -lllll 7
Com a opo "-l" dada cinco vezes, algumas das informaes descritas acima
(em "-l") so substitudas por:

.in +9
.ip KERNEL 8
O tamanho (em bytes) da parte da pilha de modo de supervisor do processo que
j foi usada.

.ip STACK 8
A percentagem correspondente ao uso da pilha (veja acima).

.ep
.in -9

.ip -k 8
Envia o sinal "SIGTERM", interativamente, para os processos desejados.
Se a opo for dada duas vezes ("-kk"), envia o sinal "SIGTERM".

.ip "-t" 8
Fornece informaes apenas sobre processos associados ao terminal <tty>.
O nome do terminal pode ser dado com ou sem o prefixo "tty"
(como por exemplo "tty002" ou simplesmente "002").
Se <tty> for "?" , sero dadas
informaes apenas sobre processos sem terminal associado. 

.ip "<pid>" 8
Fornece informaes apenas sobre processos cujas
identificaes so dadas pelos <pid>s.

.ep
.in -3

.in
.sp
.b "ESTADOS DOS PROCESSOS"
.in 5
Os vrios estados dos processos so dados abaixo pelos cdigos e
seus respectivos nomes simblicos:

.in 8
.ip r 4
SSWAPRDY: pronto para executar, porm no disco;
.ip R 4
SCORERDY: pronto para executar, e na memria interna;
.ip s 4
SSWAPSLP: esperando alguma recurso, no disco;
.ip S 4
SCORESLP: esperando alguma recurso, na memria interna;
.ip i 4
SRUN:	executando na CPU "i";
.ip Z 4
SZOMBIE: o processo j terminou, mas o pai ainda no chamou "wait".
.ep

.in
.sp
.b "INDICADORES DOS PROCESSOS"
.in 5
Os indicadores dos processos do informaes auxiliares sobre o processo.
Os vrios indicadores so dados abaixo em hexadecimal, juntamente
com seus nomes simblicos:

.in 8
.ip 0x01 8
SSYS: processo especial;
.ip 0x02 8
SLOCK:	deve ficar sempre na memria principal;
.ip 0x04 8
SSCTXT:	o estado est em uma rea alternativa;
.ip 0x08 8
SULOCK:	processo regular que deve ficar sempre na memria principal;
.ip 0x10 8
SIGWAKE: foi acordado sem esperar o recurso;
.ip 0x20 8
STRACE: processo em trace;
.ip 0x40 8
SWAITED: a informao de trace j foi dada;
.ip 0x80 8
SIGEXIT: envia o sinal "SIGHILD".
.ep

.in
.sp
.b OBSERVAES
.in 5
Um sistema operacional, juntamente com seus usurios e processos,
formam uma atividade dinmica, e como a tarefa de coletar as diversas
informaes sobre os  processos no  instantnea,
o comando "ps" pode fornecer informaes possivelmente desatualizadas.

.sp
Algumas informaes impressas para processos defuntos
(estado SZOMBIE) podem ser irrelevantes.

.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd): "
kill, nice
.br
.wo "(sys): "
intro, nice
.br

.in
.sp
.b ARQUIVOS
.in 5
/dev/console
 /dev/tty*
 /dev/ptyc*
 /dev/video*
 /dev/swap
 /etc/passwd

.in
.sp
.b ESTADO
.in 5
Efetivo.
.in
