/*
 ****************************************************************
 *								*
 *			pwd.c					*
 *								*
 *	Imprime o diretrio corrente				*
 *								*
 *	Verso	1.0.0, de 04.04.86				*
 *		3.0.1, de 28.07.97				*
 *								*
 *	Mdulo: pwd						*
 *		Utilitrios Bsicos				*
 *		Categoria B					*
 *								*
 *	TROPIX: Sistema Operacional Tempo-Real Multiprocessado	*
 *		Copyright  2000 NCE/UFRJ - tecle "man licena"	*
 * 								*
 ****************************************************************
 */

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

/*
 ****************************************************************
 *	Variveis e Definies globais				*
 ****************************************************************
 */
const char	pgversion[] =  "Verso:	3.0.1, de 28.06.97";

#define	elif	else if

#define		PWDNMSZ		512

entry int	vflag;		/* Verbose */

/*
 ****** Prottipos de funes ***********************************
 */
void		help (void);

/*
 ****************************************************************
 *	Imprime o diretrio corrente				*
 ****************************************************************
 */
int
main (int argc, register const char *argv[])
{
	register int	opt;
	char		*pwd;

	/*
	 *	Analisa as opes
	 */
	while ((opt = getopt (argc, argv, "vH")) != EOF)
	{
		switch (opt)
		{
		    case 'v':			/* Verbose */
			vflag++;
			break;

		    case 'H':			/* Help */
			help ();

		    default:			/* Erro */
			putc ('\n', stderr);
			help ();

		}	/* end switch */

	}	/* end while */

	argv += optind;
	argc -= optind;

	/*
	 *	Obtm o diretrio corrente
	 */
	if ((pwd = getcwd (NOSTR, PWDNMSZ)) == NOSTR)
	{
		fprintf
		(	stderr,
			"%s: No consegui obter o nome do diretrio corrente (%s)\n",
			pgname, strerror (errno)
		);
		exit (1);
	}

	/*
	 *	Imprime o diretrio corrente
	 */
	printf ("%s\n", pwd);

	return (0);

}	/* end pwd */

/*
 ****************************************************************
 *	Resumo de utilizao do programa			*
 ****************************************************************
 */
void
help (void)
{
	fprintf
	(	stderr,
		"%s - imprime o diretrio corrente\n"
		"\n%s\n"
		"\nSintaxe:\n"
		"\t%s\n",
		pgname, pgversion, pgname
	);

	exit (2);

}	/* end help */
