.bp
.he 'REDUCE (cmd)'TROPIX: Manual de Referncia'REDUCE (cmd)'
.fo 'Escrito em 16.09.90'Verso 2.3'Pag. %'

.b NOME
.in 5
Comprime/expande um arquivo segundo o algoritmo LZW:
.sp
.wo "reduce -"
comprime ou expande, de acordo com as opes
.br
.wo "rcat   -"
apenas expande
.br

.in
.sp
.b SINTAXE
.in 5
.(l
reduce [-b <n>] [-rfv] <original> [<comprimido>]

reduce -u [-ft] <comprimido> [<original>]

rcat <comprimido> [<original>]
.)l

.in
.sp
.b DESCRIO
.in 5
O comando "reduce" tenta reduzir o tamanho do arquivo <original>,
armazenando uma forma reduzida no arquivo <comprimido>.
Se o nome do arquivo <original> for "-", ele  lido da entrada
padro. Se o nome do arquivo <comprimido> no for dado, ele  escrito
na sada padro.

.sp
Um arquivo <comprimido> pode ser restaurado  sua forma original
atravs de "rcat" (ou "reduce" com a opo "-u").
Se o nome do arquivo <comprimido> for "-", ele  lido da entrada
padro. Se o nome do arquivo <original> no for dado, ele  escrito
na sada padro.

.sp
O comando "reduce" usa um algoritmo baseado no mtodo de
"Lempel-Ziv-Welch" (LZW), um processo adaptativo de compresso de dados.
Subcadeias comuns do arquivo <original> so substitudas inicialmente
por cdigos de 9 bits, a partir de 257. Quando  alcanado o cdigo 512,
passa-se para 10 bits, e assim sucessivamente, at o mximo de 16 bits.
Periodicamente, o fator de compresso  avaliado, e se est decrescendo,
a tabela de subcadeias  esvaziada, recomeando a codificao a partir
de 9 bits. Isto faz com que "reduce" se adapte a arquivos longos,
em que o estilo (isto , o repertrio de subcadeias) varia.

.sp
O fator de compresso obtido depende do tamanho do arquivo <original>, o
nmero de bits utilizado na codificao, e a distribuio das
subcadeias comuns.
Para programas fontes, so tpicos fatores de compresso de 50 a 66 \%
(isto , o arquivo <comprimido> tem da metade  tera parte do tamanho do
<original>). Para mdulos objeto, os fatores de compresso so menores,
situando-se em geral na faixa de 30 a 40 \%.

.sp
A reduo mxima de tamanho  obtida com a utilizao de cdigos de 16
bits. Para isto, no entanto,  necessria uma quantidade aprecivel de memria
(principalmente durante a compresso).
A quantidade da memria necessria para a tabela de compresso/expanso
 uma funo exponencial do tamanho mximo do cdigo -
cada bit a mais exige o dobro de memria.

.(t
Na tabela abaixo damos o tamanho total necessrio por "reduce",
para alguns valores de tamanho mximo do cdigo: 

.sp
.ts
center
allbox;
c|c|c.
Bits	Compresso	Expanso
.t&
c|c|c.
 9	 48 Kb	 52 Kb
13	120 Kb	 84 Kb
14	196 Kb	116 Kb
16	656 Kb	308 Kb
.te
.)t

.sp
Repare que se forem gerados cdigos de 16 bits, existe a possibilidade de no
ser possvel a operao de expanso em um outro computador com menos memria
disponvel (veja a opo "-b").

.sp
Normalmente, so adicionadas informaes de CRC durante o processo de
compresso, que so verificadas durante a expanso. Isto oferece
uma garantia bem alta de que o arquivo recuperado durante o processo de
expanso  de fato idntico ao original que foi comprimido (veja a opo "-r").  

.sp
Existe uma possibilidade de o arquivo <comprimido> ficar maior
do que o <original>. Isto ocorre principalmente com arquivos
pequenos (menores do que 256 bytes). Se isto ocorrer,  emitida uma
mensagem de advertncia.

.sp
As opes do comando so:

.in +3
.ip -b
Tamanho mximo do cdigo (em bits).
Esta opo deve ser utilizada apenas na compresso
(o arquivo <comprimido> j contm o tamanho mximo a ser utilizado na expanso).
Este valor deve ser dado na faixa de 9 a 16 bits
(se for omitido, ser usado um tamanho mximo de 14 bits, que  um bom
compromisso entre o fator de compresso e a memria necessria para arquivos
da 30 Kb ou menores).

.ip -r
Gera o arquivo <comprimido> SEM os CRCs. Com isto,
a velocidade de compresso/expanso fica aproximadamente
.wo '20 \%'
maior e o arquivo <comprimido> fica da ordem de
.wo '1 \%'
menor. Por outro lado, a segurana proporcionada pelos cheques
de CRCs  perdida.  

.ip -f
Normalmente, o usurio  consultado para decidir se um arquivo destino
j existente deve ser reescrito.
A opo "-f" suprime esta consulta, recriando o arquivo.

.ip -v
Estatstica.
Imprime os totais de caracteres processados e o fator de compresso obtido.

.ip -u
Operao de expanso.

.ip -t
Imprime a tabela de cadeias utilizada.

.ep

.in
.sp
.b
VALOR DE RETORNO
.r
.in 5
Se ocorreu qualquer tipo de erro, o cdigo do "exit"  1;
se durante uma operao de compresso o arquivo teve o seu
tamanho aumentado, o cdigo do "exit"  2;
em caso contrrio, o cdigo do "exit"  0.

.in
.sp
.bc	/*************************************/
.b OBSERVAO(ES)
.ec	/*************************************/
.b OBSERVAO
.in 5
O arquivo <comprimido> contm codificado um indicador de final de arquivo.
Isto significa que ele pode residir tambm em arquivos especiais (de blocos
ou caracteres), e ser corretamente recuperado.
Alis, como o arquivo <comprimido> contm normalmente CRCs, comprimir
um arquivo diretamente para um disquete ou fita magntica  um modo
conveniente de armazenamento/transporte de arquivos, como no exemplo abaixo:

.sp
.(t
.nf
		reduce alpha /dev/d5a
		rcat /dev/d5a .....
.fi
.)t
.sp

.bc	/*************************************/
.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd): "
c
.br
.wo "(sys): "
s
.br
.wo "(libc):"
l
.br
.wo "(fmt): "
f
.br
.ec	/*************************************/

.in
.sp
.b
REFERNCIAS
.r
.in 5
"A Technique for High Performance Data Compression",
Terry A. Welch, "IEEE Computer,"
vol. 17, no. 6 (June 1984), pp. 8-19.

.bc	/*************************************/
.in
.sp
.b EXEMPLOS
.in 7
.sp 2
e
.ec	/*************************************/

.in
.sp
.b ESTADO
.in 5
Efetivo.

.in
