.bp
.he 'EDSCB (cmd)'TROPIX: Manual de Referncia'EDSCB (cmd)'
.fo 'Atualizado em 21.10.03'Verso 4.5.0'Pag. %'

.b NOME
.in 5
.wo "edscb -"
imprime/edita o bloco de controle do ncleo do TROPIX
.br

.in
.sp
.b SINTAXE
.in 5
.(l
edscb [-v] [<kernel> [<scbfile> ...] ]
.)l

.in
.sp
.b DESCRIO
.in 5
O ncleo do sistema operacional TROPIX contm um bloco de controle
(SCB) com diversos parmetros,
cujo objetivo  definir a configurao do sistema.
Alterando um (ou mais) destes parmetros podemos modificar vrios
aspectos do sistema operacional,
e deste modo atender a diversos desejos e necessidades.
Os parmetros do SCB so descritos em "scb" (fmt).

.sp
O comando "edscb" edita o bloco de controle do ncleo do TROPIX, cuja
imagem est no arquivo <kernel>. Se <kernel> no for dado, ser
impresso o bloco de controle do ncleo em execuo.

.sp
Se o TROPIX foi instalado em arquivos do MS-DOS, o arquivo contendo
a imagem do ncleo estar no disquete BOOT (veja a observao, abaixo).

.sp
Se um ou mais arquivos de configurao <scbfile> forem dados, eles
devem conter comandos de configurao. Em caso contrrio, os comandos
de configurao so lidos da entrada padro (normalmente o teclado) -
veja o "modo interativo" e "modo no-interativo", abaixo.

.sp
Os novos valores dos parmetros somente entraro em vigor
aps uma nova carga do sistema operacional, e valero enquanto
no for utilizado novamente o comando "edscb".

.sp
Aps a carga, pode ser utilizado o comando "prscb" (cmd)
(que imprime os parmetros em uso efetivo no momento),
para verificar se as modificaes realizadas atravs de "edscb"
foram as desejadas.

.sp
 tambm possvel alterar os parmetros de forma provisria,
durante a carga do sistema, respondendo afirmativamente a pergunta
"Deseja alterar parmetros?".
Estas alteraces, no entanto, sero vlidas apenas para aquela execuo
do sistema operacional, j que  apenas alterada a tabela na memria
interna do computador, e no no arquivo imagem do sistema.
 
.sp
Repare que podemos ter vrias imagens do ncleo com diversas configuraes
(por exemplo, "/new.tropix", "/big.tropix", ...) e selecionar a configurao
desejada durante o "boot", escolhendo um dos arquivos.

.sp
No momento (ainda) no podemos alterar dinmicamente os parmetros. Sempre
necessitamos recarregar o sistema para ativar efetivamente um
SCB modificado.

.bc	/*************************************/
Esta tabela (chamada de SCB, ou seja "system control block") est contida
na imagem do ncleo do TROPIX em disco (normalmente o arquivo "/tropix"),
e  copiada para a memria (de onde  consultada) durante o processo
de "boot" (ou seja, a carga do sistema operacional).
.ec	/*************************************/

.sp
As opes do comando so:

.in +3
.ip -v
Verboso.

.ep
.in -3

.in
.sp
.(t
.b "MODO INTERATIVO"
.in 5
Se NO for dado nenhum arquivo de configurao <scbfile>, os comandos
de configurao so lidos da entrada padro (normalmente teclado).
Neste caso, o comando utiliza o modo interativo, no qual "edscb" imprime uma
tela contendo alguns parmetros,
e em seguida aguarda um comando do usurio aps o "prompt"
"> ".
.)t

.sp
Como uma tela apenas no  suficiente para todos os parmetros, so usadas
3 telas: "A", "B" e "C".
Para consultar uma outra tela, basta teclar o nome da tela desejada.

.sp
Um comando da forma "<param>=<valor>" atribui o valor <valor> ao parmetro
<param>. O <valor> pode ser um nmero decimal, hexadecimal ou octal (de acordo
com a sintaxe de "strtol" (libc)) com o sufixo opcional "k", "K", "m" ou "M" indicando
que o nmero deve ser multiplicado por 1024 ou (1024 * 1024).

.bc	/*************************************/
Para alterar um parmetro, deve-se dar um comando da forma "<param>=<valor>".
.ec	/*************************************/


.sp
Para encerrar "edscb", com a possibilidade de atualizar o SCB da
imagem do ncleo, temos os comandos "w" e "q" (ou basta teclar <^D>).
Repare que a imagem do ncleo s  atualizada ao final da execuo
de "edscb", e somente se for respondida afirmativamente
a confirmao de atualizao do arquivo <kernel>.

.in
.sp
.b "MODO NO-INTERATIVO"
.in 5
Tambm  possvel ler os comandos de configurao dos parmetros de um
(ou mais) arquivo(s) de configurao <scbfile>.
Cada comando deve ser da forma "<param>=<valor>" (ver acima), e dados um por linha.
NO  necessrio incluir os comandos "w" ou "q" ao final.

.in
.sp
.b OBSERVAO
.in 5
Se o TROPIX foi instalado em arquivos do MS-DOS, o arquivo contendo
a imagem do ncleo estar no disquete BOOT, e os parmetros do SCB
podem ser modificados do seguinte modo:

.sp
.nf
	mount -w /dev/fd0 /mnt
	edscb /mnt/tropix ... 
	umount /dev/fd0
.fi

.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(libc): "
strtol
.br
.wo "(cmd):  "
prscb
.br
.wo "(ref):  "
install
.br
.wo "(fmt):  "
scb
.br

.in
.sp
.b ESTADO
.in 5
Efetivo.

.in
