/*
 ****************************************************************
 *								*
 *			scan.h					*
 *								*
 *	Definies relativas  anlise lxica			*
 *								*
 *	Verso	3.2.2, de 16.09.99				*
 *								*
 *	Mdulo: SHELL						*
 *		Interpretador de Comandos			*
 *								*
 *	TROPIX: Sistema Operacional Tempo-Real Multiprocessado	*
 *		Copyright  2000 NCE/UFRJ - tecle "man licena"	*
 * 								*
 ****************************************************************
 */

#ifdef	MAJOR		/* Evita conflitos com <sys/common.h> */
#undef	MAJOR
#endif	MAJOR

#define	VAR_SYMBOL	24
#define	CMD_SYMBOL	25

/*
 ****************************************************************
 *	Majors dos Tokens 					*
 ****************************************************************
 */
typedef	enum
{
	EOT,		/* Final de texto */
	EOL,		/* Final da linha */

	STRING,		/* Cadeia */
	DEFVAR,		/* Definio de varivel */
	PROG,		/* Comando de programao */

	REDIREC,	/* Redirecionamento */

	/*
	 *	Ateno: a ordem dos conectores no pode ser alterada.
	 */
	BG,		/* & */
	SM,		/* ; */
	AND,		/* && */
	OR,		/* || */
	PIPE,		/* | */

	SMSM,		/* ;; */

	LP,		/* ( */
	RP,		/* ) */
	LC,		/* { */
	RC		/* } */

}	MAJOR;

/*
 ****************************************************************
 *	Estrutura de sada do Analisador Lxico			*
 ****************************************************************
 */
typedef	struct
{
	MAJOR	t_major;	/* Major do Token */

	int	t_nline;	/* Nmero da linha do token */

	char	*t_begin,	/* Coluna inicial do token na linha */
		*t_end;		/* Coluna final   do token na linha */

	char	*t_sval;	/* Se t_major == STRING */

	PROGID	t_progid;	/* Se t_major == PROG */

}	TOKEN;

/*
 ****************************************************************
 *	Variveis do Analisador Lxico				*
 ****************************************************************
 */
extern	TOKEN		token;
extern	FILE		*input_file;
extern	char		*lineread;
