.bp
.he 'SH (cmd)'TROPIX: Manual de Referncia'SH (cmd)'
.fo 'Atualizado em 24.03.04'Verso 4.5.0'Pag. %'

.b NOME
.in 5
sh - interpretador de comandos programvel
.br

.in
.sp
.b SINTAXE
.in 5
sh [-c <comando>] [-derv] [<arg> ...]

.in
.sp
.b DESCRIO
.in 5
O utilitrio "sh"  um interpretador de comandos programvel que
executa comandos lidos de um terminal ou arquivo.
Os comandos devem ser dados em uma linguagem prpria, que  descrita abaixo.

.sp
As opes so:

.in +3 
.ip "-c" 5
Executa o <comando> dado como argumento e encerra.

.ip "-d" 5
Aceita tambm <^D> para terminar o "sh". Normalmente, para
terminar a execuo, devem ser usados os comandos internos
"exit", "login" ou "logout".

.ip "-e" 5
Termina a execuo do "sh" imediatamente, se um comando retornar no-zero.

.ip "-r" 5
Verifica a reescrita de arquivos no redirecionamento.

.ip "-v" 5
Lista cada linha de comandos lida do arquivo de entrada.

.ep
.in -3 

.in
.sp 2
.b "DESCRIO DA LINGUAGEM"
.in 5

.in
.sp
.in 2
.b Definies
.in 5
.sp
Um "branco"  um <sp> ou um <ht>. Uma "palavra"  uma seqncia de
caracteres que no incluem brancos.
Um "nome"  uma seqncia de letras, dgitos, ou "sublinhado"s ("_")
iniciada por uma letra ou "sublinhado".
Um "parmetro"  um nome, um dgito,
ou um dos caracteres "*", "@", "#", "?", "-", "$", "!", ":" e "\%".

.in
.sp
.in 2
.b Comandos
.in 5
.sp
Um "comando-simples"  uma seqncia de palavras separadas por brancos.
A primeira palavra especifica o nome do comando a ser executado.
Salvo excees (que sero vistas abaixo), as palavras restantes so
passadas como argumentos ao comando invocado.
O nome do comando  passado como argumento de nmero 0 (veja "exec" (sys)).

.sp
Se um comando-simples terminar normalmente, o seu "valor de retorno"
 dado pelo argumento fornecido  chamada "exit" (sys).
Caso contrrio, o seu "valor de retorno"  dado por 0x80 + cdigo de retorno
(veja "wait" e "signal" (sys) para uma lista dos cdigos de retorno).

.sp
Uma "linha de canais" ("pipeline")  uma seqncia de dois ou mais comandos
separados por "|".
Um "pipeline"  construdo conectando-se a sada padro de cada comando
(com a exceo do ltimo),  entrada padro do comando seguinte
atravs da chamada ao sistema "pipe" (sys).

Cada comando  executado como um processo independente;
"sh" espera pelo trmino do ltimo comando.
O valor de retorno de um "pipeline"  o valor de retorno do ltimo comando.

.sp
Uma "lista de pipelines" (ou simplesmente uma "lista")
 uma seqncia de um ou mais "pipeline"s separados por ";", "&", "&&" ou "||"
e, opcionalmente, terminado por ";" ou "&".

Destes quatro smbolos, ";" e "&" tm a mesma precedncia,
que  menor do que as precedncias de "&&" e "||".
Os smbolos "&&" e "||" tambm tm a mesma precedncia.

.sp
Um ponto e vrgula (";") causa a execuo seqencial do "pipeline"
precedente; um "e comercial" ("&") provoca uma execuo assncrona do
"pipeline" precedente (isto , "sh" no espera pelo trmino daquele "pipeline").

.sp
O smbolo "&&" ("||") faz com que a lista que o
segue seja executada apenas se o "pipeline" anterior tiver
um valor de retorno igual a zero (diferente de zero).
Um nmero arbitrrio de <nl> pode aparecer em
uma lista, ao invs de ponto e vrgulas, para delimitar comandos.

.sp
Um "comando"  uma lista, um "comando-interno" ou
um dos comandos-de-programao descritos adiante
(veja "comandos internos" e "comandos de programao", abaixo).
A menos que seja estabelecido de outro modo, o valor de retorno de
um comando  aquele do ltimo comando-simples executado.

.sp
.in 2
.b
Comandos-de-Programao
.r
.in 5

.sp
for <nome> [in <palavra> ...] do <lista> done
.br

.in +8
.sp
Este comando executa a <lista> para cada <palavra> dada.
Em cada execuo, <nome> recebe o valor da <palavra> seguinte.

.bc	/*************************************/
atribuindo <nome> com o valor da respectiva <palavra>. 
.ec	/*************************************/

Se a parte "in <palavra> ..." for omitida, a <lista> ser executada
para cada "parmetro posicional" definido
(veja "substituio de parmetros", abaixo).

.in -8
.sp
.(l
case <palavra> in
    [<padro> [|<padro>] ...) <lista> ;;] ...
esac
.)l
.in +8
.br

.sp
O comando "case" executa a <lista> associada ao primeiro <padro> que
seja aceito (tenha correspondncia) com a <palavra> dada.
A forma dos <padres>  a mesma que  usada para a gerao de nomes de arquivos
(veja "gerao de nomes de arquivos"),
exceto que uma barra ("/'), um ponto (".") inicial,
ou um ponto imediatamente aps
uma barra no precisam ser aceitos explicitamente.

.in -8
.sp
.(l
if <lista> then <lista>
    [ elif <lista> then <lista> ] ...
    [ else <lista> ]
fi
.)l
.br

.in +8
A <lista> aps o "if"  executada,
e caso tenha um valor de retorno igual a zero,
 executada a <lista> aps o "then".
Em caso contrrio, a <lista> aps o "elif" (se dada)  executada,
e caso tenha um valor de retorno igual a zero,
 executada a <lista> aps o "then" seguinte.
Falhando todos os "elif"s,  executada a <lista>
aps o "else" (se dada).
Caso no seja executada nenhuma <lista> de "else" ou "then",
o comando termina com um valor de retorno diferente de zero.

.in -8
.sp
.(t
while <lista> do <lista> done
.sp
until <lista> do <lista> done
.br

.sp
.in +8
O comando "while" executa repetidamente a primeira e a segunda <lista>.
Se o valor de retorno do ltimo comando da primeira <lista> for
diferente de zero, a segunda <lista> no  executada e a malha termina.
Se nenhum comando da segunda <lista> for executado, o comando
"while" termina com o valor de retorno igual a zero.
A palavra chave "until" pode ser utilizado ao invs de "while"
para negar o teste de trmino de repetio.
.)t
.in -8

.sp
( <lista> )
.sp
.in +8
Cria um processo filho "sh" para executar a <lista>. 
.in -8

.sp
{ <lista>; }
.in +8
.sp
Executa a <lista> neste "sh".
.in -8

.sp
As seguintes palavras so sempre consideradas reservadas:
.sp
.(l
    if then else elif fi case esac for while until do done { }
.)l

.sp
Se, em algum momento, for necessrio utiliz-las de outro
modo, elas devem ser includas entre aspas ou apstrofos.

.in
.sp
.in 2
.b Comentrios
.in 5
.sp
Todos os caracteres aps o "#" at o primeiro <nl> posterior so ignorados.

.in
.sp
.in 2
.b
Substituio de Comandos
.r
.in 5
.sp
O comando "sh" l comandos de uma cadeia de caracteres entre dois acentos
graves (`...`), executa estes comandos, e a sua sada padro
pode ser usada como parte integral ou parcial de uma palavra.
Os caracteres <nl> da sada padro so removidos.

.sp
Um comando til para a utilizao com os acentos graves  o "from",
como no exemplo abaixo:

.sp
.nf
	for i in `from 1 to 10`
	do
		echo $i
	done
.fi

.sp
em que o comando "echo"  executado 10 vezes, com os valores consecutivos
de "1" a "10" para a varivel "i".

.sp
No  realizada qualquer interpretao dos caracteres da cadeia
lida, exceto para a remoo de barras invertidas ("\"), usadas para
desabilitar o significado especial de caracteres. Uma barra invertida ("\")
pode ser usada para desabilitar o significado especial de um acento
grave ou outra barra invertida ("\") e  removida antes que a cadeia
de caracteres seja lida.
Se a substituio de comandos encontra-se entre um par de aspas
.wo '(" ... ` ... ` ... "),'
ento uma barra invertida usada para desabilitar o significado especial
de uma aspas ser removida; em outros casos ela ser mantida intacta.


.bc	/*************************************/
A desabilitao do significado especial de
acentos graves permite o aninhamento de substituies de comandos.
.ec	/*************************************/


.sp
Se uma barra invertida ("\")  usada para anular o significado especial
de um <nl>, tanto a barra invertida quanto o <nl> sero
removidos (veja a seo posterior sobre "mecanismos de quotao").
Alm disto, barras invertidas usadas para anular o significado do
sinal de dollar ("$") so removidos. J que no  realizada nenhuma
interpretao na cadeia de caracteres do comando antes que ele
seja lido, a insero de uma barra invertida antes de um sinal de
dollar no tem efeito. Barras invertidas que precedam caracteres
outros que "\", "`", '"', <nl> e "$" so mantidos intactos quando
 lida a cadeia de caracteres do comando.

.in
.sp
.in 2
.b
Substituio de Parmetros
.r
.in 5
.sp
O caractere '$'  usado para introduzir parmetros substituveis.
Temos dois tipos de parmetros: posicionais e de palavras-chaves.
Se um parmetro  um dgito, ele  um parmetro posicional.
Podemos atribuir valores aos parmetros posicionais com o comando
"set".
Atribuimos valores a parmetros de palavras-chaves (tambm chamadas
de variveis) escrevendo:

.sp
.in +5
    <nome>=<valor> [<nome>=<valor> ...]
.in -5

.sp
A expanso de nomes no  realizada em <valor>.
.bc	/*************************************/
NO podemos ter uma funo e uma varivel com o mesmo nome.
.ec	/*************************************/

.ip "${<parmetro>}" 16
O valor, se algum, do <parmetro>  substitudo.
As chaves s so necessrias se o nome do <parmetro>
for seguido por uma letra, dgito, ou "sublinhado" ('_'),
que no deve ser interpretado como parte do nome.

.ep

.sp
Os seguintes parmetros tm seus valores automaticamente
atribudos pelo comando "sh":

.in +3
.ip "#" 3
O nmero de parmetros posicionais (em decimal).

.ip "-" 3
Opes dadas ao comando "sh" ou dadas atravs do comando "set".

.ip "?" 3
O valor de retorno em decimal retornado pelo ltimo comando
executado sincronamente.

.ip "$" 3
A identifiao do processo (PID) deste "sh".

.ip "!" 3
A identifiao do processo (PID) do ltimo comando em "background" executado.

.ip ":" 3
O nmero do prximo comando a entrar no histrico (veja "histrico", abaixo).

.ip "@" 3
Os parmetros posicionais (veja adiante)  exceo de $0.

.ip "*" 3
Uma cadeia com os parmetros posicionais  exceo de $0.

.ip "\%" 3
Uma cadeia com o nome do n (nome do prprio computador na rede).

.ip "~" 3
O nome do diretrio corrente.

.ip "&" 3
O caractere "#" se o usurio for um superusurio, e "$" em caso contrrio.

.in -3
.ep

.sp
.(t
Os seguintes parmetros so utilizados pelo comando "sh":

.in +3
.ip "HOME" 6
O diretrio "home", o argumento assumido por omisso para o comando "cd".
O caractere '~'  equivalente a $HOME, quando ocorre em caminhos.
.)t

.ip "PATH" 6
Os caminhos de busca para os comandos (veja execuo abaixo).

.ip "PS1" 6
A cadeia de caracteres com o "prompt", normalmente "$ ".

.ip "PS2" 6
A cadeia de caracteres com o "prompt" secundrio, normalmente "> ".

.bc	/*************************************/
.ip "IFS" 6
Separadores de campos utilizados pelo comando "sh",
normalmente  <sp>, <ht> e <nl>.
.ec	/*************************************/

.in -3
.ep

.sp
A 
O comando "sh" atribui os valores iniciais para as variveis
"PATH", "PS1" e "PS2".
O valor inicial de "HOME"  atribudo pelo comando "login".

.in
.sp
.in 2
.(t
.b
Interpretao de brancos
.r
.in 5
.sp

Aps a substituio de parmetros e de comandos, o resultado da substituio
 examinado  procura de caracteres separadores de campos
e separado em argumentos distintos
onde estes so encontrados.
Argumentos explicitamente nulos ("" ou '') so mantidos.
Argumentos nulos implcitos (aqueles decorrentes de parmetros sem valor)
so removidos.
.)t

.in
.sp
.in 2
.b
Redirecionamento de Entrada e Sada
.r
.in 5
.sp
As entradas e sadas de um comando podem ser redirecionadas
usando uma notao especial interpretada pelo comando "sh".
As construes apresentadas a seguir
podem aparecer em qualquer lugar de um comando-simples,
e no so passados como argumentos ao comando invocado.
Note que a substituio de comandos e parmetros  realizada
antes que <nome> ou <dgito> seja usado.

.in +3
.ip "< <nome>" 12
Usa o arquivo <nome> como a entrada padro
(relativo ao descritor de arquivos 0).

.ip "> <nome>" 12
Usa o arquivo <nome> como a sada padro
(relativo ao descritor de arquivos 1).
Se o arquivo no existe ele  criado; em caso contrrio  truncado.

.ip ">> <nome>" 12
Usa o arquivo <nome> como sada padro.
Se o arquivo j existe a sada  adicionada ao seu final;
em caso contrrio o arquivo  criado.

.ip "<< <nome>" 12
Aps a substituio de parmetros e de comandos ser realizada em <nome>,
a entrada do comando "sh"  lida at a primeira linha que corresponda
literalmente ao <nome> resultante, ou at um fim de arquivo.

.ip "< &<dgito>" 12
Usa o arquivo associado ao descritor de arquivos dado pelo <dgito>
como a entrada padro.

.ip "> &<dgito>" 12
Usa o arquivo associado ao descritor de arquivos dado pelo <dgito>
como a sada padro.

.ip "<&-" 12
Fecha a entrada padro.

.ip ">&-" 12
Fecha a sada padro.

.in -3
.ep

.sp
Se qualquer uma das cadeias acima for precedida por um dgito,
o descritor de arquivos que ser associado ao arquivo  aquele
dado pelo dgito (ao invs dos valores 0 ou 1 assumidos por omisso).
Por exemplo:

.sp
.in +8
 ... 2>&1
.in -8

.sp
associa o descritor de arquivos 2 ao arquivo correntemente associado
com o descritor de arquivos 1.

.sp
A ordem em que so dadas as redirees  significante;
o comando "sh" avalia as redirees da esquerda para direita.
Por exemplo:

.sp
.in +8
 ... 1> <arquivo> 2>&1
.in -8
.sp

em primeiro lugar associa o descritor de arquivos 1 ao <arquivo>;
em seguida associa o descritor de arquivos 2 ao arquivo associado
ao descritor de arquivos 1 (isto  <arquivo>).

.sp
Se a ordem de redirees fosse a reversa, o descritor de arquivos 2
seria associado ao terminal/vdeo (assumindo que o descritor de arquivos
1 o tinha sido) e em seguida, o descritor de arquivos 1 seria associado
ao <arquivo>.

.sp
Usando a terminologia introduzida na primeira pgina, em "comandos",
se um comando  composto de vrios comandos-simples, as redirees
so avaliadas para o comando como um todo, antes que sejam avaliadas
para cada comando-simples.
Em outras palavras, o comando "sh" avalia os redirecionamentos
para a lista inteira, em seguida para cada "pipeline" dentro da lista e
finalmente para cada lista dentro de cada comando.

.sp
Se um comando  seguido por "&", a entrada padro para o
comando ser o arquivo vazio "/dev/null".
Em caso contrrio, o ambiente para a execuo de um comando
contm os descritores de arquivos do comando "sh"
que o invocou, segundo as modificaes dadas pelas
especificaes de entrada e sada.

.in
.sp
.in 2
.b
Gerao de Nomes de Arquivos
.r
.in 5
.sp
Antes que um comando seja executado, cada palavra do comando 
examinada  procura dos caracteres "*", "?", "!" e "[".
Se algum destes caracteres estiver presente, a palavra  considerada
um padro.
A palavra  substituda pela lista ordenada alfabeticamente
de nomes de arquivos que correspondem ao padro dado. Se no for
encontrado nomes de arquivos que correspondam ao padro, o comando
"sh" indica o erro. O caractere "." no incio de um nome de arquivo
ou imediatamente aps uma barra ("/"), assim como o caractere barra
devem corresponder explicitamente ao padro.

.in +3
.ip ? 8
Corresponde a (um) caractere qualquer.

.ip * 8
Corresponde a zero ou mais caracteres quaisquer.

.ip !c 8
Corresponde a qualquer caractere diferente de "c".

.ip [...] 8
Corresponde a um caractere igual a um dos caracteres entre os colchetes.
Podemos tambm ter construes do tipo "x-y"
entre os colchetes,
que representa todos os caracteres de "x" a "y" (inclusive). 

.ip ![....] 8
Corresponde a um caractere que deve ser diferente de todos os caracteres
entre os colchetes. Assim como acima, "x-y" representa todos os
caracteres de "x" a "y".

.ip \c 8
Corresponde ao caractere "c". Esta construo  til para desfazer
o efeito especial dos meta-caracteres.

.in +3
.ep

.bc	/*************************************/
.sp
.in +5

.ip "*" 8
Corresponde a qualquer cadeia de caracteres, inclusive a cadeia nula.

.ip "?" 8
Corresponde a qualquer (nico) caractere.

.ip "[...]" 8
Corresponde a qualquer um dos caracteres entre os colchetes.
Um par de caracteres separados por "-" corresponde a qualquer
caractere lexicamente entre o par (incluindo o primeiro o ltimo).
Se o primeiro caractere aps o abre colchete for um "!" qualquer caractere
no especificado entre os colchetes  correspondido.

.ip "!" 8
Corresponde a qualquer caractere a exceo do caractere especificado
aps.
.ep
.in -5
.ec	/*************************************/

.in
.sp
.in 2
.b
Mecanismos de Quotao
.r
.in 5

.sp
Os seguinte caracteres tm um significado especial para o comando "sh"
e causam o fim de uma palavra a menos que estejam quotados:
.sp
.in +5
.b
;  &  (  )  |  <  >  <nl>  <sp>  <ht>
.r
.in -5

.sp
Um caractere pode ser "quotado"
(isto , fazer com que perca o seu significado especial)
precedendo-o por uma barra invertida ("\") ou inserindo-o entre um par de
marcas de quotao ('' ou "").
Durante o processamento, o comando "sh" pode quotar alguns caracteres
para evitar que eles tenham um significado especial.
Barras invertidas usadas para quotar um caractere so removidas
da palavra antes que o comando seja executado.
O par "\<nl>"  removido antes da substituio de comandos e parmetros.

.sp
Todos os caracteres entre um par de acentos agudos (''), exceto
um acento agudo, so quotados pelo comando "sh".
Uma barra invertida no tem um significado especial dentro de um
par de acentos agudos.
Um acento agudo pode ser quotado dentro de um par de
aspas (por exemplo "'").

.sp
Dentro de um par de aspas (""),  realizada a substituio de
parmetros e comandos, mas sobre o resultado o comando "sh"
no faz interpretao de brancos, nem gerao de nomes de arquivos.
Se "$*" est entre um par de aspas ("$*"), os parmetros
posicionais so substitudos e formam uma nica palavra,
considerada como quotada, com um espao entre cada par de
parmetros ("$1 $2 $3 ...").
No entanto, se "$@" estiver entre um par de aspas ("$@"),
os parmetros posicionais so
substitudos e quotados separados por espaos
("$1" "$2" "$3" ...).
Uma barra invertida ("\") retira
o significado especial dos caracteres "\", "'", '"' e "$".
O par "\<nl>"  removido antes da substituo de parmetros
e comandos.
Se a barra invertida precede caracteres diferentes de "\", "'", '"' e "$",
ela prpria  quotada pelo comando "sh".

.in
.sp
.in 2
.(t
.b '"Prompt"'
.in 5

.sp
Quando usado interativamente, o comando "sh" mostra o "prompt" dado
pelo valor da varivel "PS1", antes de ler o comando.
Se a qualquer tempo um <nl> for teclado e for
necessria mais entrada para completar o comando, o "prompt"
secundrio (isto , o valor de "PS2")  exibido.
.)t

.in
.sp
.in 2
.b Ambiente
.in 5

.sp
O ambiente (veja environ (fmt))  uma lista de pares (<nome>, <valor>)
que  passada a um programa executado, do mesmo modo que a lista de
argumentos.
O comando "sh" interage com o ambiente de vrios modos.
Na sua invocao, o comando "sh" examina o ambiente,
e cria uma varivel para cada <nome> encontrado,
associando-a ao <valor> respectivo.
Se o usurio modificar o <valor> de qualquer dessas variveis ou
criar novas variveis, nenhuma destas afeta o ambiente a menos
que o comando "export" seja utilizado para direcionar a varivel
do comando "sh" para o ambiente (veja tambm "set -a").
Uma varivel pode ser removida do ambiente atravs do comando "unset".
O ambiente recebido por qualquer comando executado  ento composto dos
pares (<nome>, <valor>) no modificados, originalmente herdado pelo
comando "sh", menos os pares removidos pelo comando "unset",
mais quaisquer modificaes ou adies,
realizadas atravs do comando "export".

.bc	/*************************************/
.sp
O ambiente para qualquer comando-simples pode ser acrescido
prefixando por uma ou mais atribuies a variveis. Logo:
.sp
.in +5
$ TERM=450 cmd
.wo "                         e"
.br
$ (export TERM; TERM=450; cmd)
.in -5
.sp
so equivalentes no que concerne a excecuo de "cmd".

.sp
Se a opo "-k" est ativa, todas as variveis so colocadas no
ambiente dos comandos, mesmo que elas ocorram aps o nome do comando.
Por exemplo:
.sp
.in +5
$ echo a=b c
.br
$ set -k
.br
$ echo a=b c
.sp
mostra "a=b c" e ento "c".
.ec	/*************************************/

.in
.sp
.in 2
.b Sinais
.in 5

.sp
Os sinais SIGINT e SIGQUIT (veja "signal" (sys))
para um comando executado so ignorados
se o comando for seguido de um "&";
os demais sinais tm seus valores herdados pela
comando "sh" do seu pai, com a exceo do sinal SIGBUS
(veja o comando "trap" abaixo).

.in
.sp
.in 2
.b Execuo
.in 5

.sp
Para cada comando executado, so efetuadas as substituies dadas acima.
Se o nome do comando corresponde a um dos comandos-internos
dados abaixo, ele  executado no processo do prprio comando "sh"
(ao invs de criar um comando "sh" filho).

.bc	/*************************************/
Se o nome do comando no corresponde ao nome de um comando-interno nem
o nome de uma funo definida, um novo processo  criado
e uma tentativa  efetuada para executar o comando via exec (sys).
.ec	/*************************************/

.sp
A varivel "PATH" do comando "sh" define os caminhos
dos diretrios onde os comandos sero procurados.
Os nomes dos diversos diretrios devem vir separados por dois-pontos (":").
O "PATH" padro  ".:/bin:/usr/bin:/etc" (especificando o diretrio
corrente ".", "/bin", "/usr/bin" e "/etc", nesta ordem).

.sp
Se o nome do comando comear por "/", trata-se de um nome absoluto,
e a varivel "PATH" no  utilizada.
Em caso contrrio, cada diretrio dado em "PATH"  examinado  procura
de um arquivo executvel com o nome do comando.
Se o arquivo tem permisso de execuo,
mas no  um arquivo com o formato "a.out"
(veja o arquivo "/usr/include/a.out.h"),
assume-se que seja um arquivo contendo comandos para o "sh",
ou seja, um procedimento de comando "sh".
Neste caso, um "sh" filho  criado para process-lo.
Um comando entre parnteses tambm  executado por um comando "sh" filho.

.sp
Por questo de eficincia, o "sh" mantm internamente uma tabela HASH
contendo os nomes de todos os arquivos executveis encontrados nos diretrios
especificados no contedo da varivel PATH. Assim, se um destes diretrios
for modificado atravs da incluso ou excluso de algum
executvel, o comando "rehash" deve ser utilizado, a fim de manter
atualizada a estrutura de dados interna do "sh".

.in
.sp
.in 2
.b
Histrico
.r
.in 5
.br
O comando "sh" armazena em um "histrico", um certo nmero
dos ltimos comandos executados.
Com isto,  possvel re-executar comandos executados anteriormente,
inclusive com alteraes.
Os comandos internos que gerenciam o hstrico so "h", "eh" e "xh"
(veja abaixo).
O nmero de comandos armazenados no histrico  dado pela varivel
"HIST".

.in
.sp
.in 2
.b
Comandos Internos
.r
.in 5
.br

.sp
Os comandos internos so executados pela "shell" sem a criao de um
subprocesso.
O redirecionamento de entrada/sada tambm  permitido para os
comandos-internos.

.sp
.in +3
.ip ":"
.sp
Sem efeito; este comando nada faz.
Produz um valor de retorno igual a zero.

.ip ". <arquivo>"
.sp
L e executa os comandos do <arquivo> e retorna.
Os caminhos de busca especificados em "PATH" so utilizados
para achar o diretrio contendo <arquivo>.

.ip "cd [<dir>]"
.sp
Troca o diretrio corrente para "<dir>".
Se <dir> no for dado, troca o diretrio corrente para o valor
da varivel "HOME".

.ip "eh [<num> ...]"
.sp
Permite a edio do comando <num> do histrico.
Se forem dados mais de um <num>, permite a juno, edio e execuo
de vrios comandos do histrico.
Se <num> no for especificado, edita o ltimo comando do histrico.
Os comandos de edio so os do editor visual "ex" (cmd) que fazem
sentido para a edio de uma nica linha.
Os comandos do editor e a edio terminam respectivamente por <esc> ou "q".

.ip "eval [<arg> ...]"
.sp
Os argumentos so lidos como entrada para o comando "sh"
e os comandos resultantes executados.

.ip "exec [<arg> ...]"
.sp
O comando especificado pelos <arg>s  executado no lugar
deste comando "sh", sem que seja criado um novo processo.
Podem ser dados redirecionamentos de entrada e sada,
e se nenhum outro <arg> for dado,
causa a modificao da entrada/sada do comando "sh".

.ip "exit [<n>]"
.sp
Termina a execuo do presente comando "sh",
com o valor de retorno <n>.
Se <n> for omitido, o valor de retorno  o do ltimo comando executado.
De acordo com a opo "-d", um fim de arquivo (normalmente <^D>) tambm
pode terminar o "sh" (veja o comando-interno "set").

.ip "export [<nome> ...]"
.sp
Os <nome>s dados so marcados para a exportao automtica para
o ambiente dos comandos executados posteriormente.
Se no forem dados argumentos, so listados os <nome>s das variveis
que so exportveis.

.ip "false"
.sp
Produz um valor de retorno diferente de zero
(para ser usado em conjunto com os comandos-de-programao).

.ip "gh"
.sp
O histrico   mostrado na tela e o usurio poder selecionar o
comando desejado atravs das setas. Escolhido o comando, trs opes so
possveis: <enter> para executar o comando, "e" para editar o comando ou
"q" para desistir.

.ip "h"
.sp
Mostra o histrico com os ltimos $HIST comandos executados.

.ip "login"
.sp
Termina a sesso corrente do comando "sh" (veja o comando-interno "exit").

.(t
.ip "read [<nome> ...]"
.sp
Uma linha  lida da entrada padro e, usando os separadores
de campo internos (<sp> ou <ht>), para
delimitar as fronteiras entre as palavras, a primeira palavra
 atribuda ao primeiro <nome>, a segunda palavra ao segundo <nome>,
e assim sucessivamente.
As palavras que sobrarem so todas atribudas ao ltimo <nome>.
Qualquer caractere pode ser quotado precedendo-o por barra invertida
("\"), inclusive <nl>. O valor de retorno  zero, a menos que
seja encontrado um fim de arquivo.
.)t

.ip "readonly [<nome> ...]"
.sp
Os <nome>s dados so considerados como variveis apenas para a leitura,
e os seus valores no podem ser alterados por atribuies posteriores.
Se nenhum argumento for dado,  impressa uma lista de
todas as variveis "readonly".

.ip "set [-derv] [<arg> ...]"

.sp
Altera alguns indicadores do "sh":

.in +7
.ip "-d" 4
Aceita tambm <^D> para terminar o "sh". Normalmente, para
terminar a execuo do presente "sh", deve-se usar os comandos-internos
"exit", "login" ou "logout.

.ip "-e" 4
Termina a execuo do "sh" imediatamente, se um comando retornar no-zero.

.ip "-r" 4
Verifica a reescrita de arquivos no redirecionamento.

.ip "-v" 4
Lista cada linha de comandos lida do arquivo de entrada.

.ep
.sp
Com "+" ao invs de "-", os indicadores so desligados.
Este indicadores tambm podem serem usados na invocao do "sh".
O estado atual destes indicadores pode ser consultada atravs de "$-".
Os <arg>s dados so valores atribudos aos parmetros posicionais
"$0", "$1", ... Se no forem dados argumentos, so impressos os
valores de todos os nomes.

.in -7

.ip "shid"
.sp
Imprime a verso do comando "sh".

.(t
.ip "shift [<n>]"
.sp
Os parmetros posicionais $<n+1> ... recebem os novos nomes $1 ...
Se <n> no for dado, assume-se o valor 1.
.)t

.ip "time <arg> ..."
.sp
Marca e mostra o tempo de execuo do comando formado pelos <arg>s
dados.

.ip "times"
.sp
Mostra os tempos de usurio e sistema acumulados para os processos
executados pelo comando "sh".

.ip "trap [<arg>] [<n> ...]"
.sp
O comando <arg>  lido e executado quando o comando "sh"
receber o(s) sinal(is) de nmero(s) <n> ...
(note que <arg>  examinado quando o comando
 dado e quando o sinal  recebido).
Os comandos dados so executados na ordem dos nmeros dos sinais.
Qualquer tentativa para interceptar a recepo de um sinal
que estava sendo ignorado na invocao do comando "sh"  ineficaz.
Se <arg> no for dado, ento os "traps" dos nmeros dados
so restaurados aos seus valores originais.
Se <arg>  uma cadeia de caracteres nula, ento os sinais relacionados
so ignorados pelo comando "sh" e pelos comandos que ele invocar.
Se <n> for zero, ento o comando especificado
 executado ao fim da execuo do comando "sh".
Se no forem dados <arg>s, "trap" lista os comandos associados a cada sinal
(veja "signal" (sys)).

.ip "true"
.sp
Produz o valor de retorno igual a zero
(deve ser usado em conjunto com os comandos-de-programao).

.ip "umask [<nnn>]"
.sp
A mscara de criao de arquivos do usurio  modificada para <nnn>
(veja umask (sys)). Se <nnn> for omitido,  impresso o valor corrente.
Todos os valores <nnn> so dados em octal.

.(t
.ip "unset [<nome> ...]"
.sp
Para cada <nome> dado, remove a varivel correspondente.
As variveis "PATH", "PS1" e "PS2" no podem ser removidas.
.)t

.(t
.ip "xh [<num>]"
.sp
Reexecuta o comando de nmero <num> do histrico.
Assume por omisso o ltimo comando.
.)t

.ip "wait [<n>]"
.sp
Espera pelo processo assncrono (em "background") cuja identificao
(PID)  <n>, e imprime seu valor de retorno.
Se <n> for omitido, todos os processos assncronos correntemente
ativos so esperados e o valor de retorno ser zero.

.in -3
.ep

.in
.sp
.in 2
.b
Invocao
.r
.in 5
Se um comando "sh"  invocado atravs de "exec" (sys)
e o primeiro caractere do argumento zero  "-",
ento inicialmente o comando "sh"
l comandos do arquivo "/etc/.profile" e de "$HOME/.profile
(caso estes arquivos existam).
A partir deste ponto, o comando "sh" l comandos como descrito anteriormente,
que  tambm o caso quando o comando "sh"  invocado como "/bin/sh".
Ao trmino da execuo do comando "sh", ele
executa os comandos de "$HOME/.logout" se o primeiro caractere
do argumento zero for "-".

.bc	/*************************************/
.sp
As opes a seguir so interpretadas pelo
comando "sh" apenas na sua invocao.
Note que, a menos que a opo "-c" seja dada, assume-se
que o primeiro argumento  o nome de um arquivo
contendo comandos, e os demais argumentos passados como parmetros
posicionais daquele arquivo de comandos.

.in +3
.ip "-c <linha>"
So lidos e executados comandos da cadeia <linha>.

.in -3
.ep

.sp
As opes restantes so descritas na parte referente
ao comando-interno "set".
.ec	/*************************************/

.in
.sp
.b
VALOR DE RETORNO
.r
.in 5
Erros detetados pelo comando "sh" (como erros de sintaxe),
acarretam um valor de retorno diferente de zero do "sh".
Se o comando "sh" est sendo utilizada no interativamente,
a execuo do arquivo passado ao comando "sh"  abandonada.
Em caso contrrio, a comando "sh" devolve o valor de retorno
do ltimo comando executado (veja tambm o comando "exit" acima).

.in
.sp
.(t
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd): "
echo, intro, login, pwd, test, ex
.br
.wo "(sys): "
dup, exec, fork, pipe, signal, umask, exit
.br
.wo "(libc):"
edit
.br
.wo "(fmt): "
environ
.br
.)t

.in
.sp
.(t
.b ARQUIVOS
.in 5
/etc/.profile
 $HOME/.profile
 $HOME/.logout
 /tmp/sh*
 /dev/null
 /usr/include/a.out.h
.)t

.in
.sp
.b ESTADO
.in 5
Efetivo

.in
