.bp

.sp 5

.nf
     *********************************************************
     *							     *
     *			    CAPTULO 2			     *
     *							     *
     *	     		     COMANDOS			     *
     *							     *
     *********************************************************

.fi

.sp 4


.pp
O usurio se comunica com o sistema operacional TROPIX por meio dos
comandos fornecidos  "shell". Sempre que a "shell" est com o controle
do terminal, ela os interpreta e executa. A indicao de que a "shell"
est com o controle do terminal  dada pelo "prompt" escrito pela
"shell" no terminal. O "prompt"  um caractere ou seqncia de
caracteres definida pelo usurio. Por omisso, a seqncia "$ " 
utilizada.

.sp 4
.b
2.1 - Comandos simples
.r

.pp
Um comando simples  formado por palavras (seqncia de caracteres diferentes
de branco e dos metacaracteres apresentados no decorrer do texto), separadas 
pelos caracteres de espacejamento <sp> ou <ht> (branco ou tab).
A primeira palavra  o nome do comando a ser executado (o argumento 0)
e as demais so argumentos para o comando.
Por exemplo:

.sp
.in +5

$ date

.in -5
.sp
 um comando que fornece a data atual.

.sp
.in +5

$ ls -l

.in -5
.sp
lista os arquivos do diretrio corrente. O argumento "-l" faz com que sejam
listadas tambm outras informaes, como tamanho e data de criao de cada
arquivo.


.sp 4
.b
2.2 - Comandos em "background"
.r


.pp
Para executar um comando a "shell" normalmente cria um 
subprocesso e espera pelo seu trmino.
O caractere "&" evita a espera pelo trmino do comando:
a "shell" cria o subprocesso, escreve na tela sua identificao (PID)
e volta a ter o controle do terminal.

.sp
Assim, ao receber:

.sp
.in +5

$ cc prog.c &

.in -5
.sp
a "shell" invoca o compilador "C" para compilar "prog.c", fornece o
nmero do  subprocesso e, imediatamente, escreve o "prompt".
Enquanto isso, a compilao se processa concorrentemente e,
quando terminar, no dar qualquer indicao ao usurio.
Pelo nmero do subprocesso, o usurio
poder consultar o seu estado atravs do comando "ps".


.sp 4
.b
2.3 - Lista de comandos
.r


.pp
Os comandos simples podem vir em seqncia, formando uma lista de comandos,
desde que separados pelos smbolos ";", "&&" ou "||",
que so alguns dos metacaracteres da "shell" (um ou mais
caracteres que tm significado especial para a "shell").


.pp
Os comandos (ou listas de comandos) separados por
";" so simplesmente executados em seqncia, como se fossem fornecidos em
linhas distintas.
O smbolo "||" separando dois comandos (ou duas listas de comandos) 
faz com que o segundo seja executado somente se o primeiro terminar
incorretamente.
Comandos (ou listas de comandos) separados por "&&" sero executados
seqencialmente at que um dos comandos termine incorretamente.


.pp
As listas de comandos tambm podem ser executadas em "background",
se terminadas por "&".


.pp
Os metacaracteres "||" e "&&" tm a mesma precedncia, maior do que a de 
";" e "&", iguais entre si.

.sp
Por exemplo em:

.sp
.in +5

$ ls pg.h && cc -c pg1.c

.in -5
.sp
pg1.c ser compilado apenas se pg.h (por exemplo contendo declaraes usadas
em pg1.c) existir.

.sp
E em

.sp
.in +5

$ cc -c src/pg1.c || cc -c fonte/pg1.c

.in -5
.sp
pg1.c do diretrio "fonte" ser compilado se, por exemplo, no existir
pg1.c no diretrio "src".


.sp 4
.b
2.4 - Redirecionamento de entrada e sada
.r


.pp
Os dados de entrada de um comando so em geral obtidos da entrada
padro que, normalmente, est associada ao terminal.
Da mesma forma, os dados de sada so dirigidos para a
sada padro, tambm associada ao terminal.
 possvel, no entanto, redirecionar a entrada e/ou sada dos comandos
atravs de alguns metacaracteres da "shell".
As construes apresentadas a seguir podem aparecer em qualquer
lugar em um comando simples
que no sero passados como argumentos aos comandos invocados.
Note que a substituio de comandos e parmetros
 realizada antes que a notao a seguir seja analisada.

.in +5
.ip "< nome" 12
Usa o arquivo de nome dado como a entrada padro
(relativo ao descritor de arquivos 0).

.ip "> nome" 12
Usa o arquivo de nome dado como a sada padro
(relativo ao descritor de arquivos 1).
Se o arquivo no existe ele  criado; seno ele  truncado a zero
caracteres.

.ip ">> nome" 12
Usa o arquivo de nome dado como sada padro. Se o arquivo j existe,
a sada  anexada a ele; caso contrrio, o arquivo  criado.

.ip "<< nome" 12
A entrada da "shell"  lida at a primeira linha que corresponda
literalmente ao "nome" resultante, ou at um fim de arquivo.

.ip "<&nmero" 12
Usa o arquivo associado com o descritor de arquivos dado pelo nmero
como a entrada padro. Similarmente para a sada padro com ">&nmero".

.ip "<&-" 12
Fecha a entrada  padro. Similarmente para a sada padro com ">&-".

.ep
.in -5

.pp
Se qualquer das cadeias acima for precedida por um nmero, o descritor de
arquivos que ser associado ao arquivo  aquele dado pelo nmero (ao invs
dos assumidos por omisso 0 e 1). Por exemplo:
.sp
.in +12
 ... 2>&1
.sp
.in -12

associa o descritor de arquivos 2 ao arquivo correntemente associado
com o descritor de arquivos 1.

.pp
A ordem na qual as redirees so especificadas  significante. A
"shell"
avalia as redirees da esquerda para direita. Por exemplo:
.sp
.in +12
 ... 1> xxx 2>&1
.in -12

.pp
primeiro  associado o descritor de arquivos 1 com o arquivo "xxx".
Depois  associado o descritor de arquivos 2 com o arquivo associado
ao descritor de arquivos 1 (i. e. "xxx"). Se a ordem de redirees
fosse reversa, o descritor de arquivos 2 seria associado com o
terminal (assumindo que o descritor de arquivos 1 tinha sido) e
depois o descritor de arquivos 1 seria associado ao arquivo "xxx".

.pp
Usando a terminologia introduzida anteriormente,
se um comando  composto de vrios comandos simples, as redirees
sero avaliadas para o comando como um todo, antes que seja avaliada
para cada comando simples. Isto  a "shell" avalia o redirecionamento
para a lista inteira, ento para cada "pipeline" dentro da lista e
ento para cada lista dentro de cada comando.

.pp
Se um comando  seguido por '&', a entrada padro assumida para o
comando  o arquivo vazio "/dev/null".

.pp
Exemplos:

.sp
.in +5

$ ls > file

.in -5
.sp
o arquivo "file" conter os nomes dos arquivos do diretrio corrente.

.sp
.in +5

$ wc < file

.in -5
.sp
o arquivo "file" ser lido e sero listados o nmero de caracteres, palavras
e linhas encontradas.


.sp 4
.b
2.5 - "Pipes"
.r


.pp
A sada de um comando pode ser concatenada  entrada de outro atravs do 
operador "|".

.sp
Assim,

.sp
.in +5

$ ls -l | wc

.in -5
.sp
tem efeito similar a

.sp
.in +5

$ ls -l > file ; wc < file

.in -5
.sp
com as vantagens de que o arquivo "file" no precisa ser especificado
e os dois comandos podem executados concorrentemente.

.pp
Vrios comandos podem ser concatenados atravs do "pipe".

.sp
Exemplo:

.sp
.in +5

$ ls | grep teste | wc -l

.in -5
.sp
listar o nmero de arquivos no diretrio corrente que contm a palavra
"teste" em seu nome.


.pp
Numa lista de comandos, "pipes" podem ser especificados e, neste
caso, a precedncia do metacaractere "|" 
maior que a dos metacaracteres "||", "&&", ";" e "&".


.sp 4
.b
2.6 - Valor de Retorno
.r

.pp
Atravs da chamada ao sistema "exit", os comandos retornam  "shell" um
valor inteiro, indicando seu estado de trmino.
O valor 0 significa que o programa terminou normalmente;
qualquer valor distinto de 0 indica trmino anormal.
Numa lista de comandos ou numa linha de "pipes", o valor que a "shell"
finalmente retorna  o do ltimo comando executado.

.sp 4
.b
2.7 - Resumo
.r

.pp
Os comandos interpretados pela "shell" devem obedecer  seguinte sintaxe:

.sp
CMD [delim CMD] ...

.sp
onde:

.sp
CMD = cmd [arg] ... [<ent] [>sai]

.in +2

.ip cmd 6
nome do comando

.ip arg 6
argumento para o comando

.ip ent 6
arquivo de entrada

.ip sai 6
arquivo de sada

.lp


.sp 2

.in -2 
delim = |  ;  &  &&  ||

.ip 'CM1 ; CM2    ' 13
CM1 e CM2 so executados seqencialmente.

.ip 'CM1 | CM2    ' 13
As execues de CM1 e CM2 so iniciadas simultaneamente.
A sada de CM1  a entrada de CM2.
A "shell" espera CM2 terminar. ("Pipe")

.ip 'CMD &        ' 13
A execuo de CMD  iniciada, mas seu trmino no 
esperado. ("Background")

.ip 'CM1 && CM2   ' 13
CM2  executado se CM1 terminar corretamente. ("And")

.ip 'CM1 || CM2   ' 13
CM2  executado se CM1 nao terminar corretamente. ("Or")

.lp


.sp 2
A precedncia dos metacaracteres :

.sp
.in +5
|
.sp
|| &&

.sp
| ;

.in -5

.sp 4
.b
2.8 - Arquivos de Comandos
.r


.pp
Em uso interativo, os comandos so lidos do terminal e executados.
Entretanto, esses comandos podem ser provenientes de um arquivo de
comandos ("script"), previamente editado.
Assim, se o arquivo "arq" contem comandos para a "shell",

.sp
.in +5
$ sh arq

.in -5
.sp
criar um subprocesso em que uma "shell" filha da original 
ler os comandos de "arq" e os executar.

.pp
Se esse arquivo de comandos tiver o atributo de modo indicando
que ele  executvel (veja "chmod(cmd)") a chamada

.sp
.in +5
$ arq

.in -5
.sp
ser equivalente  anterior. Em qualquer hiptese,  criado um
subprocesso que executa uma "shell" filha.

.pp
O comando interno "." evita a criao de um subprocesso. Assim

.sp
.in +5
$ . arq

.in -5
.sp
os comandos so executados diretamente pelo "shell".

.pp
Erros detectados pela "shell", quando da execuo
de um arquivo de comandos, causam o trmino da execuo desse arquivo.


.bp
.b
2.9 - Comentrios e Linhas de Continuao
.r

.pp
O metacaractere "#" inicia um comentrio, que se estende at o final da linha.
 til em arquivos de comandos.

.pp
Quando for necessrio usar varias linhas para a entrada de um
comando, as linhas que tm continuao devero ser terminadas
pela seqncia "\<nl>" (barra invertida seguida de <nl>). (Ver 3.3).

.sp 4
.b
2.10 - Comandos Internos
.r

.pp
Alguns comandos especiais no causam a criao de um subprocesso para
sua execuo, sendo esta realizada internamente pela prpria "shell".
So eles:

.sp
":", ".", "cd", "eh", "eval", "exec", "exit", "export", "false", "gh",
"h", "login",  "read", "readonly", "rehash", "set", "shid", "shift",
"time", "times", "trap", "true", "umask", "unset", "wait" e "xh".


.pp
A utilidade de alguns desses comandos ser apontada no decorrer do texto e uma
explicao mais detalhada pode ser encontrada no Captulo 4.
