.bp

.sp 5

.nf
     *********************************************************
     *							     *
     *			    CAPTULO 3			     *
     *							     *
     *	         VARIVEIS E OUTRAS SUBSTITUIES            *
     *							     *
     *********************************************************

.fi

.sp 4


.pp
Antes da execuo dos comandos, seus argumentos so analisados
quanto  existncia de variveis que devam ser substitudas por
seus valores e, posteriormente, quanto  necessidade de expanso
de nomes de arquivos.

.pp
Na anlise de um comando a executar, a "shell" leva sempre em considerao
o caractere "\" precedendo imediatamente um metacaractere. Este
procedimento anula o efeito especial do metacaractere.

.sp 4
.b
3.1 - Variveis
.r

.pp
A "shell" permite que sejam definidas variveis para posterior uso.
O nome de uma varivel  uma cadeia composta de caracteres alfanumricos,
podendo incluir tambm o caractere "_" (sublinhado).
O valor atribudo a ela  qualquer cadeia de caracteres.


.pp
A atribuio de uma cadeia a uma varivel  realizada
escrevendo-se o nome da varivel, sucedido pelo caractere "=" e da cadeia.
As variveis so declaradas na primeira atribuio.
A varivel ser substituda por seu valor,
quando esta for precedida pelo metacaractere "$".

.sp
Assim, dado

.sp
.in +5
$ DIR=a/b/c

.sp
$ mv pgm $DIR

.in -5
.sp
mover o arquivo "pgm" do diretrio corrente para o diretrio "a/b/c".

.sp 2

.pp
Para a substituio, o nome da varivel a ser substituda  procurado a partir
do caractere "$" at um caractere no alfanumrico (exceto "_").
Se esse caractere for <sp> ou <ht>, significa o fim do nome.
Se esse caractere for qualquer outro no alfanumrico, os caracteres a seguir
sero concatenados ao valor da varivel.

.sp
Assim, para

.sp
.in +5

$ A=a
$ AB=ab

.in -5
.sp

.nf
     $A          equivale a	a
     $AB         equivale a	ab
     $A.c        equivale a	a.c
     $AB.pgm     equivale a	ab.pgm
.fi


.pp
Os seguintes parmetros tm seus valores automaticamente atribudos pela
"shell":
.in +5

.ip "#"
O nmero de parmetros posicionais em decimal.

.ip "-"
Opes de funcionamento fornecidas a "shell"  na evocao ou atravs do
comando "set".

.ip "?"
O valor decimal de trmino retornado pelo ltimo comando executado sincronamente.

.ip "$"
A identifiao do processo desta "shell".

.ip "!"
A identificao do processo do ltimo comando em "background" evocado.

.ip ":"
O nmero do prximo comando a entrar no histrico.

.ip "@"
Os parmetros posicionais (veja adiante)  exceo de $0.

.ip "*"
Uma cadeia com os parmetros posicionais  exceo de $0.

.ip "\%"
Uma cadeia com o nome do n (nome do computador na rede).

.ip "~"
O nome do diretrio corrente.

.ip "&"
O caractere "#" se o usurio for um superusurio, e "$" em caso contrrio.

.ep
.in -5


.pp
Algumas variveis tm um sentido especial para a "shell" e so usadas por ela,
que j as recebe definidas. (Ver Cap. 6). So elas:

.in +5
.ip HOME 7
diretrio assumido por omisso como argumento para o comando interno "cd"

.ip PATH 7
diretrios a serem pesquisados, em ordem, na procura do comando a executar

.ip PS1 7
"prompt" principal da "shell", fornecido quando 
est apto a receber novo comando 

.ip PS2 7
"prompt" secundrio da "shell", fornecido quando o comando
continuar em outra linha

.ep
.in -5

.pp
A "shell" atribui valores iniciais para as variveis
"PATH", "PS1" e "PS2".
O valor da varivel "HOME"  atribudo pelo comando "login".
O caractere '~', quando ocorre em caminhos,  equivalente a $HOME.

.sp 4
.b
3.2 - Expanso de Nomes de Arquivos
.r

.pp
Muitos comandos aceitam argumentos que so nomes de arquivos.
A "shell" fornece um mecanismo para gerao de uma lista,
em ordem lexicogrfica, de nomes de arquivos que atendam a certo padro.
Para gerar os padres, existem os metacaracteres 
"*", "?", "[", "]" e "!", que significam:


.in +5
.ip * 8
qualquer cadeia de caracteres (exceto as iniciadas por ".")

.ip ? 8
qualquer caractere simples (exceto ".")

.ip [...] 8
qualquer caractere no intervalo [...]

.ip ! 8
qualquer caractere diferente do que segue "!"

.ep
.in -5

.sp
Por exemplo:

.sp
.in +5
$ ls -l *.c

.in -5
.sp
lista, em ordem alfabtica, informaes sobre todos os nomes de arquivos,
do diretrio corrente que terminam com o sufixo ".c"

.sp
.in +5

$ ls /cmd/*/teste

.in -5
.sp
lista todos os arquivos de nome "teste" de qualquer subdiretrio de "/cmd"

.sp
.in +5

$ ls /a/?

.in -5
.sp
lista todos os arquivos do diretrio "/a", cujos nomes tm um s caractere

.sp
.in +5
$ ls [a-d]*

.in -5
.sp
lista todos os arquivos comeados com as letras "a", "b", "c" e "d"


.sp 4
.b
3.3 - Metacaracteres como Caracteres Comuns
.r

.pp
Os seguintes caracteres tm um significado especial para a
"shell" e causam o fim de uma palavra a menos que estejam quotados:
.sp
.in +5
.b
;  &  (  )  |  ^  <  >  <nl>  <sp>  <ht>
.r
.in -5

.pp
Um caractere pode ser quotado (i.e. faz-lo siginificar ele mesmo)
precedendo-o por uma barra invertida ou inserindo-o entre um par de
marcas de quotao ('' ou ""). Durante o processamento, a "shell"
pode quotar alguns caracteres para evitar que eles tenham um
significado especial. Barras invertidas usadas para quotar um
caractere so removidas da palavra antes que o comando seja
executado. O par "\<nl>"  removido antes da substituio de
comandos e parmetros.

.pp
Todos os caracteres entre um par de acentos agudos, exceto
um acento agudo, so quotados pela "shell".
Barra invertida
no tem um significado especial dentro de um par de acentos
agudos. Um acento agudo pode ser quotado dentro de um par de
aspas (por exemplo "'").

.pp
Dentro de um par de aspas (""), ocorre a substituio de
parmetros e comandos, mas sobre o resultado a
"shell" no faz interpretao de brancos, nem gerao de nomes de arquivos.
Se "$*" est entre um par de aspas ("$*"), os parmetros
posicionais so substitudos e formam uma nica palavra,
considerada como quotada, com um espao entre cada par de
parmetros ("$1 $2 $3 ...").
Uma barra invertida ('\') retira
o significado especial dos caracteres '\', ''', '"' e '$'.
O par "\<nl>"  removido antes da substituo de parmetros
e comandos.
A barra invertida s tem o significado especial em vigor
quando precede os caracteres anteriores.

.pp
Assim, a sada de

.sp
.in +5
$ echo \?
.in -5
.sp
ser o caractere "?"

.sp
e a de
.sp
.in +5
$ echo xx'||||'xx
.in -5
.sp
ser
.sp
.in +5
xx||||xx
.in -5
.sp 2

.sp 4
.b
3.4 - Substituio de Comandos
.r

.pp
A sada padro de um comando que aparece entre um par de acentos graves (``)
pode ser usada como parte, uma, ou mais palavras. Assim, o comando

.sp
.in +5
$ grep -l driver `walk -s .`
.in -5
.sp
faz com que a lista de arquivos produzida pelo comando "walk" seja
utilizada pelo comando "grep".

.sp
Um comando til para a utilizao com os acentos graves  o "from",
como no exemplo abaixo:

.sp
.nf
	for i in `from 1 to 10`
	do
		echo $i
	done
.fi

.sp
em que o comando "echo"  executado 10 vezes, com os valores consecutivos
de "1" a "10" para a varivel "i".

.pp
No  realizada qualquer interpretao dos caracteres da cadeia
lida, exceto para a remoo de barras invertidas ('\'), usadas para
desabilitar o significado especial de caracteres.
Uma barra invertida ('\') pode ser usada para desabilitar o significado
especial de um acento grave ou outra barra invertida ('\') e
 removida antes que a cadeia de caracteres seja lida.

.pp
Se uma barra invertida ('\')  usada para anular o significado especial
de um <nl>, tanto a barra invertida quanto o <nl> sero
removidos.
Em adio, barras invertidas usadas para anular o significado do
cifro ('$') so removidos. J que no  realizada uma
interpretao na cadeia de caracteres do comando antes que ele
seja lido, a insero de uma barra invertida antes de um cifro
no tem efeito. Barras invertidas que precedam caracteres
outros que '\', '`', '"', <nl> e '$' so mantidos intactos quando
a cadeia de caracteres do comando  lida.
