.bp

.sp 5

.nf
     *********************************************************
     *							     *
     *			    CAPTULO 4			     *
     *							     *
     *	           COMANDOS INTERNOS E HISTRICO	     *
     *							     *
     *********************************************************

.fi

.sp 4
.b
4.1 - Histrico
.r

.pp
Uma das facilidades mais interessantes oferecidas pela  "shell"
quando em uso interativo  a manuteno de um histrico.
Seu propsito  guardar os ltimos comandos fornecidos pelo usurio,
visando facilitar a edio e reexecuo de comandos grandes
e de difcil digitao, bem como manter controle do trabalho
realizado no terminal.

.pp
O histrico consiste numa lista cujo tamanho  dado pela varivel "HIST",
que inicialmente tem valor igual a 10, mas pode ser facilmente modificada
pelo usurio atravs de uma atribuio.

.pp
Cada comando recebe um nmero, atravs do qual pode ser posteriormente
refereciado.
O histrico pode ento ser consultado e seus comandos editados,
agrupados e reexecutados atravs dos comandos internos "h", "eh", "gh" e "xh",
respectivamente.

.sp 2
.b
4.2 - Comandos Internos
.r

.pp
Os comandos internos so executados pela "shell" sem a criao de um
subprocesso.
.in +5

.sp
.ip ":"
Este comando no faz nada. Produz um valor de retorno igual a zero.

.ip ". arquivo"
L e executa os comandos em "arquivo" e retorna. Os caminhos de busca
especificados em "PATH" so utilizados para achar o diretrio contendo
"arquivo".

.ip "cd [dir]"
Troca o diretrio corrente para "dir". O valor da varivel "HOME"
 o argumento assumido por omisso.

.ip "eh [num]"
Permite a edio do comando "num" do histrico. Se "num" no for
especificado,  assumido o ltimo comando do histrico.
Os comandos de edio so os do editor visual "ex" que fazem
sentido para uma linha. Os comandos do editor e a edio terminam
respectivamente por <esc> ou "q".

.ip "eval [arg ...]"
Os argumentos so lidos como entrada para a "shell"
e os comandos resultantes executados.

.ip "exec [arg ...]"
O comando especificado pelos argumentos  executado no lugar
desta "shell", sem que seja criado um subprocesso. Redirecionamentos
de entrada e sada podem aparecer, e se nenhum outro argumento
for dado, causa a modificao da entrada/sada da "shell".

.ip "exit [n]"
Provoca o trmino da "shell" com valor de retorno "n".
Se "n" for omitido, o valor de retorno do ltimo comando executado
 utilizado.

.ip "export [nome ...]"
As variveis mencionadas so marcadas como exportveis, o que provoca
a incluso de uma cadeia definindo seu valor nos ambientes
dos programas executados posteriormente.
Se no for mencionado nenhum nome de varivel, a "shell" mostra as variveis
que so exportveis.

.ip "false  "
Produz um valor de retorno diferente de zero.

.ip "gh     "
O histrico   mostrado na tela e o usurio poder selecionar o
comando desejado atravs das setas. Escolhido o comando, trs opes so
possveis: <enter> para executar o comando, <e> para editar o comando ou
<q> para desistir.

.ip "h      "
Apenas mostra o histrico com os ltimos comandos executados.

.ip "login   "
Termina a sesso corrente da "shell".

.ip "read [nome ...]"
Este comando  usado para ler valores de variveis.
Uma linha  lida da entrada padro e a primeira palavra
 atribuda ao primeiro nome, a segunda palavra ao segundo nome,
e assim sucessivamente.
As palavras que sobrarem so todas atribudas ao ltimo nome.
Qualquer caractere pode ser quotado precedendo-o por barra invertida
('\'), inclusive <nl>. O valor de retorno  zero, a menos que
seja encontrado um fim de arquivo.

.ip "readonly [nome ...]"
As variveis cujos nomes so mencionados tornam-se inalterveis,
no podendo ser afetadas por atribuies posteriores.
Se nenhum argumento for dado, uma lista de todos as variveis neste estado
 mostrada.

.ip "rehash"
Por questo de eficincia, o "sh" mantm internamente uma tabela HASH
contendo os nomes de todos os arquivos executveis encontrados nos diretrios
especificados no contedo da varivel PATH. Assim, se um destes diretrios
for modificado atravs da incluso ou excluso de algum
executvel, o comando "rehash" deve ser utilizado, a fim de manter
atualizada a estrutura de dados interna do "sh".

.(t
.ip "set [--derv] [arg ...]"

.in +7

.ip "-d"
Permite que a execuo se encerre com <control-D>.
.)t

.ip "-e"
Termina a execuo imediatamente, se um comando no retornar zero.

.ip "-r"
Verifica a reescrita de arquivos no redirecionamento.

.ip "-v"
Lista cada linha de comandos lida do arquivo de entrada.

.ep

.in -7

.ip "shid"
Imprime a verso corrente da "shell".

.ip "shift [n]"
Os parmetros posicionais de $n+1 ... so renomeados de $1 ...
Se "n" no for dado, ele  assumido que  1.

.ip "time arg ..."
Marca e mostra o tempo de execuo do comando formado pelos argumentos
dados.

.ip "times "
Mostra os tempos de usurio e sistema acumulados para os processos
executados pela "shell".

.ip "trap [arg] [n] ..."
O comando "arg" ser lido e executado quando a "shell".
receber o(s) sinal(is) cujos nmeros foram dados.
(Note que "arg"  varrido quando o comando
 dado e quando o sinal  recebido.) Os comandos dados so
executados na ordem dos nmeros dos sinais. Qualquer tentativa
de preparao para a recepo de um sinal que estava sendo ignorado
na entrada da "shell"  ineficaz.
Se "arg" no for dado ento os "traps" dos nmeros dados
so restaurados aos seus valores originais. Se "arg" 
uma cadeia de caracteres nula, ento os sinais relacionados
so ignorados pela "shell" e pelos comandos que ela evocar.
Se for especificado o sinal zero, ento o comando relacionado
 executado ao fim da execuo da shell, seno ao recebimento
de um sinal de nmero "n", conforme especificado em "signal" (sys).
Se no forem dados argumentos "trap" mostra os comandos
associados a cada sinal.

.ip "true  "
No faz nada: apenas produz o valor de retorno igual a zero.

.ip "umask [nnn]"
A mscara de criao de arquivos do usurio  modificada para "nnn"
(veja umask (sys)). Se "nnn" for omitido, o valor corrente de "umask"
 mostrado.

.ip "unset [nome ...]"
Para cada nome dado, remove a varivel correspondente.

.ip "wait [n]"
Espera pelo processo assncrono (em "background") cuja identificao
seja "n" e mostra seu valor de retorno . Se "n" for omitido todos os
processos assncronos correntemente ativos so esperados e o
valor de retorno ser zero.

.ip "xh [num]"
Reexecuta o comando de nmero dado do histrico. Assume por omisso
o ltimo comando.

.ep
.in -5
