.bp
.sp 5

.nf
     *********************************************************
     *							     *
     *			    CAPTULO 5			     *
     *							     *
     *	       A SHELL COMO LINGUAGEM DE PROGRAMAO	     *
     *							     *
     *********************************************************

.fi

.sp 4

.pp
Alm de seu uso como um interpretador interativo de comandos,
a "shell" pode ser usada tambm como linguagem de programao.
Duas de suas caractersticas como linguagem de programao j foram
abordadas: arquivos de comandos e variveis.
Outras facilidades como as estruturas de controle tradicionais esto
disponveis, possibilitando a criao de arquivos de comandos
("scripts"), que desempenham tarefas complexas. Estas caractersticas
incluem o seguinte:

.in +5
.ip "-"
Arquivos de comandos: um arquivo pode conter uma seqncia de comandos
para a execuo posterior.

.ip "-"
Variveis:
um arquivo de comandos pode ter declaraes, atribuies e
expanses de variveis.

.ip "-"
Argumentos:
um arquivo de comandos pode receber os argumentos passados
na linha de comando de sua evocao.

.ip "-"
Execuo condicional:
a seqncia de comandos a executar pode variar,
podendo ser definida por condies externas (comandos if..then..else..elif).

.ip "-"
Seleo de casos:
uma entre vrias seqncias de comandos pode ser
selecionada para a execuo, dependendo de condies externas.

.ip "-"
Repetio enumerada:
 possvel a repetio da execuo de uma
seqncia de comandos, enumerando-se os valores de uma varivel
de controle do lao.

.ip "-"
Repetio condicional:
 possvel a repetio de uma seqncia de
comandos, enquanto persistir uma condio, ou at ocorrer uma
condio.

.ip "-"
Blocos de comandos:
uma seqncia de comandos pode ser agrupada e assim as mesmas condies
de execuo podem ser especificadas para toda a seqncia.

.ip "-"
Tratamento de Excees:
 possvel explicitar quais aes devem ser realizadas quando
da ocorrncia de uma exceo.

.ip "-"
Comentrios:
textos explicativos podem ser inseridos como comentrios em um
arquivo de comandos.

.ep

.in -5

.pp
Os comandos de programao e os blocos de comandos a serem
vistos a seguir, podem substituir comandos simples em uma lista de
comandos, podem sofrer redirecionamentos de entrada e sada como
um comando simples, ou podem ser executados em "background" como
um comando simples. Quando no especificado o valor de retorno
de um bloco de comandos ou de um comando de programao  o do
ultimo comando simples executado.


.sp 4

.b
5.1 - Passagem de Argumentos
.r

.pp
Como j visto em "Comandos" (captulo 2), a chamada de um
comando  constituda por uma ou mais seqncias de caracteres.
A primeira indica o nome do comando a ser evocado, as prximas,
desde que iniciadas pelo caractere '-', indicam opes de
funcionamento do comando, ou seja o "modo" de execuo do comando,
e as ltimas indicam os objetos sobre os quais o comando vai agir.
Todas estas seqncias de caracteres posteriores ao nome do
comando so consideradas como argumentos do comando.

.pp
A "shell" permite que um arquivo de comandos
que precisa ser interpretado por uma "shell" para executar,
seja externamente indistinguvel de um comando tradicional com um
programa objeto executvel diretamente. Seguindo este objetivo
a "shell" passa os argumentos dados para um arquivo com comandos,
que pode acess-los atravs dos parmetros posicionais $0, $1, $2, ..., $9.
Os nomes dessas variveis foram inspirados pelo vetor de argumentos
"argv" passados a primeira funo a executar de um programa na
linguagem de programao "C".

.pp
Os parmetros posicionais podem ser redefinidos pelo
comando interno "set" e reordenados pelo comando interno "shift" (captulo 4).

.sp 4

.b
5.2 - Execuo Condicional
.r

.pp
A determinao da execuo ou no de listas de comandos pode ser
realizada a tempo de execuo. Para tanto existem os comandos de
programao "if", "else", "elif" e "fi". A sua sintaxe :

.sp
.b if
lista 
.b then
lista [

.b elif
lista 
.b then
lista]... [
.b else
lista]
.b fi
.br

.pp
A lista seguinte ao
.b if
 executada e, se ela tiver um valor de retorno igual a zero,
ento a lista aps o
.b then
 executada. Seno a lista aps o
.b elif
se dada  executada e se o seu valor de retorno for zero a lista aps o
prximo
.b then
 executada. Falhando a lista do 
.b elif
, a lista aps o
.b else
 executada. Se nenhuma lista associada a um
.b then
ou a um
.b else
for executada o valor de retorno do
.b if
ser zero.

.sp 4

.b
5.3 - Seleo de Casos
.r

.pp
Para a seleo de uma lista de comandos entre vrias para
a execuo a "shell" tem o comando "case". Sua sintaxe :

.sp
.b case
palavra 
.b in
[padro [|padro] ...) lista ;;]
.b esac
.br

.pp
O comando
.b case
executa a lista associada ao primeiro padro que
tenha correspondncia com a palavra dada. A forma dos padres
 a mesma que  usada para a gerao de nomes de arquivos
exceto que uma barra ('/'),
um ponto ('.') inicial, ou um ponto ('.') imediatamente aps
uma barra ('/') no precisam ser explicitados.

.sp 4

.b
5.4 - Repetio Enumerada
.r

.pp
A repetio enumerada permite a execuo de uma lista de comandos
para cada um de uma lista de nomes dados. A cada iterao a varivel
de controle assume um dos nomes dados e assim os comandos da lista
podem realizar uma determinada operao sobre ele. A sintaxe do
comando de repetio enumerada :

.sp
.b for
nome [
.b in
palavra ...]
.b do
lista
.b done
.br

.pp
Este comando faz a repetio da execuo da lista
dada, por um nmero de vezes definido a priori. A cada repetio
 varivel identificada por "nome"  atribudo como valor a palavra
cuja posio entre as palavras dadas corresponde ao nmero da
iterao corrente. Se a parte "
.b in
palavra ..." no for dada ser assumido como palavras dadas
os parmetros posicionais (veja
.b
"Substituio de Parmetros"
.r
adiante). A execuo deste comando termina quando  "nome"
j houver sido atribudo todas as palavras dadas.


.sp 4

.b
5.5 - Repetio Condicional
.r

.pp
A "shell" tem construes de controle para a repetio de uma
lista de comandos enquanto persistir uma condio ("while"), ou
at que ocorra uma condio. Sua sintaxe :

.sp

.b while
lista
.b do
lista
.b done
.br

.pp
Um comando
.b while
executa repetidamente a primeira e a segunda lista. Se o valor
de retorno do ltimo comando da primeira lista for diferente de zero,
a segunda lista no  executada e a repetio
termina. Se nenhum comando da segunda lista for
executado, ento o comando
.b while
retorna zero como valor de retorno . O comando
.b until
pode ser utilizado ao invs de
.b while
para negar o teste de trmino de repetio.
.in 0
.sp


.sp 4

.b
5.6 - Blocos de Comandos
.r

.pp
Uma lista de comandos pode formar um bloco, com o objetivo
de ser executada sob as mesmas condies, porm diferentes das dos
demais. Como exemplo destas condies podem ser citadas o redirecionamento
de entrada e sada, o ambiente, o tratamento de excees, etc...

.pp
Um bloco de comandos pode ser executado pela prpria "shell" corrente,
ou por uma "shell" "filha" criada especialmente para execut-lo.
Uma lista de comandos entre parnteses  executada por uma "shell" "filha",
enquanto uma terminada por ';' e entre chaves 
executada pela prpria "shell" corrente.
Modificaes das condies de execuo da "shell" realizadas por
comandos componentes de um
bloco de comandos executado pela "shell" corrente mantm-se para
a execuo dos prximos comandos. J estas modificaes realizadas
por um bloco de comandos executados por uma "shell" filha s so
vlidas durante a a existncia da "shell" filha, ou seja durante a
execuo do bloco.


.sp 4

.b
5.7 - Tratamento de Excees
.r

.pp
A "shell" tem um mecanismo que permite especificar as aes
a serem realizadas quando da ocorrncia de uma exceo.
So consideradas excees a recepo de um sinal (veja signal (sys))
e o fim de arquivo da entrada padro da "shell".

.pp
O comando interno "trap" posibilita a associao de uma linha
de comando para cada exceo. As excees so especificadas pela sua 
constante inteira correspondente, por exemplo: a recepo de um sinal
de alarme de relgio provoca a exceo "SIGALRM". O fim de arquivo da
entrada padro da "shell" corrente corresponde a exceo 0.
Mais de uma exceo pode ser associada a uma mesma linha de comando.
 possvel especificar excees que devem ser ignoradas e excees
cujo tratamento deve ser restaurado ao estado inicial. Uma descrio
detalhada da sintaxe de "trap" est no captulo 4.

.sp 6

.b
5.8 - Comentrios
.r

.pp
O caractere '#' delimita o incio de um comentrio. Todos os
caracteres posteriores at o primeiro <nl> posterior so ignorados.
