.bp

.sp 5

.nf
     *********************************************************
     *							     *
     *			    CAPTULO 6			     *
     *							     *
     *	           CHAMADA  "SHELL" E AMBIENTE	             *
     *							     *
     *********************************************************

.fi

.sp 4


.pp
No TROPIX, aps o "login", a "shell"  invocada para ler
e executar comandos do usurio em um terminal especfico.
Poder tambm ser chamada explicitamente pelo usurio, como qualquer
comando, ou implicitamente, como para a execuo de um arquivo de
comandos ("script").


.sp 4
.b
6.1 - Chamada  "shell"
.r

.pp
A chamada  "shell" obedece  seguinte sintaxe:
.sp
.in +10
 [-]sh [-c <comando>] [-erv]
.in -10
.sp
 onde "cmdarq"  um comando ou um arquivo de comandos.


.pp
Se o primeiro caractere do argumento 0,
ou seja o nome do comando "sh", for precedido pelo caractere
"-", a "shell" executar inicialmente o arquivo de comandos
"$HOME/.profile",
passando depois a receber os comandos normalmente. 


.pp
As opes tm os seguintes significados:
.in +5

.ip -c
executa o <comando> dado como argumento.

.ip "-e"
Termina a execuo quando um comando retorna erro.

.ip "-r"
Verifica a reescrita de arquivos no redirecionamento.

.ip "-v"
Lista cada linha de comandos lida do arquivo de entrada.

.in -5
.lp


.sp 4
.b
6.2 - "Prompt"
.r

.pp
O uso mais comum da "shell"  o interativo.
A "shell" fornece um "prompt" (caractere ou cadeia de caracteres),
definido pela varivel "PS1", sempre que est apto a receber comandos.
Se esse comando deve continuar em outra linha,  fornecido um "prompt"
secundrio, definido pela varivel "PS2".
Os "prompt" podem ser modificados atravs
da atribuio de um novo valor s suas variveis.


.sp 4
.b
6.3 - Ambiente
.r


.pp
A "shell" quando chamada recebe o ambiente de execuo,
que nada mais  do que uma lista
de variveis. Este ambiente  passado para os subprocessos criados por ela.

.pp
Por exemplo, as variveis "HOME", "PATH", "PS1" e "PS2"
usadas pela "shell" (ver 3.1) so passadas a ela atravs do ambiente.

.in +5
.sp
"PS1" e "PS2" so os "prompts" principal e secundrio da "shell".

.sp
"HOME"  o diretrio corrente, representado por "."
e usado na resoluo de referncias a arquivos que no comeam com "/".
O comando interno "cd"  usado para se mudar o diretrio corrente.

.sp
"PATH" define os diretrios onde os comandos a executar devem ser
procurados e a ordem desta procura.
Se no for especificado ser, por omisso, o diretrio corrente,
"/bin" e "/usr/bin", nessa ordem. Assume-se,
"PATH=.:/bin:/usr/bin",  onde o caractere ":" separa os nomes dos diretrios.
Se o comando comea com "/", o "PATH" no  usado.

.in -5

.pp
O usurio pode atribuir novos valores para essas variveis,
bem como criar outras.
Ento, os "prompts" podem ser escolhidos pelo usurio
e os valores das variveis "HOME" e "PATH" modificados sempre que necessrio.

.pp
Essas modificaes e adies de variveis s so repassadas ao
ambiente atravs do comando interno "export". 
Assim, os processos criados pela "shell", para executar os comandos,
recebero o ambiente da "shell", somente com as modificaes
e adies explicitadas atravs do comando interno "export".


.sp 4
.b
6.4 - Sinais
.r


.pp
Os sinais do processo que inicia a "shell" so tambm passados
a ela no ambiente
e sero  repassados aos processos criados para executar os comandos,
com uma exceo:
para os comandos terminados por "&", que devero ser executados em
"background", o sinal
"SIGINT"   passado  com o valor "SIG_IGN", que far com que eles
no possam ser interrompidos pelo terminal teclando o caractere "intr"
(usualmente <^C>).
