.bp
.he 'MAN (cmd)'TROPIX: Manual de Referncia'MAN (cmd)'
.fo 'Atualizado em 04.12.02'Verso 4.4.0'Pag. %'

.b NOME
.in 5
.wo "man -"
mostra um manual na janela do vdeo
.br

.in
.sp
.b SINTAXE
.in 5
.(l
man [-cslfwnxrgeD] [<manual>]
.)l

.in
.sp
.b DESCRIO
.in 5
O comando "man" permite ler/reler de forma conveniente
um <manual> na janela do vdeo.

.sp
O <manual> pedido pode ser o de referncia de um comando,
de uma chamada ao sistema, de uma funo da biblioteca padro,
de uma descrio de formato, de uma funo da biblioteca "curses",
o guia de um comando ou um outro da seo de manuais diversos.
Atravs da opo "-D" (ver abaixo) podemos obter um ndice dos
manuais disponveis em cada seo.

.sp
A busca do <manual>  realizada na ordem indicada acima; como em alguns
casos sees distintas possuem manuais homnimos, podemos indicar
qual a seo desejada atravs de uma opo. 

.sp
O comando permite que a pgina visvel do <manual> na janela avance ou
retroceda, e podemos ler pginas posteriores ou reler pginas
anteriores do <manual>.

.sp
Os comandos internos que permitem avanar/retroceder as pginas do
<manual> so dados abaixo. Eles so semelhantes aos comandos internos
do "vi" (cmd), e o o usurio habituado com o "vi" no ter dificuldades
em utilizar o comando "man".

.sp 2
As opes do comando so:

.in +3
.ip -c
Seo "cmd": o <manual> desejado  o de referncia de um comando.

.ip -s
Seo "sys": o <manual> desejado  o de uma chamada ao sistema.

.ip -l
Seo "libc": o <manual> desejado  o de uma funo da biblioteca padro da linguagem "C".

.ip -f
Seo "fmt": o <manual> desejado  o de uma descrio de formato.

.ip -w
Seo "curses": o <manual> desejado  o de uma funo da biblioteca "curses".

.ip -n
Seo "network": o <manual> desejado  o de uma funo da biblioteca
de "networking" (padro XTI).

.ip -x
Seo "X-Window": o <manual> desejado  o de uma funo ou de um comando
do sistema "X-Window".

.ip -r
Seo "ref": o <manual> desejado  o guia de um comando.

.ip -g
Seo "ref": como a opo "-r".

.ip -e
Seo "etc": o <manual> desejado  o da seo de outros manuais diversos.

.ip -D
Ao invs de um manual, mostra na janela o ndice dos manuais disponveis 
em uma das sees (que deve ser escolhida atravs de uma das opes
acima ("-c" por omisso)).

.ep
.in -3

.sp 2
.(t
Os comandos internos para avanar/retroceder a pgina visvel do
<manual> na janela so os seguintes:

.in +3

.ip '[<n>] +' 13
.it '[<n>] <nl>' 13
.it '[<n>] <cr>' 13
Avana <n> linhas. Se <n> for omitido, avana uma linha.
.)t

.ip '[<n>] -' 13
Retrocede <n> linhas. Se <n> for omitido, retrocede uma linha.

.ip <^D> 13
.it '<Page Down>' 13
Avana meia janela.

.ip <^U> 13
.it '<Page Up>' 13
Retrocede meia janela.

.ip <Home> 13
Retrocede para o incio do diretrio/carta.

.ip <End> 13
Avana para o final do diretrio/carta.

.ip "[<n>] <^F>" 13
Avana <n> janelas. Se <n> for omitido, avana uma janela.

.ip "[<n>] <^B>" 13
Retrocede <n> janelas. Se <n> for omitido, retrocede uma janela.

.ip "[<n>] <^V>" 13
Avana <n> pginas (de 75 linhas cada). Se <n> for omitido, avana uma pgina.

.ip "[<n>] <^Z>" 13
Retrocede <n> pginas. Se <n> for omitido, retrocede uma pgina.

.ip <^R> 13
Reescreve a janela.

.ip 'f' 13
.it 'F' 13
.it <^G> 13
Escreve o nome do <manual> na ltima linha da janela.

.ip '<sp>' 13
Tira a mensagem da ltima linha da janela.

.ip "[<n>] g" 13
.it "[<n>] G" 13
Avana/retrocede para a janela que comea na linha <n>.
Se <n> for omitido, avana para a ltima janela do <manual>.

.ip "[<n>] p" 13
.it "[<n>] P" 13
Avana/retrocede para a pgina <n>.
Se <n> for omitido, avana para a ltima pgina do <manual>.

.ip '/ <cadeia>' 13
Busca de cadeia: avana/retrocede para a primeira janela do <manual>
cuja primeira linha contm a <cadeia> dada.

.ip 'n' 13
Repete a busca de cadeia avanando: mostra a janela seguinte do <manual>
cuja primeira linha contm a <cadeia> dada.

.ip 'N' 13
Repete a busca de cadeia retrocedendo: mostra a janela anterior do <manual>
cuja primeira linha contm a <cadeia> dada.

.ip 'w <nome>' 13
.it 's <nome>' 13
Cria o arquivo <nome> com o contedo do <manual> sendo examinado,
desde que o arquivo <nome> ainda no exista.

.ip 'W <nome>' 13
.it 'S <nome>' 13
Escreve/reescreve o contedo do <manual> sendo lido no arquivo <nome>,
mesmo que o arquivo <nome> j exista.

.ip '! <comando>' 13
Executa o <comando> atravs do "sh" (cmd).

.ip '?' 13
Mostra o manual do prprio comando "man", para poder consultar esta lista
de comandos internos.

.ip <^C> 13
.it 'q' 13
.it 'Q' 13
Encerra a execuo de "man".

.ep
.in -3

.in
.sp 2
.b OBSERVAO
.in 5
Repare que os comandos internos "/", "n" e "N" procuram apenas
a cadeia como originalmente dada, no realizando uma busca de expresses
regulares, como o comando "vi" (cmd).

.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd): "
vi, ex, sh, show
.br

.in
.sp
.b ESTADO
.in 5
Efetivo.

.in
