.bp
.he 'SHOW (cmd)'TROPIX: Manual de Referncia'SHOW (cmd)'
.fo 'Atualizado em 04.12.02'Verso 4.4.0'Pag. %'

.b NOME
.in 5
.wo "show -"
mostra um arquivo em uma janela do video
.br

.in
.sp
.b SINTAXE
.in 5
.(l
show [-d] [<arquivo> ...]
.)l

.in
.sp
.b DESCRIO
.in 5
O comando "show" permite examinar de forma conveniente
um <arquivo> em uma janela do video. 
Se for dado mais de um nome de <arquivo>, "show" pede ao usurio
para escolher o nome desejado.
Se o nome do <arquivo> for omitido, ser lida a entrada padro ("pipe").

.sp
O comando permite que o trecho visvel do <arquivo> na janela avance ou
retroceda, podendo-se examinar pginas posteriores ou reexaminar pginas
anteriores do <arquivo>.
Isto  especialmente til para arquivos lidos da entrada padro.

.sp
Os comandos internos que permitem avanar/retroceder as pginas do
<arquivo> so dados abaixo. Eles so semelhantes aos comandos internos
do "vi" (cmd), e o o usurio habituado com o "vi" no ter dificuldades
em utilizar o comando "show".

.sp
Normalmente, se o <arquivo> tiver linhas longas (maiores do que a janela)
elas sero truncadas. No entanto, se o tamanho da janela for aumentada,
as linhas sero reescritas completas (se o novo tamanho permitir).

.sp 2
As opes do comando "show" so:

.in +3
.ip -d
Dobra:  as linhas longas so dobradas ao invs de truncadas.
Isto  uma operao definitiva; mesmo que o tamanho da janela seja aumentada, 
as linhas continuaro dobradas. 

.ep
.in -3

.sp 2
Os comandos internos para avanar/retroceder a pgina visvel do
<arquivo> na janela so os seguintes:

.in +3

.ip '[<n>] +' 13
.it '[<n>] <nl>' 13
.it '[<n>] <cr>' 13
Avana <n> linhas. Se <n> for omitido, avana uma linha.

.ip '[<n>] -' 13
Retrocede <n> linhas. Se <n> for omitido, retrocede uma linha.

.ip <^D> 13
.it '<Page Down>' 13
Avana meia janela.

.ip <^U> 13
.it '<Page Up>' 13
Retrocede meia janela.

.ip <Home> 13
Retrocede para o incio do diretrio/carta.

.ip <End> 13
Avana para o final do diretrio/carta.

.ip "[<n>] <^F>" 13
Avana <n> janelas. Se <n> for omitido, avana uma janela.

.(t
.ip "[<n>] <^B>" 13
Retrocede <n> janelas. Se <n> for omitido, retrocede uma janela.
.)t

.ip "[<n>] <^V>" 13
Avana <n> pginas (de 75 linhas cada). Se <n> for omitido, avana uma pgina.

.ip "[<n>] <^Z>" 13
Retrocede <n> pginas. Se <n> for omitido, retrocede uma pgina.

.ip <^R> 13
Reescreve a janela.

.ip 'f' 13
.it 'F' 13
.it <^G> 13
Escreve o nome do <arquivo> na ltima linha da janela.

.ip '<sp>' 13
Tira a mensagem da ltima linha da janela.

.ip "[<n>] g" 13
.it "[<n>] G" 13
Avana/retrocede para a janela que comea na linha <n>.
Se <n> for omitido, avana para a ltima janela do <arquivo>.

.ip "[<n>] p" 13
.it "[<n>] P" 13
Avana/retrocede para a pgina <n>.
Se <n> for omitido, avana para a ltima pgina do <arquivo>.

.ip '/ <cadeia>' 13
Busca de cadeia: avana/retrocede para a primeira janela do <arquivo>
cuja primeira linha contm a <cadeia> dada.

.ip 'n' 13
Repete a busca de cadeia avanando: mostra a janela seguinte do <arquivo>
cuja primeira linha contm a <cadeia> dada.

.ip 'N' 13
Repete a busca de cadeia retrocedendo: mostra a janela anterior do <arquivo>
cuja primeira linha contm a <cadeia> dada.

.ip 'w <nome>' 13
.it 's <nome>' 13
Cria o arquivo <nome> com o contedo do <arquivo> sendo examinado,
desde que o arquivo <nome> ainda no exista.
Isto  especialmente til para arquivos lidos da entrada padro ("pipe").

.ip 'W <nome>' 13
.it 'S <nome>' 13
Escreve/reescreve o contedo do <arquivo> sendo examinado no arquivo <nome>,
mesmo que o arquivo <nome> j exista.

.ip '! <comando>' 13
Executa o <comando> atravs do "sh" (cmd).

.ip '?' 13
Mostra o manual do comando "show", para poder consultar esta lista
de comandos internos.

.ip <^C> 13
.it 'q' 13
.it 'Q' 13
Encerra a execuo de "show".

.ep
.in -3

.in
.sp 2
.(t
.b OBSERVAES
.in 5
 feita uma anlise simples dos caracteres do <arquivo>, e os caracteres
de controle (exceto <bs>, <cr> e <ht>) so convertidos nas
seqncias padronizadas "^X".
.)t

.bc	/*************************************/
.sp
Se o <arquivo> tiver linhas longas, e elas forem dobradas (isto , no
for dada a opo "-t"), o comando "show" perde a referencia aos nmeros
originais das linhas no <arquivo> dado.
Neste cado, os comandos "g" e "G" funcionam apenas com <n> igual a 1
ou com <n> omitido.
.ec	/*************************************/

.sp
Se o <arquivo> tiver linhas dobradas e/ou caracteres de controle,
o arquivo <nome> criado/reescrito
pelos comandos "w", "W", "s" e "S" no ser idntico ao <arquivo> original.

.sp
Repare que os comandos internos "/", "n" e "N" procuram apenas
a cadeia como originalmente dada, no realizando uma busca de expresses
regulares, como o comando "vi" (cmd).

.sp
O comando "show" identifica se o arquivo em edio  do estilo UNIX
(linhas terminadas por <nl>) ou estilo DOS (linhas terminadas por <cr><nl>),
e processa corretamento os dois estilos.

.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd): "
vi, ex, sh
.br

.in
.sp
.b EXEMPLO
.in 5
.nf
		grep INC *.c | show
.fi
.sp
mostra o arquivo de sada do comando "grep".

.in
.sp
.b ESTADO
.in 5
Efetivo.

.in
