.bp
.he 'SIZE (cmd)'TROPIX: Manual de Referncia'SIZE (cmd)'
.fo 'Atualizado em 11.08.04'Verso 4.6.0'Pag. %'

.b NOME
.in 5
.wo "size -"
imprime tamanhos e caractersticas de mdulos objeto
.br

.in
.sp
.b SINTAXE
.in 5
.(l
size [-dcxaN] [<mdulo> ...]
.)l

.in
.sp
.b DESCRICAO
.in 5
O comando "size" imprime uma linha para cada <mdulo> objeto dado,
contendo os tamanhos das suas vrias sees,
alm de algumas outras informaes.

.sp 
As informaes dadas so as seguintes:

.in +3
.ip MACH 8
Modelo do computador de origem do <mdulo> objeto
(Por exemplo, "486", indicando um mdulo objeto nativo para
INTEL 386/486/PENTIUM).

.ip TIPO 8
Tipo do <mdulo> objeto: "." para normal, "n" para reentrante e
"s" para biblioteca compartilhada.
Para mdulos reentrantes, so indicados ainda, com "t" ou "m"
os indicadores S_ISVTX e S_IMETX do seu estado (ver "chmod" (sys)).

.ip TS 8
Presena ("*") ou ausncia (".") da tabela de smbolos.

.ip RL 8
Presena ("*") ou ausncia (".") da informao de relocao.

.ip VER 8
Verso das bibliotecas compartilhadas referenciadas por este
<mdulo> objeto.

.ip FLAG 8
Indicadores (atualmente sem uso).

.ip TEXTO 8
Tamanho ou endereo inicial do texto (veja a opo "-s").

.ip DATA 8
Tamanho ou endereo inicial da rea de dados inicializados (veja a opo "-s").

.ip BSS 8
Tamanho da rea de dados no inicializados.

.ip COMMON 8
Soma dos tamanhos das variveis "comuns" a outros mdulos objeto.
Estas variveis sero apenas alocadas em tempo de "link-edio"
(ver "ld" (cmd)), e ficaro superpostas
a variveis hommimas de outros mdulos objeto.
Este valor s  impresso com a opo "-c" (ver adiante).

.ip REFTB 8
Tamanho da tabela de referencias externas. Esta tabela  utilizada
na execuo de mdulos objetos que referenciam bibliotecas compartilhadas.
Este valor s  impresso com a opo "-c" (ver adiante).

.ip TOTAL 8
Soma das sees TEXTO + DATA + BSS. Repare que NO inclui COMMON.

.ip -DATA- 8
Data de gerao do <mdulo>. Esta  a data contida no cabealho
do mdulo; no confundir com alguma das datas do arquivo.
Ela s  impressa com a opo "-d" (ver adiante).

.ip NOME 8
Nome do mdulo.

.ep
.in -3
.sp
.(t
As opes do comando so:

.in +3
.ip -s
Imprime o endereo inicial (em hexadecimal) das sees TEXT e DATA ao invs dos tamanhos.
.)t

.ip -d
Imprime tambm a data de gerao do <mdulo> objeto.
.)t

.ip -c
Imprime tambm os tamanhos das sees COMMON e REFTB.

.ip -x
Os tamanhos so dados em hexadecimal ao invs de decimal.

.ip -a
Emite mensagens de erro para arquivos que no so mdulos objeto
(ao invs de simplesmente ignor-los).

.ip -N
L os nomes dos <mdulos> de "stdin"

.ep
.in -3
.sp
Se no for dado nenhum <mdulo>, nem a opo "-N", sero
dadas informaes sobre "a.out".

.in
.sp
.b OBSERVAES
.in 5
.bc	/*************************************/
Como o tamanho real da rea de dados no inicializados (BSS) s  conhecido
aps a "link-edio", o comando "size" pode dar tamanhos errneos para mdulos
no executveis. Isto ocorre em virtude das variveis em "common".
.sp
.ec	/*************************************/

Para obter informaes sobre mdulos contidos em bibliotecas, podemos
usar a expanso proporcionada pelo "sh" (cmd), como por exemplo:
.sp
.nf
		size /lib/libc/id/*.o
.fi
.sp
ou ento usar o comando "walk" (cmd) para obter o nome
de todos os mdulos de uma biblioteca, como por exemplo:
.sp
.nf
		walk -p "*.o" /lib/libc | size -N
.fi

.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(sys): "
chmod
.br
.wo "(cmd): "
sh, walk, ld
.br
.wo "(fmt): "
a.out
.br

.in
.sp
.b ESTADO
.in 5
Efetivo.
.in
