.bp
.he 'SORT (cmd)'TROPIX: Manual de Referncia'SORT (cmd)'
.fo 'Atualizado em 05.07.97'Verso 3.0.0'Pag. %'

.b NOME
.in 5
.wo "sort -"
ordena e/ou intercala arquivos
.br

.in
.sp
.b SINTAXE
.in 5
.(l
sort [-vcraidf]   [-o <sada>] [-t <d>] [-k "x:y.zot ... "]
						[<entrada>]

sort -m [-vraidf] [-o <sada>] [-t <d>] [-k "x:y.zot ... "]
						<entrada> ...
.)l

.in
.sp
.b DESCRIO
.in 5
O programa "sort" ordena/intercala as linhas
dos arquivos de <entrada> dados. O resultado da ordenao/intercalao
 escrito na sada padro ou no arquivo <sada>, se este for dado
(atravs da opo "-o").

.sp
Em sua primeira forma (sem a opo "-m"), "sort" ordena as linhas
do arquivo <entrada> (ou da entrada padro se este no for dado).

.sp
Em sua segunda forma (com a opo "-m"), "sort" intercala ("merge") as linhas
dos vrios arquivos <entrada> ..., supondo que as linhas destes arquivos
j estejam ordenadas.

.sp
As comparaes so realizadas baseadas em uma ou mais chaves
contidas nas linhas de entrada (veja as opes abaixo).
Normalmente (isto , sem opes),  considerada apenas uma chave
(a linha inteira), e a ordenao  lexicogrfica pelos caracteres
na ordem normal da mquina.

.sp
As opes do comando so:

.in +3
.ip -m
Intercalao: ao invs de uma ordenao, "sort" realiza a intercalao
("merge") das linhas dos vrios arquivos <entrada> ..., supondo que
as linhas destes arquivos j estejam ordenadas.

.ip -v
Verboso: "sort" imprime algumas informaes acerca da ordenao/intercalao.

.ip -c
Verifica se o arquivo j est ordenado: apenas escreve uma mensagem informando
se o arquivo de entrada est ou no ordenado (NO escreve a sada ordenada).
Alm disto, o cdigo de retorno de "sort"  ZERO se o arquivo de entrada
j est ordenado e um valor NO-NULO em caso contrrio.
Esta opo  util (por exemplo) para certificar-se de que as diversas entradas
de uma futura intercalao esto ordenadas.

.ip -r
Ordem reversa: inverte o sentido das comparaes, isto , ordena
descendentemente ao invs de ascendentemente.

.ip -a
Tipo de ordenao LEXICOGRFICA (tipo por omisso).

.ip -i
Tipo de ordenao ISO: Usa o codigo padro ISO (BRASCII ou CBII)
para as comparaes. Com este tipo de ordenao, as letras acentuadas
tm o mesmo valor das letras sem acento, e  o tipo 
recomendado quando as chaves contem letras acentuadas
(veja "iso" (fmt)).

.ip -d
Tipo de ordenao DICIONRIO: para as comparaes so levados em
conta apenas as letras e dgitos das chaves, e alm disto, as letras
maisculas/minsculas/com acento/sem acento tm o mesmo valor.

.ip -f
Tipo de ordenao FOLD: as letras maisculas e minsculas das chaves tm
o mesmo valor (embora as minsculas precedam as maisculas numa ordenao
ascendente).

.ip -o
Escreve o arquivo ordenado em <sada> ao invs de "stdout".

.ip -t
Utiliza o caracter <d> como delimitador de campos:
Normalmente, os campos so delimitados por um ou mais <sp> ou <ht> (no
existem campos vazios). Com a opo "-t", o delimitador usado ser
o caractere <d>. Neste caso, cada ocorrncia de <d>  significativa:
a cadeia "...<d><d>..." contm um campo vazio. A delimitao dos campos
de uma linha  importante para a especificao das chaves. 

.ip -k
Define as chaves pelas quais a ordenao deve ser feita:
aps a delimitao dos vrios campos de uma linha (veja acima),
os seguintes parmetros podem ser dados para definir quais os trechos
de quais campos sero utilizados como chaves:

.in +5
.ip "x -"
Nmero do campo: se for zero, a chave considerada  a linha
inteira. Neste caso, o nmero do campo pode ser omitido mas o
caractere ":" deve ser especificado caso outros parmetros sejam
desejados para a ordenao.

.ip "y -"
Nmero do caractere dentro do campo onde comea a chave:
se no for especificado, a chave comea no incio do campo.

.ip "z -"
Largura da chave em caracteres: se no for especificada,
a chave termina no final do campo.

.ip "o -"
Letra que define o sentido da ordenao:
"a" para ascendente e "d" para descendente. 
Se for omitido, a ordenao ser ascendente.

.ip "t - "
Letra que define o tipo da ordenao:
"a" para LEXICOGRFICO, "i" para ISO, "d" para DICIONRIO e "f" para FOLD
(veja as respectivas opes acima).
Se for omitido, a ordenao ser LEXICOGRFICA.

.ep
.in -5

.ep
.in -3

.in
.sp
.b OBSERVAO
.in 5
O programa "sort" (em sua verso atual)  capaz de ordenar
apenas arquivos que caibam integralmente na memria interna disponvel do
sistema. Se isto no for o caso,  responsabilidade do usurio
dividir o arquivo em pedaos menores, orden-los
separadamente e depois usar uma intercalao (opo "-m").

.sp
O programa "sort"  orientado por linhas (de tamanho varivel),
isto , ele assume que os registros sejam delimitados por <nl>.
Caso este no seja o caso, tambm  responsabilidade do usurio
inserir um caractere <nl> ao final de cada registro.

.sp
Na verso atual da operao de intercalao, assume-se que as linhas
no tenha mais de 1024 caracteres.

.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd): "
comm, uniq
.br
.wo "(libc):"
qsort, qtsort, cmptb
.br
.wo "(fmt): "
iso
.br

.in
.sp
.b EXEMPLOS
.in 5
.nf
		sort alpha
.fi

.sp
ordena o arquivo "alpha" em ordem ascendente e pe a sada em "stdout".

.sp 2
.nf
		sort -t : -k "3 4 1" beta
.fi

.sp
ordena o arquivo "beta", que tem campos delimitados pelo
caractere ":", em ordem ascendente considerando primeiro o
campo 3, depois o 4 e finalmente o 1.

.sp 2
.nf
	sort -t : -m -k "3 4 1" arq1 arq2 arq3 arq4 arq5
.fi

.sp
faz a intercalao dos cinco arquivos mencionados 
seguindo as chaves conforme o exemplo anterior.

.sp 2
.nf
		sort -k :ai
.fi

.sp
ordena o arquivo lido do "stdin" em ordem ascendente utilizando tipo de
ordenao ISO usando a linha inteira como chave.

.sp 2
.nf
		sort -t = -k "3:2.3af 4:3.2di" esttuas
.fi

.sp
ordena o arquivo "esttuas", que tem campos delimitados pelo
caractere "=", em primeiro lugar pelo campo 3 a partir da
posio 2 com uma chave de largura 3 em ordem ascendente e
considerando letras maisculas e minsculas indistintamente e,
a seguir, pelo campo 4 a partir da posio 3 com uma chave de
largura 2 em ordem descendente utilizando tipo de ordenao ISO.

.in
.sp
.b ESTADO
.in 5
Efetivo.

.in
