.bp
.he 'TEST (cmd)'TROPIX: Manual de Referncia'TEST (cmd)'
.fo 'Atualizado em 24.04.02'Verso 4.2.0'Pag. %'

.b NOME
.in 5
.wo "test -"
testa propriedades de arquivos
.br

.in
.sp
.b SINTAXE
.in 5
.(l
test [-o] [-{rwxfdcblpugkms} <arquivo>] ... [-t <fd>] ...
.)l

.in
.sp
.b DESCRIO
.in 5
O utilitrio "test" testa diversas propriedades de arquivos,
com a finalidade principal de fornecer um cdigo de retorno
para o comando de programao "if" do "sh" (cmd).
 
.sp
Se a expresso (composta do e-rio ou ou-trio das diversas
propriedades testadas) for verdadeira, "test" retorna "0"
(o que  interpretado como verdadeiro pelo "if" do "sh");
no caso contrrio retorna "1" (o que  interpretado como falso).

.sp
As diversas permisses de acesso a arquivos so testadas utilizando-se
os UID/GID efetivos (ver "intro" (sys)). Se no for dado nenhum
teste de arquivo, o retorno de "test"  falso.

.sp
Se o <arquivo> for um elo simblico, a propriedade ser testada
no alvo referenciado, exceto na opo "-l" (ver abaixo).

.sp
As opes do comando so:

.in +5
.ip -o 14
Normalmente,  realizado o e-rio dos diversos testes dos arquivos.
Com esta opo,  feito um ou-trio.
Se usada, esta opo deve ser a primeira.

.ip '-r <arquivo>' 14
Verdadeiro se o <arquivo> existe, e puder ser lido.

.ip '-w <arquivo>' 14
Verdadeiro se o <arquivo> existe, e puder ser escrito.

.ip '-x <arquivo>' 14
Verdadeiro se o <arquivo> existe, e puder ser executado.

.ip '-f <arquivo>' 14
Verdadeiro se o <arquivo> existe, e for regular.

.ip '-d <arquivo>' 14
Verdadeiro se o <arquivo> existe, e for um diretrio.

.ip '-c <arquivo>' 14
Verdadeiro se o <arquivo> existe, e for especial de caracteres
(no-estruturado).

.ip '-b <arquivo>' 14
Verdadeiro se o <arquivo> existe, e for especial de blocos
(estruturado).

.ip '-l <arquivo>' 14
Verdadeiro se o <arquivo> existe, e for um elo simblico.

.ip '-p <arquivo>' 14
Verdadeiro se o <arquivo> existe, e for um FIFO.

.ip '-u <arquivo>' 14
Verdadeiro se o <arquivo> existe, e o bite "set-user-ID" estiver ligado.

.ip '-g <arquivo>' 14
Verdadeiro se o <arquivo> existe, e o bite "set-group-ID" estiver ligado.

.ip '-k <arquivo>' 14
Verdadeiro se o <arquivo> existe, e o bite para guardar
o texto no "swap" estiver ligado.

.ip '-m <arquivo>' 14
Verdadeiro se o <arquivo> existe, e o bite para guardar
o texto na memria estiver ligado.

.ip '-s <arquivo>' 14
Verdadeiro se o <arquivo> existe, e o seu tamanho for maior do que zero.

.ip '-t <fd>' 14
Verdadeiro se o arquivo cujo descritor for <fd> estiver aberto e for um terminal.

.ep
.in -5

.in
.sp
.b OBSERVAO
.in 5
O teste "-x" apenas consulta os bites correspondentes do modo do arquivo,
no garantindo que o referido arquivo possa realmente ser executado.

.in
.sp
.b
VEJA TAMBM
.r
.in 5
.wo "(cmd): "
sh
.br
.wo "(sys): "
intro
.br

.in
.sp
.b EXEMPLOS
.in 5
O comando
.sp
.nf
		test -f alpha -d dir
.fi

.sp
retorna verdadeiro se "alpha" for um arquivo regular E "dir" um diretrio. 

.sp
Por outro lado, o comando
.sp
.nf
		test -o -f alpha -d dir
.fi

.sp
retorna verdadeiro se "alpha" for um arquivo regular OU "dir" um diretrio. 

.in
.sp
.b ESTADO
.in 5
Efetivo.

.in
